program Prometheon;

import "mod_grproc";
import "mod_key";
import "mod_map";
import "mod_math";
import "mod_proc";
import "mod_rand";
import "mod_screen";
import "mod_scroll";
import "mod_sound";
import "mod_text";
import "mod_video";
import "mod_wm";
import "mod_file";
import "mod_draw";
import "mod_effects";
import "mod_joy";


global

  // Variables

  int LevelCheckID;  // System
  int Volume;
  int Song;
  int GlobalRed;
  int GlobalGreen;
  int GlobalBlue;
  int Selection;
  int ScreenFull;
  int TempCollisionID;
  int CameraID;
  int MoreParticles;
  int GameMenuID;
  int FadeText;
  int Combo;
  int ComboCounter;

  int LevelCollision;  // Levels
  int LevelMiddle;
  int LevelBackground;
  int LevelSky;
  int MaxLevelY;

  int PlayerID;  // Player
  int PlayerWeaponID;
  int PlayerFlag;
  int PlayerX;
  int PlayerY;
  int SelectedWeapon;
  int MinWeapon;
  int MaxWeapon;
  int PlayerHP;
  int PLayerLives;
  int CurrentArea;
  int PlayerScore;
  int SwordDamage;
  int ArmID;
  int AmmoType1;
  int AmmoType2;
  int AmmoType3;
  int ShotUpgrade;
  int MissileUpgrade;

  int EnemyFindX;  // Enemies
  int EnemyFindY;

  int MovingPlatformOn;
  int SolkBossOn;
  int SchmupBossOn;

  int ActiveLamp1_X;  // Shadows
  int ActiveLamp1_Y;
  int ActiveLamp2_X;
  int ActiveLamp2_Y;

  int SpiritBattle1Done; // Memory
  int SpiritBattle2Done;
  int ComputerGame1Done;
  int ComputerGame2Done;
  int FindMainComputerDone;
  int ComputerGame3Done;
  int ComputerGame4Done;
  int ComputerGame5Done;
  int Coin1Found;
  int Coin2Found;
  int DestructibleItem1;
  int DestructibleItem2;
  int BrainDestroyed;
  int MemoryChair;
  int TutorialText;
  int IntroText;
  int BabbyCount;
  int Boss1Done;

  // Save

  struct Save[0];
    int SaveDone;
    int CurrentArea;
    int SpiritBattle1Done;
    int SpiritBattle2Done;
    int ComputerGame1Done;
    int ComputerGame2Done;
    int FindMainComputerDone;
    int ComputerGame3Done;
    int ComputerGame4Done;
    int ComputerGame5Done;
    int Coin1Found;
    int Coin2Found;
    int DestructibleItem1;
    int DestructibleItem2;
    int BrainDestroyed;
    int MemoryChair;
    int TutorialText;
    int IntroText;
    int BabbyCount;
    int Boss1Done;
  end

  // Sound INT's

  int Explode0;
  int Explode1;
  int Explode2;
  int Rocket;
  int Beam1;
  int Beam2;
  int Longshot;
  int Slash;
  int Tube;
  int Teleport;
  int Photon;
  int OpenMenu;
  int BigShot;
  int Plane;
  int OpenDoor1;
  int SluddarGun;
  int MineJump;
  int Charge1;
  int Charge2;
  int Jump1;
  int Shot4;
  int SpiritShot1;
  int Water1;
  int MenuSelect;
  int Splash1;
  int Splash2;
  int Klirr;
  int Laser;
  int Bounce;
  int PsyOwl1;
  int PsyOwl2;
  int MenuMove;
  int PickUp;
  int Gun2;
  int FloorFall;
  int Warning;
  int Sword1;
  int CompOn;
  int Drop;
  int Steam;
  int PowerDown;
  int NewMission;
  int Mashing;

local
  int Control;
  int Check;
  int HP;
end


begin

Full_Screen=true;
set_mode(640,480,16,0);
set_fps(30,0);
sound_freq=44100;
load_fpg("Prometheon.fpg");

Explode0=load_wav("Sound/explode0.wav");
Explode1=load_wav("Sound/explode1.wav");
Explode2=load_wav("Sound/explode2.wav");
Rocket=load_wav("Sound/rocket.wav");
Beam1=load_wav("Sound/beam1.wav");
Beam2=load_wav("Sound/beam2.wav");
Longshot=load_wav("Sound/longshot.wav");
Slash=load_wav("Sound/slash.wav");
Tube=load_wav("Sound/tube.wav");
Teleport=load_wav("Sound/teleport.wav");
Photon=load_wav("Sound/photon.wav");
OpenMenu=load_wav("Sound/openmenu.wav");
BigShot=load_wav("Sound/bigshot.wav");
Plane=load_wav("Sound/plane.wav");
OpenDoor1=load_wav("Sound/dooropen.wav");
SluddarGun=load_wav("Sound/sluddargun.wav");
MineJump=load_wav("Sound/minejump.wav");
Charge1=load_wav("Sound/charge1.wav");
Charge2=load_wav("Sound/charge2.wav");
Jump1=load_wav("Sound/jump1.wav");
Shot4=load_wav("Sound/shot4.wav");
SpiritShot1=load_wav("Sound/spiritshot1.wav");
Water1=load_wav("Sound/water1.wav");
MenuSelect=load_wav("Sound/menuselect.wav");
Splash1=load_wav("Sound/splash1.wav");
Splash2=load_wav("Sound/splash2.wav");
Klirr=load_wav("Sound/klirr.wav");
Laser=load_wav("Sound/laser.wav");
Bounce=load_wav("Sound/bounce.wav");
PsyOwl1=load_wav("Sound/psyowl1.wav");
PsyOwl2=load_wav("Sound/psyowl2.wav");
MenuMove=load_wav("Sound/menumove.wav");
PickUp=load_wav("Sound/pickup.wav");
Gun2=load_wav("Sound/gun2.wav");
FloorFall=load_wav("Sound/floorfall.wav");
Warning=load_wav("Sound/warning.wav");
Sword1=load_wav("Sound/sword1.wav");
CompOn=load_wav("Sound/compon.wav");
Drop=load_wav("Sound/drop.wav");
Steam=load_wav("Sound/steam.wav");
PowerDown=load_wav("Sound/powerdown.wav");
NewMission=load_wav("Sound/newmission.wav");
Mashing=load_wav("Sound/mashing.wav");

ScreenFull=1;
Volume=70;
MoreParticles=1;

SelectedWeapon=2;
MinWeapon=1;
MaxWeapon=5;

PlayerLives=5;

AmmoType1=300;
AmmoType2=200;
AmmoType3=50;

if (Volume>6) set_song_volume(Volume-5); end
if (Volume<=6) set_song_volume(Volume); end
set_wav_volume(Explode0,Volume);
set_wav_volume(Explode1,Volume);
set_wav_volume(Explode2,Volume);
set_wav_volume(Rocket,Volume);
set_wav_volume(Beam1,Volume);
set_wav_volume(Beam2,Volume);
set_wav_volume(Longshot,Volume);
set_wav_volume(Slash,Volume);
set_wav_volume(Tube,Volume);
set_wav_volume(Teleport,Volume);
set_wav_volume(Photon,Volume);
set_wav_volume(OpenMenu,Volume);
set_wav_volume(BigShot,Volume);
set_wav_volume(Plane,Volume);
set_wav_volume(OpenDoor1,Volume);
set_wav_volume(SluddarGun,Volume);
set_wav_volume(MineJump,Volume);
set_wav_volume(Charge1,Volume);
set_wav_volume(Charge2,Volume);
set_wav_volume(Jump1,Volume);
set_wav_volume(Shot4,Volume);
set_wav_volume(SpiritShot1,Volume);
set_wav_volume(Water1,Volume);
set_wav_volume(MenuSelect,Volume);
set_wav_volume(Splash1,Volume);
set_wav_volume(Splash2,Volume);
set_wav_volume(Klirr,Volume);
set_wav_volume(Laser,Volume);
set_wav_volume(Bounce,Volume);
set_wav_volume(PsyOwl1,Volume);
set_wav_volume(PsyOwl2,Volume);
set_wav_volume(MenuMove,Volume);
set_wav_volume(PickUp,Volume);
set_wav_volume(Gun2,Volume);
set_wav_volume(FloorFall,Volume);
set_wav_volume(Warning,Volume);
set_wav_volume(Sword1,Volume);
set_wav_volume(CompOn,Volume);
set_wav_volume(Drop,Volume);
set_wav_volume(Steam,Volume);
set_wav_volume(PowerDown,Volume);
set_wav_volume(NewMission,Volume);
set_wav_volume(Mashing,Volume);

Intro();

//Title();

//MainMenu();

//StartRoom(220,270);

//Level1Part0(30,355);
//Level1Part1(30,350);
//Level1Part2(30,470);
//MainCityEntrance(190,460);
//Level1Part3(80,331);
//Level1Part4(30,570);
//Level1Part5(30,280);
//Level1Part6(30,200);
//Level1Part7(40,270);
//Level1Part8(30,680);
//PsykodromeEntry(30,460);
//Level1Part9(30,360,0);
//Level1Part10(40,290);
//PsykodromeCorridor(30,390);
//Level1Part11(40,760);
//Level1Part12(40,350);
//Level1Part13(270,-20);
//Level1Part14(400,-20);
//Level1Part15(214,-100);
//Level1Part16(40,380);
//Level1Part17(40,240);
//Level1Part18(40,700);
//Elevator1(40,2870);
//Level1Part19(40,440,0);
//Level1Part20(30,460);
//Level1Part21(30,460);
//Level1Part22(30,370);
//Level1Part23(30,1870);
//Level1Part24(30,420);

//SchmupTutorial();
//SchmupLevel1();

//TunnelFall();

//SpiritBattle1();

//ComputerGame3();



repeat frame; until(key(_esc) or joy_getbutton(0,1) or key(_space) or joy_getbutton(0,0) or key(_enter) or joy_getbutton(0,2))
write(0,0,470,0,"Press again to skip intro...");
frame(500); FadeText=100;
repeat
  if (FadeText>0) FadeText--; end
  if (FadeText==1) delete_text(0); end
  frame;
until(key(_esc) or joy_getbutton(0,1) or key(_space) or joy_getbutton(0,0) or key(_enter) or joy_getbutton(0,2))
delete_text(0);
let_me_alone();
Title();


end



process Intro();
begin

  SongPlayer(8);
  frame(2000); frame(2000); frame(200);
  IntroObject(320,100,4,350,0);
  IntroObject(320,160,4,351,0);

  IntroObject(320,360,4,395,0);
  IntroObject(320,360,5,396,0);

  repeat frame; until(exists(type IntroObject)==0)

  IntroObject(320,240,4,397,1);

  repeat frame; until(exists(type IntroObject)==0)

  IntroObject(320,40,4,398,1); frame(2000);
  IntroObject(320,140,4,399,1); frame(2000);
  IntroObject(320,220,4,400,1); frame(2000);
  IntroObject(320,320,4,401,1); frame(2000);
  IntroObject(320,420,4,402,1); frame(2000);

  repeat frame; until(exists(type IntroObject)==0)

  IntroObject(320,90,4,403,1); frame(2000);
  IntroObject(320,190,4,404,1); frame(2000);
  IntroObject(320,290,4,405,1); frame(2000);
  IntroObject(320,390,4,406,1); frame(2000);

  repeat frame; until(exists(type IntroObject)==0)

  IntroObject(320,140,4,407,1); frame(2000);
  IntroObject(320,240,4,408,1); frame(2000);
  IntroObject(320,340,4,409,1); frame(2000);

  repeat frame; until(exists(type IntroObject)==0)

  IntroObject(320,90,4,410,1); frame(2000);
  IntroObject(320,190,4,411,1); frame(2000);
  IntroObject(320,290,4,412,1); frame(2000);
  IntroObject(320,390,4,413,1); frame(2000);

  repeat frame; until(exists(type IntroObject)==0)

  Title();
end



process IntroObject(x,y,z,graph,Mode);
begin
  alpha=5; repeat alpha+=5; frame(50); until(alpha=>255)
  frame(5000); frame(5000); frame(5000);
  if (Mode==1)
    frame(5000); frame(5000);
    frame(5000); frame(5000);
    frame(5000); frame(5000);
    frame(5000); frame(5000);
    frame(5000); frame(5000);
  end
  repeat alpha-=5; frame(50); until(alpha<=10)
end



process Title();
private
  int ArcWhiteID;
begin

  let_me_alone();
  FadeSong();
  SongPlayer(7);

  x=320; y=240; z=6; graph=414;
  alpha=5; repeat alpha+=5; frame(50); until(alpha=>255)
  frame(2000);
  TitleObject(320,60,1,0);
  frame(2000); frame(2000); frame(2000);
  ArcWhiteID=TitleObject(-240,280,4,1);
  TitleObject(-240,140,3,2);
  TitleObject(-240,380,3,2);
  TitleObject(-380,280,3,2);
  TitleObject(-540,190,3,2);
  TitleObject(-540,440,3,2);
  TitleObject(-750,130,3,2);
  TitleObject(-800,290,3,2);
  TitleObject(-990,210,3,2);
  TitleObject(-990,360,3,2);
  TitleObject(-1210,140,3,2);
  TitleObject(-1210,380,3,2);
  TitleObject(-1410,240,3,2);
  TitleObject(-1610,190,3,2);
  TitleObject(-1610,420,3,2);

  repeat
    if (rand(1,50)==1) TitleObject(rand(-100,-200),rand(140,460),2,3); end
    frame;
  until(key(_enter) or key(_space) or key(_esc) or key(_control) or joy_getbutton(0,0) or ArcWhiteID.x>720)

  fade(0,0,0,8);
  frame(2000);
  fade(100,100,100,8);
  MainMenu();

end


process TitleObject(x,y,z,Mode);
private
  int HoverCounter;
begin
  if (Mode==0) graph=329; alpha=5; flags=16; end
  if (Mode==1) graph=330; alpha=250; end
  if (Mode==2) graph=308; alpha=250; flags=1; HoverCounter=rand(0,63); end
  if (Mode==3)
    graph=310; alpha=250; flags=1; HoverCounter=rand(0,63);
    frame;
    if (collision(type TitleObject)) return; end
  end
  repeat alpha+=5; frame; until(alpha=>255)

  loop
    if (Mode==1)
      if (HoverCounter%2==0) x++; end
      HoverCounter++;
      if (HoverCounter==8 or HoverCounter==16) y++; end
      if (HoverCounter==32 or HoverCounter==48) y--; end
      if (HoverCounter==64) HoverCounter=0; end
    end
    if (Mode==2)
      x++;
      HoverCounter++;
      if (HoverCounter==8 or HoverCounter==16) y++; end
      if (HoverCounter==32 or HoverCounter==48) y--; end
      if (HoverCounter==64) HoverCounter=0; end
    end
    if (Mode==3)
      x+=2;
      HoverCounter++;
      if (HoverCounter==8 or HoverCounter==16) y++; end
      if (HoverCounter==32 or HoverCounter==48) y--; end
      if (HoverCounter==64) HoverCounter=0; end
    end
    frame;
  end
end



process MainMenu();
begin
  let_me_alone();
  //Lighting(0);
  FadeSong();
  SongPlayer(7);
  delete_text(0);

  LevelCollision=load_png("Levels/Level1/StartRoom_Collision.png");
  LevelMiddle=load_png("Levels/Level1/StartRoom_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(320,240,10,LevelCollision);

  StreetLight(232,121,3,1,13); StreetLightHalo(232,39,2,5);
  StreetLight(558,121,3,1,13); StreetLightHalo(558,39,2,5);

  AquariumEel(333,300,9,0);
  LevelObject(333,294,8,22);


  MenuBackground(1);
  frame(2000); frame(2000);

  MainMenuOption(320,80,1,1);
  MainMenuOption(320,140,1,2);
  MainMenuOption(320,200,1,3);
  MainMenuOption(320,260,1,4);
  MainMenuOption(320,320,1,5);
  MainMenuOption(320,380,1,6);
  frame(1000);
  MainMenuSelector(320,80,0,0);

  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  play_wav(MenuSelect,0);
  if (Selection==1) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); StartRoom(220,270); end
  if (Selection==2) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); LoadGame(); end
  if (Selection==3) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); MainMenu(); end
  if (Selection==4) frame(2000); frame(2000); Options(0); end
  if (Selection==5) frame(2000); frame(2000); Extras(); end
  if (Selection==6) frame(2000); fade(0,0,0,8); frame(2000); exit("Quit",0); end
end



process MainMenuSelector(x,y,z,Mode);
begin
  graph=338; flags=16; Selection=1;
  repeat
    if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); Selection--; frame; end
    if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); Selection++; frame; end
    if (Selection==0) Selection=6; end
    if (Selection==7) Selection=1; end
    if (Selection==1 and y>80) repeat y--; frame(10); until(y==80) end
    if (Selection==2 and y>140) repeat y--; frame(10); until(y==140) end
    if (Selection==2 and y<140) repeat y++; frame(10); until(y==140) end
    if (Selection==3 and y<200) repeat y++; frame(10); until(y==200) end
    if (Selection==3 and y>200) repeat y--; frame(10); until(y==200) end
    if (Selection==4 and y<260) repeat y++; frame(10); until(y==260) end
    if (Selection==4 and y>260) repeat y--; frame(10); until(y==260) end
    if (Selection==5 and y<320) repeat y++; frame(10); until(y==320) end
    if (Selection==5 and y>320) repeat y--; frame(10); until(y==320) end
    if (Selection==6 and y<380) repeat y++; frame(10); until(y==380) end
    frame;
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
end



process MainMenuOption(x,y,z,Mode);
begin
  if (Mode==1) graph=332; end
  if (Mode==2) graph=333; end
  if (Mode==3) graph=334; end
  if (Mode==4) graph=335; end
  if (Mode==5) graph=336; end
  if (Mode==6) graph=337; end
  alpha=0; flags=16;
  repeat
    if (Selection==Mode and alpha<255) alpha++; end
    if (Selection!=Mode and alpha>200) alpha--; end
    if (alpha<200) alpha+=5; end
    frame(25);
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  if (Selection!=Mode) repeat alpha-=5; frame(25); until(alpha<=20) end
  if (Selection==Mode)
    repeat size_y-=5; frame(25); until(size_y==5)
    repeat size_x-=5; frame(25); until(size_x==5)
    MainMenuBlip(x,y,z,Mode);
  end
end



process MainMenuBlip(x,y,z,Mode);
begin
  graph=117; size=0; alpha=50; flags=16;
  repeat size+=2; alpha+=5; frame(25); until(size==50)
  repeat size-=2; alpha-=5; frame(25); until(size==0)
end



process MenuBackground(Mode);
private
  int XSpeed;
  int SlowdownCounter;
begin
  x=-320; y=240; z=2; graph=331; XSpeed=23;
  play_wav(OpenMenu,0);
  repeat
    x+=XSpeed;
    if (XSpeed>8)
      SlowdownCounter++;
      if (SlowdownCounter==2) XSpeed--; SlowdownCounter=0; end
    end
    frame(50);
  until(x=>320);
  x=320;
  ComputerScreenEffect1();
  ComputerScreenEffect2(155,55,0,0);
  ComputerScreenEffect2(178,78,0,1);
  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  if (Mode==1) frame(2000); end
  signal(type ComputerScreenEffect1, s_kill);
  signal(type ComputerScreenEffect2, s_kill);
  SlowdownCounter=0;
  repeat
    x+=XSpeed;
    if (XSpeed<23)
      SlowdownCounter++;
      if (SlowdownCounter==2) XSpeed++; SlowdownCounter=0; end
    end
    frame(50);
  until(x=>960);
end



process Options(Mode);
private
  int MenuBkgID;
begin

  MenuBkgID=MenuBackground(1);
  frame(2000); frame(2000);

  OptionMenuOption(320,80,1,1);
  OptionMenuOption(320,140,1,2);
  OptionMenuOption(320,200,1,3);
  OptionMenuOption(320,260,1,4);
  SoundSelector(320,80,0,0);
  signal(MenuBkgID, s_freeze);
  frame(1000);
  OptionMenuSelector(320,80,0,0);

  repeat
    frame;
  until(Selection==4 and key(_enter) or Selection==4 and key(_space) or Selection==4 and key(_c) or Selection==4 and joy_getbutton(0,0))
  play_wav(MenuSelect,0);
  signal(MenuBkgID, s_wakeup);
  if (Selection==4 and Mode==0) frame(2000); frame(2000); MainMenu(); end
  if (Selection==4 and Mode==1) frame(2000); frame(2000); GameMenu(); end
end



process OptionMenuSelector(x,y,z,Mode);
begin
  graph=338; flags=16; Selection=1;
  repeat
    if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); Selection--; frame; end
    if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); Selection++; frame; end
    if (Selection==0) Selection=4; end
    if (Selection==5) Selection=1; end
    if (Selection==1 and y>80) repeat y--; frame(10); until(y==80) end
    if (Selection==2 and y>140) repeat y--; frame(10); until(y==140) end
    if (Selection==2 and y<140) repeat y++; frame(10); until(y==140) end
    if (Selection==3 and y>200) repeat y--; frame(10); until(y==200) end
    if (Selection==3 and y<200) repeat y++; frame(10); until(y==200) end
    if (Selection==4 and y<260) repeat y++; frame(10); until(y==260) end
    frame;
  until(Selection==4 and key(_enter) or Selection==4 and key(_space) or Selection==4 and key(_c) or Selection==4 and joy_getbutton(0,0))
end



process OptionMenuOption(x,y,z,Mode);
begin
  if (Mode==1) graph=341; end
  if (Mode==2) graph=342; end
  if (Mode==3) graph=344; end
  if (Mode==4) graph=339; end
  alpha=0; flags=16;
  if (Mode==1)
    loop
      if (Selection==Mode and alpha<255) alpha++; end
      if (Selection!=Mode and alpha>200) alpha--; end
      if (alpha<200) alpha+=5; end
      if (Selection==4)
        if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
          repeat alpha-=5; frame(25); until(alpha<=20)
          return;
        end
      end
      frame;
    end
  end

  if (Mode==2)
    loop
      if (Selection==Mode and alpha<255) alpha++; end
      if (Selection!=Mode and alpha>200) alpha--; end
      if (alpha<200) alpha+=5; end
      if (Selection==2)
        if (key(_enter) or key(_space) or key(_c) or key(_left) or key(_right) or joy_getbutton(0,0))
          repeat alpha-=5; frame(20); until(alpha<=20)
          if (MoreParticles==0) MoreParticles=1; graph=342;
          elseif (MoreParticles==1) MoreParticles=0; graph=343; end
          repeat alpha+=5; frame(20); until(alpha=>200)
        end
      end
      if (Selection==4)
        if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
          repeat alpha-=5; frame(25); until(alpha<=20)
          return;
        end
      end
      frame;
    end
  end

  if (Mode==3)
    loop
      if (Selection==Mode and alpha<255) alpha++; end
      if (Selection!=Mode and alpha>200) alpha--; end
      if (alpha<200) alpha+=5; end
      if (Selection==3)
        if (key(_enter) or key(_space) or key(_c) or key(_left) or key(_right) or joy_getbutton(0,0))
          if (ScreenFull==1) Full_Screen=false; set_mode(640,480,16,0); ScreenFull=0; graph=345;
          elseif (ScreenFull==0) Full_Screen=true; set_mode(640,480,16,0); ScreenFull=1; graph=344; end
        end
      end
      if (Selection==4)
        if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
          repeat alpha-=5; frame(25); until(alpha<=20)
          return;
        end
      end
      frame;
    end
  end

  repeat
    if (Selection==Mode and alpha<255) alpha++; end
    if (Selection!=Mode and alpha>200) alpha--; end
    if (alpha<200) alpha+=5; end
    frame(25);
  until(Selection==4 and key(_enter) or Selection==4 and key(_space) or Selection==4 and key(_c) or Selection==4 and joy_getbutton(0,0))
  if (Selection!=Mode) repeat alpha-=5; frame(25); until(alpha<=20) end
  if (Selection==Mode)
    repeat size_y-=5; frame(25); until(size_y==5)
    repeat size_x-=5; frame(25); until(size_x==5)
    MainMenuBlip(x,y,z,Mode);
  end
end



process SoundSelector(x,y,z,Mode);
begin
  graph=340; x=220+Volume*2; alpha=200; flags=16;
  loop
    x=220+Volume*2;
    if (Selection==1)
      if (key(_right) or joy_getaxis(0,0)>20)
        Volume+=2;
        if (Volume>100) Volume=100; End
        if (Volume>6) set_song_volume(Volume-5); end
        if (Volume<=6) set_song_volume(Volume); end
        set_wav_volume(Explode0,Volume);
        set_wav_volume(Explode1,Volume);
        set_wav_volume(Explode2,Volume);
        set_wav_volume(Rocket,Volume);
        set_wav_volume(Beam1,Volume);
        set_wav_volume(Beam2,Volume);
        set_wav_volume(Longshot,Volume);
        set_wav_volume(Slash,Volume);
        set_wav_volume(Tube,Volume);
        set_wav_volume(Teleport,Volume);
        set_wav_volume(Photon,Volume);
        set_wav_volume(OpenMenu,Volume);
        set_wav_volume(BigShot,Volume);
        set_wav_volume(Plane,Volume);
        set_wav_volume(OpenDoor1,Volume);
        set_wav_volume(SluddarGun,Volume);
        set_wav_volume(MineJump,Volume);
        set_wav_volume(Charge1,Volume);
        set_wav_volume(Charge2,Volume);
        set_wav_volume(Jump1,Volume);
        set_wav_volume(Shot4,Volume);
        set_wav_volume(SpiritShot1,Volume);
        set_wav_volume(Water1,Volume);
        set_wav_volume(MenuSelect,Volume);
        set_wav_volume(Splash1,Volume);
        set_wav_volume(Splash2,Volume);
        set_wav_volume(Klirr,Volume);
        set_wav_volume(Laser,Volume);
        set_wav_volume(Bounce,Volume);
        set_wav_volume(PsyOwl1,Volume);
        set_wav_volume(PsyOwl2,Volume);
        set_wav_volume(MenuMove,Volume);
        set_wav_volume(PickUp,Volume);
        set_wav_volume(Gun2,Volume);
        set_wav_volume(FloorFall,Volume);
        set_wav_volume(Warning,Volume);
        set_wav_volume(Sword1,Volume);
        set_wav_volume(CompOn,Volume);
        set_wav_volume(Drop,Volume);
        set_wav_volume(Steam,Volume);
        set_wav_volume(PowerDown,Volume);
        set_wav_volume(NewMission,Volume);
        set_wav_volume(Mashing,Volume);
      end
      if (key(_left) or joy_getaxis(0,0)<-20)
        Volume-=2;
        if (Volume<1) Volume=1; End
        if (Volume>6) set_song_volume(Volume-5); end
        if (Volume<=6) set_song_volume(Volume); end
        set_wav_volume(Explode0,Volume);
        set_wav_volume(Explode1,Volume);
        set_wav_volume(Explode2,Volume);
        set_wav_volume(Rocket,Volume);
        set_wav_volume(Beam1,Volume);
        set_wav_volume(Beam2,Volume);
        set_wav_volume(Longshot,Volume);
        set_wav_volume(Slash,Volume);
        set_wav_volume(Tube,Volume);
        set_wav_volume(Teleport,Volume);
        set_wav_volume(Photon,Volume);
        set_wav_volume(OpenMenu,Volume);
        set_wav_volume(BigShot,Volume);
        set_wav_volume(Plane,Volume);
        set_wav_volume(OpenDoor1,Volume);
        set_wav_volume(SluddarGun,Volume);
        set_wav_volume(MineJump,Volume);
        set_wav_volume(Charge1,Volume);
        set_wav_volume(Charge2,Volume);
        set_wav_volume(Jump1,Volume);
        set_wav_volume(Shot4,Volume);
        set_wav_volume(SpiritShot1,Volume);
        set_wav_volume(Water1,Volume);
        set_wav_volume(MenuSelect,Volume);
        set_wav_volume(Splash1,Volume);
        set_wav_volume(Splash2,Volume);
        set_wav_volume(Klirr,Volume);
        set_wav_volume(Laser,Volume);
        set_wav_volume(Bounce,Volume);
        set_wav_volume(PsyOwl1,Volume);
        set_wav_volume(PsyOwl2,Volume);
        set_wav_volume(MenuMove,Volume);
        set_wav_volume(PickUp,Volume);
        set_wav_volume(Gun2,Volume);
        set_wav_volume(FloorFall,Volume);
        set_wav_volume(Warning,Volume);
        set_wav_volume(Sword1,Volume);
        set_wav_volume(CompOn,Volume);
        set_wav_volume(Drop,Volume);
        set_wav_volume(Steam,Volume);
        set_wav_volume(PowerDown,Volume);
        set_wav_volume(NewMission,Volume);
        set_wav_volume(Mashing,Volume);
      end
    end
    if (Selection==4)
      if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
        repeat alpha-=5; frame(25); until(alpha<=20)
        return;
      end
    end
    frame(50);
  end
end



process Extras();
private
  int MenuBkgID;
begin
  let_me_alone();
  //Lighting(0);
  SongPlayer(5);

  LevelCollision=load_png("Levels/Level1/StartRoom_Collision.png");
  LevelMiddle=load_png("Levels/Level1/StartRoom_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(320,240,10,LevelCollision);

  StreetLight(232,121,3,1,13); StreetLightHalo(232,39,2,5);
  StreetLight(558,121,3,1,13); StreetLightHalo(558,39,2,5);

  MenuBkgID=MenuBackground(1);
  frame(2000); frame(2000);

  ExtrasMenuOption(320,80,1,1);
  ExtrasMenuOption(320,140,1,2);
  ExtrasMenuOption(320,200,1,3);
  signal(MenuBkgID, s_freeze);
  frame(1000);
  ExtrasMenuSelector(320,80,0,0);

  repeat
    frame;
  until(Selection>1 and key(_enter) or Selection>1 and key(_space) or Selection>1 and key(_c) or Selection>1 and joy_getbutton(0,0))
  play_wav(MenuSelect,0);
  signal(MenuBkgID, s_wakeup);
  if (Selection==2) frame(2000); frame(2000); Database(1); end
  if (Selection==3) frame(2000); frame(2000); MainMenu(); end

end



process ExtrasMenuSelector(x,y,z,Mode);
begin
  graph=338; flags=16; Selection=1;
  repeat
    if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); Selection--; frame; end
    if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); Selection++; frame; end
    if (Selection==0) Selection=3; end
    if (Selection==4) Selection=1; end
    if (Selection==1 and y>80) repeat y--; frame(10); until(y==80) end
    if (Selection==2 and y>140) repeat y--; frame(10); until(y==140) end
    if (Selection==2 and y<140) repeat y++; frame(10); until(y==140) end
    if (Selection==3 and y<200) repeat y++; frame(10); until(y==200) end
    frame;
  until(Selection>1 and key(_enter) or Selection>1 and key(_space) or Selection>1 and key(_c) or Selection>1 and joy_getbutton(0,0))
end



process ExtrasMenuOption(x,y,z,Mode);
private
  int SelectSong;
begin
  if (Mode==1)
    graph=346;
    SelectSong=1;
    set_text_color(rgb(255,130,130));
    write_int(0,369,85,0,&SelectSong);
    set_text_color(rgb(255,255,255));
  end
  if (Mode==2) graph=347; end
  if (Mode==3) graph=339; end
  alpha=0; flags=16;

  if (Mode==1)
    loop
      if (Selection==Mode and alpha<255) alpha++; end
      if (Selection!=Mode and alpha>200) alpha--; end
      if (alpha<200) alpha+=5; end
      if (Selection==1)
        if (key(_left) or joy_getaxis(0,0)<-20)
          SelectSong--;
          if (SelectSong==0) SelectSong=5; end
          if (SelectSong==6) SelectSong=1; end
          frame(600);
        end
        if (key(_right) or joy_getaxis(0,0)>20)
          SelectSong++;
          if (SelectSong==0) SelectSong=5; end
          if (SelectSong==6) SelectSong=1; end
          frame(600);
        end
        if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0)) FadeSong(); SongPlayer(SelectSong); frame(600); end
      end
      if (Selection>1)
        if (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
          delete_text(0);
          repeat alpha-=5; frame(25); until(alpha<=20)
          return;
        end
      end
      frame(25);
    end
  end

  repeat
    if (Selection==Mode and alpha<255) alpha++; end
    if (Selection!=Mode and alpha>200) alpha--; end
    if (alpha<200) alpha+=5; end
    frame(25);
  until(Selection>1 and key(_enter) or Selection>1 and key(_space) or Selection>1 and key(_c) or Selection>1 and joy_getbutton(0,0))
  if (Selection!=Mode) repeat alpha-=5; frame(25); until(alpha<=20) end
  if (Selection==Mode)
    repeat size_y-=5; frame(25); until(size_y==5)
    repeat size_x-=5; frame(25); until(size_x==5)
    MainMenuBlip(x,y,z,Mode);
  end
end




process GameMenu();
begin
  signal(PlayerID, s_freeze_tree); signal(GameMenuID, s_freeze_tree);
  signal(type Sign, s_kill); signal(type MissionObjectiveSign, s_kill); signal(id, s_wakeup);
  MenuBackground(1);
  frame(2000); frame(2000);

  GameMenuOption(320,80,1,1);
  GameMenuOption(320,130,1,2);
  GameMenuOption(320,180,1,3);
  GameMenuOption(320,230,1,4);
  GameMenuOption(320,280,1,5);
  GameMenuOption(320,330,1,6);
  GameMenuOption(320,380,1,7);
  frame(1000);
  GameMenuSelector(320,80,0,0);

  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  play_wav(MenuSelect,0);
  if (Selection==1) signal(PlayerID, s_wakeup_tree); signal(GameMenuID, s_wakeup_tree); return; end
  if (Selection==2) frame(2000); frame(2000); signal(PlayerID, s_wakeup_tree); signal(GameMenuID, s_wakeup_tree); SaveGame(); end
  if (Selection==3) frame(2000); frame(2000); MissionBriefing1(1); end
  if (Selection==4) frame(2000); frame(2000); Database(2); end
  if (Selection==5) frame(2000); frame(2000); DisplayControls(); end
  if (Selection==6) frame(2000); frame(2000); Options(1); end
  if (Selection==7) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); MainMenu(); end
end



process GameMenuSelector(x,y,z,Mode);
begin
  graph=338; flags=16; Selection=1;
  repeat
    if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); Selection--; frame; end
    if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); Selection++; frame; end
    if (Selection==0) Selection=7; end
    if (Selection==8) Selection=1; end
    if (Selection==1 and y>80) repeat y--; frame(10); until(y==80) end
    if (Selection==2 and y>130) repeat y--; frame(10); until(y==130) end
    if (Selection==2 and y<130) repeat y++; frame(10); until(y==130) end
    if (Selection==3 and y<180) repeat y++; frame(10); until(y==180) end
    if (Selection==3 and y>180) repeat y--; frame(10); until(y==180) end
    if (Selection==4 and y<230) repeat y++; frame(10); until(y==230) end
    if (Selection==4 and y>230) repeat y--; frame(10); until(y==230) end
    if (Selection==5 and y<280) repeat y++; frame(10); until(y==280) end
    if (Selection==5 and y>280) repeat y--; frame(10); until(y==280) end
    if (Selection==6 and y<330) repeat y++; frame(10); until(y==330) end
    if (Selection==6 and y>330) repeat y--; frame(10); until(y==330) end
    if (Selection==7 and y<380) repeat y++; frame(10); until(y==380) end
    frame;
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
end



process GameMenuOption(x,y,z,Mode);
begin
  if (Mode==1) graph=339; end
  if (Mode==2) graph=348; end
  if (Mode==3) graph=349; end
  if (Mode==4) graph=347; end
  if (Mode==5) graph=352; end
  if (Mode==6) graph=335; end
  if (Mode==7) graph=337; end
  alpha=0; flags=16;
  repeat
    if (Selection==Mode and alpha<255) alpha++; end
    if (Selection!=Mode and alpha>200) alpha--; end
    if (alpha<200) alpha+=5; end
    frame(25);
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  if (Selection!=Mode) repeat alpha-=5; frame(25); until(alpha<=20) end
  if (Selection==Mode)
    repeat size_y-=5; frame(25); until(size_y==5)
    repeat size_x-=5; frame(25); until(size_x==5)
    MainMenuBlip(x,y,z,Mode);
  end
end



process SaveGame();
begin
    Save[0].SaveDone=1;
    Save[0].CurrentArea=CurrentArea;
    Save[0].SpiritBattle1Done=SpiritBattle1Done;
    Save[0].SpiritBattle1Done=SpiritBattle2Done;
    Save[0].ComputerGame1Done=ComputerGame1Done;
    Save[0].ComputerGame2Done=ComputerGame2Done;
    Save[0].FindMainComputerDone=FindMainComputerDone;
    Save[0].ComputerGame3Done=ComputerGame3Done;
    Save[0].ComputerGame4Done=ComputerGame4Done;
    Save[0].ComputerGame5Done=ComputerGame5Done;
    Save[0].Coin1Found=Coin1Found;
    Save[0].Coin2Found=Coin2Found;
    Save[0].DestructibleItem1=DestructibleItem1;
    Save[0].DestructibleItem2=DestructibleItem2;
    Save[0].BrainDestroyed=BrainDestroyed;
    Save[0].MemoryChair=MemoryChair;
    Save[0].TutorialText=TutorialText;
    Save[0].IntroText=IntroText;
    Save[0].BabbyCount=BabbyCount;
    Save[0].Boss1Done=Boss1Done;
    save("save.dat",Save);
end



process LoadGame();
begin
  load("save.dat",Save);
  if (Save[0].SaveDone==0) frame(2000); frame(2000); MainMenu(); return; end

  CurrentArea=Save[0].CurrentArea;
  SpiritBattle1Done=Save[0].SpiritBattle1Done;
  SpiritBattle2Done=Save[0].SpiritBattle2Done;
  ComputerGame1Done=Save[0].ComputerGame1Done;
  ComputerGame2Done=Save[0].ComputerGame2Done;
  FindMainComputerDone=Save[0].FindMainComputerDone;
  ComputerGame3Done=Save[0].ComputerGame3Done;
  ComputerGame4Done=Save[0].ComputerGame4Done;
  ComputerGame5Done=Save[0].ComputerGame5Done;
  Coin1Found=Save[0].Coin1Found;
  Coin2Found=Save[0].Coin2Found;
  DestructibleItem1=Save[0].DestructibleItem1;
  DestructibleItem2=Save[0].DestructibleItem2;
  BrainDestroyed=Save[0].BrainDestroyed;
  MemoryChair=Save[0].MemoryChair;
  TutorialText=Save[0].TutorialText;
  IntroText=Save[0].IntroText;
  BabbyCount=Save[0].BabbyCount;
  RestartLevel();

end



process GameOver();
begin
  //signal(PlayerID, s_freeze_tree);

  MenuBackground(1);
  frame(2000); frame(2000);

  GameOverMenuOption(320,80,1,1);
  GameOverMenuOption(320,320,1,5);
  GameOverMenuOption(320,380,1,6);
  frame(1000);
  GameOverMenuSelector(320,320,0,0);

  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))

  if (Selection==5) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); LoadGame(); end
  if (Selection==6) frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); MainMenu(); end
end



process GameOverMenuSelector(x,y,z,Mode);
begin
  graph=338; flags=16; Selection=5;
  repeat
    if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); Selection--; frame; end
    if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); Selection++; frame; end
    if (Selection==4) Selection=6; end
    if (Selection==7) Selection=5; end

    if (Selection==5 and y>320) repeat y--; frame(10); until(y==320) end
    if (Selection==6 and y<380) repeat y++; frame(10); until(y==380) end
    frame;
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
end



process GameOverMenuOption(x,y,z,Mode);
begin
  if (Mode==1) graph=353; end
  if (Mode==5) graph=354; end
  if (Mode==6) graph=337; end
  alpha=0; flags=16;
  repeat
    if (Selection==Mode and alpha<255) alpha++; end
    if (Selection!=Mode and alpha>200) alpha--; end
    if (alpha<200) alpha+=5; end
    frame(25);
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  if (Selection!=Mode) repeat alpha-=5; frame(25); until(alpha<=20) end
  if (Selection==Mode)
    repeat size_y-=5; frame(25); until(size_y==5)
    repeat size_x-=5; frame(25); until(size_x==5)
    MainMenuBlip(x,y,z,Mode);
  end
end



process StartRoom(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  PlayerHP=100;
  CurrentArea=0;
  MaxLevelY=520;

  Lighting(0);
  FadeSong();
  SongPlayer(5);

  LevelCollision=load_png("Levels/Level1/StartRoom_Collision.png");
  LevelMiddle=load_png("Levels/Level1/StartRoom_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(320,240,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(232,121,3,1,13); StreetLightHalo(232,39,2,5);
  StreetLight(558,121,3,1,13); StreetLightHalo(558,39,2,5);

  AquariumEel(333,300,9,0);
  LevelObject(333,294,8,22);

  frame(500);

  if (IntroText==0) VreidaIntro(); IntroText=1; end

  loop
    if (PlayerX>640) Level1Part0(30,370); end

    if (fget_dist(155,240,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        VreidaRoom1();
      end
    end

    if (fget_dist(335,220,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        VreidaRoom2();
      end
    end

    if (fget_dist(550,225,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        VreidaRoom3();
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end

    frame;
  end
end



process Level1Part0(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=10;
  MaxLevelY=850;

  Lighting(0);
  SongPlayer(5);

  LevelCollision=load_png("Levels/Level1/Area0_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area0_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1500,400,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(232,121,3,1,13); StreetLightHalo(232,36,2,5);
  StreetLight(557,121,3,1,13); StreetLightHalo(557,36,2,5);
  StreetLight(1124,121,3,1,13); StreetLightHalo(1124,36,2,5);
  StreetLight(1450,121,3,1,13); StreetLightHalo(1450,36,2,5);
  StreetLight(2889,192,3,1,13); StreetLightHalo(2889,110,2,5);

  MovingPlatform(2158,415,5,110,1);
  MovingPlatform(2513,415,5,110,1);

  frame(500);

  loop
    if (rand(0,2)==1) GreySmoke(646,262,8,4); end
    if (rand(0,2)==1) GreySmoke(640,274,8,4); end
    if (rand(0,2)==1) GreySmoke(966,262,8,3); end
    if (rand(0,2)==1) GreySmoke(972,274,8,3); end

    if (rand(0,2)==1) GreySmoke(1606,322,8,4); end
    if (rand(0,2)==1) GreySmoke(1600,335,8,4); end
    if (rand(0,2)==1) GreySmoke(1926,322,8,3); end
    if (rand(0,2)==1) GreySmoke(1932,335,8,3); end

    if (PlayerX<0) StartRoom(610,280); end
    if (PlayerX>3000) Level1Part1(30,350); end

    if (fget_dist(807,237,PlayerX,PlayerY)<120)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0) or TutorialText==0)
        signal(type Sign, s_kill);
        TutorialText1();
      end
    end

    if (fget_dist(1767,278,PlayerX,PlayerY)<120)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0) or TutorialText==1)
        signal(type Sign, s_kill);
        TutorialText2();
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end

    frame;
  end
end



process Level1Part1(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=10;
  MaxLevelY=850;

  Lighting(0);
  SongPlayer(5);

  LevelCollision=load_png("Levels/Level1/Area1_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area1_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1500,400,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(532,121,3,1,13); StreetLightHalo(532,39,2,5);
  StreetLight(795,121,3,1,13); StreetLightHalo(795,39,2,5);
  StreetLight(1054,121,3,1,13); StreetLightHalo(1054,39,2,5);

  StreetLight(1820,121,3,1,13); StreetLightHalo(1820,39,2,5);
  StreetLight(2079,121,3,1,13); StreetLightHalo(2079,39,2,5);

  StreetLight(2341,121,3,1,13); StreetLightHalo(2341,39,2,5);
  StreetLight(2603,121,3,1,13); StreetLightHalo(2603,39,2,5);

  StreetLight(2889,195,3,1,13); StreetLightHalo(2889,113,2,5);

  Spinner(670,625,4,0,3);
  Spinner(900,540,4,2,4);
  Spinner(920,600,4,3,3);

  frame(500);

  loop
    if (rand(0,2)==1) GreySmoke(314,323,8,3); end
    if (rand(0,2)==1) GreySmoke(320,336,8,3); end

    if (rand(0,2)==1) GreySmoke(1152,622,8,4); end
    if (rand(0,2)==1) GreySmoke(1146,634,8,4); end
    if (rand(0,2)==1) GreySmoke(1253,577,8,3); end
    if (rand(0,2)==1) GreySmoke(1259,589,8,3); end

    if (rand(0,2)==1) GreySmoke(1278,323,8,4); end
    if (rand(0,2)==1) GreySmoke(1272,335,8,4); end
    if (rand(0,2)==1) GreySmoke(1600,323,8,3); end
    if (rand(0,2)==1) GreySmoke(1606,335,8,3); end

    if (rand(0,2)==1) GreySmoke(2436,621,8,4); end
    if (rand(0,2)==1) GreySmoke(2430,634,8,4); end
    if (rand(0,2)==1) GreySmoke(2538,577,8,3); end
    if (rand(0,2)==1) GreySmoke(2544,589,8,3); end

    if (PlayerX<0) Level1Part0(2970,350); end
    if (PlayerX>3000) Level1Part2(30,470); end

    if (fget_dist(155,260,PlayerX,PlayerY)<120)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0) or TutorialText==2)
        signal(type Sign, s_kill);
        TutorialText3();
      end
    end

    if (fget_dist(1439,275,PlayerX,PlayerY)<120)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0) or TutorialText==3)
        signal(type Sign, s_kill);
        TutorialText4();
      end
    end

    if (ComputerGame4Done==0)
      if (fget_dist(1895,700,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame4)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame4)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame4();
          end
        end
      end
    end
    if (ComputerGame5Done==0)
      if (fget_dist(2222,700,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame5)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame5)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame5();
          end
        end
      end
    end

    if (ComputerGame4Done==1 and ComputerGame5Done==1 and TutorialText==4)
      frame(2000); frame(2000);
      TutorialText5();
      TutorialText=5;
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end

    frame;
  end
end



process Level1Part2(x,y);
begin
  let_me_alone();
  delete_text(0);

  ComputerGame4Done=0;
  ComputerGame5Done=0;

  MovingPlatformOn=0;
  CurrentArea=12;
  MaxLevelY=850;

  Lighting(0);
  SongPlayer(5);

  LevelCollision=load_png("Levels/Level1/Area2_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area2_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(750,350,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(158,215,3,1,13); StreetLightHalo(158,133,2,5);
  StreetLight(229,215,3,1,13); StreetLightHalo(229,133,2,5);

  StreetLight(1000,215,3,1,13); StreetLightHalo(1000,133,2,5);
  StreetLight(1072,215,3,1,13); StreetLightHalo(1072,133,2,5);

  LevelObject(1030,460,8,19);
  LevelObject(818,425,8,20);

  ComputerScreen(302,278,9,0,2);
  ComputerScreen(302,343,9,0,1);
  ComputerScreen(400,411,9,0,2);
  ComputerScreen(351,311,9,0,1);

  frame(500);

  loop
    if (rand(0,2)==1) GreySmoke(770,454,8,4); end
    if (rand(0,2)==1) GreySmoke(764,466,8,4); end

    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(971,474,8,4); GreySmoke(971,474,8,4); GreySmoke(971,474,8,4); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(1052,450,8,3); GreySmoke(1052,450,8,3); GreySmoke(1052,450,8,3); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(980,406,8,4); GreySmoke(980,406,8,4); GreySmoke(980,406,8,4); end

    if (fget_dist(1308,460,PlayerX,PlayerY)<70)
      if (exists(type Sign)==0) Sign(320,160,2,2); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(PlayerID, s_freeze_tree);
        play_wav(Tube,0);
        fade(0,0,0,8);
        frame(2000);
        fade(100,100,100,8);
        MainCityEntrance(190,460);
        return;
      end
    end

    if (fget_dist(795,440,PlayerX,PlayerY)<70)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        EnerGoreExamine1();
      end
    end

    if (fget_dist(1030,460,PlayerX,PlayerY)<70)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        EnerGoreExamine2();
      end
    end

    if (fget_dist(425,420,PlayerX,PlayerY)<140)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0) or TutorialText==4 or TutorialText==5)
        signal(type Sign, s_kill);
        EnerGoreExamine3();
        frame(500);
      end
    end

    if (PlayerX<0) Level1Part1(2970,340); end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end
    frame;
  end
end



process MainCityEntrance(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  if (CurrentArea==13) FadeSong(); end
  CurrentArea=12;
  MaxLevelY=750;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/CityEntrance_Collision.png");
  LevelMiddle=load_png("Levels/Level1/CityEntrance_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area1_Background.png");
  LevelSky=load_png("Levels/Level1/Area1_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(500,350,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  ComputerScreen(773,368,9,0,2);
  ComputerScreen(773,433,9,0,1);
  ComputerScreen(643,433,9,0,1);
  ComputerScreen(541,332,9,0,1);

  LevelObject(550,460,8,19);

  AmmoPack(690,470,5,1);

  frame(200);
  LevelObject(870,460,8,19);

  frame(300);

  loop

    if (fget_dist(191,458,PlayerX,PlayerY)<70)
      if (exists(type Sign)==0) Sign(320,160,2,2); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(PlayerID, s_freeze_tree);
        play_wav(Tube,0);
        fade(0,0,0,8);
        frame(2000);
        fade(100,100,100,8);
        Level1Part2(1307,456);
        return;
      end
    end

    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(588,474,8,4); GreySmoke(588,474,8,4); GreySmoke(588,474,8,4); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(572,450,8,3); GreySmoke(572,450,8,3); GreySmoke(572,450,8,3); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(500,406,8,4); GreySmoke(500,406,8,4); GreySmoke(500,406,8,4); end

    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(809,474,8,4); GreySmoke(809,474,8,4); GreySmoke(809,474,8,4); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(892,450,8,3); GreySmoke(892,450,8,3); GreySmoke(892,450,8,3); end
    if (rand(0,70)==1) play_wav(Steam,0); GreySmoke(820,406,8,4); GreySmoke(820,406,8,4); GreySmoke(820,406,8,4); end

    if (PlayerX>1000) Level1Part3(30,380); end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end
    frame;
  end
end



process Level1Part3(x,y);
private
  int BubbleCounter;
begin
  let_me_alone();
  delete_text(0);
  
  MovingPlatformOn=1;
  if (CurrentArea==12) FadeSong(); end
  CurrentArea=13;
  MaxLevelY=1050;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area3_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area3_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1500,500,10,LevelCollision);

  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  LightBot(900,510,4,0);
  LightBot(1130,100,4,0);

  StreetLight(36,225,3,1,1); StreetLightHalo(37,140,2,1);
  StreetLight(194,225,3,2,1); StreetLightHalo(195,140,2,1);
  StreetLight(358,225,3,1,1); StreetLightHalo(358,140,2,1);

  StreetLight(1387,540,3,1,1); StreetLightHalo(1386,455,2,1);
  StreetLight(1525,540,3,2,1); StreetLightHalo(1525,455,2,1);
  StreetLight(1677,540,3,1,1); StreetLightHalo(1678,455,2,1);

  MovingPlatform(2070,485,5,155,1);

  LevelObject(2376,233,6,9);
  LevelObject(2376,445,6,10);
  LevelObject(2376,339,7,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);
  AquariumFish(2376+rand(-60,60),339+rand(-60,60),9,1);

  SpaceParticles(500,200,18,1);

  FlyingHappyDroid(1600,320,7,0);

  ComputerScreen(33,197,9,0,2);
  ComputerScreen(165,301,9,0,3);
  ComputerScreen(39,319,9,0,1);

  BackgroundShip(-320,350,18,1);
  BackgroundShip(320,350,18,1);
  BackgroundShip(960,350,18,1);

  AmmoPack(1050,250,5,1);
  HealthPack(2600,740,5,1);

  DirectionArrow(2140,342,8,0);

  Spinner(2220,305,5,2,1);
  Spinner(2120,350,5,2,2);
  Spinner(2020,390,5,2,1);

  FlyFish(1120,450,5,0); frame(200);
  FlyFish(800,450,5,0);  frame(200);
  FlyFish(1120,250,5,0);

  frame;

  loop
    BubbleCounter++;
    if (BubbleCounter==100) IntroBubble(2376+rand(-100,100),438,14,234,80); BubbleCounter=0; end
    if (PlayerX>3000) Level1Part4(30,585); end
    if (PlayerX<0) MainCityEntrance(970,455); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part4(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=14;
  MaxLevelY=1050;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area4_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area4_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1250,500,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  MovingPlatform(1780,472,5,130,1);
  MovingPlatform(1530,230,5,50,1);

  StreetLight(50,466,3,1,2); StreetLightHalo(133,544,2,2);
  StreetLight(402,380,3,2,3); StreetLightHalo(319,456,2,2);
  StreetLight(546,435,3,1,2); StreetLightHalo(629,511,2,2);
  StreetLight(888,570,3,2,3); StreetLightHalo(805,648,2,2);

  StreetLight(1673,728,3,1,2); StreetLightHalo(1756,806,2,2);
  StreetLight(1678,410,3,2,2); StreetLightHalo(1759,488,2,2);
  StreetLight(2018,437,3,1,3); StreetLightHalo(1936,515,2,2);
  StreetLight(2152,516,3,2,2); StreetLightHalo(2235,594,2,2);

  ComputerScreen(1336,499,9,0,1);
  ComputerScreen(1359,545,9,0,2);
  ComputerScreen(1336,545,9,0,1);

  ComputerScreen(1336,604,9,0,2);
  ComputerScreen(1359,604,9,0,3);
  ComputerScreen(1359,627,9,0,1);

  ComputerScreen(1359,670,9,0,1);
  ComputerScreen(1359,716,9,0,2);
  ComputerScreen(1336,670,9,0,1);

  LightBot(1050,350,4,0);

  PsykoDrone(910,600,5,0);
  PsykoDrone(1300,325,5,1);

  AmmoPack(2185,680,5,3);

  DirectionArrow(1623,540,8,1);
  DirectionArrow(2440,530,8,2);

  FlyFish(2140,104,5,0); frame(200);
  FlyFish(2190,169,5,0); frame(200);
  FlyFish(2070,52,5,0);

  frame;

  loop
    if (PlayerX<0) Level1Part3(2970,420); end
    if (PlayerX>2500) Level1Part5(30,300); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part5(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=15;
  MaxLevelY=750;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area5_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area5_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1150,350,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(231,380,3,1,5); StreetLightHalo(148,459,2,3);
  StreetLight(723,415,3,1,5); StreetLightHalo(643,494,2,3);
  StreetLight(1395,263,3,1,4); StreetLightHalo(1478,340,2,3);
  StreetLight(1739,432,3,1,5); StreetLightHalo(1656,510,2,3);

  LevelObject(1042,633,8,2);
  AquariumFish(1007,614,9,2);
  AquariumFish(1076,636,9,2);
  AquariumFish(1019,656,9,2);

  LevelObject(1045,310,6,3);
  LevelObject(1045,310,7,5);

  LevelObject(1152,361,6,4);
  LevelObject(935,360,6,4);

  LevelObject(1108,362,6,6);
  LevelObject(979,361,6,6);

  DarknessParticle2(1050,330,3,0);
  DarknessParticle2(1050,330,3,0);
  DarknessParticle2(1050,330,3,0);

  GhostFish(1045,450,5,700,1380,1);

  ComputerScreen(2018,178,9,0,2);
  ComputerScreen(2105,161,9,0,3);
  ComputerScreen(2101,223,9,0,1);

  HooverTrooper(1830,290,5,1790,2220,0);

  HealthPack(1700,390,5,1);

  frame(500);

  loop
    if (PlayerX<0) Level1Part4(2470,170); end
    if (PlayerX>2300) Level1Part6(30,230); end
    if (rand(1,20)==1) DarknessParticle(979,361,4,1); end
    if (rand(1,20)==1) DarknessParticle(1107,361,4,1); end
    if (rand(1,10)==1) Sparks(1172,363,4,3); end
    if (rand(1,10)==1) Sparks(912,362,4,3); end

    if (exists(type GhostFish)==0)
      if (fget_dist(1045,380,PlayerX,PlayerY)<150)
        if (exists(type Sign)==0) Sign(320,160,2,3); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          signal(type Sign, s_kill);
          GEngineExamine();
        end
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part6(x,y);
private
  int DarknessOn;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=16;
  MaxLevelY=2550;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area6_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area6_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area6_Background.png");
  LevelSky=load_png("Levels/Level1/Area6_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(350,1250,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(311,772,2,1,1); StreetLightHalo(311,690,2,1);
  StreetLight(468,772,2,2,1); StreetLightHalo(467,690,2,1);
  StreetLight(623,772,2,1,1); StreetLightHalo(622,690,2,1);

  StreetLight(76,1120,2,1,1); StreetLightHalo(77,1038,2,1);
  StreetLight(232,1120,2,2,1); StreetLightHalo(232,1038,2,1);
  StreetLight(388,1120,2,1,1); StreetLightHalo(388,1038,2,1);

  StreetLight(311,1440,2,1,1); StreetLightHalo(311,1360,2,1);
  StreetLight(468,1440,2,2,1); StreetLightHalo(467,1360,2,1);
  StreetLight(623,1440,2,1,1); StreetLightHalo(622,1360,2,1);

  LevelObject(408,2297,7,7);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);
  AquariumFish(408+rand(-160,160),2297+rand(-150,150),9,3);

  LevelObject(292,2301,0,8);
  LevelObject(388,2212,0,8);
  LevelObject(458,2376,0,8);
  LevelObject(580,2342,0,8);

  ComputerScreen(36,85,9,0,1);
  ComputerScreen(101,84,9,0,1);
  ComputerScreen(224,84,9,0,1);

  SpiderMine(250,300,5,0);
  SpiderMine(214,627,5,0);
  SpiderMine(486,974,5,0);

  SpiderMine(214,1295,5,0);
  SpiderMine(284,1657,5,0);
  SpiderMine(482,1657,5,0);
  SpiderMine(212,2061,5,0);

  frame(500);

  loop
    if (PlayerX<0) Level1Part5(2270,290); end
    if (PlayerX>700) Level1Part7(30,300); end
    if (PlayerY>1200 and DarknessOn==0)
      signal(type StreetLight, s_kill); signal(type StreetLightHalo, s_kill);  signal(type ComputerScreen, s_kill);
      DarknessOn=1; DarknessMask(); play_wav(PowerDown,0);
    end

    if (fget_dist(430,2300,PlayerX,PlayerY)<200)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        GhostFishExamine();
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part7(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=17;
  MaxLevelY=550;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area7_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area7_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1750,250,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(430,229,3,1,2); StreetLightHalo(511,306,2,2);
  StreetLight(727,107,3,1,3); StreetLightHalo(644,184,2,2);
  StreetLight(1094,276,3,0,3); StreetLightHalo(1012,354,2,2);
  StreetLight(2033,133,3,1,2); StreetLightHalo(2116,210,2,2);
  StreetLight(2436,257,3,1,3); StreetLightHalo(2354,335,2,2);

  LightBot(1365,220,4,0);

  Spinner(1720,250,5,2,1);
  Spinner(1780,350,5,2,2);
  Spinner(1820,290,5,2,2);

  GunShip1(3000,270,5,0);

  PsykoDrone(735,300,5,3);

  ComputerScreen(168,174,9,0,2);
  ComputerScreen(220,175,9,0,1);
  ComputerScreen(284,175,9,0,2);

  AmmoPack(1715,390,5,2);
  HealthPack(2610,390,5,1);

  frame(500);

  loop
    if (PlayerX<0) Level1Part6(670,2400); end
    if (PlayerX>3500) Level1Part8(30,700); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part8(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  if (CurrentArea==19) FadeSong(); end
  CurrentArea=18;
  MaxLevelY=850;

  Lighting(0);
  SongPlayer(1);

  LevelCollision=load_png("Levels/Level1/Area8_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area8_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(2500,400,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(505,554,3,1,3); StreetLightHalo(423,631,2,2);
  StreetLight(530,461,3,1,2); StreetLightHalo(612,539,2,2);
  StreetLight(884,648,3,1,2); StreetLightHalo(966,725,2,2);
  StreetLight(1453,557,3,1,3); StreetLightHalo(1372,635,2,2);
  StreetLight(1957,574,3,1,2); StreetLightHalo(2039,652,2,2);

  StreetLight(4695,554,2,1,6); StreetLightHalo(4695,472,2,4);
  StreetLight(4825,554,2,2,6); StreetLightHalo(4825,472,2,4);
  StreetLight(4952,554,2,1,6); StreetLightHalo(4952,472,2,4);

  AmmoPack(820,700,5,1);

  LightBot(3960,395,4,0);

  HooverTrooper(1500,690,5,1470,1925,0);

  FlyFish(580,600,5,0); frame(200);
  FlyFish(475,532,5,0); frame(200);
  FlyFish(590,425,5,0);

  PsyOwl(2500,519,5,0);
  PsyOwl(3500,519,5,0);

  frame;

  loop
    if (PlayerX<0) Level1Part7(3470,390); end
    if (PlayerX>5000) PsykodromeEntry(30,460); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process PsykodromeEntry(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  if (CurrentArea==18) FadeSong(); end
  CurrentArea=19;
  MaxLevelY=650;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/PsykodromeEntry_Collision.png");
  LevelMiddle=load_png("Levels/Level1/PsykodromeEntry_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(500,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  LevelObject(619,400,7,18);

  StreetLight(549,407,8,2,10); StreetLightHalo(471,490,8,1);
  StreetLight(700,407,8,1,9); StreetLightHalo(777,490,8,1);

  frame(500);

  loop
    if (PlayerX>1000) Level1Part9(30,390,0); end
    if (PlayerX<0) Level1Part8(4970,690); end

    if (fget_dist(620,400,PlayerX,PlayerY)<130)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        LucidorExamine();
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part9(x,y,Mode);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=19;
  MaxLevelY=650;

  Lighting(Mode);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area9_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area9_Middle.png");
  //LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  //LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,0,0,12);
  LevelCheckID=LevelCheck(800,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  BoomerTrooper(490,370,5,200,1100,0);

  if (SpiritBattle1Done==0) LevelObject(1397,315,8,11); end

  frame(500);

  loop
    if (PlayerX<0) PsykodromeEntry(970,460); end
    if (PlayerX>1600) Level1Part10(30,310); end
    if (PlayerX=>1240 and SpiritBattle1Done==0) SpiritBattle1(); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type SpiritBattlePlayer)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part10(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=20;
  MaxLevelY=1550;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area10_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area10_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(750,750,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(105,147,2,1,1); StreetLightHalo(104,61,2,1);
  StreetLight(314,147,2,1,1); StreetLightHalo(313,61,2,1);
  StreetLight(514,147,2,1,1); StreetLightHalo(513,61,2,1);

  StreetLight(483,626,2,1,1); StreetLightHalo(483,540,2,1);
  StreetLight(695,626,2,1,1); StreetLightHalo(695,540,2,1);
  StreetLight(1092,933,2,1,1); StreetLightHalo(1092,847,2,1);

  StreetLight(485,1170,2,1,1); StreetLightHalo(485,1084,2,1);
  StreetLight(684,1170,2,1,1); StreetLightHalo(684,1084,2,1);
  StreetLight(934,1170,2,1,1); StreetLightHalo(934,1084,2,1);

  StreetLight(1392,1208,2,1,1); StreetLightHalo(1392,1122,2,1);

  ComputerScreen(1086,722,9,0,2);
  ComputerScreen(1144,723,9,0,1);
  ComputerScreen(1087,775,9,0,2);
  ComputerScreen(1145,776,9,0,1);

  ComputerScreen(985,223,9,0,4);
  ComputerScreen(928,275,9,0,5);

  ComputerScreen(1055,399,9,0,6);
  ComputerScreen(1113,400,9,0,4);
  ComputerScreen(1112,347,9,0,5);

  ComputerScreen(1095,189,9,0,6);

  FlyingHappyDroid(470,240,7,1);

  BoomerTrooper(480,990,5,390,900,0);

  SpiderMine(495,512,5,0);
  SpiderMine(760,512,5,0);

  SpiderMine(942,820,5,0);
  SpiderMine(868,1342,5,0);
  SpiderMine(731,1400,5,0);

  AmmoPack(563,1440,5,1);
  HealthPack(485,1440,5,1);

  frame(500);

  loop
    if (PlayerX<0) Level1Part9(1570,390,0); end
    if (PlayerX>1500) PsykodromeCorridor(30,410); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process PsykodromeCorridor(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=20;
  MaxLevelY=550;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/PsykodromeCorridor_Collision.png");
  LevelMiddle=load_png("Levels/Level1/PsykodromeCorridor_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(750,250,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  PsyLord(700,80,5,1);

  frame(500);

  loop
    if (PlayerX<0) Level1Part10(1470,1400); end
    if (PlayerX>1500) Level1Part11(30,800); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part11(x,y);
private
  int BabbyCounter;
  int BarrierID;
  int PauseCounter;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=21;
  MaxLevelY=1050;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area11_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area11_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1000,500,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  MovingPlatform(622,470,5,140,1);
  MovingPlatform(1438,470,5,140,1);
  MovingPlatform(672,470,5,320,0);

  StreetLight(885,191,2,1,8); StreetLightHalo(807,108,2,1);
  StreetLight(1251,190,2,2,7); StreetLightHalo(1332,107,2,1);

  ComputerScreen(77,702,9,0,6);
  ComputerScreen(123,702,9,0,4);
  ComputerScreen(146,748,9,0,5);
  ComputerScreen(77,748,9,0,4);
  ComputerScreen(146,725,9,0,4);

  ComputerScreen(1600,311,9,1,5);
  ComputerScreen(1646,334,9,1,6);

  ComputerScreen(363,334,9,1,6);
  ComputerScreen(409,311,9,1,4);

  HooverTrooper(915,800,5,715,1180,0);

  if (ComputerGame1Done!=1 and ComputerGame2Done!=1) BarrierID=LevelObject(1603,714,4,13); end

  frame(500);

  loop
    BabbyCounter++;
    if (BabbyCounter==40) BabbyMover(605,592,8,1); end
    if (BabbyCounter==80) BabbyMover(173,275,8,2); BabbyCounter=0; end

    if (PlayerX<0) PsykodromeCorridor(1470,410); end
    if (PlayerX>2000) Level1Part12(30,370); end

    if (ComputerGame1Done==0)
      if (fget_dist(386,367,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame1)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame1)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame1();
          end
        end
      end
    end
    if (ComputerGame2Done==0)
      if (fget_dist(1624,368,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame2)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame2)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame2();
          end
        end
      end
    end
    if (exists(type ComputerGame1))
      if (key(_esc) or joy_getbutton(0,1))
        ArmID.HP=2;
        signal(type ComputerGameScreen, s_kill);
        signal(type ComputerGameScreenObject, s_kill);
        signal(type ComputerGame1, s_kill);
        signal(PlayerID, s_wakeup_tree);
      end
    end
    if (exists(type ComputerGame2))
      if (key(_esc) or joy_getbutton(0,1))
        ArmID.HP=2;
        signal(type ComputerGameScreen, s_kill);
        signal(type ComputerGameScreenEnemy1, s_kill);
        signal(type ComputerGameScreenObject, s_kill);
        signal(type ComputerGame2, s_kill);
        signal(PlayerID, s_wakeup_tree);
      end
    end

    if (ComputerGame1Done==1 and ComputerGame2Done==1 and exists(BarrierID))
      signal(BarrierID, s_kill);
      PauseCounter=0;
      repeat
        PauseCounter++;
        BabbyCounter++;
        if (BabbyCounter==40) BabbyMover(605,592,8,1); end
        if (BabbyCounter==80) BabbyMover(173,275,8,2); BabbyCounter=0; end
        frame;
      until(PauseCounter==100)
      MissionObjectiveSign(1,1);
    end
    if (ComputerGame1Done!=1 or ComputerGame2Done!=1)
      if (PlayerID.y>550 and PlayerID.x=>1565) PlayerID.x=1565; end
    end
    if (ComputerGame1Done!=1 or ComputerGame2Done!=1)
      if (fget_dist(1603,714,PlayerX,PlayerY)<140)
        if (exists(type MissionObjectiveSign)==0) MissionObjectiveSign(1,0); end
        if (exists(type MissionObjectiveArrow)==0)
          if (ComputerGame1Done!=1) MissionObjectiveArrow(386,367,0); end
          if (ComputerGame2Done!=1) MissionObjectiveArrow(1840,405,1); end
        end
      end
    end

    if (key(_enter) or joy_getbutton(0,6))
      if (exists(type MissionObjectiveSign)==0)
        if (ComputerGame1Done!=1 or ComputerGame2Done!=1) MissionObjectiveSign(1,0); end
        if (ComputerGame1Done==1 and ComputerGame2Done==1) MissionObjectiveSign(1,1); end
      end
      if (exists(type MissionObjectiveArrow)==0)
        if (ComputerGame1Done!=1) MissionObjectiveArrow(215,405,0); end
        if (ComputerGame2Done!=1) MissionObjectiveArrow(1624,368,1); end
      end
    end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill); signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        PauseCounter=0;
        repeat
          PauseCounter++;
          BabbyCounter++;
          if (BabbyCounter==40) BabbyMover(605,592,8,1); end
          if (BabbyCounter==80) BabbyMover(173,275,8,2); BabbyCounter=0; end
          frame;
        until(PauseCounter==10)
      end
    end

    frame;
  end
end



process Level1Part12(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=22;
  MaxLevelY=650;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area12_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area12_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area6_Background.png");
  LevelSky=load_png("Levels/Level1/Area6_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(800,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  ComputerScreen(223,321,9,0,2);
  ComputerScreen(259,362,9,0,1);
  ComputerScreen(1341,362,9,0,2);
  ComputerScreen(1377,321,9,0,1);

  ComputerScreen(107,289,9,1,4);
  ComputerScreen(107,335,9,1,5);
  ComputerScreen(130,335,9,1,4);
  ComputerScreen(153,312,9,1,6);
  ComputerScreen(176,289,9,1,4);

  ComputerScreen(330,289,9,0,4);
  ComputerScreen(376,312,9,0,5);
  ComputerScreen(353,335,9,0,6);

  MovingFloor(665,461,4,1);
  MovingFloor(736,461,4,1);
  MovingFloor(807,461,4,0);
  MovingFloor(878,461,4,0);
  MovingFloor(949,461,4,2);
  MovingFloor(1020,461,4,2);

  HealthPack(530,390,5,1);

  FlyFish(712,240,5,1); frame(200);
  FlyFish(816,388,5,1); frame(200);
  FlyFish(935,287,5,1);

  frame;

  loop
    if (PlayerX<0) Level1Part11(1970,800); end
    if (PlayerX=>940) PlayerID.X=940; end
    if (PlayerY=>620) TunnelFall(); return; end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part13(x,y);
private
  int DoorID;
  int DoorOpen;
  int AllDone;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=23;
  MaxLevelY=2550;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area13_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area13_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area13_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1500,1250,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  MovingPlatform(380,1919,5,200,1);
  MovingPlatform(2828,2108,5,106,1);
  MovingPlatform(2250,1542,5,280,1);
  MovingPlatform(2220,630,5,210,1);

  StreetLight(1142,1421,2,1,9); StreetLightHalo(1221,1506,2,1); LightInsects(1221,1506,3,0); LightInsects(1221,1506,3,1);
  StreetLight(2205,1421,2,2,10); StreetLightHalo(2129,1505,2,1); LightInsects(2129,1505,3,0); LightInsects(2129,1505,3,1);

  PsyLord(580,1710,5,0);
  PsyLord(2680,1625,5,0);

  FindableItem(1525,276,5,0);
  FindableItem(2910,2415,5,1);

  PsykoDrone(1000,2280,5,1);
  PsykoDrone(2370,2280,5,2);

  Spinner(1014,1287,5,2,1);
  //Spinner(1153,1355,5,2,2);
  //Spinner(1797,679,5,2,1);
  //Spinner(1589,714,5,2,2);
  Spinner(2451,1148,5,2,1);
  Spinner(2666,1207,5,2,2);

  AmmoPack(2692,1710,5,3);
  HealthPack(1670,320,5,1);

  DoorID=LevelObject(1689,952,9,14);

  frame;
  PsyOwl(2563,411,5,0);

  frame(400);

  MissionObjectiveSign(1,2);
  MissionObjectiveArrow(1674,2215,2);

  loop

    if (fget_dist(1674,2215,PlayerX,PlayerY)<150)
      if (FindMainComputerDone==0)
          signal(type MissionObjectiveSign, s_kill);
          FindMainComputerDone=1;
          MissionObjectiveSign(1,3);
          MissionObjectiveArrow(370,1184,3);
          MissionObjectiveArrow(2722,456,4);
          frame(2000); frame(1000);
          MissionObjectiveSign(2,4);
          MissionObjectiveArrow(1525,276,5);
          MissionObjectiveArrow(2910,2415,6);
      end
    end

    if (DoorOpen==0)
      if (fget_dist(1689,951,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0) Sign(320,160,2,1); end
      end
    end
    if (DoorOpen==1)
      if (fget_dist(1689,951,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0) Sign(320,160,2,2); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          DoorID.HP=1; signal(PlayerID, s_freeze_tree); play_wav(OpenDoor1,0);
          frame(2000); frame(2000); fade(0,0,0,16);
          frame(2000);
          fade(100,100,100,1);
          Level1Part14(400,-20);
          return;
        end
      end
    end

    if (FindMainComputerDone==1 and ComputerGame4Done==1 and ComputerGame5Done==1 and Coin1Found==1 and Coin2Found==1 and ComputerGame3Done==0)
      if (fget_dist(1674,2215,PlayerX,PlayerY)<150)
        if (exists(type Sign)==0 and exists(type ComputerGame3)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame3)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerHackTutorial3();
            frame(500);
            ComputerGame3();
          end
        end
      end
      Alldone=1;
      if (AllDone==0)
        AllDone=1;
        signal(type MissionObjectiveSign, s_kill);
        MissionObjectiveSign(1,2);
        MissionObjectiveArrow(1674,2215,9);
      end
    end

    if (ComputerGame3Done==1)
      if (DoorOpen==0)
        signal(PlayerID, s_freeze_tree);
        CameraView(1675,2275,2);
        repeat frame; until(exists(type CameraView)==0)
        signal(PlayerID, s_wakeup_tree);
        scroll[0].camera=PlayerID;
        MissionObjectiveSign(1,5);
        MissionObjectiveArrow(1689,952,10);
      end
      DoorOpen=1;
    end

    if (ComputerGame4Done==0)
      if (fget_dist(370,1184,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame4)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame4)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame4();
          end
        end
      end
    end
    if (ComputerGame5Done==0)
      if (fget_dist(2722,456,PlayerX,PlayerY)<100)
        if (exists(type Sign)==0 and exists(type ComputerGame5)==0) Sign(320,160,2,0); end
        if (key(_space) or key(_c) or joy_getbutton(0,0))
          if (exists(type ComputerGame5)==0)
            signal(type Sign, s_kill);
            signal(type MissionObjectiveSign, s_kill);
            ComputerGame5();
          end
        end
      end
    end
    if (exists(type ComputerGame4))
      if (key(_esc) or joy_getbutton(0,1))
        ArmID.HP=2;
        signal(type ComputerGameScreen, s_kill);
        signal(type ComputerGameScreenObject, s_kill);
        signal(type ComputerGameScreenArrow, s_kill);
        signal(type ComputerGame4, s_kill);
        signal(PlayerID, s_wakeup_tree);
      end
    end
    if (exists(type ComputerGame5))
      if (key(_esc) or joy_getbutton(0,1))
        ArmID.HP=2;
        signal(type ComputerGameScreen, s_kill);
        signal(type ComputerGameDodgeFile, s_kill);
        signal(type ComputerGameTracer, s_kill);
        signal(type ComputerGameScreenObject, s_kill);
        signal(type ComputerGame2, s_kill);
        signal(PlayerID, s_wakeup_tree);
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end
    if (key(_enter) or joy_getbutton(0,6))
      if (exists(type MissionObjectiveSign)==0)
        if (FindMainComputerDone==0) MissionObjectiveSign(1,2); end
        if (FindMainComputerDone==1 and ComputerGame4Done==0 or ComputerGame5Done==0) MissionObjectiveSign(1,3); end
        if (FindMainComputerDone==1 and Coin1Found==0 or FindMainComputerDone==1 and Coin2Found==0) MissionObjectiveSign(2,4); end
        if (DoorOpen==1) MissionObjectiveSign(1,5); end
        if (FindMainComputerDone==1 and ComputerGame4Done==1 and ComputerGame5Done==1 and Coin1Found==1 and Coin2Found==1) MissionObjectiveSign(1,2); end
      end
    end

    frame;
  end
end



process Level1Part14(x,y);
private
  int WaterCounter;
  int WaterGraph;
  int DelayCounter;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=24;
  MaxLevelY=1250;
  WaterCounter=95;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area14_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area14_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");
  WaterGraph=load_png("Levels/Level1/Area14_Water.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(400,500,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(234,85,3,1,1); StreetLightHalo(234,5,2,1);
  StreetLight(557,85,3,1,1); StreetLightHalo(557,5,2,1);

  StreetLight(185,522,3,1,1); StreetLightHalo(185,442,2,1);
  StreetLight(616,522,3,1,1); StreetLightHalo(616,442,2,1);

  LevelObject(399,723,6,3);
  LevelObject(399,723,7,5);

  LevelObject(255,677,6,15);
  LevelObject(544,676,6,15);

  LevelObject(289,677,6,6);
  LevelObject(509,676,6,6);

  DarknessParticle2(399,723,3,0);
  DarknessParticle2(399,723,3,0);
  DarknessParticle2(399,723,3,0);

  DestructibleItem(179,562,6,1);
  DestructibleItem(619,561,6,0);

  frame(500);
  MissionObjectiveSign(1,6);
  MissionObjectiveArrow(179,562,8);
  MissionObjectiveArrow(622,562,7);

  loop

    if (key(_enter) or joy_getbutton(0,6))
      if (exists(type MissionObjectiveSign)==0)
        if (exists(type DestructibleItem)) MissionObjectiveSign(1,6); end
      end 
    end

    if (exists(type DestructibleItem)==0)
      if (GlobalRed==100) GlobalRed=150; end
      if (WaterCounter==95)
        ctype=c_scroll; x=400; y-=500; z=11; flags=16; graph=WaterGraph;
        signal(type StreetLight, s_kill);
        signal(type StreetLightHalo, s_kill);
        DelayCounter=10; play_wav(Warning,0);
      end
      if (y<570) y+=10; end
      if (rand(1,2)==1) CreateSparks(x+rand(-300,300),y+500+rand(-20,10),4,5); CreateSparks(x+rand(-300,300),y+500+rand(-20,10),4,6); end
      if (WaterCounter==1) LevelCheckID=LevelCheck(400,500,10,0); LevelObject(400,500,10,15); end
      if (WaterCounter<80)
        if (collision(PlayerID))
          PlayerID.z=12;
          PlayerWeaponID.z=12;
          if (DelayCounter>0) DelayCounter--; end
          if (DelayCounter==0)
            if (PlayerID.x>410) PlayerID.x-=10; end
            if (PlayerID.x<390) PlayerID.x+=10; end
            PlayerID.y+=4;
          end
        end
      end
      if (PlayerID.y>1050) Level1Part15(214,-100); return; end
      if (WaterCounter>0) WaterCounter--; end
    end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0)
        signal(type Sign, s_kill);
        signal(type MissionObjectiveSign, s_kill);
        GameMenuID=id;
        GameMenu();
        frame(1000);
      end
    end

    frame;
  end
end



process Level1Part15(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=25;
  MaxLevelY=690;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area15_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area15_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(750,320,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  play_wav(Water1,0);
  SewerWater(760,461,3,0);

  FallingSludge(210,-30,3,0);
  FallingSludge(210,-177,3,1);

  Sluddar1(1000,418,5,900,1350,0);

  FlyFish(1170,340,5,2);

  frame(500);

  loop
    if (PlayerX>1500) Level1Part16(30,380); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part16(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=26;
  MaxLevelY=850;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area16_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area16_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1250,400,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  SewerWater(740,429,3,0);
  SewerWater(2257,740,3,1);
  SewerWater2(1499,429,4,0);

  Sluddar1(350,387,5,250,1260,0);
  Sluddar1(1770,698,5,1770,2270,0);

  FlyFish(1760,310,5,2);

  DarknessMask2();

  frame(500);

  loop
    if (PlayerX<0) Level1Part15(1470,410); end
    if (PlayerX>2500) Level1Part17(30,250); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part17(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=27;
  MaxLevelY=900;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area17_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area17_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1100,425,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(185,348,3,1,3); StreetLightHalo(101,427,2,2);
  StreetLight(470,266,3,1,2); StreetLightHalo(553,343,2,2);

  StreetLight(852,231,3,1,3); StreetLightHalo(770,308,2,2);
  StreetLight(2033,404,3,1,2); StreetLightHalo(2115,481,2,2);

  StreetLight(1278,512,2,1,11); StreetLightHalo(1195,434,2,1);
  StreetLight(1467,464,2,2,12); StreetLightHalo(1551,386,2,1);

  SewerWater2(58,295,4,1);

  AmmoPack(280,300,5,1);
  HealthPack(430,300,5,1);

  GhostFish2(735,490,950,420,1250,500,5,0);
  GhostFish2(1515,510,1715,440,1925,360,5,0);

  frame(500);

  loop
    if (PlayerX<0) Level1Part16(2470,680); end
    if (PlayerX>2200) Level1Part18(30,730); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part18(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=28;
  MaxLevelY=1250;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area18_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area18_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1250,600,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  SewerWater(1242,1100,3,0);

  MovingPlatform(1920,824,5,70,1);
  MovingPlatform(2254,516,5,70,1);

  Sluddar1(860,1058,5,760,1710,0);

  FlyFish(760,690,5,2);
  FlyFish(1630,690,5,2);

  AmmoPack(2100,720,5,2);
  HealthPack(2410,430,5,1);

  DarknessMask2();

  frame(500);

  loop
    if (PlayerX<0) Level1Part17(2170,335); end
    if (PlayerX>2500) Elevator1(30,2910); end
    if (rand(1,15)==1) SewerDrop(rand(510,1965),228,4,0); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Elevator1(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=1;
  CurrentArea=285;
  MaxLevelY=3050;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Elevator_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Elevator_Collision.png");
  LevelBackground=load_png("Levels/Level1/Tunnel_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(320,1500,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  MovingPlatform(400,2950,5,1316,2);

  frame;

  FallMine(608,2500,5,3);
  FallMine(32,2600,5,2);

  FallMine(608,2200,5,3);
  FallMine(32,2100,5,2);

  FallMine(32,1900,5,2);
  FallMine(32,1850,5,2);
  FallMine(32,1800,5,2);

  FallMine(608,1600,5,3);
  FallMine(608,1550,5,3);
  FallMine(608,1500,5,3);

  FallMine(608,1100,5,3);
  FallMine(32,1000,5,2);

  FallMine(608,800,5,3);
  FallMine(32,850,5,2);

  FallMine(608,650,5,3);
  FallMine(32,600,5,2);

  PsykoDrone(120,2000,5,1);
  PsykoDrone(120,700,5,2);

  FlyFish(320,1000,5,2);
  FlyFish(320,1700,5,2);

  frame(400);

  loop
    if (PlayerX<0) Level1Part18(2460,435); end
    if (PlayerX>640) Level1Part19(40,450,0); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end

    frame;
  end
end



process Level1Part19(x,y,Mode);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=29;
  MaxLevelY=650;

  Lighting(Mode);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area19_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area19_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(500,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  frame(500);

  loop
    if (PlayerX<0) Elevator1(610,240); end
    if (PlayerX>1000) Level1Part20(30,460); end
    if (PlayerX=>315 and SpiritBattle2Done==0) SpiritBattle2(PlayerX,PlayerY); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type SpiritBattlePlayer)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end

    frame;
  end
end



process Level1Part20(x,y);
private
  int DestructItem1ID;
  int DestructItem2ID;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=30;
  MaxLevelY=650;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area20_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area20_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(1000,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  if (BrainDestroyed==0) DestructItem1ID=DestructibleItem(1045,401,7,2); end
  if (BrainDestroyed==0) DestructItem2ID=DestructibleItem(1045,394,6,3); end
  if (BrainDestroyed==1) DestructItem1ID=DestructibleItem(1045,401,7,2); DestructItem1ID.HP=0; end

  CreepingBrain(470,400,5,0);
  CreepingBrain(1650,400,5,0);
  CreepingBrain(1000,400,5,0);

  frame(500);

  loop
    if (PlayerX<0) Level1Part19(970,460,0); end
    if (PlayerX>2000) Level1Part21(30,460); end

    if (BrainDestroyed==0)
      if (exists(DestructItem2ID)==0)
        DestructItem1ID.HP=0;
      end
    end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part21(x,y);
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=31;
  MaxLevelY=650;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area21_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area21_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(500,300,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  CreepingBrain(250,400,5,0);
  CreepingBrain(750,400,5,0);

  frame(500);

  loop
    if (PlayerX<0) Level1Part20(1970,460); end
    if (PlayerX>1000) Level1Part22(30,370); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  end
end



process Level1Part22(x,y);
private
  int Lamp1ID;
  int Lamp2ID;
  int Lamp3ID;
  int Lamp4ID;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  CurrentArea=32;
  MaxLevelY=650;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area22_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area22_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(900,240,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);
  AquariumFish(954+rand(-50,50),236+rand(-40,40),9,1);

  LevelObject(1075,271,8,17);
  LevelObject(1245,317,9,21);

  StreetLightHalo(468,195,2,6);
  StreetLightHalo(780,195,2,6);
  StreetLightHalo(1134,156,2,6);
  StreetLightHalo(1481,252,2,6);

  AmmoPack(135,350,5,1);
  HealthPack(295,350,5,1);

  frame(500);

  loop
    if (PlayerX<0) Level1Part21(970,460); end
    if (PlayerX>1800) Level1Part23(30,1870); end

    if (exists(Lamp1ID)==0) Lamp1ID=AlgaeLamp(468,22,2,0); end
    if (exists(Lamp2ID)==0) Lamp2ID=AlgaeLamp(780,22,2,0); end
    if (exists(Lamp3ID)==0) Lamp3ID=AlgaeLamp(1134,22,2,0); end
    if (exists(Lamp4ID)==0) Lamp4ID=AlgaeLamp(1481,22,2,0); end

    if (fget_dist(467,329,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine1();
      end
    end

    if (fget_dist(634,345,PlayerX,PlayerY)<50)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine2();
      end
    end

    if (fget_dist(967,352,PlayerX,PlayerY)<50)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine3();
      end
    end

    if (fget_dist(1103,369,PlayerX,PlayerY)<50)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine4();
      end
    end

    if (fget_dist(1244,358,PlayerX,PlayerY)<50)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine5();
      end
    end

    if (fget_dist(1440,350,PlayerX,PlayerY)<50)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine6();
      end
    end

    if (fget_dist(1585,350,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,3); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(type Sign, s_kill);
        SolkExamine7();
      end
    end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end

    frame;
  end
end



process Level1Part23(x,y);
begin
  let_me_alone();
  delete_text(0);

  SolkBossOn=1;
  MovingPlatformOn=0;
  CurrentArea=33;
  MaxLevelY=2050;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area23_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area23_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(600,1000,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLight(69,1750,2,1,6); StreetLightHalo(69,1668,2,4);
  StreetLight(1129,1750,2,1,6); StreetLightHalo(1129,1668,2,4);

  if (Boss1Done==0) SolkBoss1(600,1700,5,0); end

  frame(500);

  loop
    if (PlayerX<0) Level1Part22(1770,365); end
    if (PlayerX>1200) Level1Part24(30,420); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type SpiritBattlePlayer)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end
    if (SolkBossOn==2) SolkBoss2(625,200,5,0); SolkBossOn=3; end
    if (SolkBossOn>2)
      if (PlayerID.y>1650 and PlayerID.x<=184) PlayerID.x=184; end
      if (PlayerID.y>1650 and PlayerID.x=>1014) PlayerID.x=1014; end
    end
    frame;
  end
end



process Level1Part24(x,y);
private
  int Lamp1ID;
  int Lamp2ID;
  int Lamp3ID;
begin
  let_me_alone();
  delete_text(0);

  SolkBossOn=0;
  MovingPlatformOn=0;
  CurrentArea=34;
  MaxLevelY=550;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area24_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area24_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area24_Background.png");
  LevelSky=load_png("Levels/Level1/Area13_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(850,250,10,LevelCollision);
  PlayerID=Player(x,y,5);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  StreetLightHalo(518,195,2,6);
  StreetLightHalo(934,196,2,6);
  StreetLightHalo(1418,195,2,6);

  frame(500);

    if (exists(Lamp1ID)==0) Lamp1ID=AlgaeLamp(518,0,2,0); end
    if (exists(Lamp2ID)==0) Lamp2ID=AlgaeLamp(934,0,2,0); end
    if (exists(Lamp3ID)==0) Lamp3ID=AlgaeLamp(1418,0,2,0); end

  loop
    if (PlayerX<0) Level1Part23(1170,1870); end
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0 and exists(type TextBox)==0) GameMenuID=id; GameMenu(); end
    end

    if (fget_dist(1595,365,PlayerX,PlayerY)<100)
      if (exists(type Sign)==0) Sign(320,160,2,4); end
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        signal(PlayerID, s_freeze_tree);
        fade(0,0,0,8);
        frame(2000);
        fade(100,100,100,8);
        SchmupTutorial();
        return;
      end
    end

    frame;
  end
end



process TunnelFall();
private
  int FallCameraID;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  MaxLevelY=5050;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Tunnel_Collision.png");
  //LevelMiddle=load_png("Levels/Level1/Tunnel_Middle.png");
  LevelBackground=load_png("Levels/Level1/Tunnel_Background.png");
  //LevelSky=load_png("Levels/Level1/Tunnel_Sky.png");

  TunnelBackground(240);
  TunnelBackground(720);

  LevelScroll(LevelCollision,LevelBackground,0,12);
  LevelCheckID=LevelCheck(320,2500,10,LevelCollision);
  PlayerID=FreeFallPlayer(320,-40,5);

  FallSpinner(200,1000,5,2,0);
  FallSpinner(200,1100,5,2,0);
  FallSpinner(200,1200,5,2,0);
  FallSpinner(200,1300,5,2,0);
  FallSpinner(200,1400,5,2,0);

  FallMine(32,1500,5,0);

  FallSpinner(440,1700,5,2,0);
  FallSpinner(440,1800,5,2,0);
  FallSpinner(440,1900,5,2,0);
  FallSpinner(440,2000,5,2,0);
  FallSpinner(440,2100,5,2,0);

  FallMine(608,2200,5,1);

  FallSpinner(320,2500,5,2,0);
  FallSpinner(320,2600,5,2,0);
  FallSpinner(320,2700,5,2,0);
  FallSpinner(320,2800,5,2,0);
  FallSpinner(320,2900,5,2,0);

  FallMine(608,3000,5,1);

  FallSpinner(200,3200,5,2,2);
  FallSpinner(200,3300,5,2,2);
  FallSpinner(200,3400,5,2,2);
  FallSpinner(200,3500,5,2,2);
  FallSpinner(200,3600,5,2,2);

  FallSpinner(440,3200,5,2,1);
  FallSpinner(440,3300,5,2,1);
  FallSpinner(440,3400,5,2,1);
  FallSpinner(440,3500,5,2,1);
  FallSpinner(440,3600,5,2,1);

  FallMine(32,3000,5,0);
  FallMine(608,3100,5,1);

  FallSpinner(320,3800,5,2,1);
  FallSpinner(320,3900,5,2,2);
  FallSpinner(320,4000,5,2,1);
  FallSpinner(320,4100,5,2,2);
  FallSpinner(320,4200,5,2,1);
  FallSpinner(320,4300,5,2,2);
  FallSpinner(320,4400,5,2,1);
  FallSpinner(320,4500,5,2,2);

  FallMine(32,4700,5,0);

  FallCameraID=FallCamera(320,-40);

  frame(500);

  loop
    PlayerID.y=FallCameraID.y-160;
    if (PlayerX=>620) PlayerID.X=620; end
    if (PlayerX<=20) PlayerID.X=20; end
    if (PlayerY=>5000) fade(0,0,0,8); end
    if (PlayerY=>5160) TunnelFall2(); return; end
    frame;
  end
end



process TunnelFall2();
private
  int FallCameraID;
begin
  let_me_alone();
  delete_text(0);

  MovingPlatformOn=0;
  MaxLevelY=5050;

  Lighting(0);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Tunnel_Collision.png");
  //LevelMiddle=load_png("Levels/Level1/Tunnel_Middle.png");
  LevelBackground=load_png("Levels/Level1/Tunnel_Background.png");
  //LevelSky=load_png("Levels/Level1/Tunnel_Sky.png");

  TunnelBackground(240);
  TunnelBackground(720);

  LevelScroll(LevelCollision,LevelBackground,0,12);
  LevelCheckID=LevelCheck(320,2500,10,LevelCollision);
  PlayerID=FreeFallPlayer(320,-60,5);

  FallSpinner(200,1000,5,2,2);
  FallSpinner(200,1200,5,2,2);
  FallSpinner(200,1400,5,2,2);
  FallSpinner(200,1600,5,2,2);
  FallSpinner(200,1800,5,2,2);

  FallMine(32,2000,5,0);

  FallSpinner(440,1100,5,2,1);
  FallSpinner(440,1300,5,2,1);
  FallSpinner(440,1500,5,2,1);
  FallSpinner(440,1700,5,2,1);
  FallSpinner(440,1900,5,2,1);

  FallSpinner(110,2100,5,2,0);
  FallSpinner(150,2200,5,2,0);
  FallSpinner(190,2300,5,2,0);
  FallSpinner(250,2400,5,2,0);
  FallSpinner(290,2500,5,2,0);
  FallSpinner(330,2600,5,2,0);
  FallSpinner(370,2700,5,2,0);
  FallSpinner(410,2800,5,2,0);
  FallSpinner(450,2900,5,2,0);
  FallSpinner(490,3000,5,2,0);
  FallSpinner(510,3100,5,2,0);

  FallMine(608,3200,5,1);
  FallMine(32,3300,5,0);

  FallSpinner(110,3400,5,2,1);
  FallSpinner(150,3500,5,2,1);
  FallSpinner(190,3600,5,2,1);
  FallSpinner(250,3700,5,2,1);
  FallSpinner(290,3800,5,2,1);
  FallSpinner(330,3900,5,2,0);
  FallSpinner(370,4000,5,2,2);
  FallSpinner(410,4100,5,2,2);
  FallSpinner(450,4200,5,2,2);
  FallSpinner(490,4300,5,2,2);
  FallSpinner(510,4400,5,2,2);

  FallMine(608,4400,5,1);
  FallMine(32,4500,5,0);

  FallCameraID=FallCamera(320,-60);

  frame(500);

  loop
    PlayerID.y=FallCameraID.y-160;
    if (PlayerX=>620) PlayerID.X=620; end
    if (PlayerX<=20) PlayerID.X=20; end
    if (PlayerY=>5000) fade(0,0,0,8); end
    if (PlayerY=>5160) Level1Part13(270,-20); return; end
    frame;
  end
end



process TunnelBackground(y);
begin
  x=320; z=20;
  LevelSky=load_png("Levels/Level1/Tunnel_Sky.png");
  graph=LevelSky;
  loop
    y-=2;
    if (y==-240) y=720; end
    frame;
  end
end



process SchmupTutorial();
begin

  let_me_alone();
  delete_text(0);
  MaxLevelY=530;
  SchmupBossOn=1;

  Lighting(0);
  if (CurrentArea==34) FadeSong(); end
  SongPlayer(6);

  LevelCollision=load_png("Levels/Level1/Schmup1.png");
  LevelMiddle=load_png("Levels/Level1/Schmup1.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(2750,240,10,LevelCollision);

  CameraID=SchmupCamera(5180,240,0);
  PlayerID=SchmupPlayer(1);

  frame(5000); frame(1000);
  SchmupTutorialText();

  repeat
    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0) GameMenuID=id; GameMenu(); end
    end
    frame;
  until(CameraID.x=>5180)
  repeat frame; until(PlayerX=>5440)
  PlayerID.Control=2;
  frame(5000);
  SchmupLevel1();

end



process SchmupLevel1();
begin

  let_me_alone();
  delete_text(0);

  SchmupBossOn=0;
  MovingPlatformOn=0;
  CurrentArea=35;
  MaxLevelY=530;

  Lighting(0);
  SongPlayer(6);

  LevelCollision=load_png("Levels/Level1/Schmup1.png");
  LevelMiddle=load_png("Levels/Level1/Schmup1.png");
  LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(2750,240,10,LevelCollision);

  CameraID=SchmupCamera(320,240,0);
  PlayerID=SchmupPlayer(0);

  repeat

    if (CameraID.x==400) SchmupGrunt(720,100,5,0); end
    if (CameraID.x==450) SchmupGrunt(770,100,5,0); end
    if (CameraID.x==500) SchmupGrunt(820,100,5,0); end

    if (CameraID.x==510) SchmupStar(930,140,5,4,1); end
    if (CameraID.x==540) SchmupStar(960,140,5,4,1); end
    if (CameraID.x==570) SchmupStar(990,140,5,4,1); end

    if (CameraID.x==700) SchmupGunner(1100,240,5,0); end

    if (CameraID.x==1000) SchmupTank(1400,240,5,0); end

    if (CameraID.x==980) SchmupEnergyBalls(1380,90,7,2,0); SchmupEnergyBalls(1380,390,7,0,0); end

    if (CameraID.x==1400) SchmupGrunt(1720,100,5,0); end
    if (CameraID.x==1450) SchmupGrunt(1770,100,5,0); end
    if (CameraID.x==1500) SchmupGrunt(1820,100,5,0); end

    if (CameraID.x==1600) SchmupSpiderBot(1900,430,5,0); end

    if (CameraID.x==1800) SchmupTriGun(2130,160,5,0); end

    if (CameraID.x==1900) SchmupGrunt(2220,100,5,0); end
    if (CameraID.x==1950) SchmupGrunt(2270,100,5,0); end
    if (CameraID.x==2000) SchmupGrunt(2320,100,5,0); end

    if (CameraID.x==2050) SchmupSpiderBot(2360,445,5,0); end

    if (CameraID.x==2100) SchmupTank(2700,240,5,0); end

    if (CameraID.x==2100) SchmupEnergyBalls(2730,390,7,2,0); SchmupEnergyBalls(2730,90,7,0,0); end

    if (CameraID.x==2650) SchmupSpiderBot(2972,442,5,0); end
    if (CameraID.x==2650) SchmupTriGun(3057,190,5,0); end

    if (CameraID.x==2700) SchmupStar(3060,140,5,2,1); SchmupStar(3060,310,5,2,1); end
    if (CameraID.x==2730) SchmupStar(3090,140,5,2,1); SchmupStar(3090,310,5,2,1); end
    if (CameraID.x==2760) SchmupStar(3120,140,5,2,1); SchmupStar(3120,310,5,2,1); end

    if (CameraID.x==2800) SchmupEnergyBalls(3226,86,7,2,0); end
    if (CameraID.x==2850) SchmupEnergyBalls(3285,337,7,1,0); end
    if (CameraID.x==2900) SchmupEnergyBalls(3500,357,7,3,0); end
    if (CameraID.x==2950) SchmupEnergyBalls(3510,121,7,0,0); end
    if (CameraID.x==3050) SchmupTriGun(3390,240,5,0); end

    if (CameraID.x==3350) SchmupGunner(3720,80,5,0); end
    if (CameraID.x==3450) SchmupGunner(3820,180,5,0); end

    if (CameraID.x==3500) SchmupSpiderBot(3810,440,5,0); end
    if (CameraID.x==3550) SchmupSpiderBot(3935,440,5,0); end
    if (CameraID.x==3600) SchmupSpiderBot(4050,440,5,0); end

    if (CameraID.x==3700) SchmupGrunt(4100,100,5,0); end
    if (CameraID.x==3800) SchmupGrunt(4200,100,5,0); end
    if (CameraID.x==3900) SchmupGrunt(4300,100,5,0); end

    if (CameraID.x==3750) SchmupGrunt(4150,180,5,0); end
    if (CameraID.x==3850) SchmupGrunt(4250,180,5,0); end
    if (CameraID.x==3950) SchmupGrunt(4350,180,5,0); end

    if (CameraID.x==4100) SchmupGunner(4500,200,5,0); end
    if (CameraID.x==4200) SchmupGunner(4600,300,5,0); end
    if (CameraID.x==4300) SchmupGunner(4700,300,5,0); end
    if (CameraID.x==4100) SchmupTank(4510,100,5,0); end

    if (CameraID.x==4500) SchmupGunner(5000,200,5,0); end
    if (CameraID.x==4500) SchmupGunner(5150,400,5,0); end

    if (CameraID.x==4600) SchmupGrunt(5200,100,5,0); end
    if (CameraID.x==4600) SchmupGrunt(5300,100,5,0); end
    if (CameraID.x==4600) SchmupGrunt(5400,100,5,0); end

    if (CameraID.x==4650) SchmupGrunt(5250,300,5,0); end
    if (CameraID.x==4650) SchmupGrunt(5350,300,5,0); end
    if (CameraID.x==4650) SchmupGrunt(5450,300,5,0); end

    if (key(_esc) or joy_getbutton(0,1))
      if (exists(type GameMenu)==0) GameMenuID=id; GameMenu(); end
    end

    frame;
  until(CameraID.x=>5180)
  SchmupBossOn=1;
  SchmupBoss1(5600,320,5,0);
  repeat frame; until(exists(type SchmupBoss1)==0)
  PlayerID.Control=1;

end



process SchmupCamera(x,y,Mode);
begin

  ctype=c_scroll; scroll[0].camera=id;
  loop
    if (Mode==0 and x<5180) x+=2; end
    frame;
  end
end



process SpiritBattle1();
private
  int MasherID;
  int DoFlash;
begin
  let_me_alone();
  delete_text(0);

  Lighting(1);
  fade(100,100,100,1);
  SongPlayer(1);
  MaxLevelY=650;

  LevelCollision=load_png("Levels/Level1/Area9_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area9_Middle.png");
  //LevelBackground=load_png("Levels/Level1/Area3_Background.png");
  //LevelSky=load_png("Levels/Level1/Area3_Sky.png");

  LevelScroll(LevelMiddle,0,0,12);
  LevelCheckID=LevelCheck(800,300,10,LevelCollision);
  PlayerID=SpiritBattlePlayer(1240,PlayerY,5,0);
  Player_Shadow1(x,y,11);
  Player_Shadow2(x,y,11);

  LevelObject(1397,315,8,11);

  repeat
    if (PlayerID.y<409) PlayerID.y+=7; end
    frame;
  until(PlayerID.y=>409)
  PlayerID.y=409;

  frame;
  SpiritBattle1Text1();

  MasherID=ButtonMasher(320,80,2,0);

  frame(500);

  ctype=c_scroll; flags=16; z=4;

  x=1272; y=397; graph=147; size_y=0;
  repeat size_y+=10; y-=9; frame; until(size_y==100);

  loop
  
    if (MasherID.HP=>0 and MasherID.HP<=10 and key(_left)) x=1272; y=312; graph=147; end
    if (MasherID.HP=>0 and MasherID.HP<=10 and key(_right)) x=1284; y=311; graph=148; end
    if (MasherID.HP>10 and MasherID.HP<=20 and key(_left)) x=1284; y=311; graph=148; end
    if (MasherID.HP>10 and MasherID.HP<=20 and key(_right)) x=1310; y=314; graph=149; end
    if (MasherID.HP>20 and MasherID.HP<=30 and key(_left)) x=1310; y=314; graph=149; end
    if (MasherID.HP>20 and MasherID.HP<=30 and key(_right)) x=1307; y=314; graph=150; end
    if (MasherID.HP>30 and MasherID.HP<=40 and key(_left)) x=1307; y=314; graph=150; end
    if (MasherID.HP>30 and MasherID.HP<=40 and key(_right)) x=1310; y=314; graph=151; end
    if (MasherID.HP>40 and MasherID.HP<=50 and key(_left)) x=1310; y=314; graph=151; end
    if (MasherID.HP>40 and MasherID.HP<=50 and key(_right)) x=1308; y=315; graph=152; end
    if (MasherID.HP>50 and MasherID.HP<=60 and key(_left)) x=1308; y=315; graph=152; end
    if (MasherID.HP>50 and MasherID.HP<=60 and key(_right)) x=1310; y=314; graph=151; end

    if (MasherID.HP=>0 and MasherID.HP<=10 and joy_getaxis(0,0)<-20) x=1272; y=312; graph=147; end
    if (MasherID.HP=>0 and MasherID.HP<=10 and joy_getaxis(0,0)>20) x=1284; y=311; graph=148; end
    if (MasherID.HP>10 and MasherID.HP<=20 and joy_getaxis(0,0)<-20) x=1284; y=311; graph=148; end
    if (MasherID.HP>10 and MasherID.HP<=20 and joy_getaxis(0,0)>20) x=1310; y=314; graph=149; end
    if (MasherID.HP>20 and MasherID.HP<=30 and joy_getaxis(0,0)<-20) x=1310; y=314; graph=149; end
    if (MasherID.HP>20 and MasherID.HP<=30 and joy_getaxis(0,0)>20) x=1307; y=314; graph=150; end
    if (MasherID.HP>30 and MasherID.HP<=40 and joy_getaxis(0,0)<-20) x=1307; y=314; graph=150; end
    if (MasherID.HP>30 and MasherID.HP<=40 and joy_getaxis(0,0)>20) x=1310; y=314; graph=151; end
    if (MasherID.HP>40 and MasherID.HP<=50 and joy_getaxis(0,0)<-20) x=1310; y=314; graph=151; end
    if (MasherID.HP>40 and MasherID.HP<=50 and joy_getaxis(0,0)>20) x=1308; y=315; graph=152; end
    if (MasherID.HP>50 and MasherID.HP<=60 and joy_getaxis(0,0)<-20) x=1308; y=315; graph=152; end
    if (MasherID.HP>50 and MasherID.HP<=60 and joy_getaxis(0,0)>20) x=1310; y=314; graph=151; end

    if (MasherID.HP==11 and DoFlash==0) GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6); DoFlash++; play_wav(Gun2,0); end
    if (MasherID.HP==21 and DoFlash==1) GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6); DoFlash++; play_wav(Gun2,0); end
    if (MasherID.HP==31 and DoFlash==2) GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6); DoFlash++; play_wav(Gun2,0); end
    if (MasherID.HP==41 and DoFlash==3) GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6); DoFlash++; play_wav(Gun2,0); end
    if (MasherID.HP==51 and DoFlash==4) GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6); DoFlash++; play_wav(Gun2,0); end

    if (MasherID.HP>30) Spread(1397+rand(-10,10),310+rand(-10,10),3,2); end

    if (key(_left) or joy_getaxis(0,0)<-20) alpha=255; end
    if (key(_right) or joy_getaxis(0,0)>20) alpha=220; end

    if (MasherID.HP==70)
      GlobalRed=160; GlobalGreen=160; GlobalBlue=170; CreateSpread(1230,400,4,6);
      play_wav(Gun2,0); PlayerScore+=1000;
      x=1307; y=314; graph=150; CreateSpread(1230,400,4,6); frame(300);
      LevelObject(1397,315,8,12);
      MasherID.Control=1;
      x=1310; y=314; graph=149; CreateSpread(1230,400,4,6); frame(300);
      x=1284; y=311; graph=148; CreateSpread(1230,400,4,6); frame(300);
      x=1272; y=312; graph=147; CreateSpread(1230,400,4,6); frame(300);
      frame(2000);
      repeat size_y-=10; y+=9; frame; until(size_y<=0);
      SpiritBattle1Text2();
      SpiritBattle1Done=1; Level1Part9(1240,407,1); return;
    end

    if (exists(type LevelObject) and MasherID.HP>30) signal(type LevelObject, s_kill); end

    frame;
  end
end



process SpiritBattle2(x,y);
private
  int MasherID;
  int DoFlash;
  int CameraID;
  int TempID;
  int GraphCounter;
  int CatID;
begin
  let_me_alone();
  delete_text(0);

  SongPlayer(1);
  MaxLevelY=650;

  Lighting(1);
  SongPlayer(2);

  LevelCollision=load_png("Levels/Level1/Area19_Collision.png");
  LevelMiddle=load_png("Levels/Level1/Area19_Middle.png");
  LevelBackground=load_png("Levels/Level1/Area11_Background.png");
  LevelSky=load_png("Levels/Level1/Area11_Sky.png");

  LevelScroll(LevelMiddle,LevelBackground,LevelSky,12);
  LevelCheckID=LevelCheck(500,300,10,LevelCollision);
  PlayerID=SpiritBattlePlayer(x,y,5,0);

  CameraID=CameraView(x,y,0);
  repeat
    if (PlayerID.y<460) PlayerID.y+=7; end
    frame;
  until(CameraID.x=>510)
  PlayerID.y=470;

  CatID=SpiritBattleOpponent(710,380,8,0);

  frame(500);
  signal(CatID, s_freeze);
  SpiritBattle2Text1();
  signal(CatID, s_wakeup);

  MasherID=ButtonMasher(320,80,2,1);

  frame(500);

  ctype=c_scroll; flags=16; z=4;
  x=345; y=473; graph=290; size_y=0;
  repeat size_y+=10; y-=9; frame(50); until(size_y==100);
  HP=250;

  loop

    if (GraphCounter>0) GraphCounter--; end
    if (GraphCounter==0) graph=290; end

    if (MasherID.HP==11 and DoFlash==0) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==21 and DoFlash==1) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==31 and DoFlash==2) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==41 and DoFlash==3) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==51 and DoFlash==4) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==61 and DoFlash==5) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==71 and DoFlash==6) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==81 and DoFlash==7) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==91 and DoFlash==8) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==101 and DoFlash==9) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end
    if (MasherID.HP==111 and DoFlash==10) graph=291; GraphCounter=9; GlobalRed=120; GlobalGreen=120; GlobalBlue=140; SpiritBattleProjectile(x+30,y-5,z-1,0); DoFlash++; end

    if (key(_left) or joy_getaxis(0,0)<-20) alpha=255; end
    if (key(_right) or joy_getaxis(0,0)>20) alpha=200; end

    if (TempID=collision(type SpiritBattleProjectile))
      if (TempID.Control==1 and TempID.HP==0)
        TempID.HP=1;
        HP-=20; GraphCounter=7; graph=292;
      end
    end
    if (HP<=40)
      repeat size_y-=10; y+=9; frame; until(size_y<=0);
      fade(0,0,0,8);
      frame(2000);
      fade(100,100,100,8);
      Level1Part19(30,450,0);
      return;
    end

    if (exists(type SpiritBattleOpponent)==0)
      PlayerScore+=1000;
      frame(2000); repeat size_y-=10; y+=9; frame; until(size_y<=0);
      MasherID.Control=1;
      SpiritBattle2Done=1;
      CameraID=CameraView(510,450,1);
      repeat frame; until(CameraID.x<=350)
      SpiritBattle2Text2();
      Level1Part19(350,450,1);
      return;
    end

    frame;
  end
end



process SpiritBattleOpponent(x,y,z,Mode);
private
  int DelayCounter;
  int GraphCounter;
  int TempID;
begin
  ctype=c_scroll; flags=16; z=4; HP=250;
  if (Mode==0)
    x=719; y=422; graph=294; size_y=0;
    repeat size_y+=10; y-=5; frame(50); until(size_y==100);
    loop
      if (GraphCounter>0) GraphCounter--; end
      if (GraphCounter==0) graph=294; end
      if (alpha<255) alpha+=5; end
      DelayCounter++;
      if (DelayCounter==50)
        DelayCounter=0; GraphCounter=7; graph=295; SpiritBattleProjectile(x-10,y+10,z-1,1);
      end
      if (TempID=collision(type SpiritBattleProjectile))
        if (TempID.Control==0 and TempID.HP==0)
          TempID.HP=1;
          HP-=20; GraphCounter=7; graph=296; alpha=200;
        end
      end
      if (HP<=40)
        repeat size_y-=10; y+=5; frame(50); until(size_y==0);
        return;
      end
      frame;
    end
  end
end



process SpiritBattleProjectile(x,y,z,Mode);
private
  int Speed;
begin
  ctype=c_scroll; flags=16; size=10; Speed=2;
  if (Mode==0) graph=293; play_wav(SpiritShot1,0); end
  if (Mode==1) graph=297; play_wav(SluddarGun,0); end
  loop
    if (size<100) size+=10; end
    if (Speed<10) Speed++; end
    if (Mode==0) x+=Speed; end
    if (Mode==1) x-=Speed; end
    if (HP==1)
      repeat size-=10; frame(50); until(size<=10)
      if (Mode==0) CreateSpread(x,y,z,6); end
      if (Mode==1) CreateSpread(x,y,z,11); end
      frame;
      return;
    end
    if (y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    Control=Mode;
    frame;
  end
end



process CameraView(x,y,Mode);
begin
  ctype=c_scroll; scroll[0].camera=id;
  if (Mode==0)
    repeat
      x++;
      if (y<460) y++; end
      frame(50);
    until(x=>510)
    loop frame; end
  end
  if (Mode==1)
    repeat
      x--;
      frame(25);
    until(x<=350)
    loop frame; end
  end
  if (Mode==2)
    repeat
      y-=5;
      frame(25);
    until(y<=955)
    frame(2000);
    repeat
      y+=5;
      frame(25);
    until(y=>2275)
    return;
  end
  if (Mode==3)
    loop frame; end
  end
  if (Mode==4)
    repeat
      x--;
      frame(25);
    until(x<=505)
    loop frame; end
  end
end



process LevelObject(x,y,z,Mode);
private
  int TempImage;
  int HoverCounter;
begin
  ctype=c_scroll;
  if (Mode==1) graph=1; flags=16; alpha=150; end
  if (Mode==2) graph=66; flags=16; alpha=150; end
  if (Mode==3)
    graph=68; flags=16; alpha=150;
    loop size=rand(98,102); frame; end
  end
  if (Mode==4)
    graph=70; flags=16; alpha=250;
    loop flags=rand(16,19); frame; end
  end
  if (Mode==5)
    graph=72; flags=16; alpha=200;
    loop alpha=rand(10,20)*10; frame; end
  end
  if (Mode==6)
    graph=75; size=150; alpha=150;
    loop alpha=rand(10,15)*10; frame; end
  end
  if (Mode==7) graph=77; flags=16; alpha=150; end
  if (Mode==8) graph=81; flags=16; alpha=150; end
  if (Mode==9) graph=91; end
  if (Mode==10) graph=91; flags=2; end
  if (Mode==11) graph=153; flags=16; end
  if (Mode==12)
    graph=153; flags=16;
    repeat
      Spread(1397+rand(-10,10),380+rand(-10,10),3,2); 
      size_y-=5; y+=5;
      frame;
    until(size_y==0)
    return;
  end
  if (Mode==13) graph=220; flags=16; end
  if (Mode==14)
    graph=246;
    repeat frame; until(HP==1)
    y-=2;
    repeat y-=2; size_y-=4; frame; until(size_y==0)
    return;
  end
  if (Mode==15)
    graph=248; flags=16; alpha=250;
    loop flags=rand(16,19); frame; end
  end
  if (Mode==16)
    TempImage=load_png("Levels/Level1/Area14_Collision.png");
    graph=TempImage;
  end
  if (Mode==17) graph=262; flags=16; alpha=150; end
  if (Mode==18)
    graph=266; flags=16;
    loop
      HoverCounter++;
      if (HoverCounter==4 or HoverCounter==8) y++; end
      if (HoverCounter==12 or HoverCounter==16) y--; end
      if (HoverCounter==16) HoverCounter=0; end
      frame(200);
    end
  end
  if (Mode==19)
    loop
      graph=285;
      frame(rand(100,300)*10);
      graph=286;
      frame(rand(100,300)*10);
    end
  end
  if (Mode==20)
    graph=287; flags=16;
    loop
      HoverCounter++;
      if (HoverCounter==4 or HoverCounter==8) y++; end
      if (HoverCounter==12 or HoverCounter==16) y--; end
      if (HoverCounter==16) HoverCounter=0; end
      frame(200);
    end
  end
  if (Mode==21)
    graph=288; flags=16; size=200;
    loop
      HoverCounter++;
      if (HoverCounter==4 or HoverCounter==8) y++; end
      if (HoverCounter==12 or HoverCounter==16) y--; end
      if (HoverCounter==16) HoverCounter=0; end
      frame(200);
    end
  end
  if (Mode==22) graph=421; flags=16; alpha=150; end

  loop frame; end
end


process Sign(x,y,z,Mode);
begin
  alpha=50; size_y=0;
  if (Mode==0) graph=219; end
  if (Mode==1) graph=244; end
  if (Mode==2) graph=245; end
  if (Mode==3) graph=326; end
  if (Mode==4) graph=326; end
  repeat alpha+=10; size_y+=5; frame(50); until(size_y==100)
  frame(2000); frame(2000);
  repeat alpha-=10; size_y-=5; frame(50); until(size_y==0)
end



process LightInsects(x,y,z,Mode);
private
  int XMoveCounter;
  int YMoveCounter;
begin
  ctype=c_scroll; graph=423; flags=16; alpha=50;
  if (Mode==0) YMoveCounter=5; end
  if (Mode==1) YMoveCounter=15; XMoveCounter=6; end
  loop
    XMoveCounter++;
    if (XMoveCounter==1 or XMoveCounter==2 or XMoveCounter==3 or XMoveCounter==5 or XMoveCounter==6) x++; end
    if (XMoveCounter==7 or XMoveCounter==8 or XMoveCounter==9 or XMoveCounter==10 or XMoveCounter==11) x--; end
    if (XMoveCounter==12) XMoveCounter=0; end
    YMoveCounter++;
    if (YMoveCounter>0 and YMoveCounter<10) y++; end
    if (YMoveCounter>10 and YMoveCounter<20) y--; end
    if (YMoveCounter==20) YMoveCounter=0; end
    frame;
  end
end



process MissionObjectiveSign(Position,Mode);
private
  int MoveSpeed;
begin
  play_wav(NewMission,0);
  if (Mode==0) graph=221; end
  if (Mode==1) graph=238; end
  if (Mode==2) graph=239; end
  if (Mode==3) graph=240; end
  if (Mode==4) graph=241; end
  if (Mode==5) graph=247; end
  if (Mode==6) graph=251; end

  if (Position==1) y=100; end
  if (Position==2) y=200; end
  if (Position==3) y=300; end
  x=740; MoveSpeed=20;
  repeat
    x-=MoveSpeed;
    if (MoveSpeed>1) MoveSpeed--; end
    if (x<540) x=540; end
    frame;
  until(x<=540)
  frame(2000); frame(2000);
  frame(2000); frame(2000);
  MoveSpeed=2;
  repeat
    x+=MoveSpeed;
    if (MoveSpeed<20) MoveSpeed++; end
    if (x>740) x=740; end
    frame;
  until(x=>740)
end



process MissionObjectiveArrow(FindX,FindY,Mode);
private
  int DisplayMode;
  int ChangeDelay;
begin
  ctype=c_scroll; z=2; DisplayMode=1; ChangeDelay=10; flags=16;
  if (Mode==0 or Mode==1 or Mode==2 or Mode==3 or Mode==4 or Mode==9 or Mode==10) graph=222; end
  if (Mode==5 or Mode==6 or Mode==7 or Mode==8) graph=243; end
  loop
    x=PlayerX; y=PlayerY;
    angle=fget_angle(PlayerX,PlayerY,FindX,FindY);
    if (Mode==0 and ComputerGame1Done==1) return; end
    if (Mode==1 and ComputerGame2Done==1) return; end
    if (Mode==2 and FindMainComputerDone==1) return; end
    if (Mode==3 and ComputerGame4Done==1) return; end
    if (Mode==4 and ComputerGame5Done==1) return; end
    if (Mode==5 and Coin1Found==1) return; end
    if (Mode==6 and Coin2Found==1) return; end
    if (Mode==7 and DestructibleItem1==1) return; end
    if (Mode==8 and DestructibleItem2==1) return; end
    if (Mode==9 and ComputerGame3Done==1) return; end

    if (key(_h) and DisplayMode==1 and ChangeDelay==0) DisplayMode=2; ChangeDelay=10; end
    if (key(_h) and DisplayMode==2 and ChangeDelay==0) DisplayMode=1; ChangeDelay=10; end   
    if (ChangeDelay>0) ChangeDelay--; end
    if (DisplayMode==1 and alpha<240); alpha+=20; end
    if (DisplayMode==2 and alpha>0); alpha-=20; end

    frame;
  end
end



process DirectionArrow(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll; flags=16; graph=302;
  if (Mode==1) angle=90000; end
  if (Mode==2) flags=17; end
  if (Mode==3) flags=-180000; end
  loop
    HoverCounter++;
    if (HoverCounter>0 and HoverCounter<10)
      if (Mode==0 or Mode==2) x--; end
      if (Mode==1 or Mode==3) y--; end
    end
    if (HoverCounter>10 and HoverCounter<20)
      if (Mode==0 or Mode==2) x++; end
      if (Mode==1 or Mode==3) y++; end
    end
    if (HoverCounter==20) HoverCounter=0; end
    frame;
  end

end



process FindableItem(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==1) graph=242; end
  loop
    HoverCounter++;
    if (HoverCounter>0 and HoverCounter<10) y--; end
    if (HoverCounter>10 and HoverCounter<20) y++; end
    if (HoverCounter==20) HoverCounter=0; end

    if (Mode==0)
      if (collision(PlayerID))
        play_wav(PickUp,0); Coin1Found=1; z=4;
        repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
        repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
        repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
        repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
        repeat y--; size_x-=5; size_y-=3; frame(20); until(size_x<=20)
        CreateSpread(x,y,z,1);
        frame;
        return;
      end
    end
    if (Mode==1)
      if (collision(PlayerID))
        play_wav(PickUp,0); Coin2Found=1; z=4;
        repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
        repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
        repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
        repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
        repeat y--; size_x-=5; size_y-=3; frame(20); until(size_x<=20)
        CreateSpread(x,y,z,1);
        frame;
        return;
      end
    end

    frame;
  end
end



process DestructibleItem(x,y,z,Mode);
private
  int TempID;
  int AuraID;
  int HoverCounter;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==1) graph=249; HP=1; AuraID=DestructibleItemAura(x,y,z-1,Mode); flags=Mode; end
  if (Mode==2) graph=303; HP=1; end
  if (Mode==3) graph=305; flags=16; alpha=100; HP=1; end

  repeat

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
      HP--;
      end
    end

    if (Mode==2)
      HoverCounter++;
      if (HoverCounter==10 or HoverCounter==20) y--; end
      if (HoverCounter==30 or HoverCounter==40) y++; end
      if (HoverCounter==60) HoverCounter=0; end
    end

    frame;
  until(HP<=0)

  if (Mode==0 or Mode==1)
    PlayerScore+=100;
    signal(AuraID, s_kill);
    Explode(x-30,y,z-1,100);
    Explode(x,y,z-1,100);
    Explode(x+30,y,z-1,100);
    CreateSpread(x,y,z,1);
    frame(200);
    if (Mode==0) DestructibleItem1=1; end
    if (Mode==1) DestructibleItem2=1; end
  end

  if (Mode==2)
    PlayerScore+=100;
    CreateSparks(x-20,y,z--,8); CreateSparks(x,y,z--,8); CreateSparks(x+20,y,z--,8);
    BrainDestroyed=1; play_wav(Klirr,0);
    repeat y+=2; frame(50); until(collision(LevelCheckID))
    play_wav(Splash2,0);
    CreateSparks(x-20,y+12,z--,8); CreateSparks(x,y+12,z--,8); CreateSparks(x+20,y+12,z--,8);
    repeat
      size_y-=7; y++;
      CreateSparks(x-20,y+12,z--,8); CreateSparks(x,y+12,z--,8); CreateSparks(x+20,y+12,z--,8);
      frame;
    until(size_y<=60)
    loop frame; end
  end

  if (Mode==3)
    PlayerScore+=100;
    Explode(x,y,z-1,150);
    Sparks(x-30,y-30,z--,9); Sparks(x,y-30,z--,9); Sparks(x+30,y-30,z--,9);
    Sparks(x-30,y+30,z--,9); Sparks(x,y+30,z--,9); Sparks(x+30,y+30,z--,9);
    Sparks(x-30,y,z--,9); Sparks(x+30,y,z--,9);
  end

end



process DestructibleItemAura(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==1)
    graph=250; flags=16+Mode;
  end
  loop
    FadeCounter++;
    if (FadeCounter>0 and FadeCounter<10) alpha-=10; end
    if (FadeCounter>10 and FadeCounter<20) alpha+=10; end
    if (FadeCounter==20) FadeCounter=0; end
    frame;
  end
end



process SewerWater(x,y,z,Mode);
private
  int TouchOnce;
  int SplashCounter;
  int TempID;
begin
  ctype=c_scroll; graph=184; flags=16;
  loop
    if (rand(1,15)==1) SewerBubble(x+rand(-735,735),y+rand(-4,6),4,rand(0,1)); end
    if (TouchOnce==0)
      if (collision(PlayerID))
        play_wav(Splash1,0);
        CreateSparks(PlayerID.x-8,PlayerID.y+48,4,6);
        CreateSparks(PlayerID.x+8,PlayerID.y+48,4,5);
        TouchOnce=1;
      end
    end
    if (TouchOnce==1)
      if (collision(PlayerID)==0) TouchOnce=0; end
    end

    if (key(_left) and SplashCounter==0 or joy_getaxis(0,0)<-20 and SplashCounter==0)
      if (collision(PlayerID))
        if (rand(1,2)==1) play_wav(Splash2,0); end
        CreateSparks(PlayerID.x+rand(20,23),PlayerID.y+rand(38,42),4,5);
        SplashCounter=2;
      end
    end
    if (key(_right) and SplashCounter==0 or joy_getaxis(0,0)>20 and SplashCounter==0)
      if (collision(PlayerID))
        if (rand(1,2)==1) play_wav(Splash2,0); end
        CreateSparks(PlayerID.x-rand(20,23),PlayerID.y+rand(38,42),4,6);
        SplashCounter=2;
      end
    end
    if (SplashCounter>0) SplashCounter--; end

    if (Mode==1)
      if (TempID=collision(type SewerSludge)) 
        CreateSparks(TempID.x+rand(-2,2),TempID.y+rand(10,12),3,5);
      end
    end

    frame;
  end
end



process SewerWater2(x,y,z,Mode);
private
  int TouchOnce;
  int SplashCounter;
  int SludgeCounter;
begin
  ctype=c_scroll; flags=16;
  if (Mode==0) graph=189; end
  if (Mode==1) graph=190; end
  loop
    if (TouchOnce==0)
      if (collision(PlayerID))
        play_wav(Splash1,0);
        CreateSparks(PlayerID.x-8,PlayerID.y+48,4,6);
        CreateSparks(PlayerID.x+8,PlayerID.y+48,4,5);
        TouchOnce=1;
      end
    end
    if (TouchOnce==1)
      if (collision(PlayerID)==0) TouchOnce=0; end
    end

    if (key(_left) and SplashCounter==0 or joy_getaxis(0,0)<-20 and SplashCounter==0)
      if (collision(PlayerID))
        if (rand(1,2)==1) play_wav(Splash2,0); end
        CreateSparks(PlayerID.x+rand(20,23),PlayerID.y+rand(38,42),4,5);
        SplashCounter=2;
      end
    end
    if (key(_right) and SplashCounter==0 or joy_getaxis(0,0)>20 and SplashCounter==0)
      if (collision(PlayerID))
        if (rand(1,2)==1) play_wav(Splash2,0); end
        CreateSparks(PlayerID.x-rand(20,23),PlayerID.y+rand(38,42),4,6);
        SplashCounter=2;
      end
    end
    if (SplashCounter>0) SplashCounter--; end

    SludgeCounter++;
    if (SludgeCounter==1 or SludgeCounter==3 or SludgeCounter==5)
      if (Mode==0) CreateSparks(x+rand(20,26),y+rand(6,12),3,5); end
      if (Mode==1) CreateSparks(x+rand(60,66),y+rand(6,12),3,5); end
    end
    if (SludgeCounter==2 or SludgeCounter==4 or SludgeCounter==6)
      if (Mode==1) CreateSparks(x+rand(58,64),y+rand(5,13),3,5); end
    end
    if (SludgeCounter==8)
      if (Mode==0)
        SewerSludge(x+20,y,z,Mode);
        CreateSparks(x+rand(20,26),y+rand(6,12),3,5);
        SludgeCounter=0;
      end
      if (Mode==1)
        SewerSludge(x+60,y+2,z,Mode);
        CreateSparks(x+rand(60,66),y+rand(6,12),3,5);
        SludgeCounter=0;
      end
    end

    frame;
  end
end



process SewerSludge(x,y,z,Mode); 
begin
  ctype=c_scroll; graph=188; flags=16+rand(0,1); size=20;
  repeat
    size+=10;
    x++; y++;
    frame;
  until(size==110);
  repeat
    y+=4;
    frame;
  until(collision(type SewerWater) or y>MaxLevelY)
  x++;
  repeat
    y+=2;
    alpha-=30;
    size_y-=8;
    frame;
  until(size_y<20)
end



process FallingSludge(x,y,z,Mode); 
begin
  ctype=c_scroll; graph=267; flags=16;
  if (Mode==1) flags=18; end
  repeat
    y+=8;
    if (Mode==0)
      CreateSparks(x-75,y+75,4,5); CreateSparks(x-75,y+75,4,6);
      CreateSparks(x+75,y+75,4,6); CreateSparks(x+75,y+75,4,5);
    end
    if (Mode==1)
      CreateSparks(x-75,y-75,4,5); CreateSparks(x-75,y-75,4,6);
      CreateSparks(x+75,y-75,4,6); CreateSparks(x+75,y-75,4,5);
    end
    frame;
  until(collision(type SewerWater) or y>MaxLevelY)
  CreateSparks(x-75,y,3,6);
  CreateSparks(x+75,y,3,5);
  CreateSparks(x-35,y,3,6);
  CreateSparks(x+35,y,3,5);
  CreateSparks(x-10,y,3,6);
  CreateSparks(x+10,y,3,5);
  repeat
    y+=4;
    size_y-=5;
    if (Mode==1) size_y-=1; end
    size_x++;
    if (rand(0,1)==1) CreateSparks(x-75,y,3,6); end
    if (rand(0,1)==1) CreateSparks(x+75,y,3,5); end
    if (rand(0,1)==1) CreateSparks(x-35,y,3,6); end
    if (rand(0,1)==1) CreateSparks(x+35,y,3,5); end
    if (rand(0,1)==1) CreateSparks(x-10,y,3,6); end
    if (rand(0,1)==1) CreateSparks(x+10,y,3,5); end
    frame;
  until(size_y<=15)
  CreateSparks(x-75,y,3,6);
  CreateSparks(x+75,y,3,5);
  CreateSparks(x-35,y,3,6);
  CreateSparks(x+35,y,3,5);
  CreateSparks(x-10,y,3,6);
  CreateSparks(x+10,y,3,5);
end



process SewerBubble(x,y,z,Mode); 
begin
  ctype=c_scroll; graph=185+Mode; flags=16; alpha=100;
  repeat
    y--;
    alpha-=5;
    frame;
  until(alpha<=10)
end



process SewerDrop(x,y,z,Mode);
begin
  ctype=c_scroll; graph=223; flags=16+rand(0,1); alpha=80;
  repeat
    if (alpha<200) alpha+=20; end
    y+=7;
    frame;
  until(collision(type SewerWater) or collision(PlayerID) or collision(type PlayerWeapon) or y>MaxLevelY)
  play_wav(Drop,0); CreateSparks(x,y,z,7);
end



process ComputerGame5();
private
  int ArmID;
  int DelayCounter;
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);
  ComputerHackTutorial5();

  ArmID=ComputerGameArm();
  repeat frame; until(ArmID.HP==1)

  ComputerGameScreen(320,240,2,6);
  ComputerGameDodgeFile(255,218,1,0);

  x=253; y=286; z=1; graph=180;

  repeat
    DelayCounter++;
    if (DelayCounter==10 or DelayCounter==20) HP++; end
    if (DelayCounter==20)
      DelayCounter=0; ComputerGameTracer(343,rand(203,235),1,0);
    end
    if (HP<0) HP=0; end
    x=253+HP;
    frame;
  until(x=>335 or key(_esc) or joy_getbutton(0,1))

  signal(type ComputerGameTracer, s_kill);
  if (x=>335)
    PlayerScore+=1000;
    ComputerGameScreenObject(320,240,0,7);
    ComputerGame5Done=1;
    frame(5000); frame(5000);
  end

  graph=0;
  signal(type ComputerGameScreen, s_kill);
  signal(type ComputerGameDodgeFile, s_kill);
  signal(type ComputerGameScreenObject, s_kill);
  ArmID.HP=2;
  frame(4000);

  signal(PlayerID, s_wakeup_tree);
  signal(father, s_wakeup);
end



process ComputerGameTracer(x,y,z,Mode);
begin
  graph=275; size_x=0; repeat size_x+=10; frame(50); until(size_x=>100)
  
  repeat
    x--;
    if (HP==1)
      repeat size_x-=10; frame(50); until(size_x<=10)
      return;
    end
    frame(50);
  until(x<=242)
  repeat size_x-=10; frame(50); until(size_x<=10)
end



process ComputerGameDodgeFile(x,y,z,Mode);
private
  int TempID;
begin
  graph=304;
  loop
    if (key(_up) or joy_getaxis(0,1)<-20) y--; end
    if (key(_down) or joy_getaxis(0,1)>20) y++; end
    if (y<207) y=207; end
    if (y>231) y=231; end
    if (TempID=collision(type ComputerGameTracer))
      father.HP-=4;
      TempID.HP=1;
    end
    frame(50);
  end
end



process ComputerGame4();
private
  int ArmID;
  int ArrowCounter;
  int ArrowSelection;
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);
  ComputerHackTutorial4();

  ArmID=ComputerGameArm();
  repeat frame; until(ArmID.HP==1)

  ComputerGameScreen(320,240,2,5);

  x=336; y=218; z=1; graph=180;

  repeat
    y=218+HP;
    if (HP<0) HP=0; end
    ArrowCounter++;
      if (ArrowCounter==18)
       ArrowCounter=0;
       ArrowSelection=rand(1,4);
       if (ArrowSelection==1) ComputerGameScreenArrow(238,193,1,1); end
       if (ArrowSelection==2) ComputerGameScreenArrow(251,193,1,2); end
       if (ArrowSelection==3) ComputerGameScreenArrow(264,193,1,3); end
       if (ArrowSelection==4) ComputerGameScreenArrow(278,193,1,4); end
      end
    frame;
  until(y=>245 or key(_esc) or joy_getbutton(0,1))

  signal(type ComputerGameScreenArrow, s_kill);
  if (y=>245)
    PlayerScore+=1000;
    ComputerGameScreenObject(320,240,0,7);
    ComputerGame4Done=1;
    frame(5000); frame(5000);
  end

  graph=0;
  signal(type ComputerGameScreen, s_kill);
  signal(type ComputerGameScreenObject, s_kill);
  signal(type ComputerGameScreenArrow, s_kill);
  ArmID.HP=2;
  frame(4000);

  signal(PlayerID, s_wakeup_tree);
  signal(father, s_wakeup);
end



process ComputerGameScreenArrow(x,y,z,Mode);
begin
  if (Mode==1) graph=270; end
  if (Mode==2) graph=271; end
  if (Mode==3) graph=272; end
  if (Mode==4) graph=273; end
  size=0; repeat size+=10; frame(50); until(size=>100)

  repeat
    y+=2;

    if (Mode==1)
      if (key(_left) or joy_getaxis(0,0)<-20)
        if (y>259 and y<267)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
        if (y>267 and y<275)
          father.HP++;
          repeat size+=10; alpha-=10; frame(50); until(size=>200)
          return;
        end
        if (y>275)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
      end
    end
    if (Mode==2)
      if (key(_down) or joy_getaxis(0,1)>20)
        if (y>259 and y<267)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
        if (y>267 and y<275)
          father.HP++;
          repeat size+=10; alpha-=10; frame(50); until(size=>200)
          return;
        end
        if (y>275)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
      end
    end
    if (Mode==3)
      if (key(_up) or joy_getaxis(0,1)<-20)
        if (y>259 and y<267)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
        if (y>267 and y<275)
          father.HP++;
          repeat size+=10; alpha-=10; frame(50); until(size=>200)
          return;
        end
        if (y>275)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
      end
    end
    if (Mode==4)
      if (key(_right) or joy_getaxis(0,0)>20)
        if (y>259 and y<267)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
        if (y>267 and y<275)
          father.HP++;
          repeat size+=10; alpha-=10; frame(50); until(size=>200)
          return;
        end
        if (y>275)
          father.HP--;
          repeat size-=10; frame(50); until(size<=10)
          return;
        end
      end
    end

    frame;
  until(y=>284)
  if (Mode==1 or Mode==4) y--; end
  repeat size-=10; frame(50); until(size<=10)
  father.HP--;
end



process ComputerGame3();
private
  int Direction;
  int AnimationCounter;
  int GameScore;
  int TempScore;
  int TempID;
  int ReloadCounter;
  int Life1ID;
  int Life2ID;
  int Life3ID;
  int InvincibleCounter;
  int HitEffectCounter;
begin

  let_me_alone();
  delete_text(0);

  Lighting(0);
  FadeSong();
  SongPlayer(3);

  TempCollisionID=ComputerGameScreen(320,240,2,2);
  ComputerGameScreen(320,228,3,3);
  ComputerGameScreen(320,228,5,4);

  x=139; y=42; z=1; graph=227; HP=4;
  ComputerGame3Effect();
  ComputerScreenEffect1();
  ComputerScreenEffect2(155,55,0,0);
  ComputerScreenEffect2(178,78,0,1);

  ComputerGame3Enemy(240,140,1,0);
  ComputerGame3Enemy(410,140,1,0);
  ComputerGame3Enemy(240,320,1,0);
  ComputerGame3Enemy(410,320,1,0);

  ComputerGame3Score(320,130,2,0);

  ComputerGame3Button(321,253,1,0);

  Life1ID=ComputerGame3Life(300,235,1,0);
  Life2ID=ComputerGame3Life(320,235,1,0);
  Life3ID=ComputerGame3Life(340,235,1,0);

  ComputerGameScreenObject(47,105,1,8);

  set_text_color(rgb(240,40,0));
  write_int(0,300,215,0,&TempScore);

  repeat
    if (key(_left) or joy_getaxis(0,0)<-20) Direction=1; end
    if (key(_right) or joy_getaxis(0,0)>20) Direction=2; end
    if (key(_up) or joy_getaxis(0,1)<-20) Direction=3; end
    if (key(_down) or joy_getaxis(0,1)>20) Direction=4; end

    if (Direction==1) flags=2; angle=270000; end
    if (Direction==2) flags=0; angle=90000; end
    if (Direction==3) flags=2; angle=0; end
    if (Direction==4) flags=0; angle=0; end

    if (Direction==1) x--; end
    if (Direction==2) x++; end
    if (Direction==3) y--; end
    if (Direction==4) y++; end

    if (collision(TempCollisionID))
      if (HitEffectCounter==0)
        Spread(x,y,4,9); Spread(x,y,4,9);
        Spread(x,y,4,9); Spread(x,y,4,9);
        HitEffectCounter=20;
      end
      if (Direction==1) x++; Direction=2;
      elseif (Direction==2) x--; Direction=1;
      elseif (Direction==3) y++; Direction=4;
      elseif (Direction==4) y--; Direction=3; end
    end
    if (HitEffectCounter>0) HitEffectCounter--; end

    AnimationCounter++;
    if (AnimationCounter>0 and AnimationCounter<=10) graph=227; end
    if (AnimationCounter>10 and AnimationCounter<=20) graph=228; end
    if (AnimationCounter==21) AnimationCounter=0; end

    if (TempID=collision(type ComputerGame3Score))
      if (TempID.HP==0) GameScore+=3000; GlobalRed=120; end
      TempID.HP=1;
    end
    if (TempScore<GameScore) TempScore+=10; end

    if (ReloadCounter==0 and key(_control) or ReloadCounter==0 and key(_z) or ReloadCounter==0 and joy_getbutton(0,2)==1)
      GlobalRed=130;
      ComputerGame3Attack(x,y,4,0);
      ReloadCounter=400;
    end
    if (ReloadCounter>0) ReloadCounter--; end
    Control=ReloadCounter;

    if (collision(type ComputerGame3Enemy) and InvincibleCounter==0)
      HP--; GlobalRed=130;
      if (HP==3) Life3ID.HP=1; end
      if (HP==2) Life2ID.HP=1; end
      if (HP==1) Life1ID.HP=1; end
      repeat Spread(x,y,4,9); size-=5; alpha-=10; frame(50); until(alpha<30)
      x=139; y=42; InvincibleCounter=200; size=0; ReloadCounter=0;
      repeat size+=10; alpha+=10; frame; until(size==100)
      Shockwave2(x,y,4,117);
    end
    if (InvincibleCounter>0) InvincibleCounter--; alpha=150; end
    if (InvincibleCounter==0) alpha=255; end

    frame(25);
  until(GameScore==30000 or HP==0)
  TempScore=30000; repeat Spread(x,y,4,9); size-=5; alpha-=10; frame(50); until(alpha<30) graph=0;
  signal(type ComputerGame3Effect, s_kill);

  if (HP>0)
    PlayerScore+=10000;
    signal(type ComputerGameScreenObject, s_kill);
    ComputerGameScreenObject(47,105,1,9);
    ComputerGame3Done=1;
  end

  frame(5000); frame(5000); frame(3000);

  fade(0,0,0,8);
  frame(2000);
  fade(100,100,100,8);

  set_text_color(rgb(255,255,255));

  FadeSong();
  Level1Part13(1672,2275);

end



process ComputerGame3Life(x,y,z,Mode);
begin
  graph=235;
  repeat
    frame;
  until(HP==1)
  repeat alpha-=10; frame(50); until(alpha==40)
end



process ComputerGame3Button(x,y,z,Mode);
begin
  graph=234;
  loop
    if (father.Control>0 and alpha=>100) alpha-=50; end
    if (father.Control==0 and alpha<250) alpha+=50; end
    frame;
  end
end



process ComputerGame3Attack(x,y,z,Mode);
begin
  graph=233; size=20; flags=16; alpha=255;
  repeat
    size+=10; alpha-=5;
    frame(50);
  until(alpha<=30)
end



process ComputerGame3Score(x,y,z,Mode);
private
  int StopLoop;
begin
  graph=232; size=0;
  Shockwave2(x,y,4,117);
  repeat frame(50); size+=10; until(size==100)
  loop
    if (HP==1)
      Shockwave2(x,y,4,117);
      repeat frame(50); size-=10; until(size==10)
      alpha=10; size=100;
      repeat
        StopLoop=1;
        x=rand(130,514);
        y=rand(32,424);
        frame(10);
        if (collision(TempCollisionID)) StopLoop=0; end
      until(StopLoop==1)
      alpha=255; size=10;
      HP=0;
      Shockwave2(x,y,4,117);
      repeat frame(50); size+=10; until(size==100)
    end
    frame;
  end
end



process ComputerGame3Enemy(x,y,z,Mode);
private
  int Direction;
begin
  graph=229; Direction=rand(1,4); ComputerGame3Effect();
  loop
    if (Direction==1) x--; y--; flags=0; end
    if (Direction==2) x++; y--; flags=1; end
    if (Direction==3) x++; y++; flags=3; end
    if (Direction==4) x--; y++; flags=2; end

    if (collision(TempCollisionID))
      Spread(x,y,4,9); Spread(x,y,4,9);
      Spread(x,y,4,9); Spread(x,y,4,9); Spread(x,y,4,9);
      if (Direction==1) Direction=2;
      elseif (Direction==2) Direction=3;
      elseif (Direction==3) Direction=4;
      elseif (Direction==4) Direction=1; end
    end

    if (collision(type ComputerGame3Attack))
      alpha=200;
      repeat
        Spread(x+rand(-5,5),y+rand(-5,5),4,9);
        alpha++;
        frame(50);
      until(alpha==255)
    end

    frame(30);
  end
end



process ComputerScreenEffect1();
begin
  x=320; y=30; z=0; alpha=0; flags=16; graph=230;
  loop
    y+=5;
    if (alpha<50 and y<400) alpha+=5; end
    if (y=>415 and alpha>0) alpha-=5; end
    if (y=>430) y=30; alpha=0; end
    frame;
  end
end


process ComputerScreenEffect2(x,y,z,Mode);
private
  int Direction;
begin
  alpha=100; flags=16; graph=231; Direction=1;
  if (Mode==1) size=50; end
  loop
    if (Direction==1) alpha-=5; end
    if (Direction==2) alpha+=5; end
    if (Direction==2 and alpha==100) Direction=1; end
    if (Direction==1 and alpha==50) Direction=2; end
    frame;
  end
end


process ComputerGame3Effect();
begin
  graph=117; z=4; flags=16; alpha=100;
  loop
    x=father.x; y=father.y;
    frame(25);
  end
end



process ComputerGame2();
private
  int ArmID;
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);
  ComputerHackTutorial2();

  ArmID=ComputerGameArm();
  repeat frame; until(ArmID.HP==1)

  ComputerGameScreen(320,240,2,1);

  x=255; y=227; z=1; graph=180;

  ComputerGameScreenEnemy1(263,247,1,1,0);
  ComputerGameScreenEnemy1(284,207,1,2,0);

  ComputerGameScreenEnemy1(302,247,1,1,1);

  ComputerGameScreenEnemy1(318,207,1,2,1);
  ComputerGameScreenEnemy1(334,247,1,1,1);

  repeat
    if (key(_left) and x>255 or joy_getaxis(0,0)<-20 and x>255) x--; end
    if (key(_right) and x<341 or joy_getaxis(0,0)>20 and x<341) x++; end

    if (collision(type ComputerGameScreenEnemy1))
      repeat alpha=100; x--; frame(50); until(x==255) alpha=255;
    end

    frame;
  until(x=>341 or key(_esc) or joy_getbutton(0,1))

  if (x=>341)
    PlayerScore+=1000;
    ComputerGameScreenObject(297,224,0,7);
    ComputerGame2Done=1;
    frame(5000); frame(5000);
  end

  graph=0;
  signal(type ComputerGameScreen, s_kill);
  signal(type ComputerGameScreenEnemy1, s_kill);
  signal(type ComputerGameScreenObject, s_kill);
  ArmID.HP=2;
  frame(5000);

  signal(PlayerID, s_wakeup_tree);
  signal(father, s_wakeup);
end



process ComputerGameScreenEnemy1(x,y,z,Direction,Mode);
begin
  graph=181;
  loop
    if (Direction==1) y--; end
    if (Direction==2) y++; end
    if (Direction==2 and y==249) Direction=1; end
    if (Direction==1 and y==205) Direction=2; end
    if (Mode==0) frame; end
    if (Mode==1) frame(80); end
  end
end



process ComputerGame1();
private
  int Code1;
  int Code2;
  int Code3;
  int Code4;
  int Code1ID;
  int Code2ID;
  int Code3ID;
  int Code4ID;
  int SetCode1;
  int SetCode2;
  int SetCode3;
  int SetCode4;
  int CurrentCode;
  int SelectCode;
  int DelayCounter;
  int CorrectCounter;
  int GameScreenID;
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);
  ComputerHackTutorial1();

  ArmID=ComputerGameArm();
  repeat frame; until(ArmID.HP==1)

  GameScreenID=ComputerGameScreen(320,240,2,0);
  frame(1000);

  Code1=rand(1,4);
  Code2=rand(1,4);
  Code3=rand(1,4);
  Code4=rand(1,4);

  Code1ID=ComputerGameScreenObject(316,282,1,Code1);
  Code2ID=ComputerGameScreenObject(343,282,1,Code2);
  Code3ID=ComputerGameScreenObject(369,282,1,Code3);
  Code4ID=ComputerGameScreenObject(395,282,1,Code4);

  x=243; y=198; z=1;
  repeat
    if (CurrentCode==4) CurrentCode=0; end
    CurrentCode++;
    if (CurrentCode==1) graph=171; end
    if (CurrentCode==2) graph=172; end
    if (CurrentCode==3) graph=173; end
    if (CurrentCode==4) graph=174; end
    repeat
      DelayCounter++;
      if (key(_down) or key(_control) or key(_z) or key(_x) or key(_c) or joy_getbutton(0,0) or joy_getbutton(0,2) or joy_getbutton(0,3)) SelectCode++; end
      frame;
    until(DelayCounter==20 or SelectCode==1)
    DelayCounter=0;
    frame;
  until(SelectCode==1)
  SetCode1=CurrentCode;
  ComputerGameScreenObject(243,198,1,CurrentCode);
  ComputerGameScreenObject(243,231,1,CurrentCode);
  frame(500);

  x=269; y=198; DelayCounter=0; CurrentCode=0;
  repeat
    if (CurrentCode==4) CurrentCode=0; end
    CurrentCode++;
    if (CurrentCode==1) graph=171; end
    if (CurrentCode==2) graph=172; end
    if (CurrentCode==3) graph=173; end
    if (CurrentCode==4) graph=174; end
    repeat
      DelayCounter++;
      if (key(_down) or key(_control) or key(_z) or key(_x) or key(_c) or joy_getbutton(0,0) or joy_getbutton(0,2) or joy_getbutton(0,3)) SelectCode++; end
      frame;
    until(DelayCounter==20 or SelectCode==2)
    DelayCounter=0;
    frame;
  until(SelectCode==2)
  SetCode2=CurrentCode;
  ComputerGameScreenObject(269,198,1,CurrentCode);
  ComputerGameScreenObject(269,231,1,CurrentCode);
  frame(500);

  x=295; y=198; DelayCounter=0; CurrentCode=0;
  repeat
    if (CurrentCode==4) CurrentCode=0; end
    CurrentCode++;
    if (CurrentCode==1) graph=171; end
    if (CurrentCode==2) graph=172; end
    if (CurrentCode==3) graph=173; end
    if (CurrentCode==4) graph=174; end
    repeat
      DelayCounter++;
      if (key(_down) or key(_control) or key(_z) or key(_x) or key(_c) or joy_getbutton(0,0) or joy_getbutton(0,2) or joy_getbutton(0,3)) SelectCode++; end
      frame;
    until(DelayCounter==20 or SelectCode==3)
    DelayCounter=0;
    frame;
  until(SelectCode==3)
  SetCode3=CurrentCode;
  ComputerGameScreenObject(295,198,1,CurrentCode);
  ComputerGameScreenObject(295,231,1,CurrentCode);
  frame(500);

  x=321; y=198; DelayCounter=0; CurrentCode=0;
  repeat
    if (CurrentCode==4) CurrentCode=0; end
    CurrentCode++;
    if (CurrentCode==1) graph=171; end
    if (CurrentCode==2) graph=172; end
    if (CurrentCode==3) graph=173; end
    if (CurrentCode==4) graph=174; end
    repeat
      DelayCounter++;
      if (key(_down) or key(_control) or key(_z) or key(_x) or key(_c) or joy_getbutton(0,0) or joy_getbutton(0,2) or joy_getbutton(0,3)) SelectCode++; end
      frame;
    until(DelayCounter==20 or SelectCode==4)
    DelayCounter=0;
    frame;
  until(SelectCode==4)
  SetCode4=CurrentCode;
  ComputerGameScreenObject(321,198,1,CurrentCode);
  ComputerGameScreenObject(321,231,1,CurrentCode);
  frame(500);

  frame(1000);
  if (SetCode1==Code1) ComputerGameScreenObject(243,231,0,5); CorrectCounter++; end
  if (SetCode1!=Code1) ComputerGameScreenObject(243,231,0,6); end
  frame(1000);
  if (SetCode2==Code2) ComputerGameScreenObject(269,231,0,5); CorrectCounter++; end
  if (SetCode2!=Code2) ComputerGameScreenObject(269,231,0,6); end
  frame(1000);
  if (SetCode3==Code3) ComputerGameScreenObject(295,231,0,5); CorrectCounter++; end
  if (SetCode3!=Code3) ComputerGameScreenObject(295,231,0,6); end
  frame(1000);
  if (SetCode4==Code4) ComputerGameScreenObject(321,231,0,5); CorrectCounter++; end
  if (SetCode4!=Code4) ComputerGameScreenObject(321,231,0,6); end
  frame(1000);

  if (CorrectCounter==4) ComputerGame1Done=1; PlayerScore+=1000; end

  frame(5000); frame(4000);
  GameScreenID.HP=1; graph=0;
  signal(type ComputerGameScreenObject, s_kill);
  frame(1000);
  ArmID.HP=2;
  frame(2000);
  signal(PlayerID, s_wakeup_tree);
  signal(father, s_wakeup);
end



process ComputerGameScreen(x,y,z,Mode);
begin
  if (Mode==0) graph=170; end
  if (Mode==1) graph=179; end
  if (Mode==2) graph=224; end
  if (Mode==3) graph=225; end
  if (Mode==4) graph=226; end
  if (Mode==5) graph=269; end
  if (Mode==6) graph=274; end
  size_y=0;
  repeat size_y+=5; frame(25); until(size_y==100)
  repeat frame; until(HP==1)
  repeat size_y-=5; frame(25); until(size_y==0)
end



process ComputerGameScreenObject(x,y,z,Mode);
begin
  if (Mode==1) graph=171; end
  if (Mode==2) graph=172; end
  if (Mode==3) graph=173; end
  if (Mode==4) graph=174; end
  if (Mode==5) graph=175; end
  if (Mode==6) graph=176; end
  if (Mode==7) graph=182; size=0; end
  if (Mode==8) graph=236; end
  if (Mode==9) graph=237; end
  loop
    frame;
    if (Mode==5) frame(2000); frame(2000); graph=177; end
    if (Mode==6) frame(2000); frame(2000); graph=178; end
    if (Mode==7 and size<100) size+=10; end
  end
end



process ComputerGameArm();
private
  int SpeedCounter;
begin
  graph=254; y=-125; x=320; z=3; SpeedCounter=20;
  repeat
    frame;
    y+=SpeedCounter;
    if (SpeedCounter>4 and SpeedCounter%2==0) SpeedCounter--; end
  until(y=>255);
  y=255; HP=1; play_wav(CompOn,0);
  repeat frame; until(HP==2)
  play_wav(CompOn,0);
  repeat
    frame;
    y-=SpeedCounter;
    if (SpeedCounter<20 and rand(0,1)==1) SpeedCounter++; end
  until(y<=-125);
end



process MovingFloor(x,y,z,Mode);
private
  int YSpeed;
begin
  ctype=c_scroll; graph=169; YSpeed=8;
  repeat frame; until(collision(PlayerID) or collision(type MovingFloor))
  play_wav(FloorFall,0);
  if (Mode==0 or Mode==1) x++; end
  if (Mode==2) x--; end
  frame;
  repeat
    y+=YSpeed;
    if (YSpeed<17) YSpeed++; end
    if (Mode==1) x+=rand(0,1); angle-=500; end
    if (Mode==2) x-=rand(0,1); angle+=500; end
    frame;
  until(y>MaxLevelY)
end



process BabbyMover(x,y,z,Mode);
private
  int MoveCounter;
  int TempID;
begin
  ctype=c_scroll; graph=168; HP=1;
  if (Mode==1)
    flags=1; size=0;
    repeat size+=5; frame; until(size==100)
    repeat
      x+=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==425)
    repeat size-=5; frame; until(size==0)
    return;
  end

  if (Mode==2)
    flags=1; size=0;
    repeat size+=5; frame; until(size==100)
    repeat
      x+=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==357) MoveCounter=0;
    repeat
      y+=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==72) MoveCounter=0;
    repeat
      x+=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==161) MoveCounter=0;
    repeat
      y-=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==72) MoveCounter=0;
    repeat
      x+=2;
      MoveCounter++;

      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          ShockWave(TempID.x,TempID.y,z,130); Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1); signal(TempID, s_kill_tree); HP--;
        end
      end
      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
          Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
          Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2); HP--;
        end
      end
      if (HP<=0)
        BrokenBabbyMover(x,y,z,Mode); return;
      end

      frame;
    until(MoveCounter==310)
    repeat size-=5; frame; until(size==0)
    return;
  end
end


process BrokenBabbyMover(x,y,z,Mode);
private
  int FallSpeed;
  int FadeCounter;
begin
  ctype=c_scroll; graph=168; flags=1;
  if (BabbyCount<100) BabbyCount++; end
  Explode(x,y-20,z-1,75); CreateSparks(x,y-20,z-1,2); frame;
  Explode(x,y,z-1,75); CreateSparks(x,y,z-1,2); frame;
  Explode(x,y+20,z-1,75); CreateSparks(x,y+20,z-1,2);
  FallSpeed=2;
  repeat
    y+=FallSpeed;
    if (FallSpeed<14) FallSpeed++; end
    frame;
  until(collision(LevelCheckID));
  Explode(x,y+30,z-1,100); CreateSparks(x,y+30,z-1,2); y+=3;
  repeat
    angle+=10000; y++;
    Explode(x+rand(-20,20),y+rand(-20,20),z-1,100); Sparks(x+rand(-20,20),y+rand(-20,20),z-1,2);
    frame(50);
  until(angle=>90000)
  CreateSparks(x,y-20,4,6);
  CreateSparks(x,y-20,4,5);
  Explode(x-20,y,z-1,150); CreateSparks(x-20,y,z-1,2); frame;
  Explode(x,y,z-1,150); CreateSparks(x,y,z-1,2); frame;
  Explode(x+20,y,z-1,150); CreateSparks(x+20,y,z-1,2);
  angle=0; graph=380;
  repeat y++; frame(0); until(collision(LevelCheckID))
  repeat
    FadeCounter++;
    frame;
  until(FadeCounter=>800)
  Explode(x-20,y,z-1,100); CreateSparks(x-20,y,z-1,2); frame;
  Explode(x,y,z-1,100); CreateSparks(x,y,z-1,2); frame;
  Explode(x+20,y,z-1,100); CreateSparks(x+20,y,z-1,2);
end



process Player(x,y,z);
private
  int Counter;
  int DelayCounter;
  int JumpCounter;
  int TouchGround;
  int MoveSpeed;
  int MaxMoveSpeed;
  int MinMoveSpeed;
  int DubbelJump;
  int HoverCounter;
  int TempID;
  int HoverBallID;
  int AnimationCounter;
  int YFallSpeed;
begin

  scroll[0].camera=id;
  ctype=c_scroll;
  MaxMoveSpeed=8;
  MinMoveSpeed=-8;

  MoveSpeed=0;
  PlayerHealthMeter();
  HoverBallID=HoverBall(1);
  frame; PlayerWeaponID=PlayerWeapon();

  if (CurrentArea==32)
    MaxMoveSpeed=5;
    MinMoveSpeed=-5;
    signal(PlayerWeaponID, s_kill);
    PlayerWeaponID=PlayerNoWeapon(0);
    signal(HoverBallID, s_kill);
    HoverBallID=HoverBall(0);
  end

  loop

    if (key(_left) or joy_getaxis(0,0)<-20)
      if (MoveSpeed>MinMoveSpeed) MoveSpeed-=3; end
      flags=1;
    end

    if (key(_right) or joy_getaxis(0,0)>20)
      if (MoveSpeed<MaxMoveSpeed) MoveSpeed+=3; end
      flags=0;
    end

    if (MoveSpeed>0) Sparks(x,y+44,z+1,1); end
    if (MoveSpeed<0) Sparks(x,y+44,z+1,1); end

    if (MoveSpeed!=0) x+=MoveSpeed; AnimationCounter++; end
    if (AnimationCounter==2) graph=5; end
    if (AnimationCounter==4) graph=110; end
    if (AnimationCounter==6) graph=111; end
    if (AnimationCounter==8) graph=110; AnimationCounter=0; end

    if (MoveSpeed==0) graph=4; end
    if (CurrentArea==32) graph=389; end

    if (collision(LevelCheckID))
      if (MoveSpeed>0)
        MoveSpeed=-6;
        x-=9;
        JumpCounter=0;
        TouchGround=0;
      elseif (MoveSpeed<0)
        MoveSpeed=6;
        x+=9;
        JumpCounter=0;
        TouchGround=0;
      end
    end
    frame(0); Control=MoveSpeed;


    DelayCounter++;
    if (DelayCounter==1)
      DelayCounter=0;
      if (MoveSpeed>0) MoveSpeed--; end
      if (MoveSpeed<0) MoveSpeed++; end
    end

    if (JumpCounter==0)
      if (key(_control) or key(_z) or joy_getbutton(0,3))
        if (TouchGround==1)
          play_wav(Jump1,0);
          JumpCounter=25;
          TouchGround=0;
        end
      end
    end
    frame(0);
    if (DubbelJump==1)
      if (key(_control) or key(_z) or joy_getbutton(0,3))
        if (TouchGround==0 and JumpCounter<=16)
          play_wav(Jump1,0);
          JumpCounter=25;
          if (DubbelJump==1) DubbelJump=0; end
        end
      end
    end

    if (JumpCounter>0) JumpCounter--; end
    if (JumpCounter<0) JumpCounter=0; end
    y-=JumpCounter;
  
    y+=10;
 
    if (collision(LevelCheckID))
      if (JumpCounter==0) TouchGround=1; DubbelJump=1; end
      frame(0);
      repeat
        frame(0);
        y-=10;
        if (JumpCounter>0) y+=JumpCounter+3; JumpCounter=0; TouchGround=0; DubbelJump=0; break; end
      until (collision(LevelCheckID)==0)
    end

    if (MovingPlatformOn==1)
      if (TempID=collision(type MovingPlatform))
        TempID.Control=1;
        if (TempID.HP==0) x+=TempID.Check; end
        if (TempID.HP==1 or TempID.HP==2) y+=TempID.Check; end
        if (JumpCounter==0) TouchGround=1; DubbelJump=1; end
        frame(0);
        repeat
          frame(0);
          y-=10;
          if (JumpCounter>0) y+=JumpCounter+3; JumpCounter=0; TouchGround=0; DubbelJump=0;  break; end
        until (collision(type MovingPlatform)==0)
      end
    end

    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4) y++; frame(0); if (collision(LevelCheckID)) y--; end end
    if (HoverCounter==6 or HoverCounter==8) y--; end
    if (HoverCounter==10) HoverCounter=0; end

    if (PlayerHP<=0 or y>MaxLevelY+50)
      Explode(x,y-40,z-1,200); CreateSpread(x,y-40,z,4);
      Explode(x,y+40,z-1,200); CreateSpread(x,y+40,z,4);
      frame(200);
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        Spread(x+rand(-20,20),y+rand(-40,40),z,4);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        x+=MoveSpeed;
        if (MoveSpeed>0) MoveSpeed--; end
        if (MoveSpeed<0) MoveSpeed++; end
        frame;
      until(collision(LevelCheckID) or collision(type MovingPlatform) or y>MaxLevelY)
      signal(PlayerWeaponID, s_sleep); signal(HoverBallID, s_sleep);
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        Spread(x+rand(-20,20),y+rand(-40,40),z,4);
        if (flags==0) angle-=8000; end
        if (flags==1) angle+=8000; end
        alpha-=20; y++;
        frame;
      until(alpha<40)
      graph=0;
      frame(2000); frame(2000);
      if (PlayerLives>0) PlayerLives--; RestartLevel(); frame; return; end
      GameOver(); frame;
      loop frame; end
    end

    if (SolkBossOn>0)
      if (collision(type FlyBeam))
        JumpCounter=20; TouchGround=0; DubbelJump=1;
        play_wav(SpiritShot1,0);
      end
    end

    Check=Touchground;
    PlayerFlag=flags;
    Control=MoveSpeed;
    PlayerX=x;
    PlayerY=y;

    frame;
  end
end



process SpiritBattlePlayer(x,y,z,Mode);
private
  int PlayerWeaponID;
  int HoverCounter;
  int HoverBallID;
  int AnimationCounter;
begin

  if (Mode==0) scroll[0].camera=id; end
  ctype=c_scroll;
  PlayerHealthMeter();
  HoverBallID=HoverBall(1);
  frame; PlayerWeaponID=PlayerWeapon();
  graph=4;
  Control=0;
  Check=0;

  loop

    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4) y++; end
    if (HoverCounter==6 or HoverCounter==8) y--; end
    if (HoverCounter==10) HoverCounter=0; end

    PlayerX=x;
    PlayerY=y;

    frame;
  end
end




process FreeFallPlayer(x,y,z);
private
  int Counter;
  int DelayCounter;
  int MoveSpeed;
  int MaxMoveSpeed;
  int MinMoveSpeed;
  int AnimationCounter;
  int ReloadCounter;
  int TempID;
  int YFallSpeed;
  int ExplodeCounter;
begin

  ctype=c_scroll;
  MaxMoveSpeed=8;
  MinMoveSpeed=-8;
  MoveSpeed=0;
  PlayerHealthMeter();

  loop

    if (key(_left) or joy_getaxis(0,0)<-20)
      if (MoveSpeed>MinMoveSpeed) MoveSpeed-=2; end
      flags=1;
    end

    if (key(_right) or joy_getaxis(0,0)>20)
      if (MoveSpeed<MaxMoveSpeed) MoveSpeed+=2; end
      flags=0;
    end

    if (MoveSpeed!=0) x+=MoveSpeed; end
    AnimationCounter++;
    if (AnimationCounter==2) graph=191; end
    if (AnimationCounter==4) graph=370; end
    if (AnimationCounter==6) graph=371; end
    if (AnimationCounter==8) graph=372; AnimationCounter=0; end

    if (collision(LevelCheckID) and MoveSpeed>0)
      MoveSpeed=-6;
      x-=9;
    end
    frame(0); Control=MoveSpeed;
    if (collision(LevelCheckID) and MoveSpeed<0)
      MoveSpeed=6;
      x+=9;
    end
    frame(0); Control=MoveSpeed;

    DelayCounter++;
    if (DelayCounter==2)
      DelayCounter=0;
      if (MoveSpeed>0) MoveSpeed--; end
      if (MoveSpeed<0) MoveSpeed++; end
    end

    if (key(_alt) and ReloadCounter==0 or key(_x) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0)
      if (flags==0) FallGunFire(-1,0,z+1,0); end
      if (flags==1) FallGunFire(1,0,z+1,0); end
      ReloadCounter=20;
    end
    if (ReloadCounter>0) ReloadCounter--; end

    if (PlayerHP<=0)
      Explode(x,y-40,z-1,200); CreateSpread(x,y-40,z,4);
      Explode(x,y+40,z-1,200); CreateSpread(x,y+40,z,4);
      frame(200);
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        Spread(x+rand(-20,20),y+rand(-40,40),z,4);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        x+=MoveSpeed;
        if (MoveSpeed>0) MoveSpeed--; end
        if (MoveSpeed<0) MoveSpeed++; end
        ExplodeCounter++;
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY or ExplodeCounter=>30)
      repeat
        y+=YFallSpeed;
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        Spread(x+rand(-20,20),y+rand(-40,40),z,4);
        alpha-=20; y++;
        frame;
      until(alpha<40)
      graph=0;
      frame(2000); frame(2000);
      if (PlayerLives>0) PlayerLives--; RestartLevel(); frame; return; end
      GameOver(); frame;
      loop frame; end
    end

    if (TempID=collision(type FallSpinner)) PlayerHP--; TempID.HP=0; end

    PlayerFlag=flags;
    Control=MoveSpeed;
    PlayerX=x;
    PlayerY=y;

    frame;
  end
end



process FallCamera(x,y);
begin
  scroll[0].camera=id;
  loop
    y+=9;
    frame;
  end
end



process SchmupPlayer(Mode);
private
  int DelayCounter;
  int MoveSpeedX;
  int MoveSpeedY;
  int MaxMoveSpeed;
  int MinMoveSpeed;
  int ReloadCounter;
  int ReloadCounter2;
  int ReloadCounter3;
  int FallSpeed;
begin

  ctype=c_scroll;
  MaxMoveSpeed=7;
  MinMoveSpeed=-7;
  MoveSpeedX=0;
  MoveSpeedY=0;
  PlayerHealthMeter();
  graph=307;

  if (Mode==1)
    x=4800; y=240; z=5; PlayerHP=100;
    repeat
      x+=5;
      ShipTrail(x-29,y-3,z+1,0);
      ReloadCounter++;
      if (ReloadCounter==2) SchmupShockwave(x+10,y,z,0); ReloadCounter=0; end
      frame(50);
    until(x==5100);
    ReloadCounter=0;
  end

  if (Mode==0)
    x=-50; y=240; z=5;
    repeat
      x+=5;
      ShipTrail(x-29,y-3,z+1,0);
      ReloadCounter++;
      if (ReloadCounter==2) SchmupShockwave(x+10,y,z,0); ReloadCounter=0; end
      frame(50);
    until(x==180);
    ReloadCounter=0;
  end

  loop

    if (key(_left) or joy_getaxis(0,0)<-20)
      if (MoveSpeedX>MinMoveSpeed) MoveSpeedX-=2; end
    end

    if (key(_right) or joy_getaxis(0,0)>20)
      if (MoveSpeedX<MaxMoveSpeed) MoveSpeedX+=2; end
    end

    if (key(_up) or joy_getaxis(0,1)<-20)
      if (MoveSpeedY>MinMoveSpeed) MoveSpeedY-=2; end
    end

    if (key(_down) or joy_getaxis(0,1)>20)
      if (MoveSpeedY<MaxMoveSpeed) MoveSpeedY+=2; end
    end

    y+=MoveSpeedY;
    x+=MoveSpeedX;

    if (x<CameraID.x-295) x=CameraID.x-295; end
    if (x>CameraID.x+295) x=CameraID.x+295; end
    if (y<CameraID.y-215) y=CameraID.y-215; end
    if (y>CameraID.y+215) y=CameraID.y+215; end

    if (collision(LevelCheckID))
      MoveSpeedX=-(MoveSpeedX);
      MoveSpeedY=-(MoveSpeedY);
      Explode(x,y,z-1,100);
      PlayerHP-=10;
    end

    DelayCounter++;
    if (DelayCounter==2)
      DelayCounter=0;
      if (SchmupBossOn==0)
        if (MoveSpeedX>2) MoveSpeedX--; end
        if (MoveSpeedX<2) MoveSpeedX++; end
      end
      if (SchmupBossOn==1)
        if (MoveSpeedX>0) MoveSpeedX--; end
        if (MoveSpeedX<0) MoveSpeedX++; end
      end
      if (MoveSpeedY>0) MoveSpeedY--; end
      if (MoveSpeedY<0) MoveSpeedY++; end
    end

    if (key(_control) and ReloadCounter==0 or key(_z) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0)
      if (ShotUpgrade==0) Gun2Fire(x-5,y-3,z+1,1); end
      if (ShotUpgrade==1) Gun2Fire(x-5,y-3,z+1,1); Gun2Fire(x-5,y+3,z+1,1); end
      if (ShotUpgrade==2) Gun2Fire(x-5,y-3,z+1,1); Gun2Fire(x-5,y+3,z+1,1); Gun2Fire(x-5,y+9,z+1,1); end
      ReloadCounter=10;
    end
    if (ReloadCounter>0) ReloadCounter--; end

    if (ReloadCounter2==0 and MissileUpgrade==0)
      if (key(_alt) or key(_x) or joy_getbutton(0,3))
        play_wav(Rocket,0);
        SchmupMissile(x,y,z+1,1,6,0);
        SchmupMissile(x,y,z+1,2,6,0);
        ReloadCounter2=50;
      end
    end
    if (ReloadCounter2==0 and MissileUpgrade==1)
      if (key(_alt) or key(_x) or joy_getbutton(0,3))
        play_wav(Rocket,0);
        SchmupMissile(x,y,z+1,1,8,0);
        SchmupMissile(x,y,z+1,2,8,0);
        SchmupMissile(x,y,z+1,1,6,1);
        SchmupMissile(x,y,z+1,2,6,1);
        ReloadCounter2=50;
      end
    end  
    if (ReloadCounter2==0 and MissileUpgrade==2)
      if (key(_alt) or key(_x) or joy_getbutton(0,3))
        play_wav(Rocket,0);
        SchmupMissile(x,y,z+1,1,10,0);
        SchmupMissile(x,y,z+1,2,10,0);
        SchmupMissile(x,y,z+1,1,8,1);
        SchmupMissile(x,y,z+1,2,8,1);
        SchmupMissile(x,y,z+1,1,6,2);
        SchmupMissile(x,y,z+1,2,6,2);
        ReloadCounter2=50;
      end
    end 
    if (ReloadCounter2>0) ReloadCounter2--; end

    if (ReloadCounter3==0)
      if (key(_space) or key(_c) or joy_getbutton(0,0))
        Deflector(x,y,z-1,0); ReloadCounter3=200;
      end
    end
    if (ReloadCounter3>0) ReloadCounter3--; end

    if (PlayerHP<=0)
      signal(type Deflector, s_kill); Explode(x,y,z-1,150); frame(200);
      repeat
        angle+=1000;
        Explode(x,y,z-1,50);
        y+=FallSpeed;
        if (FallSpeed<8 and rand(0,1)==1) FallSpeed++; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      graph=0;
      fade(0,0,0,8);
      frame(2000);
      if (PlayerLives>0) PlayerLives--; SchmupLevel1(); frame; return; end
      GameOver(); frame; return;
    end

    if (rand(1,2)==1) GreySmoke(x-29,y-3,z+1,0); end
    ShipTrail(x-29,y-3,z+1,0);

    if (Control==1)
      repeat
        x+=10;
        ShipTrail(x-29,y-3,z+1,0);
        ReloadCounter++;
        if (ReloadCounter==2) SchmupShockwave(x+10,y,z,0); ReloadCounter=0; end
        frame(50);
      until(x=>5650);
      Credits();
      loop frame; end
    end

    if (Control==2)
      repeat
        x+=10;
        ShipTrail(x-29,y-3,z+1,0);
        ReloadCounter++;
        if (ReloadCounter==2) SchmupShockwave(x+10,y,z,0); ReloadCounter=0; end
        frame(50);
      until(x=>5650);
      loop frame; end
    end

    PlayerFlag=flags;
    PlayerX=x;
    PlayerY=y;

    frame;
  end
end



process ShipTrail(x,y,z,Mode);
begin
  ctype=c_scroll; graph=268; flags=17;
  repeat
    alpha-=20;
    frame;
  until(alpha<=40)
end



process RestartLevel();
begin

  fade(0,0,0,1); FadeSong();
  PlayerHP=100;

  if (CurrentArea==10) Level1Part0(30,370); end
  if (CurrentArea==11) Level1Part1(30,350); end
  if (CurrentArea==12) Level1Part2(30,470); end
  if (CurrentArea==13) Level1Part3(30,380); end
  if (CurrentArea==14) Level1Part4(30,585); end
  if (CurrentArea==15) Level1Part5(30,300); end
  if (CurrentArea==16) Level1Part6(30,230); end
  if (CurrentArea==17) Level1Part7(30,300); end
  if (CurrentArea==18) Level1Part8(30,700); end
  if (CurrentArea==19) Level1Part9(30,390,0); end
  if (CurrentArea==20) Level1Part10(30,310); end
  if (CurrentArea==205) PsykodromeCorridor(30,410); end
  if (CurrentArea==21) Level1Part11(30,800); end
  if (CurrentArea==22) Level1Part12(30,370); end
  if (CurrentArea==23) Level1Part13(270,-20); end
  if (CurrentArea==24) Level1Part14(400,-20); end
  if (CurrentArea==25) Level1Part15(214,-100); end
  if (CurrentArea==26) Level1Part16(30,380); end
  if (CurrentArea==27) Level1Part17(30,250); end
  if (CurrentArea==28) Level1Part18(30,730); end
  if (CurrentArea==285) Elevator1(30,2910); end
  if (CurrentArea==29) Level1Part19(40,450,0); end
  if (CurrentArea==30) Level1Part20(30,460); end

  if (CurrentArea==31) Level1Part21(30,460); end
  if (CurrentArea==32) Level1Part22(30,370); end
  if (CurrentArea==33) Level1Part23(30,1870); end
  if (CurrentArea==34) Level1Part24(30,420); end

end



process PlayerHealthMeter();
begin
  y=10; z=1; graph=42;
  PlayerHealthMeterBorder();
  loop
    x=-49+PlayerHP;
    frame;
  end
end



process PlayerHealthMeterBorder();
private
  int AmmoTextID;
  int LivesTextID;
  int ScoreTextID;
  int DisplayAmmo;
  int DisplayScore;
  int Reset;
begin
    x=67; y=32; z=0; graph=41; DisplayScore=PlayerScore;
    AmmoTextID=write_int(0,4,43,0,&DisplayAmmo);
    LivesTextID=write_int(0,32,43,0,&PlayerLives);
    ScoreTextID=write_int(0,4,54,0,&DisplayScore);
    loop
      if (SelectedWeapon==1) DisplayAmmo=0; end
      if (SelectedWeapon==2) DisplayAmmo=AmmoType1; end
      if (SelectedWeapon==3) DisplayAmmo=AmmoType2; end
      if (SelectedWeapon==4) DisplayAmmo=AmmoType3; end
      if (SelectedWeapon==5) DisplayAmmo=0; end
      if (Reset>0) Reset--; end
      if (Reset==0)
        delete_text(AmmoTextID); AmmoTextID=write_int(0,4,43,0,&DisplayAmmo); Reset=20;
        delete_text(LivesTextID); LivesTextID=write_int(0,32,43,0,&PlayerLives); Reset=20;
        delete_text(ScoreTextID); ScoreTextID=write_int(0,4,54,0,&DisplayScore); Reset=20;
      end
      if (DisplayScore<PlayerScore) DisplayScore+=10; end
      if (ComboCounter>0) ComboCounter--; end
      if (ComboCounter==1) Combo=0; end
      frame;
    end
end



process HoverBall(Mode);
begin
  ctype=c_scroll; graph=43; z=6; alpha=100; flags=16;

  if (Mode==0)
    loop
      y=father.y+40;
      if (PlayerFlag==0) x=father.x-11; end
      if (PlayerFlag==1) x=father.x+11; end
      frame(10);
    end
  end

  loop

    if (father.Control==0)
      y=father.y+36;
      if (PlayerFlag==0) x=father.x-6; end
      if (PlayerFlag==1) x=father.x+6; end
    end

    if (father.Control!=0)
      y=father.y+26;
      if (PlayerFlag==0) x=father.x-26; end
      if (PlayerFlag==1) x=father.x+26; end
    end

    if (Control==1)
      repeat
        alpha-=10;
        frame(50);
      until(alpha<=40)
      return;
    end
    frame(10);
  end
end



process PlayerNoWeapon(Setting);
private
  int Mode;
  int ReloadCounter;
  int SwordLift;
  int ChargeCounter;
begin
  ctype=c_scroll; graph=289; z=4;

  if (Setting==0)
    loop frame; end
  end

  if (Setting==1)
    loop
      flags=father.flags;
      if (flags==0) Mode=1; end
      if (flags==1) Mode=4; end  

      if (flags==0) x=father.x+39; y=father.y-13; end
      if (flags==1) x=father.x-39; y=father.y-13; end

      frame(10);
    end
  end

  loop
    flags=father.flags;
    if (flags==0) Mode=1; end
    if (flags==1) Mode=4; end  

    if (PlayerID.Control==0)
      if (flags==0)
        x=father.x+39; y=father.y-13;
      end
      if (flags==1)
        x=father.x-39; y=father.y-13;
      end
    end
    if (PlayerID.Control>0 or PlayerID.Control<0)
      if (flags==0)
        x=father.x+43; y=father.y+3;
      end
      if (flags==1)
        x=father.x-43; y=father.y+3;
      end
    end

    frame(10);
  end
end



process PlayerWeapon();
private
  int Mode;
  int ReloadCounter;
  int SwordLift;
  int ChargeCounter;
  int SwitchWeapon;
  int FireMode;
begin
  ctype=c_scroll; graph=6; z=4;

  loop

    if (key(_tab) and SwitchWeapon==0 or joy_getbutton(0,4) and SwitchWeapon==0)
      SelectedWeapon++;
      if (SelectedWeapon>MaxWeapon) SelectedWeapon=MinWeapon; end
      if (SelectedWeapon<MinWeapon) SelectedWeapon=MaxWeapon; end
      SwitchWeapon=2;
    end
    if (key(_backspace) and SwitchWeapon==0 or joy_getbutton(0,5) and SwitchWeapon==0)
      SelectedWeapon--;
      if (SelectedWeapon>MaxWeapon) SelectedWeapon=MinWeapon; end
      if (SelectedWeapon<MinWeapon) SelectedWeapon=MaxWeapon; end
      SwitchWeapon=2;
    end

    if (SwitchWeapon==2 and size_y>10)
      size_y-=2;
    end
    if (SwitchWeapon==2 and size_y==10) SwitchWeapon=1; end

    if (SwitchWeapon==1 and size_y<100)
      size_y+=2;
    end
    if (SwitchWeapon==1 and size_y==100) SwitchWeapon=0; end

    if (SelectedWeapon==1)
      graph=6; flags=father.flags;
      if (flags==0) Mode=1; end
      if (flags==1) Mode=4; end  

      if (PlayerID.Control==0)
        if (flags==0)
          x=father.x+39; y=father.y-13;
        end
        if (flags==1)
          x=father.x-39; y=father.y-13;
        end
      end
      if (PlayerID.Control>0 or PlayerID.Control<0)
        if (flags==0)
          x=father.x+43; y=father.y+3;
        end
        if (flags==1)
          x=father.x-43; y=father.y+3;
        end
      end


      if (key(_up) or joy_getaxis(0,1)<-20)
        graph=8; flags=father.flags;
        if (flags==0) Mode=0; end
        if (flags==1) Mode=3; end  

        if (PlayerID.Control==0)
          if (flags==0)
            x=PlayerX+34; y=PlayerY-21;
          end
          if (flags==1)
            x=PlayerX-34; y=PlayerY-21;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+37; y=father.y-9;
          end
          if (flags==1)
            x=father.x-37; y=father.y-9;
          end
        end
      end

      if (key(_down) or joy_getaxis(0,1)>20)
        graph=9; flags=father.flags;
        if (flags==0) Mode=2; end
        if (flags==1) Mode=5; end   

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+35; y=father.y-5;
          end
          if (flags==1)
            x=father.x-35; y=father.y-5;
          end
        end     
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+40; y=father.y+12;
          end
          if (flags==1)
            x=father.x-40; y=father.y+12;
          end

        end
      end

      if (SwitchWeapon==0)
        if (key(_alt) and ReloadCounter==0 or key(_x) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0) Gun1Fire(x,y,z+1,Mode); ReloadCounter=100; end
      end
      if (ReloadCounter>0) ReloadCounter--; end
    end



    if (SelectedWeapon==2)
      graph=131; flags=father.flags;
      if (flags==0) Mode=1; end
      if (flags==1) Mode=4; end  

      if (PlayerID.Control==0)
        if (flags==0)
          x=father.x+47; y=father.y-10;
        end
        if (flags==1)
          x=father.x-47; y=father.y-10;
        end
      end
      if (PlayerID.Control>0 or PlayerID.Control<0)
        if (flags==0)
          x=father.x+50; y=father.y+3;
        end
        if (flags==1)
          x=father.x-50; y=father.y+3;
        end
      end

      if (key(_up) or joy_getaxis(0,1)<-20)
        graph=133; flags=father.flags;
        if (flags==0) Mode=0; end
        if (flags==1) Mode=3; end  

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+40; y=father.y-27;
          end
          if (flags==1)
            x=father.x-40; y=father.y-27;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+43; y=father.y-15;
          end
          if (flags==1)
            x=father.x-43; y=father.y-15;
          end
        end
      end

      if (key(_down) or joy_getaxis(0,1)>20)
        graph=132; flags=father.flags;
        if (flags==0) Mode=2; end
        if (flags==1) Mode=5; end

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+42; y=father.y+2;
          end
          if (flags==1)
            x=father.x-42; y=father.y+2;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+46; y=father.y+15;
          end
          if (flags==1)
            x=father.x-46; y=father.y+15;
          end
        end
      end

      if (key(_alt) and ReloadCounter==0 or key(_x) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0)
        if (AmmoType1>0 and SwitchWeapon==0)
          AmmoType1--;
          if (flags==0) Gun2Fire(x+4,y,z+1,Mode); end
          if (flags==1) Gun2Fire(x-16,y,z+1,Mode); end
          ReloadCounter=50;
        end
      end
      if (ReloadCounter>0) ReloadCounter--; end
    end



    if (SelectedWeapon==3)
      FireMode=1;
      graph=137; flags=father.flags;
      if (flags==0) Mode=1; end
      if (flags==1) Mode=4; end  
      if (PlayerID.Control==0)
        if (flags==0)
          x=father.x+47; y=father.y-10;
        end
        if (flags==1)
          x=father.x-47; y=father.y-10;
        end
      end
      if (PlayerID.Control>0 or PlayerID.Control<0)
        if (flags==0)
          x=father.x+50; y=father.y+3;
        end
        if (flags==1)
          x=father.x-50; y=father.y+3;
        end
      end

      if (key(_up) or joy_getaxis(0,1)<-20)
        FireMode=2;
        graph=133; flags=father.flags;
        if (flags==0) Mode=0; end
        if (flags==1) Mode=3; end  

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+40; y=father.y-27;
          end
          if (flags==1)
            x=father.x-40; y=father.y-27;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+43; y=father.y-15;
          end
          if (flags==1)
            x=father.x-43; y=father.y-15;
          end
        end
      end

      if (key(_down) or joy_getaxis(0,1)>20)
        FireMode=3;
        graph=132; flags=father.flags;
        if (flags==0) Mode=2; end
        if (flags==1) Mode=5; end

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+42; y=father.y+2;
          end
          if (flags==1)
            x=father.x-42; y=father.y+2;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+46; y=father.y+15;
          end
          if (flags==1)
            x=father.x-46; y=father.y+15;
          end
        end
      end

      if (key(_alt) and ReloadCounter==0 or key(_x) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0)
        if (AmmoType2>0 and SwitchWeapon==0)
          AmmoType2--; play_wav(Laser,0);
          if (flags==0)
            if (FireMode==1)
              Gun3Fire(x+20,y,z+1,0); Gun3Fire(x+20,y,z+1,1); Gun3Fire(x+20,y,z+1,2); ReloadCounter=100;
            end
            if (FireMode==1)
              Gun3Fire(x+20,y,z+1,0); Gun3Fire(x+20,y,z+1,1); Gun3Fire(x+20,y,z+1,2); ReloadCounter=100;
            end
            if (FireMode==2)
              Gun3Fire(x+20,y-20,z+1,6); Gun3Fire(x+20,y-20,z+1,1); Gun3Fire(x+20,y-20,z+1,0); ReloadCounter=100;
            end
            if (FireMode==3)
              Gun3Fire(x+20,y+20,z+1,7); Gun3Fire(x+20,y+20,z+1,1); Gun3Fire(x+20,y+20,z+1,2); ReloadCounter=100;
            end
          end
          if (flags==1)
            if (FireMode==1)
              Gun3Fire(x-20,y,z+1,3); Gun3Fire(x-20,y,z+1,4); Gun3Fire(x-20,y,z+1,5); ReloadCounter=100;
            end
            if (FireMode==1)
              Gun3Fire(x-20,y,z+1,3); Gun3Fire(x-20,y,z+1,4); Gun3Fire(x-20,y,z+1,5); ReloadCounter=100;
            end
            if (FireMode==2)
              Gun3Fire(x-20,y-20,z+1,6); Gun3Fire(x-20,y-20,z+1,4); Gun3Fire(x-20,y-20,z+1,3); ReloadCounter=100;
            end
            if (FireMode==3)
              Gun3Fire(x-20,y+20,z+1,7); Gun3Fire(x-20,y+20,z+1,4); Gun3Fire(x-20,y+20,z+1,5); ReloadCounter=100;
            end
          end
        end
      end
      if (ReloadCounter>0) ReloadCounter--; end
    end



    if (SelectedWeapon==4)
      graph=143; flags=father.flags;
      if (flags==0) Mode=1; end
      if (flags==1) Mode=4; end  
      if (PlayerID.Control==0)
        if (flags==0)
          x=father.x+47; y=father.y-10;
        end
        if (flags==1)
          x=father.x-47; y=father.y-10;
        end
      end
      if (PlayerID.Control>0 or PlayerID.Control<0)
        if (flags==0)
          x=father.x+50; y=father.y+3;
        end
        if (flags==1)
          x=father.x-50; y=father.y+3;
        end
      end

      if (key(_up) or joy_getaxis(0,1)<-20)
        graph=133; flags=father.flags;
        if (flags==0) Mode=0; end
        if (flags==1) Mode=3; end  

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+40; y=father.y-27;
          end
          if (flags==1)
            x=father.x-40; y=father.y-27;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+43; y=father.y-15;
          end
          if (flags==1)
            x=father.x-43; y=father.y-15;
          end
        end
      end

      if (key(_down) or joy_getaxis(0,1)>20)
        graph=132; flags=father.flags;
        if (flags==0) Mode=2; end
        if (flags==1) Mode=5; end

        if (PlayerID.Control==0)
          if (flags==0)
            x=father.x+42; y=father.y+2;
          end
          if (flags==1)
            x=father.x-42; y=father.y+2;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+46; y=father.y+15;
          end
          if (flags==1)
            x=father.x-46; y=father.y+15;
          end
        end
      end

      if (key(_alt) and ReloadCounter==0 or key(_x) and ReloadCounter==0 or joy_getbutton(0,2) and ReloadCounter==0)
        if (AmmoType3>0 and SwitchWeapon==0)
          Ammotype3--;
          Gun4Fire(x,y,z+1,Mode);
          ReloadCounter=200;
        end
      end
      if (ReloadCounter>0) ReloadCounter--; end
    end



    if (SelectedWeapon==5)
      graph=15; flags=father.flags;

      if (PlayerID.Control==0)
        if (flags==0)
          x=PlayerX+78; y=PlayerY-13;
        end
        if (flags==1)
          x=PlayerX-78; y=PlayerY-13;
        end
      end
      if (PlayerID.Control>0 or PlayerID.Control<0)
        if (flags==0)
          x=father.x+83; y=father.y-2;
        end
        if (flags==1)
          x=father.x-83; y=father.y-2;
        end
      end

      if (key(_alt) and SwordLift==0 or key(_x) and SwordLift==0 or joy_getbutton(0,2) and SwordLift==0)
        play_wav(Sword1,0);
        flags=father.flags+16;
        if (flags==16) x=father.x+56; end
        if (flags==17) x=father.x-56; end
        y=father.y-48; graph=16;
        frame; SwordLift=1;
      end

      if (key(_alt) and SwordLift==1 or key(_x) and SwordLift==1 or joy_getbutton(0,2) and SwordLift==1)
        if (exists(type ChargeMeter)==0 and ChargeCounter>40) ChargeMeter(); end
        if (ChargeCounter>40 and rand(1,2)==1) SwordParticle(rand(-10,10),rand(10,30),4,0); end
        if (ChargeCounter<600) ChargeCounter++; end
        HP=ChargeCounter;
        graph=17; flags=father.flags;

        if (PlayerID.Control==0)
          if (flags==0)
            x=PlayerX+24; y=PlayerY-60;
          end
          if (flags==1)
            x=PlayerX-24; y=PlayerY-60;
          end
        end
        if (PlayerID.Control>0 or PlayerID.Control<0)
          if (flags==0)
            x=father.x+28; y=father.y-47;
          end
          if (flags==1)
            x=father.x-28; y=father.y-47;
          end
        end
      end

      if (key(_alt)==0 and key(_x)==0 and joy_getbutton(0,2)==0 and SwordLift==1)
        if (ChargeCounter=>500) SwordSlash(x,y-48,z,Mode); play_wav(Slash,0); end
        if (ChargeCounter<500) play_wav(Sword1,0); end
        ChargeCounter=0; HP=0; SwordDamage=25; frame(0);
        flags=father.flags+16;
        if (flags==16) x=father.x+56; end
        if (flags==17) x=father.x-56; end
        y=father.y-48; graph=16;
        frame; SwordLift=0;
        if (flags==16)
          Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x+25+rand(-5,5),y+42+rand(-5,5),4,2);
        end
        if (flags==17)
          Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2);
          Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2); Spread(x-25+rand(-5,5),y+42+rand(-5,5),4,2);
        end
      end
    end

    Check=SwordLift;
    if (SwordDamage>0) SwordDamage--; end

    frame(10);
  end
end



process AmmoPack(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll;
  if (Mode==1) graph=298; end
  if (Mode==2) graph=299; end
  if (Mode==3) graph=300; end

  repeat
    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4 or HoverCounter==6 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==14 or HoverCounter==16 or HoverCounter==18) y--; end
    if (HoverCounter==20) HoverCounter=0; end
    frame;
  until(collision(PlayerID))
  PlayerScore+=100;

  play_wav(PickUp,0);

  if (Mode==1)
    AmmoType1+=100;
    if (AmmoType1>300) AmmoType1=300; end
  end
  if (Mode==2)
    AmmoType2+=100;
    if (AmmoType2>200) AmmoType1=200; end
  end
  if (Mode==3)
    AmmoType3+=20;
    if (AmmoType3>100) AmmoType1=100; end
  end

  z=4;
  repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; size_y-=3; frame(20); until(size_x<=20)
  CreateSpread(x,y,z,1);
end



process HealthPack(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll;
  if (Mode==1) graph=301; end

  repeat
    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4 or HoverCounter==6 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==14 or HoverCounter==16 or HoverCounter==18) y--; end
    if (HoverCounter==20) HoverCounter=0; end
    frame;
  until(collision(PlayerID))
  play_wav(PickUp,0);

  if (Mode==1)
    PlayerHP+=50;
    if (PlayerHP>100) PlayerHP=100; end
  end

  z=4;
  repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; frame(20); until(size_x<=10) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; size_y-=3; frame(20); until(size_x<=20)
  CreateSpread(x,y,z,1);

end



process SwordSlash(x,y,z,Mode);
private
  int Direction;
  int FadeCounter;
begin
  ctype=c_scroll; graph=90;
  Direction=PlayerFlag; flags=16+Direction;
  repeat
    SwordDamage=4;
    FadeCounter++;
    if (Direction==0) x+=20; end
    if (Direction==1) x-=20; end
    if (collision(LevelCheckID))
      if (Direction==0) x-=17; end
      if (Direction==1) x+=17; end
      size_x-=10;
      alpha-=20;
    end
    size+=2;
    frame;
  until(alpha<20 or FadeCounter==200)
end



process SwordParticle(XOffset,YOffset,z,Mode);
private
  int MoveCounter;
  int Direction;
  int YDirection;
begin
  ctype=c_scroll; graph=89; flags=16; alpha=150; size=20; Direction=rand(1,2);
  repeat
    x=father.x+XOffset;
    y=father.y+YOffset;
    MoveCounter++;
    if (Direction==1)
      if (MoveCounter>0 and MoveCounter<=10) XOffset++; end
      if (MoveCounter>10 and MoveCounter<=20) XOffset--; end
    end
    if (Direction==2)
      if (MoveCounter>0 and MoveCounter<=10) XOffset--; end
      if (MoveCounter>10 and MoveCounter<=20) XOffset++; end
    end
    if (MoveCounter>20) MoveCounter=0; end
    YOffset-=rand(1,2);
    if (YOffset<-50)
      repeat
        alpha-=20;
        YOffset-=rand(1,2);
        x=father.x+XOffset;
        y=father.y+YOffset;
        frame;
      until(alpha<=40)
      return;
    end
    frame(50);
  until(father.Check==0)
  Direction=PlayerFlag; YDirection=rand(1,3);
  repeat
    alpha-=10;
    if (Direction==0) x+=10; end
    if (Direction==1) x-=10; end
    if (YDirection==1) y+=5; end
    if (YDirection==3) y-=5; end
    y+=rand(-1,1);
    frame;
  until(alpha<20)
end



process ChargeMeter();
begin
  ctype=c_scroll; graph=88; z=2;
  repeat
    x=PlayerX; y=PlayerY-140;
    if (father.HP==10) play_wav(Charge2,0); end
    if (father.HP>0 and father.HP<=100) graph=88; end
    if (father.HP>100 and father.HP<=200) graph=83; end
    if (father.HP>200 and father.HP<=300) graph=84; end
    if (father.HP>300 and father.HP<=400) graph=85; end
    if (father.HP>400 and father.HP<=500) graph=86; end
    if (father.HP>500 and father.HP<=600) graph=87; end
    frame(50);
  until(father.HP==0);
end



process ButtonMasher(x,y,z,Mode);
begin
  graph=252;
  if (Mode==0)
    repeat
      repeat
        frame;
      until(key(_left) or joy_getaxis(0,0)<-20)
      HP++; play_wav(Mashing,0);
      graph=253;
      repeat
        frame;
      until(key(_right) or joy_getaxis(0,0)>20)
      HP++; play_wav(Mashing,0);
      graph=252;
    until(HP=>70);
  end
  if (Mode==1)
    loop
      repeat
        if (Control==1) repeat alpha-=10; frame(50); until(alpha<=0) return; end
        frame;
      until(key(_left) or joy_getaxis(0,0)<-20)
      HP++; play_wav(Mashing,0);
      graph=253;
      repeat
        if (Control==1) repeat alpha-=10; frame(50); until(alpha<=0) return; end
        frame;
      until(key(_right) or joy_getaxis(0,0)>20)
      HP++; play_wav(Mashing,0);
      graph=252;
    end
  end
  loop
    if (Control==1) repeat alpha-=10; frame(50); until(alpha<=0) return; end
    frame;
  end
end



process Gun1Fire(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; flags=16; size=30;
  play_wav(Photon,0);
  if (Mode==0) graph=12; y-=2; end
  if (Mode==1) graph=10; y-=3; end
  if (Mode==2) graph=11; y-=2; end

  if (Mode==3) graph=12; y-=2; flags=17; end
  if (Mode==4) graph=10; y-=3; flags=17; end
  if (Mode==5) graph=11; y-=2; flags=17; end

  repeat
    if (Mode==0) x+=5; y-=5; end
    if (Mode==1) x+=5; end
    if (Mode==2) x+=5; y+=5; end
    if (Mode==3) x-=5; y-=5; end
    if (Mode==4) x-=5; end
    if (Mode==5) x-=5; y+=5; end
    FadeCounter++;
    if (FadeCounter>100 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (size<100) size+=5; end
    frame(25);
  until(collision(LevelCheckID))
  CreateSpread(x,y,z,1);
  GlobalRed+=10; GlobalGreen+=5; GlobalBlue+=10;
  ShockWave(x,y,z,130);
  repeat size-=8; frame(50); until(size<=20)
  GunFade(x,y,z,Mode);
end



process Gun2Fire(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; flags=16; size=30;
  play_wav(Laser,0);
  if (Mode==0) graph=136; y-=7; x+=6; end
  if (Mode==1) graph=134; y-=3; end
  if (Mode==2) graph=135; y+=4; x+=6; end

  if (Mode==3) graph=136; y-=7; x+=6; flags=17; end
  if (Mode==4) graph=134; y-=3; flags=17; end
  if (Mode==5) graph=135; y+=4; x+=6; flags=17; end

  repeat
    if (Mode==0) x+=5; y-=5; end
    if (Mode==1) x+=5; end
    if (Mode==2) x+=5; y+=5; end
    if (Mode==3) x-=5; y-=5; end
    if (Mode==4) x-=5; end
    if (Mode==5) x-=5; y+=5; end
    FadeCounter++;
    if (FadeCounter>100 or y<-30 or x<-30 or x>5500 or y>MaxLevelY) return; end
    if (size<100) size+=5; end
    frame(25);
  until(collision(LevelCheckID))
  CreateSpread(x,y,z,5); GlobalRed+=10; GlobalBlue+=5;
  ShockWave(x,y,z,130);
  repeat size-=10; frame(50); until(size<=20)
  GunFade(x,y,z,Mode);
end



process Gun3Fire(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; flags=16; size=50;
  if (Mode==0) graph=142; y-=2; end
  if (Mode==1) graph=140; y-=3; end
  if (Mode==2) graph=141; y-=2; end

  if (Mode==3) graph=142; y-=2; flags=17; end
  if (Mode==4) graph=140; y-=3; flags=17; end
  if (Mode==5) graph=141; y-=2; flags=17; end

  if (Mode==6) graph=140; y-=2; angle=90000; end
  if (Mode==7) graph=140; y-=2; angle=90000; end

  frame(25);

  repeat
    if (Mode==0) x+=5; y-=5; end
    if (Mode==1) x+=5; end
    if (Mode==2) x+=5; y+=5; end
    if (Mode==3) x-=5; y-=5; end
    if (Mode==4) x-=5; end
    if (Mode==5) x-=5; y+=5; end
    if (Mode==6) y-=5; end
    if (Mode==7) y+=5; end

    FadeCounter++;
    if (FadeCounter>100 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (size<100) size+=5; end
    frame(25);
  until(collision(LevelCheckID))
  CreateSpread(x,y,z,5); GlobalRed+=10; GlobalBlue+=5;
  ShockWave(x,y,z,130);
  repeat size-=10; frame(50); until(size<=20)
  GunFade(x,y,z,Mode);
end



process Gun4Fire(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=146; flags=16;
  play_wav(BigShot,0);
  if (Mode==1 or Mode==4) y-=5; end
  if (Mode==0) x+=4; y-=4; end
  if (Mode==1) x+=4; end
  if (Mode==2) x+=4; y+=4; end
  if (Mode==3) x-=4; y-=4; end
  if (Mode==4) x-=4; end
  if (Mode==5) x-=4; y+=4; end
  repeat
    if (Mode==0) x+=4; y-=4; end
    if (Mode==1) x+=4; end
    if (Mode==2) x+=4; y+=4; end
    if (Mode==3) x-=4; y-=4; end
    if (Mode==4) x-=4; end
    if (Mode==5) x-=4; y+=4; end
    FadeCounter++;
    frame(20);
  until(collision(LevelCheckID) or FadeCounter==25)
  play_wav(Gun2,0);
  Gun4Shrapnel(x,y,z,Mode); frame(10); Gun4Shrapnel(x,y,z,Mode); frame(10);
  Gun4Shrapnel(x,y,z,Mode); frame(10); Gun4Shrapnel(x,y,z,Mode); frame(10);
  Gun4Shrapnel(x,y,z,Mode); frame(10); Gun4Shrapnel(x,y,z,Mode); frame(10);
  Gun4Shrapnel(x,y,z,Mode); frame(10); Gun4Shrapnel(x,y,z,Mode);
end



process Gun4Shrapnel(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=146; flags=16; play_wav(Shot4,0);
  angle=fget_angle(x,y,EnemyFindX,EnemyFindY)+(rand(-20,20)*1000);
  Spread(x,y,z,11);
  repeat
    advance(4);
    FadeCounter++;
    frame(20);
  until(collision(LevelCheckID) or FadeCounter==100)
  Explode(x,y,z-1,20); frame(200);
end



process GunFade(x,y,z,Mode);
begin
  ctype=c_scroll; graph=268; flags=16;
  if (Mode==0) x+=6; y-=6; end
  if (Mode==1) x+=6; end
  if (Mode==2) x+=6; y+=6; end
  if (Mode==3) x-=6; y-=6; end
  if (Mode==4) x-=6; end
  if (Mode==5) x-=6; y+=6; end
  repeat alpha-=10; frame; until(alpha<=50)
end



process FallGunFire(XOffset,YOffset,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; flags=16; graph=192; size_y=20; size_x=20;
  repeat y=PlayerID.y+40+YOffset; x=(PlayerID.x+XOffset); YOffset+=2; size_y+=8; size_x+=4; frame(50); until(size_y==100)
  GlobalGreen+=30; play_wav(Longshot,0);

  repeat
    y+=10;
    FadeCounter++;
    if (rand(1,2)==1) Spread(x,y,z,8); end
    frame(25);
  until(FadeCounter>50)
end



process SchmupMissile(x,y,z,Mode,SpeedY,LaunchDelay);
private
  int AnimationCounter;
  int SpeedX;
begin
  ctype=c_scroll; graph=322;

  repeat
    LaunchDelay--;
    frame;
  until(LaunchDelay<0)

  repeat
    if (Mode==1) y+=SpeedY; end
    if (Mode==2) y-=SpeedY; end
    x+=SpeedX;
    if (SpeedX<3) SpeedX++; end
    if (SpeedY>0) SpeedY--; end
    if (collision(LevelCheckID))
      ShockWave(x,y,z,130);
      Explode(x,y,z-1,50);
      Spread(x,y,z,1); Spread(x,y,z,1); Spread(x,y,z,1);
      return;
    end
    frame;
  until(SpeedY==0)

  repeat
    AnimationCounter++;
    if (AnimationCounter==1 or AnimationCounter==2) graph=322; end
    if (AnimationCounter==3 or AnimationCounter==4) graph=323; end
    if (AnimationCounter==5) AnimationCounter=0; end  
    if (SpeedX<15) SpeedX++; end
    x+=SpeedX;
    GreySmoke(x-12,y+rand(-1,1),z+1,0);
    if (collision(LevelCheckID))
      ShockWave(x+5,y,z,130);
      Explode(x+5,y,z-1,50);
      Spread(x,y,z,1); Spread(x,y,z,1); Spread(x,y,z,1); Spread(x,y,z,1);
      return;
    end
  
    frame;
  until(x>CameraID.x+340)
end



process Deflector(x,y,z,Mode);
private
  int FadeCounter;
  int Direction;
begin
  ctype=c_scroll; graph=233; size=20; flags=16; alpha=255; Direction=1;
  repeat
    if (size<90) size+=5; end
    if (size>90 and Direction==1) size--; end
    if (size==90) Direction=2; end
    if (size<110 and Direction==2) size++; end
    if (size==110) Direction=1; end
    FadeCounter++;
    x=father.x; y=father.y;
    frame(20);
  until(FadeCounter=>300)
  repeat size+=5; alpha-=20; frame(50); until(alpha<=40)
end



process SchmupShockwave(x,y,z,Mode);
begin
  ctype=c_scroll; graph=233; size=20; flags=16; alpha=255;
  repeat
    size+=10; alpha-=5;
    frame(50);
  until(alpha<=30)
end



process MovingPlatform(x,StartY,z,Range,Mode);
private
  int Speed;
  int YOffset;
  int MoveCounter;
begin
  ctype=c_scroll; y=StartY; HP=Mode;
  if (Mode==0 or Mode==1) graph=50; Speed=2; end
  if (Mode==2)
    graph=375;
    Speed=2;
    repeat frame; until(fget_dist(x,y,PlayerX,PlayerY)<170)
  end

  if (Mode==0)
    loop
      MoveCounter++;
      if (MoveCounter<Range)
        Check=Speed;
        x+=Speed;
      end
      if (MoveCounter>Range and MoveCounter<Range*2)
        Check=-Speed;
        x-=Speed;
      end
      if (MoveCounter==Range*2) MoveCounter=0; end
/*
      if (Control==1 and PlayerID.Check==1)
        Control=0; YOffset=5;
      end
      y=StartY+YOffset;
      if (YOffset>0) YOffset--; end
*/
      frame;
    end
  end

  if (Mode==1)
    loop
      MoveCounter++;
      if (MoveCounter<Range)
        Check=Speed;
        y+=Speed;
      end
      if (MoveCounter>Range and MoveCounter<Range*2)
        Check=-Speed;
        y-=Speed;
      end
      if (MoveCounter==Range*2) MoveCounter=0; end

      frame;
    end
  end

  if (Mode==2)
    loop
      MoveCounter++;
      if (MoveCounter<Range)
        Check=-Speed;
        y-=Speed;
      end
      if (MoveCounter>Range and MoveCounter<Range*2)
        Check=0;
        loop frame; end
      end
      if (MoveCounter==Range*2) MoveCounter=0; end
      frame;
    end
  end

end




process SpiderMine(x,y,z,Mode);
private
  int BlinkCounter;
  int LaunchSpeed;
  int TempID;
begin
  ctype=c_scroll; graph=128;
  repeat
    BlinkCounter++;
    if (BlinkCounter==50) SpiderMineFlash(x+1,y+5,2,Mode); BlinkCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        repeat
          Explode(x+rand(-10,10),y+rand(-10,10),z,150);
          alpha-=20;
          frame;
        until(alpha<=80)
        return;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        repeat
          Explode(x+rand(-10,10),y+rand(-10,10),z,150);
          alpha-=20;
          frame;
        until(alpha<=80)
        return;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        repeat
          Explode(x+rand(-10,10),y+rand(-10,10),z,150);
          alpha-=20;
          frame;
        until(alpha<=80)
        return;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        repeat
          Explode(x+rand(-10,10),y+rand(-10,10),z,150);
          alpha-=20;
          frame;
        until(alpha<=80)
        return;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        repeat
          Explode(x+rand(-10,10),y+rand(-10,10),z,150);
          alpha-=20;
          frame;
        until(alpha<=80)
        return;
      end
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  until(fget_dist(x,y,PlayerX,PlayerY)<120)
  play_wav(MineJump,0); LaunchSpeed=13; graph=129;
  repeat
    y-=LaunchSpeed;
    LaunchSpeed--;
    frame;
  until(LaunchSpeed<4)
  CreateSpread(x,y,z,3);
  repeat
    Explode(x+rand(-10,10),y+rand(-10,10),z,rand(40,120));
    alpha-=20;
    frame;
  until(alpha<=80)
end



process SpiderMineFlash(x,y,z,Mode); 
begin
  ctype=c_scroll; graph=117; flags=16; size=10; alpha=240;
  repeat size+=10; alpha-=20; frame; until(size=>100)
end



process Spinner(x,y,z,Speed,Mode);
private
  int MoveCounter;
  int TempID;
  int XFallSpeed;
  int YFallSpeed;
  int FallDirection;
  int SpinnerBlinkID;
  int BounceCounter;
begin
  ctype=c_scroll; graph=93; HP=4;
  if (Mode==2) MoveCounter=120; end
  if (Mode==4) MoveCounter=120; end
  if (Mode==3 or Mode==4) graph=373; end
  loop
    if (Mode==1 or Mode==3)
      MoveCounter++;
      if (MoveCounter>0 and MoveCounter<=30) x+=Speed; y+=Speed; end
      if (MoveCounter>30 and MoveCounter<=60) x+=Speed; y-=Speed; end
      if (MoveCounter>60 and MoveCounter<=90) x-=Speed; y-=Speed; end
      if (MoveCounter>90 and MoveCounter<=120) x-=Speed; y+=Speed; end
      if (MoveCounter==121) MoveCounter=0; end
    end
    if (Mode==2 or Mode==4)
      MoveCounter--;
      if (MoveCounter>0 and MoveCounter<=30) x+=Speed; y+=Speed; end
      if (MoveCounter>30 and MoveCounter<=60) x+=Speed; y-=Speed; end
      if (MoveCounter>60 and MoveCounter<=90) x-=Speed; y-=Speed; end
      if (MoveCounter>90 and MoveCounter<=120) x-=Speed; y+=Speed; end
      if (MoveCounter==0) MoveCounter=120; end
    end

    BounceCounter++;
    if (BounceCounter>0 and BounceCounter<=20) y--; end
    if (BounceCounter>20 and BounceCounter<=40) y++; end
    if (BounceCounter==40) BounceCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(x,y,z-1,150);
        CreateSparks(x,y,z-1,2);
        if (PlayerX<x) FallDirection=0; XFallSpeed=4; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=4; end
        YFallSpeed=8;
        repeat
          if (TempID=collision(type Spinner)) TempID.HP=0; end
          Explode(x+rand(-10,10),y+rand(-15,15),z-1,100);
          if (YFallSpeed<9) YFallSpeed++; end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        play_wav(Bounce,0);
        y-=5; YFallSpeed=0; Explode(x,y,z-1,100); CreateSpread(x,y,z,4);
        XFallSpeed=3; graph=94;
        if (Mode==3 or Mode==4) graph=374; end
        repeat
          if (YFallSpeed>-8) YFallSpeed-=2; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; angle-=5000; end
          if (FallDirection==1) x-=XFallSpeed; angle+=5000; end
          frame;
        until(YFallSpeed==-8)
        repeat
          if (YFallSpeed<10) YFallSpeed++; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; angle-=5000; end
          if (FallDirection==1) x-=XFallSpeed; angle+=5000; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        if (Mode<3) Explode(x,y,z-1,100); end
        if (Mode==3 or Mode==4) Explode(x,y,z-1,150); end
        CreateSpread(x,y,z,4); alpha=150; frame(400);
        if (exists(SpinnerBlinkID)) signal(SpinnerBlinkID, s_kill); end
        frame; return;
      end
    end

    if (HP<1)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150);
      CreateSparks(x,y,z-1,2);
      if (PlayerX<x) FallDirection=0; XFallSpeed=2; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=2; end
      YFallSpeed=2;
      repeat
        if (TempID=collision(type Spinner)) TempID.HP=0; end
        if (rand(1,2)==1) Explode(x+rand(-10,10),y+rand(-15,15),z-1,100); end
        if (YFallSpeed<9) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      play_wav(Bounce,0);
      y-=5; YFallSpeed=0; Explode(x,y,z-1,100); CreateSpread(x,y,z,4);
      XFallSpeed=3; graph=94;
      if (Mode==3 or Mode==4) graph=374; end
      repeat
        if (YFallSpeed>-8) YFallSpeed-=2; end
        y+=YFallSpeed;
        if (FallDirection==0) x+=XFallSpeed; angle-=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle+=5000; end
        frame;
      until(YFallSpeed==-8)
      repeat
        if (YFallSpeed<10) YFallSpeed++; end
        y+=YFallSpeed;
        if (FallDirection==0) x+=XFallSpeed; angle-=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle+=5000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      if (Mode<3) Explode(x,y,z-1,100); end
      if (Mode==3 or Mode==4) Explode(x,y,z-1,150); end
      CreateSpread(x,y,z,4); alpha=150; frame(400);
      if (exists(SpinnerBlinkID)) signal(SpinnerBlinkID, s_kill); end
      frame; return;
    end

    if (Mode==0 or Mode==1 or Mode==2)
      if (collision(PlayerID))
        CreateSpread(x,y,z,4); Explode(x,y,z-1,100);
        PlayerHP-=5; HP=0;
      end
    end

    if (rand(1,50)==1 and exists(SpinnerBlinkID)==0) SpinnerBlinkID=SpinnerBlink(); end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process FallSpinner(x,y,z,Speed,Mode);
private
  int MoveCounter;
  int TempID;
  int XFallSpeed;
  int YFallSpeed;
  int FallDirection;
begin
  ctype=c_scroll; graph=93; HP=1;
  loop

    if (Mode==1)
      MoveCounter++;
      if (MoveCounter>0 and MoveCounter<=60) x+=1; end
      if (MoveCounter>60 and MoveCounter<=120) x-=1; end
      if (MoveCounter==121) MoveCounter=0; end
    end
    if (Mode==2)
      MoveCounter++;
      if (MoveCounter>0 and MoveCounter<=60) x-=1; end
      if (MoveCounter>60 and MoveCounter<=120) x+=1; end
      if (MoveCounter==121) MoveCounter=0; end
    end

    if (TempID=collision(type FallGunFire) or HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,100);
      CreateSpread(x,y,z-1,4);
      FallDirection=rand(0,1);
      graph=94; YFallSpeed=7; XFallSpeed=rand(-4,4);
      repeat
        if (YFallSpeed<16 and rand(0,1)==1) YFallSpeed++; end
        y+=YFallSpeed;
        if (FallDirection==0) x+=XFallSpeed; angle-=6000; end
        if (FallDirection==1) x-=XFallSpeed; angle+=6000; end
        frame;
      until(YFallSpeed==16)
      Explode(x,y,z-1,100);
      CreateSpread(x,y,z-1,4);
      return;
    end

    frame;
  end
end



process SpinnerBlink();
begin
  ctype=c_scroll; graph=father.graph; flags=16; z=father.z-1; alpha=200;
  repeat
    x=father.x; y=father.y;
    alpha-=5;
    frame(20);
  until(alpha<=60)
end



process FallMine(x,y,z,Mode);
private
  int SpeedX;
  int TempID;
begin
  ctype=c_scroll; graph=128;
  if (Mode==0 or Mode==2) angle-=90000; end
  if (Mode==1 or Mode==3) angle+=90000; end
  if (Mode==0 or Mode==1) repeat frame; until(PlayerY>y-200) end
  if (Mode==2 or Mode==3)
    repeat
      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

       frame;
     until(PlayerY<y+100)
  end
  play_wav(MineJump,0); graph=129; SpeedX=16;
  repeat
    if (Mode==0 or Mode==2) x+=SpeedX; end
    if (Mode==1 or Mode==3) x-=SpeedX; end
    if (SpeedX>10 and rand(0,1)==0) SpeedX--; end

    if (Mode==2 or Mode==3)
      if (SelectedWeapon==1)
        if (TempID=collision(type Gun1Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==2)
        if (TempID=collision(type Gun2Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,5);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==3)
        if (TempID=collision(type Gun3Fire))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==4)
        if (TempID=collision(type Gun4Shrapnel))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          ShockWave(TempID.x,TempID.y,z,130);
          Explode(TempID.x,TempID.y,z-1,50);
          CreateSpread(TempID.x,TempID.y,z,1);
          signal(TempID, s_kill);
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end

      if (SelectedWeapon==5 and SwordDamage>0)
        if (collision(type PlayerWeapon) or collision(type SwordSlash))
          Combo++; ComboCounter=60; PlayerScore+=100*Combo;
          CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return;
        end
      end
    end

    if (collision(PlayerID)) PlayerHP-=8; CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return; end
    frame;
  until(y>MaxLevelY or collision(LevelCheckID))
  CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame;
end



process PsyOwl(x,y,z,Mode);
private
  int JumpCounter;
  int DelayCounter;
  int MoveSpeed;
  int AttackDelay;
  int AttackID;
  int HoverAuraID;
  int HoverCounter;
  int TempID;
  int FallDirection;
  int XFallSpeed;
  int YFallSpeed;
  int MaxY;
begin
  ctype=c_scroll; graph=159; HP=10; MaxY=y-200;
  HoverAuraID=PsyOwlHoverAura();

  repeat frame; until(fget_dist(x,y,PlayerX,PlayerY)<400)
  play_wav(PsyOwl2,0); JumpCounter=14;
  if (PlayerX<x) MoveSpeed=-12; end
  if (PlayerX>x) MoveSpeed=12; end

  loop

    DelayCounter++;
    if (DelayCounter==2)
      DelayCounter=0;
      if (MoveSpeed>0) MoveSpeed--; end
      if (MoveSpeed<0) MoveSpeed++; end
    end

    if (JumpCounter>0) JumpCounter--; end
    if (JumpCounter>0) y-=JumpCounter; end

    x+=MoveSpeed;
    if (collision(LevelCheckID)) x-=MoveSpeed; end

    if (rand(1,20)==1 and AttackDelay<90)
      if (x>PlayerX) MoveSpeed=-10; graph=160; end
      if (x<PlayerX) MoveSpeed=10; graph=159; end
    end

    if (AttackDelay==0)
      AttackDelay=150;
      if (PlayerX<x) MoveSpeed=-8; end
      if (PlayerX>x) MoveSpeed=8; end
      repeat y+=11; x+=MoveSpeed; frame; until(collision(LevelCheckID))
      JumpCounter=12;
    end
    if (AttackDelay>0) AttackDelay--; end
    if (AttackDelay==130) AttackID=PsyOwlAttack(); end
    if (AttackDelay==90) JumpCounter=17+rand(0,3); end

    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4) y++; end
    if (HoverCounter==6 or HoverCounter==8) y--; end
    if (HoverCounter==10) HoverCounter=0; end

    if (y<60) AttackDelay=0; y++; end
    if (y<MaxY) AttackDelay=0; y++; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        if (flags==0)
          CreateSparks(x-40+rand(-5,5),y-20,z-1,2); Explode(x-40+rand(-5,5),y-20,z-1,50);
          CreateSparks(x-40+rand(-5,5),y,z-1,2); Explode(x-40+rand(-5,5),y,z-1,50);
          CreateSparks(x-40+rand(-5,5),y+20,z-1,2); Explode(x-40+rand(-5,5),y+20,z-1,50);
        end
        if (flags==1)
          CreateSparks(x+40+rand(-5,5),y-20,z-1,2); Explode(x+40+rand(-5,5),y-20,z-1,50);
          CreateSparks(x+40+rand(-5,5),y,z-1,2); Explode(x+40+rand(-5,5),y,z-1,50);
          CreateSparks(x+40+rand(-5,5),y+20,z-1,2); Explode(x+40+rand(-5,5),y+20,z-1,50);
        end
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
      if (exists(AttackID)==0) AttackID=PsyOwlAttack(); end
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      repeat
        Explode(x+rand(-15,15),y+rand(-30,30),z-1,100);
        if (YFallSpeed<10) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
        if (flags==0) angle-=8000; end
        if (flags==1) angle+=8000; end
        alpha-=20; y+=3;
        frame;
      until(alpha<40)
      signal(HoverAuraID, s_kill);
      signal(AttackID, s_kill);
      signal(type PsyOwlFlash, s_kill);
      return;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process PsyOwlHoverAura();
begin
  ctype=c_scroll; graph=43; alpha=200; flags=16;
  z=father.z-1;
  loop
    x=father.x+1; y=father.y+38;
    frame(50);
  end
end



process PsyOwlAttack();
private
  int AttackLength;
  int FlashType;
begin
  ctype=c_scroll; graph=161; flags=16; play_wav(PsyOwl1,0);
  z=father.z+1; x=father.x; y=father.y-44; frame;
  graph=161; x=father.x; y=father.y-44; frame;
  graph=161; x=father.x; y=father.y-44; frame;
  graph=162; x=father.x; y=father.y-44; frame;
  graph=162; x=father.x; y=father.y-44; frame;
  graph=162; x=father.x; y=father.y-44; frame;
  graph=163; x=father.x; y=father.y-44; frame;
  repeat
    x=father.x; y=father.y-40;
    AttackLength++;
    if (AttackLength==0 or AttackLength==20 or AttackLength==40 or AttackLength==60 or AttackLength==80 or AttackLength==100)
      FlashType=rand(1,8);
      if (FlashType==1) PsyOwlFlash(x+80+rand(-1,1),y+20+rand(-1,1),z+1,1); end
      if (FlashType==2) PsyOwlFlash(x-80+rand(-1,1),y+20+rand(-1,1),z+1,2); end
      if (FlashType==3) PsyOwlFlash(x+50+rand(-1,1),y+30+rand(-1,1),z+1,3); end
      if (FlashType==4) PsyOwlFlash(x-50+rand(-1,1),y+30+rand(-1,1),z+1,4); end
      if (FlashType==5) PsyOwlFlash(x+80+rand(-1,1),y+20+rand(-1,1),z+1,5); end
      if (FlashType==6) PsyOwlFlash(x-80+rand(-1,1),y+20+rand(-1,1),z+1,6); end
      if (FlashType==7) PsyOwlFlash(x+130+rand(-1,1),y+50+rand(-1,1),z+1,7); end
      if (FlashType==8) PsyOwlFlash(x-130+rand(-1,1),y+50+rand(-1,1),z+1,8); end
    end
    frame(20);
  until(AttackLength==130)
  graph=162; x=father.x; y=father.y-44; frame;
  graph=162; x=father.x; y=father.y-44; frame;
  graph=162; x=father.x; y=father.y-44; frame;
  graph=161; x=father.x; y=father.y-44; frame;
  graph=161; x=father.x; y=father.y-44; frame;
  graph=161; x=father.x; y=father.y-44; frame;
end



process PsyOwlFlash(XOffset,YOffset,z,Mode);
begin
  ctype=c_scroll; alpha=0; size=80;
  if (Mode==1) graph=164; flags=16; end
  if (Mode==2) graph=164; flags=17; end
  if (Mode==3) graph=165; flags=17; end
  if (Mode==4) graph=165; flags=16; end
  if (Mode==5) graph=166; flags=17; end
  if (Mode==6) graph=166; flags=16; end
  if (Mode==7) graph=167; flags=17; end
  if (Mode==8) graph=167; flags=16; end
  GlobalRed+=5; GlobalGreen+=5; GlobalBlue+=20;
  repeat 
    if (size<100) size+=5; end
    x=XOffset; y=YOffset;
    alpha+=10;
    Sparks(x+rand(-30,30),y+rand(-60,60),z,11);
    frame(20);
  until(alpha==200)
  if (PlayerX>x-150 and PlayerX<x+150)
    ActiveLamp1_X=x;
    ActiveLamp1_Y=y;
    if (rand(0,1)==0)
      ActiveLamp2_X=x;
      ActiveLamp2_Y=y;
    end
  end
  if (collision(PlayerID)) PlayerHP-=5; end
  repeat
    if (size>80) size-=5; end
    x=XOffset; y=YOffset;
    alpha-=10;
    Sparks(x+rand(-30,30),y+rand(-60,60),z,11);
    frame(20);
  until(alpha==0)
  if (ActiveLamp1_X==x) ActiveLamp1_X=-200; end
  if (ActiveLamp1_Y==y) ActiveLamp1_Y=-200; end
  if (ActiveLamp2_X==x) ActiveLamp2_X=-200; end
  if (ActiveLamp2_Y==y) ActiveLamp2_Y=-200; end
end



process GunShip1(StartX,StartY,z,Mode);
private
  int MoveCounter;
  int MoveX;
  int MoveY;
  int TempID;
  int ReloadCounter;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
  int HoverCounter;
  int PlayOnce;
  int DropOnce;
begin
  ctype=c_scroll; graph=109; HP=30;
  x=StartX; y=StartY;

  loop

    if (fget_dist(x,y,PlayerX,PlayerY)>670 and y>-100) MoveY=-10; end
    if (fget_dist(x,y,PlayerX,PlayerY)<650 and y<StartY)
      if (PlayOnce==0) play_wav(Plane,0); PlayOnce=1; end
      MoveY=10;
    end
    if (fget_dist(x,y,PlayerX,PlayerY)<230)
      if (flags==0) MoveX=14; end
      if (flags==1) MoveX=-14; end
    end
    if (x<StartX-300 and y>-200) MoveX=-5; MoveY=-10; end
    if (x>StartX+300 and y>-200) MoveX=5; MoveY=-10; end

    if (MoveX>0 or MoveX<0) x+=MoveX; end
    if (MoveY>0 or MoveY<0) y+=MoveY; end

    if (MoveX<0) MoveX++; end
    if (MoveX>0) MoveX--; end
    if (MoveY<0) MoveY++; end
    if (MoveY>0) MoveY--; end

    if (x<PlayerX) flags=1; end
    if (x>PlayerX) flags=0; end

    if (y=>200) DropOnce=1; end
    if (y<40 and DropOnce==1) GunShipBomb(x,y,z+1,Mode); DropOnce=0; end

    if (ReloadCounter==20 or ReloadCounter==25 or ReloadCounter==30)
      if (fget_dist(x,y,PlayerX,PlayerY)<700)
        if (flags==0)
          GunShipShot(x-150,y+55,z+1,0);
          GunShipShot(x-150,y+55,z+1,1);
          GunShipShot(x-150,y+55,z+1,2);
        end
        if (flags==1)
          GunShipShot(x+150,y+55,z+1,0);
          GunShipShot(x+150,y+55,z+1,1);
          GunShipShot(x+150,y+55,z+1,2);
        end
      end
    end
    if (ReloadCounter==60)
      if (flags==0) HooverTrooperMissile(x-140,y+55,z+1,Mode); end
      if (flags==1) HooverTrooperMissile(x+140,y+55,z+1,Mode); end
    end
    if (ReloadCounter>0) ReloadCounter--; end
    if (ReloadCounter==0) ReloadCounter=100; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        if (flags==0)
          CreateSparks(x-130+rand(-5,5),y,z-1,2); Explode(x-130+rand(-5,5),y,z-1,50);
          CreateSparks(x-130+rand(-5,5),y+20,z-1,2); Explode(x-130+rand(-5,5),y+20,z-1,50);
          CreateSparks(x-130+rand(-5,5),y+40,z-1,2); Explode(x-130+rand(-5,5),y+40,z-1,50);
        end
        if (flags==1)
          CreateSparks(x+130+rand(-5,5),y,z-1,2); Explode(x+130+rand(-5,5),y,z-1,50);
          CreateSparks(x+130+rand(-5,5),y+20,z-1,2); Explode(x+130+rand(-5,5),y+20,z-1,50);
          CreateSparks(x+130+rand(-5,5),y+40,z-1,2); Explode(x+130+rand(-5,5),y+40,z-1,50);
        end
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150); CreateSpread(x,y,z-1,4);
      Explode(x-100,y,z-1,150); CreateSpread(x-100,y,z-1,4);
      Explode(x+100,y,z-1,150); CreateSpread(x+100,y,z-1,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=8; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=8; end
      repeat
        Explode(x+rand(-120,120),y+rand(75,75),z-1,100);
        Explode(x+rand(-120,120),y+rand(75,75),z-1,rand(40,60));
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      Explode(x,y,z-1,150); CreateSpread(x,y,z-1,4);
      Explode(x-100,y,z-1,150); CreateSpread(x-100,y,z-1,4);
      Explode(x+100,y,z-1,150); CreateSpread(x+100,y,z-1,4);
      frame; y++; frame; y++; frame; y++; frame;
      repeat
        Explode(x+rand(-120,120),y+rand(-75,75),z-1,100);
        Explode(x+rand(-120,120),y+rand(-75,75),z-1,rand(40,60));
        Explode(x+rand(-120,120),y+rand(-75,75),z-1,rand(40,60));
        alpha-=10;
        frame;
      until(alpha<=50)
      return;
    end

    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process GunShipShot(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=59; flags=16; flags=father.flags;
  play_wav(BigShot,0);
  repeat
    if (flags==0) x-=8; end
    if (flags==1) x+=8; end
    if (Mode==1) y-=4; end
    if (Mode==2) y+=4; end
    FadeCounter++;
    if (FadeCounter>150 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID)) PlayerHP-=2; Explode(x,y,z-1,25); return; end
    frame;
  until(collision(LevelCheckID))
  repeat alpha-=20; frame(50); until(alpha<=50)
end



process GunShipBomb(x,y,z,Mode);
private
  int LaunchSpeed;
begin
  ctype=c_scroll; graph=202;
  play_wav(MineJump,0); LaunchSpeed=1;
  repeat
    y+=LaunchSpeed;
    if (LaunchSpeed<6) LaunchSpeed++; end
    frame(50);
  until(collision(LevelCheckID) or collision(PlayerID))
  CreateSpread(x,y,z,3);
  repeat
    Explode(x+rand(-15,15),y+rand(-15,15),z,rand(40,120));
    alpha-=20;
    frame;
  until(alpha<=80)
end



process FlyFish(StartX,StartY,z,Mode);
private
  int MoveCounter;
  int MoveMode;
  int MoveX;
  int MoveY;
  int TempID;
  int ReloadCounter;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
  int CallHelp;
  int CallHelpCounter;
begin
  ctype=c_scroll; graph=58; HP=3;
  x=StartX; y=StartY; MoveMode=rand(1,2);
  if (MoveMode==2) MoveCounter=120; end
  if (Mode==1) graph=198; end
  if (Mode==2) graph=390; end
  if (Mode==0) CallHelp=1; end
  if (Mode==3) CallHelp=0; MoveY=20; Mode=0; end
  loop

    if (MoveMode==1 and CallHelpCounter==0)
      MoveCounter++;
      if (MoveCounter>0 and MoveCounter<=30) x+=2; y+=2; end
      if (MoveCounter>30 and MoveCounter<=60) x+=2; y-=2; end
      if (MoveCounter>60 and MoveCounter<=90) x-=2; y-=2; end
      if (MoveCounter>90 and MoveCounter<=120) x-=2; y+=2; end
      if (MoveCounter==121) MoveCounter=0; end
    end
    if (MoveMode==2 and CallHelpCounter==0)
      MoveCounter--;
      if (MoveCounter>0 and MoveCounter<=30) x+=2; y+=2; end
      if (MoveCounter>30 and MoveCounter<=60) x+=2; y-=2; end
      if (MoveCounter>60 and MoveCounter<=90) x-=2; y-=2; end
      if (MoveCounter>90 and MoveCounter<=120) x-=2; y+=2; end
      if (MoveCounter==0) MoveCounter=120; end
    end

    if (MoveX==0 or MoveY==0)
      if (fget_dist(x,y,PlayerX,PlayerY)>300 and fget_dist(x,y,PlayerX,PlayerY)<500)
        if (x<PlayerX) MoveX=12; end
        if (x>PlayerX) MoveX=-12; end
        if (y<PlayerY) MoveY=12; end
        if (y>PlayerY) MoveY=-12; end
      end
    end

    frame(0);
    if (TempID=collision(type FlyFish))
      MoveX+=rand(-9,9); MoveY+=rand(-9,9);
    end
    frame(0);
    if (TempID=collision(LevelCheckID))
      MoveX+=rand(-9,9); MoveY+=rand(-12,0);
    end

    if (Mode==2)
      if (MoveY<0 or MoveY>0) MoveY=MoveY/2; end
    end

    if (MoveX>0 or MoveX<0) x+=MoveX; end
    if (MoveY>0 or MoveY<0) y+=MoveY; end

    if (MoveX<0) MoveX++; end
    if (MoveX>0) MoveX--; end
    if (MoveY<0) MoveY++; end
    if (MoveY>0) MoveY--; end

    if (x<PlayerX) flags=1; end
    if (x>PlayerX) flags=0; end

    if (ReloadCounter==20 or ReloadCounter==25 or ReloadCounter==30)
      if (Mode==0 or Mode==1)
        if (fget_dist(x,y,PlayerX,PlayerY)<500) FlyFishShot(x,y+3,z+1,Mode); end
      end
    end

    if(ReloadCounter>0) ReloadCounter--; end
    if (ReloadCounter==0)
      ReloadCounter=100;
      if (Mode==2)
        if (flags==0) BubbleFishBubble(x-26,y,z,Mode); end
        if (flags==1) BubbleFishBubble(x+26,y,z,Mode); end
        frame(1000); frame(200);
        ReloadCounter=130;
        if (flags==0) MoveX=10; end
        if (flags==1) MoveX=-10; end
      end
    end

    if (CallHelp==1)
      if (ReloadCounter>80)
        if (MoveX==0 and MoveY==0)
          if (fget_dist(x,y,PlayerX,PlayerY)<400)
            if (rand(1,20)==1); CallHelp=0; CallHelpCounter=18; end
          end
        end
      end
    end
    if (CallHelpCounter>0)
      CallHelpCounter--;
      MoveX=0; MoveY=0;
    end
    if (CallHelpCounter==14) ShockWave(x,y,z+1,117); end
    if (CallHelpCounter==10) ShockWave(x,y,z+1,117); end
    if (CallHelpCounter==6) ShockWave(x,y,z+1,117); end
    if (CallHelpCounter==2) FlyFish(x,y-340,z,3); end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(x,y,z-1,150);
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-25,z-1,2);
        CreateSparks(x,y+25,z-1,2);
        frame;
        if (Mode==0)
          if (flags==0)
            FlyFishPart(x-16,y,3,flags,0);
            FlyFishPart(x+16,y,5,flags,1);
          end
          if (flags==1)
            FlyFishPart(x+16,y,5,flags,3);
            FlyFishPart(x-16,y,3,flags,2);
          end
        end
        if (Mode==1)
          if (flags==0)
            FlyFishPart(x-16,y,3,flags,6);
            FlyFishPart(x+16,y,5,flags,7);
          end
          if (flags==1)
            FlyFishPart(x+16,y,5,flags,9);
            FlyFishPart(x-16,y,3,flags,8);
          end
        end
        if (Mode==2)
          if (flags==0)
            FlyFishPart(x-16,y,3,flags,10);
            FlyFishPart(x+16,y,5,flags,11);
          end
          if (flags==1)
            FlyFishPart(x+16,y,5,flags,13);
            FlyFishPart(x-16,y,3,flags,12);
          end
        end
        return;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,100); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=8; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=8; end
      repeat
        if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; angle+=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle-=5000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      frame; y++; frame; y++; frame; y++; frame;
      return;
    end

    if (Control==1)
      repeat alpha-=10; size-=5; frame(20); until(size==0)
      CreateSpread(x,y,z,6); ShockWave(x,y,z,201);
      repeat frame; until (Control==0)
      CreateSpread(x,y,z,6); ShockWave(x,y,z,201);
      repeat alpha+=10; size+=5; frame(20); until(size==100)
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process FlyFishShot(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=59; flags=16; flags=father.flags;
  play_wav(Laser,0);
  if (flags==0) x-=10; end
  if (flags==1) x+=10; end
  repeat
    if (flags==0) x-=8; end
    if (flags==1) x+=8; end
    FadeCounter++;
    if (FadeCounter>150 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID)) PlayerHP-=2; Explode(x,y,z-1,25); return; end
    frame;
  until(collision(LevelCheckID))
  repeat alpha-=20; frame(50); until(alpha<=50)
end



process FlyFishPart(x,y,z,flags,Mode);
private
  int YFallSpeed;
  int XFallSpeed;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==3) graph=60; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==1 or Mode==2) graph=61; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==6 or Mode==9) graph=199; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==7 or Mode==8) graph=200; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==10 or Mode==13) graph=392; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==11 or Mode==12) graph=393; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==4) graph=49; YFallSpeed=0; XFallSpeed=0; end
  repeat
    if (YFallSpeed<10) YFallSpeed++; end
    y+=YFallSpeed;
    if (XFallSpeed>2) XFallSpeed--; end
    if (Mode==1) x+=XFallSpeed; end
    if (Mode==0) x-=XFallSpeed; end
    if (Mode==2) x-=XFallSpeed; end
    if (Mode==3) x+=XFallSpeed; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY)
  Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
  frame; y++; frame; y++; frame; y++; frame;
  return;
end



process BubbleFishBubble(x,y,z,Mode);
private
  int FadeCounter;
  int HoverCounter;
  int TempID;
  int Direction;
begin
  ctype=c_scroll; graph=391; size=0; HP=1; Direction=rand(0,3);
  repeat frame(50); size+=5; until(size=>100)
  repeat
    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    if (Direction==0) x--; end
    if (Direction==1) x++; end
    if (Direction==2)
      x--;
      if (rand(0,1)==1) y--; end
    end
    if (Direction==3)
      x++;
      if (rand(0,1)==1) y--; end
    end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash)) HP--; end
    end

    if (HP<=0)
      CreateSpread(x,y,z,7);
      repeat frame(50); size+=5; alpha-=20; until(size=>150)
      return;
    end

    if (collision(PlayerID) or collision(type BubbleFishBubble))
      PlayerHP-=5;
      CreateSpread(x,y,z,7);
      repeat frame(50); size+=5; alpha-=20; until(size=>150)
      return;
    end

    FadeCounter++;
    frame;
  until(FadeCounter=>300 or collision(LevelCheckID))
  CreateSpread(x,y,z,7);
  repeat frame(50); size+=5; alpha-=20; until(size=>150)
end



process HooverTrooper(x,StartY,z,MinX,MaxX,Mode);
private
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int ReloadCounter;
  int ShotType;
  int YOffset;
  int HoverCounter;
  int AuraID;
  int JumpOver;
begin
  ctype=c_scroll; graph=263; HP=15; y=StartY;
  AuraID=HooverTrooperAura();
  loop

    graph=263;
    if (PlayerX<x) flags=0; end
    if (PlayerX>x) flags=1; end

    if (ReloadCounter<120 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<400)
        if (ReloadCounter==0) ReloadCounter=120; ShotType=1; end
        if (ShotType==0 and ReloadCounter==20)
          if (flags==0) HooverTrooperShot(x-55,y-17,z+1,Mode); end
          if (flags==1) HooverTrooperShot(x+55,y-17,z+1,Mode); end
        end
        if (ShotType==0 and ReloadCounter==15)
          if (flags==0) HooverTrooperShot(x-55,y-17,z+1,Mode); end
          if (flags==1) HooverTrooperShot(x+55,y-17,z+1,Mode); end
        end
        if (ShotType==0 and ReloadCounter==10)
          if (flags==0) HooverTrooperShot(x-55,y-17,z+1,Mode); end
          if (flags==1) HooverTrooperShot(x+55,y-17,z+1,Mode); end
        end
        if (ShotType==0 and ReloadCounter==5)
          if (flags==0) HooverTrooperShot(x-55,y-17,z+1,Mode); end
          if (flags==1) HooverTrooperShot(x+55,y-17,z+1,Mode); end
        end
        if (ShotType==1)
          graph=263;
          if (flags==0)
            if (ReloadCounter==120) ShockWave(x+7,y-48,z-1,130); HooverTrooperMissile(x+7,y-48,z-1,Mode); end
            if (ReloadCounter==115) ShockWave(x+13,y-48,z-1,130); HooverTrooperMissile(x+13,y-48,z-1,Mode); end
            if (ReloadCounter==110) ShockWave(x+8,y-43,z-1,130); HooverTrooperMissile(x+8,y-43,z-1,Mode); end
            if (ReloadCounter==105) ShockWave(x+13,y-43,z-1,130); HooverTrooperMissile(x+13,y-43,z-1,Mode); ShotType=0; end
          end
          if (flags==1)
            if (ReloadCounter==120) ShockWave(x-7,y-48,z-1,130); HooverTrooperMissile(x-7,y-48,z-1,Mode); end
            if (ReloadCounter==115) ShockWave(x-13,y-48,z-1,130); HooverTrooperMissile(x-13,y-48,z-1,Mode); end
            if (ReloadCounter==110) ShockWave(x-8,y-43,z-1,130); HooverTrooperMissile(x-8,y-43,z-1,Mode); end
            if (ReloadCounter==105) ShockWave(x-13,y-43,z-1,130); HooverTrooperMissile(x-13,y-43,z-1,Mode); ShotType=0; end
          end
        end
      end
    end
    if (ReloadCounter>0) ReloadCounter--; end


    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        if (flags==0)
          Explode(x+20,y-25,z-1,100); CreateSparks(x+20,y-25,z-1,2); frame;
          Explode(x+20,y,z-1,100); CreateSparks(x+20,y,z-1,2); frame;
          Explode(x+20,y+25,z-1,100); CreateSparks(x+20,y+25,z-1,2); frame;
        end
        if (flags==1)
          Explode(x-20,y-25,z-1,100); CreateSparks(x-20,y-25,z-1,2); frame;
          Explode(x-20,y,z-1,100); CreateSparks(x-20,y,z-1,2); frame;
          Explode(x-20,y+25,z-1,100); CreateSparks(x-20,y+25,z-1,2); frame;
        end
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      signal(AuraID, s_kill);
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (YFallSpeed<6) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        if (flags==0) angle-=4000; end
        if (flags==1) angle+=4000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (flags==0) angle-=7000; end
        if (flags==1) angle+=7000; end
        alpha-=20; y+=2;
        frame;
      until(alpha<40)
      return;
    end

    if (DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<=200)
        DodgeX=14;
        YOffset=6;
      end
      if (PlayerY>y-100 and PlayerY<y+100)
        if (fget_dist(x,y,PlayerX,PlayerY)>300)
          DodgeX=-14;
          YOffset=6;
        end
      end
    end

    if (JumpOver==1)
      DodgeX=25; z=7;
      repeat
        x+=DodgeX;
        DodgeX--;
        if (PlayerX<x) flags=0; end
        if (PlayerX>x) flags=1; end
        frame;
      until(DodgeX==0)
      JumpOver=0; z=5;
      ReloadCounter=120; ShotType=1;
    end
    if (JumpOver==2)
      DodgeX=25; z=7;
      repeat
        x-=DodgeX;
        DodgeX--;
        if (PlayerX<x) flags=0; end
        if (PlayerX>x) flags=1; end
        frame;
      until(DodgeX==0)
      JumpOver=0; z=5;
      ReloadCounter=120; ShotType=1;
    end

    if (DodgeX>0)
      graph=264;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x>MaxX) x-=DodgeX; graph=263; YOffset=0; JumpOver=2; end
      if (flags==1 and x<MinX) x+=DodgeX; graph=263; YOffset=0; JumpOver=1; end
      DodgeX--;
    end

    if (DodgeX<0)
      graph=264;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x<MinX) x-=DodgeX; graph=263; YOffset=0; JumpOver=1; end
      if (flags==1 and x>MaxX) x+=DodgeX; graph=263; YOffset=0; JumpOver=2; end
      DodgeX++;
    end

    if (YOffset>0) YOffset--; end
    if (YOffset<0) YOffset++; end
    if (YOffset==0 and y<StartY) YOffset=-2; end
    y-=YOffset;

    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process HooverTrooperMissile(x,y,z,Mode);
private
  int FadeCounter;
  int SpeedCounter;
begin
  ctype=c_scroll; graph=265; flags=16; flags=father.flags; SpeedCounter=1;
  play_wav(Rocket,0);
  if (flags==0) x-=6; end
  if (flags==1) x+=6; end
  repeat
    if (flags==0) x-=SpeedCounter; end
    if (flags==1) x+=SpeedCounter; end
    if (SpeedCounter<10) SpeedCounter++; end
    FadeCounter++;
    if (FadeCounter>140 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID)) PlayerHP-=5; Explode(x,y,z-1,100); return; end
    GreySmoke(x,y,z,0);
    if (PlayerY>y) y++; end
    if (PlayerY<y) y--; end
    frame;
  until(collision(LevelCheckID))
  Explode(x,y,z-1,50);
  frame;
end



process HooverTrooperShot(x,y,z,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=59; flags=16; size=10; flags=father.flags;
  play_wav(Laser,0);
  repeat
    if (flags==0) x-=8; end
    if (flags==1) x+=8; end
    FadeCounter++;
    if (FadeCounter>140 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID)) PlayerHP-=2; CreateSpread(x,y,z,1); Explode(x,y,z-1,25); return; end
    if (size<100) size+=10; end
    frame;
  until(collision(LevelCheckID))
  CreateSpread(x,y,z,1);
  repeat alpha-=20; frame(50); until(alpha<=50)
end



process HooverTrooperAura();
begin
  ctype=c_scroll; graph=43; alpha=150; flags=16;
  z=father.z-1;
  loop
    if (father.flags==0) x=father.x+25; y=father.y-5; end
    if (father.flags==1) x=father.x-25; y=father.y-5; end
    frame(50);
  end
end



process BoomerTrooper(x,StartY,z,MinX,MaxX,Mode);
private
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int ReloadCounter;
  int ShotType;
  int YOffset;
  int HoverCounter;
  int AuraID;
  int JumpOver;
begin
  ctype=c_scroll; graph=376; HP=20; y=StartY; ReloadCounter=100;
  AuraID=BoomerTrooperAura();
  loop

    graph=376;
    if (PlayerX<x) flags=0; end
    if (PlayerX>x) flags=1; end

    if (DodgeX==0)
      if (ReloadCounter==0)
        graph=376;
        if (flags==0) ShockWave(x-45,y-37,z-1,130); BoomerShot(x-45,y-33,z-1,flags); end
        if (flags==1) ShockWave(x+45,y-37,z-1,130); BoomerShot(x+45,y-33,z-1,flags);  end
        ReloadCounter=100;
      end
      if (ReloadCounter==10)
        graph=376;
        if (flags==0) ShockWave(x-45,y-37,z-1,130); BoomerShot(x-45,y-33,z-1,flags); end
        if (flags==1) ShockWave(x+45,y-37,z-1,130); BoomerShot(x+45,y-33,z-1,flags);  end
      end
      if (ReloadCounter==20)
        graph=376;
        if (flags==0) ShockWave(x-45,y-37,z-1,130); BoomerShot(x-45,y-33,z-1,flags); end
        if (flags==1) ShockWave(x+45,y-37,z-1,130); BoomerShot(x+45,y-33,z-1,flags);  end
      end
    end
    if (ReloadCounter>0) ReloadCounter--; end


    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        if (flags==0)
          Explode(x+10,y-25,z-1,100); CreateSparks(x+10,y-25,z-1,2); frame;
          Explode(x+10,y,z-1,100); CreateSparks(x+10,y,z-1,2); frame;
          Explode(x+10,y+25,z-1,100); CreateSparks(x+10,y+25,z-1,2); frame;
        end
        if (flags==1)
          Explode(x-10,y-25,z-1,100); CreateSparks(x-10,y-25,z-1,2); frame;
          Explode(x-10,y,z-1,100); CreateSparks(x-10,y,z-1,2); frame;
          Explode(x-10,y+25,z-1,100); CreateSparks(x-10,y+25,z-1,2); frame;
        end
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      signal(AuraID, s_kill);
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (YFallSpeed<6) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        if (flags==0) angle-=4000; end
        if (flags==1) angle+=4000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (flags==0) angle-=7000; end
        if (flags==1) angle+=7000; end
        alpha-=20; y+=2;
        frame;
      until(alpha<40)
      return;
    end

    if (DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<200)
        DodgeX=14;
        YOffset=6;
      end
      if (PlayerY>y-100 and PlayerY<y+100)
        if (fget_dist(x,y,PlayerX,PlayerY)>300)
          DodgeX=-14;
          YOffset=6;
        end
      end
    end

    if (JumpOver==1)
      DodgeX=25; z=7;
      repeat
        x+=DodgeX;
        DodgeX--;
        if (PlayerX<x) flags=0; end
        if (PlayerX>x) flags=1; end
        frame;
      until(DodgeX==0)
      JumpOver=0; z=5;
      ReloadCounter=20;
    end
    if (JumpOver==2)
      DodgeX=25; z=7;
      repeat
        x-=DodgeX;
        DodgeX--;
        if (PlayerX<x) flags=0; end
        if (PlayerX>x) flags=1; end
        frame;
      until(DodgeX==0)
      JumpOver=0; z=5;
      ReloadCounter=20;
    end

    if (DodgeX>0)
      graph=264;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x>MaxX) x-=DodgeX; graph=263; YOffset=0; JumpOver=2; end
      if (flags==1 and x<MinX) x+=DodgeX; graph=263; YOffset=0; JumpOver=1; end
      DodgeX--;
    end

    if (DodgeX<0)
      graph=264;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x<MinX) x-=DodgeX; graph=263; YOffset=0; JumpOver=1; end
      if (flags==1 and x>MaxX) x+=DodgeX; graph=263; YOffset=0; JumpOver=2; end
      DodgeX++;
    end

    if (YOffset>0) YOffset--; end
    if (YOffset<0) YOffset++; end
    if (YOffset==0 and y<StartY) YOffset=-2; end
    y-=YOffset;

    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process BoomerTrooperAura();
begin
  ctype=c_scroll; graph=43; alpha=150; flags=16;
  z=father.z-1;
  loop
    if (father.flags==0) x=father.x+8; y=father.y-4; end
    if (father.flags==1) x=father.x-8; y=father.y-4; end
    frame(20);
  end
end



process BoomerShot(x,y,z,Mode);
private
  int SpeedY;
  int AnimationCounter;
begin
  ctype=c_scroll; SpeedY=6;
  play_wav(Explode0,0);
  repeat
    y-=SpeedY;
    if (SpeedY>0) SpeedY--; end
    if (Mode==0) x-=5; end
    if (Mode==1) x+=5; end
    AnimationCounter++;
    if (AnimationCounter==1) graph=378; end
    if (AnimationCounter==4) graph=379; end
    if (AnimationCounter==7) AnimationCounter=0; end
    if (collision(PlayerID)) PlayerHP-=10; CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return; end
    if (collision(LevelCheckID)) CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return; end
    if (y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    frame;
  until(PlayerX>x-20 and PlayerX<x+20)
  SpiderMineFlash(x+1,y+5,2,Mode); play_wav(MineJump,0); frame(500);
  repeat
    y+=SpeedY;
    if (SpeedY<10) SpeedY++; end
    if (collision(PlayerID)) PlayerHP-=10; CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame; return; end
    frame;
  until(y>MaxLevelY or collision(LevelCheckID))
  CreateSpread(x,y,z,4); Explode(x,y,z-1,100); frame;
end



process Sluddar1(x,StartY,z,MinX,MaxX,Mode);
private
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int ReloadCounter;
  int ShotType;
  int YOffset;
begin
  ctype=c_scroll; graph=154; HP=15; y=StartY;

  loop

    graph=154;
    if (PlayerY<y-40) graph=155; end
    if (PlayerY>y+40) graph=156; end
    if (PlayerX<x) flags=0; end
    if (PlayerX>x) flags=1; end

    if (ReloadCounter<60 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<400)
        if (ReloadCounter==0) ReloadCounter=140; ShotType=1; end
        if (ShotType==0 and ReloadCounter>40)
          if (flags==0 and graph==154) SluddGun(x-52,y-14,z+1,2,0); end
          if (flags==1 and graph==154) SluddGun(x+52,y-14,z+1,2,1); end
          if (flags==0 and graph==155) SluddGun(x-37,y-44,z+1,6,0); end
          if (flags==1 and graph==155) SluddGun(x+37,y-44,z+1,6,1); end
          if (flags==0 and graph==156) SluddGun(x-45,y+20,z+1,2,0); end
          if (flags==1 and graph==156) SluddGun(x+45,y+20,z+1,2,1); end
        end
        if (ShotType==1)
          graph=155; frame(400);
          if (flags==0) ShockWave(x-37,y-44,z,130); BigSludd(x-37,y-44,z+1,6,0); end
          if (flags==1) ShockWave(x+37,y-44,z,130); BigSludd(x+37,y-44,z+1,6,1); end
          frame(300);
          ShotType=0;
        end
      end
    end
    if (ReloadCounter>0) ReloadCounter--; end


    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
        if (DodgeX==0 and rand(1,2)==1)
          frame(200); graph=155; frame(300);
          if (flags==0) ShockWave(x-37,y-44,z,130); BigSludd(x-37,y-44,z+1,6,0); end
          if (flags==1) ShockWave(x+37,y-44,z,130); BigSludd(x+37,y-44,z+1,6,1); end
        end
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
        if (DodgeX==0 and rand(1,2)==1)
          frame(200); graph=155; frame(300);
          if (flags==0) ShockWave(x-37,y-44,z,130); BigSludd(x-37,y-44,z+1,6,0); end
          if (flags==1) ShockWave(x+37,y-44,z,130); BigSludd(x+37,y-44,z+1,6,1); end
        end
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
        if (DodgeX==0 and rand(1,2)==1)
          frame(200); graph=155; frame(300);
          if (flags==0) ShockWave(x-37,y-44,z,130); BigSludd(x-37,y-44,z+1,6,0); end
          if (flags==1) ShockWave(x+37,y-44,z,130); BigSludd(x+37,y-44,z+1,6,1); end
        end
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
        if (DodgeX==0 and rand(1,2)==1)
          frame(200); graph=155; frame(300);
          if (flags==0) ShockWave(x-37,y-44,z,130); BigSludd(x-37,y-44,z+1,6,0); end
          if (flags==1) ShockWave(x+37,y-44,z,130); BigSludd(x+37,y-44,z+1,6,1); end
        end
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        if (flags==0)
          Explode(x+15,y-25,z-1,100); CreateSparks(x+15,y-25,z-1,2); frame;
          Explode(x+15,y,z-1,100); CreateSparks(x+15,y,z-1,2); frame;
          Explode(x+15,y+25,z-1,100); CreateSparks(x+15,y+25,z-1,2); frame;
        end
        if (flags==1)
          Explode(x-15,y-25,z-1,100); CreateSparks(x-15,y-25,z-1,2); frame;
          Explode(x-15,y,z-1,100); CreateSparks(x-15,y,z-1,2); frame;
          Explode(x-15,y+25,z-1,100); CreateSparks(x-15,y+25,z-1,2); frame;
        end
        HP-=3;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      repeat
        Spread(x+rand(-20,20),y+rand(-50,50),z,7); Spread(x+rand(-20,20),y+rand(-50,50),z,7);
        Spread(x+rand(-20,20),y+rand(-50,50),z,7); Spread(x+rand(-20,20),y+rand(-50,50),z,7);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Spread(x+rand(-20,20),y+rand(-50,50),z,7); Spread(x+rand(-20,20),y+rand(-50,50),z,7);
        Spread(x+rand(-20,20),y+rand(-50,50),z,7); Spread(x+rand(-20,20),y+rand(-50,50),z,7);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,100);
        Explode(x+rand(-20,20),y+rand(-40,40),z-1,50);
        if (flags==0) angle-=8000; end
        if (flags==1) angle+=8000; end
        alpha-=20; y++;
        frame;
      until(alpha<40)
      return;
    end

    if (DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<200)
        DodgeX=14;
        YOffset=6;
      end
      if (PlayerY>y-100 and PlayerY<y+100)
        if (fget_dist(x,y,PlayerX,PlayerY)>300)
          DodgeX=-14;
          YOffset=6;
        end
      end
    end

    if (DodgeX>0)
      graph=157;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x>MaxX) x-=DodgeX; graph=154; YOffset=0; end
      if (flags==1 and x<MinX) x+=DodgeX; graph=154; YOffset=0; end
      DodgeX--;
    end

    if (DodgeX<0)
      graph=157;
      if (flags==0) x+=DodgeX; end
      if (flags==1) x-=DodgeX; end
      if (flags==0 and x<MinX) x-=DodgeX; graph=154; YOffset=0; end
      if (flags==1 and x>MaxX) x+=DodgeX; graph=154; YOffset=0; end
      DodgeX++;
    end

    if (YOffset>0) YOffset--; end
    if (YOffset<0) YOffset++; end
    if (YOffset==0 and y<StartY) YOffset=-2; end
    y-=YOffset;

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end




process BigSludd(x,y,z,YSpeed,Mode);
begin
  ctype=c_scroll; graph=43; flags=16; size=50;
  play_wav(SluddarGun,0); play_wav(SluddarGun,0);
  repeat
    if (Mode==0) x-=(10+rand(0,1)); end
    if (Mode==1) x+=(10+rand(0,1)); end
    y-=YSpeed;
    if (YSpeed>-4 and rand(1,2)==1) YSpeed--; end
    size--;
    frame;
  until(YSpeed==-2)
  CreateSpread(x,y,z,7); CreateSpread(x,y,z,7);
end



process SluddGun(x,y,z,YSpeed,Mode);
begin
  ctype=c_scroll; graph=43; flags=16; size=20; alpha=200;
  play_wav(SluddarGun,0);
  repeat
    if (Mode==0) x-=(10+rand(0,1)); end
    if (Mode==1) x+=(10+rand(0,1)); end
    y-=YSpeed;
    if (YSpeed>-5 and rand(1,2)==1) YSpeed--; end
    if (collision(PlayerID)) play_wav(SluddarGun,0); PlayerHP--; z--; repeat alpha-=20; size+=5; frame; until(alpha<=60) return; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY)
  y+=4; z--;
  repeat alpha-=10; frame; until(alpha<=40)
end



process FlyingHappyDroid(StartX,StartY,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int HandID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int FollowCounter;
  int EnergyBallID;
  int TempFlag;
  int WaitCounter;
begin
  ctype=c_scroll; graph=51; HP=10;
  x=StartX; y=StartY;
  if (Mode==1) FollowCounter=1; end

  loop
    if (rand(1,1000)==1) FollowCounter=1; end
    if (FollowCounter==1)
      if (PlayerFlag==0)
        if (x<PlayerX-70) x+=4; end
        if (x>PlayerX-70) x-=4; end
      end
      if (PlayerFlag==1)
        if (x<PlayerX+70) x+=4; end
        if (x>PlayerX+70) x-=4; end
      end
      if (y<PlayerY-10) y+=3; end
      if (y>PlayerY-10) y-=3; end
      if (PlayerX<x) flags=1; end
      if (PlayerX>x) flags=0; end
    end
    if (FollowCounter==2)
      if (x<StartX) x+=3; end
      if (x>StartX) x-=3; end
      if (y<StartY) y+=2; end
      if (y>StartY) y-=2; end
    end
    if (FollowCounter!=1)
      HoverCounter++;
      if (HoverCounter<50) y+=1; end
      if (HoverCounter>50 and HoverCounter<100) y-=1; end
      if (HoverCounter==100) HoverCounter=0; end
      if (PlayerX<x) flags=1; end
      if (PlayerX>x) flags=0; end
    end

    if (x>StartX-5 and x<StartX+5 and y>StartY-5 and y<StartY+5 and Mode==0)
      FollowCounter=0;
    end

    if (collision(LevelCheckID)) FollowCounter=2; end

    if (rand(1,200)==1) 
      if (fget_dist(x,y,PlayerX,PlayerY)<600)
        if (exists(type EnergyBall)==0) EnergyBallID=EnergyBall(0); TempFlag=flags; WaitCounter=50; end
      end
    end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type SwordSlash))
        HP-=2;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon))
        if (exists(EnergyBallID)) signal(EnergyBallID, s_kill); end
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(x,y,z-1,150); CreateSparks(x,y,z-1,2);
        z=4; graph=92; frame;
        repeat
          if (PlayerFlag==0)
            flags=1;
            x=PlayerX+132;
            y=PlayerY-26;
          end
          if (PlayerFlag==1)
            flags=0;
            x=PlayerX-132;
            y=PlayerY-26;
          end
          if (rand(1,10)==1) CreateSparks(x+rand(5,5),y+rand(5,5),z-1,2); end
          if (rand(1,20)==1) Explode(x+rand(-10,10),y+rand(-10,10),z-1,100); end
          frame(20);
        until(key(_alt) or key(_x) or joy_getbutton(0,2) or SelectedWeapon!=2 or collision(LevelCheckID))
        YFallSpeed=6;
        if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
        repeat
          Explode(x+rand(-15,15),y+rand(-30,30),z-1,100);
          if (YFallSpeed<8) YFallSpeed++; end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        repeat
          Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
          if (flags==0) angle-=8000; end
          if (flags==1) angle+=8000; end
          alpha-=20; y+=3;
          frame;
        until(alpha<40)
        return;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y-40,z-1,200); Explode(x,y+40,z-1,200);
      CreateSpread(x,y-40,z,4); CreateSpread(x,y+40,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      repeat
        Explode(x+rand(-15,15),y+rand(-30,30),z-1,100);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
        if (flags==0) angle-=8000; end
        if (flags==1) angle+=8000; end
        alpha-=20; y+=3;
        frame;
      until(alpha<40)
      if (exists(EnergyBallID)) signal(EnergyBallID, s_kill); end
      return;
    end

    if (SelectedWeapon==5 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<200) DodgeX=14; end
    end
    if (DodgeX>0)
      if (flags==0) x-=DodgeX; end
      if (flags==1) x+=DodgeX; end
      if (collision(LevelChecKID))
        if (flags==0) x+=DodgeX; end
        if (flags==1) x-=DodgeX; end
      end
      DodgeX--;
    end

    if (WaitCounter>0) WaitCounter--; flags=TempFlag; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process EnergyBall(Mode);
begin
  ctype=c_scroll; graph=63; flags=16; size=0;
  y=father.y; z=father.z-1; flags=father.flags;
  if (father.flags==0) x=father.x+50; end
  if (father.flags==1) x=father.x-50; end

  repeat
    size+=5;
    if (alpha<200) alpha+=5; end
    if (rand(1,4)==1) size-=5; alpha-=5; end
    if (size<0) size=0; end
    EnergyBallParticle(x+rand(-40,40),y+rand(-40,40),z-1,0);
    y=father.y;
    if (father.flags==0) x=father.x+50; end 
    if (father.flags==1) x=father.x-50; end 
    frame;
  until(size==120)
  EnergyBeam(Mode);
  repeat alpha-=10; frame; until(alpha<=20)
end



process EnergyBeam(Mode);
begin
  ctype=c_scroll; graph=64; flags=16; size_x=0; alpha=200;
  x=father.x; y=father.y; z=father.z; flags=father.flags;
  play_wav(Beam2,0);
  repeat
    if (flags==0) x+=10; end
    if (flags==1) x-=10; end
    size_x+=20;
    size_y-=5;
    alpha-=10;
    if (collision(PlayerID)) PlayerHP--; end
    frame;
  until(alpha<=20)
end



process EnergyBallParticle(x,y,z,Mode);
private
  int StopX;
  int StopY;
begin
  ctype=c_scroll; graph=63; flags=16; size=10; alpha=0;
  StopX=father.x; StopY=father.y;
  play_wav(Charge1,0);
  repeat
    if (x<StopX) x++; end
    if (x>StopX) x--; end
    if (y<StopY) y++; end
    if (y>StopY) y--; end
    if (alpha<150) alpha+=10; end
    frame(50);
  until(x==StopX and y==StopY)
end




process GhostFish(x,StartY,z,MinX,MaxX,Mode);
private
  int Direction;
  int MoveSpeed;
  int HoverCounter;
  int ReloadCounter;
  int ReloadCounter2;
  int TempID;
begin

  ctype=c_scroll; HP=50; y=StartY;

  if (Mode==1) Direction=1; MoveSpeed=4; end
  if (Mode==2) Direction=2; MoveSpeed=4; end

  loop
    graph=104;

    if (Direction==1)
      x-=MoveSpeed;
      flags=0;
    end

    if (Direction==2)
      x+=MoveSpeed;
      flags=1;
    end

    if (Direction==1 and x<MinX) Direction=2;
    elseif (Direction==2 and x>MaxX) Direction=1; end

    if (fget_dist(x,y,PlayerX,PlayerY)<50 and ReloadCounter>0);
      TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5)
      graph=105; frame(1000);
      TeleportEffect(x,y,z-1,28); repeat alpha+=10; frame(25); until(alpha==255)
      play_wav(SpiritShot1,0);
      graph=112; frame(200); graph=97; if (collision(PlayerID)) PlayerHP-=5; end frame(200); frame(200); graph=112; frame(200); graph=105; frame(200);
      graph=113; frame(200); graph=98; if (collision(PlayerID)) PlayerHP-=5; end frame(200); graph=113; frame(200); graph=105; frame(200);
      graph=114; frame(200); graph=99; if (collision(PlayerID)) PlayerHP-=5; end frame(200); graph=114; frame(200); graph=105; frame(800);
      TeleportEffect(x,y,z-1,28); repeat alpha-=10; frame(25); until(alpha<=5)
      graph=104; x=rand(MinX,MaxX); frame(0);
      if (collision(PlayerID)) x=rand(MinX,MaxX); end
      frame(1000);
      TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha==255)
    end

    if (fget_dist(x,y,PlayerX,PlayerY)<50 and ReloadCounter==0);
      TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5)
      graph=158; frame(1000); TeleportEffect(x,y,z-1,56); repeat alpha+=10; frame(25); until(alpha==255)
      play_wav(SpiritShot1,0);
      graph=100; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=101; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=102; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=103; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=102; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=101; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=100; if (collision(PlayerID)) PlayerHP-=5; end frame(200);
      graph=158; frame(1000);
      TeleportEffect(x,y,z-1,56); repeat alpha-=10; frame(25); until(alpha<=5)
      ReloadCounter=400; graph=104; x=rand(MinX,MaxX); frame(0);
      if (collision(PlayerID)) x=rand(MinX,MaxX); end
      frame(1000);
      TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha==255)
    end
    if (ReloadCounter>0) ReloadCounter--; end


    if (rand(1,60)==1 and fget_dist(x,y,PlayerX,PlayerY)<180 and fget_dist(x,y,PlayerX,PlayerY)>80 and ReloadCounter2==0);
      ReloadCounter2=100;
      if (PlayerX<x)
        TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5)
        y=StartY-120; graph=95;
        TeleportEffect(x,y,z-1,32); repeat alpha+=10; frame(25); until(alpha==255)
        frame(500); graph=96; play_wav(Shot4,0);
        repeat
          x-=10; y+=10;
          if (collision(PlayerID)) PlayerHP-=3; end
          frame;
        until(y==StartY)
        TeleportEffect(x,y,z-1,32); repeat alpha-=10; frame(25); until(alpha<=5)
        graph=105; x=rand(MinX,MaxX); frame(0);
        if (collision(PlayerID)) x=rand(MinX,MaxX); end
        frame(1000);
        TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha==255)

      elseif (PlayerX>x)
        TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5)
        y=StartY-120; graph=95; play_wav(Shot4,0);
        TeleportEffect(x,y,z-1,32); repeat alpha+=10; frame(25); until(alpha==255)
        frame(500); flags=1; graph=96;
        repeat
          x+=10; y+=10;
          if (collision(PlayerID)) PlayerHP-=3; end
          frame;
        until(y==StartY)
        TeleportEffect(x,y,z-1,32); repeat alpha-=10; frame(25); until(alpha<=5)
        graph=105; flags=0; x=rand(MinX,MaxX); frame(0);
        if (collision(PlayerID)) x=rand(MinX,MaxX); end
        frame(1000);
        TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha==255)

      end
    end

    if (ReloadCounter>0) ReloadCounter--; end
    if (ReloadCounter2>0) ReloadCounter2--; end

    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Sparks(x,y-50,z-1,4); Sparks(x,y-50,z-1,4);
        Sparks(x,y,z-1,4); Sparks(x,y,z-1,4);
        Sparks(x,y+50,z-1,4); Sparks(x,y+50,z-1,4);
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      graph=104;
      Explode(x,y,z-1,150); Explode(x,y-50,z-1,150); Explode(x,y+50,z-1,150);
      Sparks(x,y-50,z-1,4); Sparks(x,y-50,z-1,4);
      Sparks(x,y,z-1,4); Sparks(x,y,z-1,4);
      Sparks(x,y+50,z-1,4); Sparks(x,y+50,z-1,4);
      repeat
        Explode(x+rand(-30,30),y+rand(-50,50),z-1,50);
        CreateSparks(x+rand(-40,40),y+rand(-60,60),z-1,4);
        alpha-=5;
        frame(50);
      until(alpha<=20)
      return;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process GhostFish2(Position1X,Position1Y,Position2X,Position2Y,Position3X,Position3Y,z,Mode);
private
  int Direction;
  int AttackMode;
  int MoveSpeed;
  int HoverCounter;
  int TempID;
  int ReloadCounter;
begin

  ctype=c_scroll; HP=20; x=Position1X; y=Position1Y;

  loop
    graph=104;

    Direction=0;
    AttackMode=0;
    if (ReloadCounter==0)
      if (alpha<=5) Direction=rand(1,3);
      else Direction=rand(0,4); end
      if (fget_dist(x,y,PlayerX,PlayerY)<90) AttackMode=rand(1,2); end
      ReloadCounter=20;
    end

    if (Direction==1)
      if (alpha>5) TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5) alpha=0; end
      x=Position1X; y=Position1Y;
      TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha=>250)
    end

    if (Direction==2)
      if (alpha>5) TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5) alpha=0; end
      x=Position2X; y=Position2Y;
      TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha=>250)
    end

    if (Direction==3)
      if (alpha>5) TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5) alpha=0; end
      x=Position3X; y=Position3Y;
      TeleportEffect(x,y,z-1,0); repeat alpha+=10; frame(25); until(alpha=>250)
    end

    if (PlayerX<x) flags=0; end
    if (PlayerX>x) flags=1; end

    if (AttackMode==1);
      TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5) alpha=0;
      graph=105; frame(500);
      TeleportEffect(x,y,z-1,26);
      repeat alpha+=10; frame(25); until(alpha=>250)
      play_wav(SpiritShot1,0);
      graph=112; frame(200); graph=97; if (collision(PlayerID)) PlayerHP-=4; end frame(200); frame(200); graph=112; frame(200); graph=105; frame(200);
      graph=113; frame(200); graph=98; if (collision(PlayerID)) PlayerHP-=4; end frame(200); graph=113; frame(200); graph=105; frame(200);
      graph=114; frame(200); graph=99; if (collision(PlayerID)) PlayerHP-=4; end frame(200); graph=114; frame(200); graph=105; frame(800);
      TeleportEffect(x,y,z-1,26);
      repeat alpha-=10; frame(25); until(alpha<=5) alpha=0;
    end

    if (AttackMode==2);
      TeleportEffect(x,y,z-1,0); repeat alpha-=10; frame(25); until(alpha<=5) alpha=0;
      graph=158; frame(500);
      TeleportEffect(x,y,z-1,524);
      repeat alpha+=10; frame(25); until(alpha=>250)
      play_wav(SpiritShot1,0);
      graph=100; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=101; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=102; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=103; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=102; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=101; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=100; if (collision(PlayerID)) PlayerHP-=4; end frame(200);
      graph=158; frame(1000);
      TeleportEffect(x,y,z-1,54);
      repeat alpha-=10; frame(25); until(alpha<=5) alpha=0;
    end

    if (ReloadCounter>0) ReloadCounter--; end

    HoverCounter++;
    if (HoverCounter==4 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==16) y--; end
    if (HoverCounter==16) HoverCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill_tree);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Sparks(x,y-50,z-1,4); Sparks(x,y-50,z-1,4);
        Sparks(x,y,z-1,4); Sparks(x,y,z-1,4);
        Sparks(x,y+50,z-1,4); Sparks(x,y+50,z-1,4);
        HP-=2;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      graph=104;
      Explode(x,y,z-1,150); Explode(x,y-50,z-1,150); Explode(x,y+50,z-1,150);
      Sparks(x,y-50,z-1,4); Sparks(x,y-50,z-1,4);
      Sparks(x,y,z-1,4); Sparks(x,y,z-1,4);
      Sparks(x,y+50,z-1,4); Sparks(x,y+50,z-1,4);
      repeat
        Explode(x+rand(-30,30),y+rand(-50,50),z-1,50);
        CreateSparks(x+rand(-40,40),y+rand(-60,60),z-1,4);
        alpha-=5;
        frame(50);
      until(alpha<=20)
      return;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process TeleportEffect(x,y,z,XOffset);
begin
  ctype=c_scroll; alpha=55; flags=16; graph=106;
  play_wav(Teleport,0);
  if (father.flags==0) x+=XOffset; end
  if (father.flags==1) x-=XOffset; end
  repeat alpha+=10; flags=16+rand(0,3); frame(25); until(alpha==255)
  repeat alpha-=10; flags=16+rand(0,3); frame(25); until(alpha==5)
end



process PsykoDrone(x,y,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int HandID;
  int ShieldID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
begin
  ctype=c_scroll; graph=44; HP=5;
  if (Mode==0) HandID=PsykoDroneHand(x,y,z,Mode); end
  if (Mode==1)
     HandID=PsykoDroneHand(x,y,z,Mode);
     ShieldID=PsykoDroneShield(x,y,z+1,Mode);
  end
  if (Mode==2)
     HandID=PsykoDroneSword(x,y,z-1,Mode);
     ShieldID=PsykoDroneShield(x,y,z+1,Mode);
  end
  if (Mode==3)
     HandID=PsykoDroneHand(x,y,z-1,0);
     ShieldID=PsykoDroneHand(x,y,z+1,1);
  end
  loop
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter%2==0 and MoveCounter<300) x+=1; end
    if (MoveCounter%2==0 and MoveCounter>300 and MoveCounter<600) x-=1; end
    if (MoveCounter==600) MoveCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        if (exists(HandID)) HandID.HP=0; end
        if (exists(ShieldID)) ShieldID.HP=0; end
        Explode(x,y,z-1,150);
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-25,z-1,2);
        CreateSparks(x,y+25,z-1,2);
        frame;
        if (flags==0)
          PsykoDronePart(x-16,y,3,flags,0);
          PsykoDronePart(x+16,y,5,flags,1);
        end
        if (flags==1)
          PsykoDronePart(x+16,y,5,flags,3);
          PsykoDronePart(x-16,y,3,flags,2);
        end
        PsykoDronePart(x,y+30,5,flags,4);
        return;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      if (exists(HandID)) HandID.HP=0; end
      if (exists(ShieldID)) ShieldID.HP=0; end
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=1; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=1; end
      repeat
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-30,20),z-1,100);
        if (flags==0) angle-=8000; end
        if (flags==1) angle+=8000; end
        alpha-=20; y+=2;
        frame;
      until(alpha<40)
      return;
    end

    Control=0;
    if (fget_dist(x,y,PlayerX,PlayerY)<400)
      Control=1;
      if (x<PlayerX) flags=0; end
      if (x>PlayerX) flags=1; end
    end

    if (SelectedWeapon==5 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<200) DodgeX=14; end
    end
    if (DodgeX>0)
      if (flags==0) x-=DodgeX; end
      if (flags==1) x+=DodgeX; end
      if (collision(LevelChecKID))
        if (flags==0) x+=DodgeX; end
        if (flags==1) x-=DodgeX; end
      end
      DodgeX--;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process PsykoDroneHand(x,y,z,Mode);
private
  int YOffset;
  int XOffset;
  int MoveDelay;
  int RecoilCounter;
  int ReloadCounter;
  int RoundCounter;
  int TempID;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
begin
  ctype=c_scroll; graph=45; YOffset=40; HP=3;
  if (Mode==1)
    if (flags==0) XOffset=-30; end
    if (flags==1) XOffset=30; end
    YOffset=20;
  end
  loop
    flags=father.flags;
    if (Mode==0)
      if (flags==0 and XOffset<40) XOffset+=2; end
      if (flags==1 and XOffset>-40) XOffset-=2; end
    end
    if (Mode==1)
      if (flags==0 and XOffset>-40) XOffset-=2; end
      if (flags==1 and XOffset<40) XOffset+=2; end
    end
    if (YOffset>80) YOffset=80; end
    if (YOffset<-20) YOffset=-20; end
    y=father.y+YOffset;
    x=father.x+XOffset;

    if (x<PlayerX) angle=fget_angle(x,y,PlayerX,PlayerY); end
    if (x>PlayerX) angle=180000-fget_angle(x,y,PlayerX,PlayerY); end

    if (father.Control==1)
      if (ReloadCounter==0)
        ReloadCounter=10; RoundCounter++;
        if (RoundCounter==3) RoundCounter=0; ReloadCounter=150; end
        if (x<PlayerX) PsykoDroneShot(x,y+1,z+1,angle,Mode); end
        if (x>PlayerX) PsykoDroneShot(x,y+1,z+1,angle,Mode); end
        advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-17,z-1,2);
        CreateSparks(x,y+17,z-1,2);
        HP--; YOffset+=10;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,100); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=8; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=8; end
      repeat
        if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; angle+=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle-=5000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      frame(400);
      return;
    end

    if (ReloadCounter>0) ReloadCounter--; end
    if (RecoilCounter>0) RecoilCounter--; advance(1); end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process PsykoDroneSword(x,y,z,Mode);
private
  int YOffset;
  int XOffset;
  int MoveDelay;
  int RecoilCounter;
  int ReloadCounter;
  int RoundCounter;
  int TempID;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
  int SetTempFlags;
begin
  ctype=c_scroll; graph=382; YOffset=40; HP=5; ReloadCounter=150; SetTempFlags=-1;
  if (Mode==2)
    if (flags==0) XOffset=-30; end
    if (flags==1) XOffset=30; end
    YOffset=20;
  end
  loop
    flags=father.flags;
    if (ReloadCounter>40)
      if (Mode==1)
        if (flags==0 and XOffset<40) XOffset+=2; end
        if (flags==1 and XOffset>-40) XOffset-=2; end
      end
      if (Mode==2)
        if (flags==0 and XOffset>-30) XOffset-=2; end
        if (flags==1 and XOffset<30) XOffset+=2; end
      end
      if (x<PlayerX) angle=get_angle(PlayerID); end
      if (x>PlayerX) angle=180000-get_angle(PlayerID); end
      if (YOffset>80) YOffset=80; end
      if (YOffset<-20) YOffset=-20; end
      x=father.x+XOffset;
    end
    y=father.y+YOffset;

    if (father.Control==1 or SetTempFlags>-1)
      if (ReloadCounter==40) SetTempFlags=flags; end
      if (ReloadCounter>20 and ReloadCounter<40)
        if (SetTempFlags==0) x+=10; YOffset+=3; end
        if (SetTempFlags==1) x-=10; YOffset+=3; end
      end
      if (ReloadCounter>0 and ReloadCounter<20)
        if (SetTempFlags==0) x-=10; YOffset-=3; end
        if (SetTempFlags==1) x+=10; YOffset-=3; end
      end
      if (ReloadCounter==0) ReloadCounter=150; SetTempFlags=-1; end
    end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-17,z-1,2);
        CreateSparks(x,y+17,z-1,2);
        HP--; YOffset+=10;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,100); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=8; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=8; end
      repeat
        if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; angle+=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle-=5000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      frame(400);
      return;
    end

    if (collision(PlayerID)) PlayerHP--; Spread(PlayerX,PlayerY,z,4); end

    if (ReloadCounter>0) ReloadCounter--; end
    if (RecoilCounter>0) RecoilCounter--; advance(1); end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process PsykoDroneShield(x,y,z,Mode);
private
  int YOffset;
  int XOffset;
  int MoveDelay;
  int RecoilCounter;
  int ReloadCounter;
  int RoundCounter;
  int TempID;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
begin
  ctype=c_scroll; graph=381; YOffset=30; YOffset=40; HP=30;
  loop
    flags=father.flags;
    if (flags==0 and XOffset<40) XOffset+=2; end
    if (flags==1 and XOffset>-40) XOffset-=2; end
    if (x<PlayerX) angle=get_angle(PlayerID); end
    if (x>PlayerX) angle=180000-get_angle(PlayerID); end
    if (YOffset>80) YOffset=80; end
    if (YOffset<-20) YOffset=-20; end
    y=father.y+YOffset;
    x=father.x+XOffset;

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--; advance(-5); RecoilCounter=5;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-40,z-1,2);
        CreateSparks(x,y+40,z-1,2);
        HP--; YOffset+=10;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      if (flags==0)
        Explode(x+5,y,z-1,100); CreateSpread(x+5,y,z,4);
        Explode(x+3,y-40,z-1,100); CreateSpread(x+3,y-40,z,4);
        Explode(x,y+40,z-1,100); CreateSpread(x,y,z+40,4);
      end
      if (flags==1)
        Explode(x-5,y,z-1,100); CreateSpread(x-5,y,z,4);
        Explode(x-3,y-40,z-1,100); CreateSpread(x-3,y-40,z,4);
        Explode(x,y+40,z-1,100); CreateSpread(x,y,z+40,4);
      end
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=8; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=8; end
      repeat
        if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; angle+=5000; end
        if (FallDirection==1) x-=XFallSpeed; angle-=5000; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      if (y<MaxLevelY)
        if (flags==0)
          Explode(x+5,y,z-1,100); CreateSpread(x+5,y,z,4);
          Explode(x+3,y-40,z-1,100); CreateSpread(x+3,y-40,z,4);
          Explode(x,y+40,z-1,100); CreateSpread(x,y,z+40,4);
        end
        if (flags==1)
          Explode(x-5,y,z-1,100); CreateSpread(x-5,y,z,4);
          Explode(x-3,y-40,z-1,100); CreateSpread(x-3,y-40,z,4);
          Explode(x,y+40,z-1,100); CreateSpread(x,y,z+40,4);
        end
      end
      frame(400);
      return;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end




process PsykoDronePart(x,y,z,flags,Mode);
private
  int YFallSpeed;
  int XFallSpeed;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==3) graph=47; YFallSpeed=-4; XFallSpeed=4; end
  if (Mode==1 or Mode==2) graph=48; YFallSpeed=-4; XFallSpeed=4; end 
  if (Mode==4) graph=49; YFallSpeed=0; XFallSpeed=0; end
  repeat
    if (YFallSpeed<10) YFallSpeed++; end
    y+=YFallSpeed;
    if (XFallSpeed>2) XFallSpeed--; end
    if (Mode==1) x+=XFallSpeed; end
    if (Mode==0) x-=XFallSpeed; end
    if (Mode==2) x-=XFallSpeed; end
    if (Mode==3) x+=XFallSpeed; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY)
  repeat
    y++; alpha-=20;
    Explode(x+rand(-20,20),y+rand(-20,20),z-1,50);
    if (Mode==0 or Mode==3) angle+=5000; end
    if (Mode==1 or Mode==2) angle-=5000; end
    if (Mode==4)
      if (flags==0) angle-=5000; end
      if (flags==1) angle+=5000; end
    end
    frame;
  until(alpha<40)
  return;
end



process PsykoDroneShot(x,y,z,angle,Mode);
private
  int FadeCounter;
begin
  ctype=c_scroll; graph=46; flags=16; size=10; flags=father.flags;
  play_wav(Photon,0);
  angle=fget_angle(x,y,PlayerX,PlayerY);
  advance(10);
  repeat
    advance(8);
    FadeCounter++;
    if (FadeCounter>140 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID)) PlayerHP-=2; Explode(x,y,z-1,25); return; end
    if (size<100) size+=10; end
    frame;
  until(collision(LevelCheckID))
  repeat alpha-=20; frame(50); until(alpha<=50)
end



process LightBot(x,y,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int LightID;
  int HaloID;
  int TempID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
begin
  ctype=c_scroll; graph=18;
  LightID=LightBotLight(x+62,y+54,3,Mode); HaloID=LightBotLightHalo(x,y,z-1,Mode);
  loop
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter<300) x+=1; flags=0; end
    if (MoveCounter>300 and MoveCounter<600) x-=1; flags=1; end
    if (MoveCounter==600) MoveCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(TempID.x,TempID.y,TempID.z-1,100);
        if (PlayerX<x) FallDirection=0; XFallSpeed=9; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=9; end
        signal(TempID, s_kill);
        repeat
          if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        play_wav(Bounce,0);
        y-=5; YFallSpeed=0; Explode(x,y,z-1,100); signal(LightID, s_kill); signal(HaloID, s_kill);
        XFallSpeed=4; ActiveLamp1_X=-200; ActiveLamp1_Y=-200;
        repeat
          if (YFallSpeed>-8) YFallSpeed-=2; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(YFallSpeed==-8)
        repeat
          if (YFallSpeed<10) YFallSpeed++; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
        frame(500);
        return;
      end
    end
    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(TempID.x,TempID.y,TempID.z-1,100);
        if (PlayerX<x) FallDirection=0; XFallSpeed=9; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=9; end
        signal(TempID, s_kill);
        repeat
          if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        play_wav(Bounce,0);
        y-=5; YFallSpeed=0; Explode(x,y,z-1,100); signal(LightID, s_kill); signal(HaloID, s_kill);
        XFallSpeed=4; ActiveLamp1_X=-200; ActiveLamp1_Y=-200;
        repeat
          if (YFallSpeed>-8) YFallSpeed-=2; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(YFallSpeed==-8)
        repeat
          if (YFallSpeed<10) YFallSpeed++; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
        frame(500);
        return;
      end
    end
    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(TempID.x,TempID.y,TempID.z-1,100);
        if (PlayerX<x) FallDirection=0; XFallSpeed=9; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=9; end
        signal(TempID, s_kill);
        repeat
          if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        play_wav(Bounce,0);
        y-=5; YFallSpeed=0; Explode(x,y,z-1,100); signal(LightID, s_kill); signal(HaloID, s_kill);
        XFallSpeed=4; ActiveLamp1_X=-200; ActiveLamp1_Y=-200;
        repeat
          if (YFallSpeed>-8) YFallSpeed-=2; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(YFallSpeed==-8)
        repeat
          if (YFallSpeed<10) YFallSpeed++; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
        frame(500);
        return;
      end
    end
    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        Explode(TempID.x,TempID.y,TempID.z-1,100);
        if (PlayerX<x) FallDirection=0; XFallSpeed=9; end
        if (PlayerX=>x) FallDirection=1; XFallSpeed=9; end
        signal(TempID, s_kill);
        repeat
          if (YFallSpeed<10) YFallSpeed++; Explode(x,y,z-1,100); end
          y+=YFallSpeed;
          if (XFallSpeed>3) XFallSpeed--; end
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        play_wav(Bounce,0);
        y-=5; YFallSpeed=0; Explode(x,y,z-1,100); signal(LightID, s_kill); signal(HaloID, s_kill);
        XFallSpeed=4; ActiveLamp1_X=-200; ActiveLamp1_Y=-200;
        repeat
          if (YFallSpeed>-8) YFallSpeed-=2; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(YFallSpeed==-8)
        repeat
          if (YFallSpeed<10) YFallSpeed++; end
          y+=YFallSpeed;
          if (FallDirection==0) x+=XFallSpeed; end
          if (FallDirection==1) x-=XFallSpeed; end
          frame;
        until(collision(LevelCheckID) or y>MaxLevelY)
        Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
        frame(500);
        return;
      end
    end
    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Combo++; ComboCounter=60; PlayerScore+=100*Combo;
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-17,z-1,2);
        CreateSparks(x,y+17,z-1,2);
        signal(LightID, s_kill); signal(HaloID, s_kill);
        ActiveLamp1_X=-200; ActiveLamp1_Y=-200;
        frame;
        if (flags==0)
          LightBotPart(x-12,y,3,flags,0);
          LightBotPart(x+12,y,5,flags,1);
        end
        if (flags==1)
          LightBotPart(x+12,y,5,flags,3);
          LightBotPart(x-12,y,3,flags,2);
        end
        return;
      end
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process LightBotPart(x,y,z,flags,Mode);
private
  int YFallSpeed;
  int XFallSpeed;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==3) graph=37; end
  if (Mode==1 or Mode==2) graph=38; end 
  YFallSpeed=-4; XFallSpeed=4;
  repeat
    if (YFallSpeed<10) YFallSpeed++; end
    y+=YFallSpeed;
    if (XFallSpeed>2) XFallSpeed--; end
    if (Mode==1) x+=XFallSpeed; end
    if (Mode==0) x-=XFallSpeed; end
    if (Mode==2) x-=XFallSpeed; end
    if (Mode==3) x+=XFallSpeed; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY)
  Explode(x,y,z-1,200); CreateSpread(x,y,z,4);
  frame(500);
  return;
end



process LightBotLight(x,y,z,Mode);
begin
  ctype=c_scroll; graph=19; alpha=150;
  loop
    flags=father.flags+16;
    if (flags==16) x=father.x+62; end
    if (flags==17) x=father.x-62; end
    y=father.y+55;
    if (PlayerX>x-200 and PlayerX<x+200)
      ActiveLamp1_X=x;
      ActiveLamp1_Y=y;
    end
    if (collision(PlayerID))
      if (GlobalRed<105) GlobalRed+=5; end
      if (GlobalGreen<105) GlobalGreen+=5; end
    end
    frame;
  end
end



process LightBotLightHalo(x,y,z,Mode);
begin
  ctype=c_scroll; graph=82; flags=16; alpha=50;
  loop
    if (father.flags==0) x=father.x+9; end
    if (father.flags==1) x=father.x-9; end
    y=father.y+2;
    frame;
  end
end



process PsyLord(x,y,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int HandID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int LaughOn;
  int PsyFish1;
  int PsyFish2;
  int PsyFish3;
  int ReloadCounter;
begin
  ctype=c_scroll; graph=193; HP=40;

  if (Mode==0)
    PsyFish1=FlyFish(x-80,y-80,z,1); frame(200);
    PsyFish2=FlyFish(x+80,y-80,z,1); frame(200);
    PsyFish3=FlyFish(x,y+80,z,1);
    PsyFish1.Control=1; PsyFish2.Control=1; PsyFish3.Control=1;
  end
  if (Mode==1) ReloadCounter=170; end

  loop

    if (Mode==0)
      if (fget_dist(x,y,PlayerX,PlayerY)>300)
        TeleportEffect(x,y,z-1,0);
        if (exists(PsyFish1)) PsyFish1.Control=1; end
        if (exists(PsyFish2)) PsyFish2.Control=1; end
        if (exists(PsyFish3)) PsyFish3.Control=1; end
        frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
        repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
        repeat frame; until (fget_dist(x,y,PlayerX,PlayerY)<300)
        TeleportEffect(x,y,z-1,0);
        if (exists(PsyFish1)) PsyFish1.Control=0; end
        if (exists(PsyFish2)) PsyFish2.Control=0; end
        if (exists(PsyFish3)) PsyFish3.Control=0; end
        frame; GlobalRed+=5; GlobalGreen+=5; GlobalBlue+=20; CreateSpread(x,y,z,6);
        repeat alpha+=10; size_x+=5; frame(20); until(size_x==100)
        LaughOn=30;
      end
    end

    if (LaughOn==0 and Mode==0) graph=193; end
    if (LaughOn>0)
      LaughOn--;
      if (LaughOn==29 or LaughOn==28) graph=194; end
      if (LaughOn==27 or LaughOn==26) graph=195; end
      if (LaughOn==25 or LaughOn==24) graph=196; end
      if (LaughOn==23 or LaughOn==22) graph=195; end
      if (LaughOn==21 or LaughOn==20) graph=194; end
      if (LaughOn==19 or LaughOn==18) graph=194; end
      if (LaughOn==17 or LaughOn==16) graph=195; end
      if (LaughOn==15 or LaughOn==14) graph=196; end
      if (LaughOn==13 or LaughOn==12) graph=195; end
      if (LaughOn==11 or LaughOn==10) graph=194; end
      if (LaughOn==9 or LaughOn==8) graph=194; end
      if (LaughOn==7 or LaughOn==6) graph=195; end
      if (LaughOn==5 or LaughOn==4) graph=196; end
      if (LaughOn==3 or LaughOn==2) graph=195; end
      if (LaughOn==1 or LaughOn==0) graph=194; end
      ReloadCounter=170;
    end

    if (ReloadCounter>0) ReloadCounter--; end

    if (ReloadCounter<40 and Mode==0)
      graph=197;
      if (rand(1,3)==1)
        PsyLordObject(x+rand(-20,20),y-80+rand(-20,20),4,flags);
      end
      if (ReloadCounter==1) LaughOn=30; end
    end

    if (Mode==1)
      if (ReloadCounter==160 or ReloadCounter==110 or ReloadCounter==60) graph=197; end
      if (ReloadCounter==150 or ReloadCounter==100 or ReloadCounter==50)
        if (PlayerX>260 and PlayerX<1200) SolkBox(PlayerX,30,4,0); end
      end
      if (ReloadCounter==140 or ReloadCounter==90 or ReloadCounter==40) graph=193; end
      if (ReloadCounter==1) LaughOn=30; end
    end

    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter%2==0 and MoveCounter<300) x+=1; flags=1; end
    if (MoveCounter%2==0 and MoveCounter>300 and MoveCounter<600) x-=1; flags=0; end
    if (MoveCounter==600) MoveCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Explode(x,y,z-1,150);
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-25,z-1,2);
        CreateSparks(x,y+25,z-1,2);
        HP-=4;
        frame;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=2; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=2; end
      if (exists(PsyFish1)) PsyFish1.HP=0; end
      if (exists(PsyFish2)) PsyFish2.HP=0; end
      if (exists(PsyFish3)) PsyFish3.HP=0; end
      repeat
        Explode(x+rand(-20,20),y+rand(-70,70),z-1,100);
        Explode(x+rand(-20,20),y+rand(-70,70),z-1,50);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
        if (FallDirection==0) angle+=8000; end
        if (FallDirection==1) angle-=8000; end
        alpha-=20; y+=2;
        frame;
      until(alpha<40)
      return;
    end

    Control=0;
    if (fget_dist(x,y,PlayerX,PlayerY)<400)
      Control=1;
      if (DodgeX==0)
        if (x<=PlayerX) flags=1; end
        if (x>PlayerX) flags=0; end
      end
    end

    if (SelectedWeapon==5 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<200) DodgeX=14; end
    end
    if (SelectedWeapon!=5 and DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<50) DodgeX=14; end
    end
    if (DodgeX>0)
      if (flags==0) x-=DodgeX; end
      if (flags==1) x+=DodgeX; end
      if (collision(LevelChecKID))
        if (flags==0) x+=DodgeX; end
        if (flags==1) x-=DodgeX; end
      end
      DodgeX--;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process PsyLordObject(x,y,z,Mode);
private
  int TimeCounter;
begin
  ctype=c_scroll; graph=rand(202,205); alpha=80;
  if (rand(1,5)==1) graph=94; end ShockWave(x,y,z,201);
  repeat
    if (Mode==1) x+=5; end
    if (Mode==0) x-=5; end
    y+=5;
    alpha+=20;
    frame;
  until(alpha=>240)
  repeat
    if (Mode==1) x+=5; end
    if (Mode==0) x-=5; end
    y+=5;
    TimeCounter++;
    if (collision(PlayerID)) PlayerHP-=3; Explode(x,y,z-1,100); return; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY or TimeCounter>100)
  Explode(x,y,z-1,100);
  frame;
end



process CreepingBrain(x,y,z,Mode);
private
  int AnimationCounter;
  int HoverCounter;
  int MoveCounter;
  int DodgeX;
  int SetFlags;
  int YFallSpeed;
  int XFallSpeed;
  int FallDirection;
  int TempID;
begin
  ctype=c_scroll; graph=384; HP=5;

loop
    AnimationCounter++;
    if (AnimationCounter>0 and AnimationCounter<4) graph=384; end
    if (AnimationCounter>4 and AnimationCounter<8) graph=385; end
    if (AnimationCounter>8 and AnimationCounter<12) graph=386; end
    if (AnimationCounter>12 and AnimationCounter<16) graph=385; end
    if (AnimationCounter=>16) AnimationCounter=0; end

    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter%2==0 and MoveCounter<300) x+=1; end
    if (MoveCounter%2==0 and MoveCounter>300 and MoveCounter<600) x-=1; end
    if (MoveCounter==600) MoveCounter=0; end

    if (fget_dist(x,y,PlayerX,PlayerY)>50 and fget_dist(x,y,PlayerX,PlayerY)<200 and DodgeX==0)
      DodgeX=20; SetFlags=flags;
      AnimationCounter++;
    end

    if (DodgeX>0)
      if (SetFlags==1) x+=DodgeX; end
      if (SetFlags==0) x-=DodgeX; end
      if (collision(LevelChecKID))
        if (SetFlags==1) x-=DodgeX; end
        if (SetFlags==0) x+=DodgeX; end
      end
      DodgeX--;
    end

    if (x<=PlayerX) flags=1; end
    if (x>PlayerX) flags=0; end

    if (collision(PlayerID))
      if (rand(0,1)==1) PlayerHP--; play_wav(Splash2,0); end
      Spread(x+rand(-20,20),y+rand(10,40),z,5);
      Spread(x+rand(-20,20),y+rand(10,40),z,5);
      Spread(x+rand(-20,20),y+rand(10,40),z,5);
    end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        CreateSparks(x,y,z-1,2); Explode(x,y-30,z-1,100);
        CreateSparks(x,y-30,z-1,2); Explode(x,y,z-1,100);
        CreateSparks(x,y+30,z-1,2); Explode(x,y+30,z-1,100);
        frame;
        if (flags==0)
          CreepingBrainPart(x-12,y,3,flags,0);
          CreepingBrainPart(x+12,y,5,flags,1);
        end
        if (flags==1)
          CreepingBrainPart(x+12,y,5,flags,3);
          CreepingBrainPart(x-12,y,3,flags,2);
        end
        return;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      CreateSparks(x,y,z-1,2); Explode(x,y-30,z-1,100);
      CreateSparks(x,y-30,z-1,2); Explode(x,y,z-1,100);
      CreateSparks(x,y+30,z-1,2); Explode(x,y+30,z-1,100);
      frame(200);
      if (PlayerX<x) FallDirection=0; XFallSpeed=2; end
      if (PlayerX=>x) FallDirection=1; XFallSpeed=2; end
      repeat
        Explode(x+rand(-10,10),y+rand(-20,20),z-1,50);
        if (YFallSpeed<8) YFallSpeed++; end
        y+=YFallSpeed;
        if (XFallSpeed>3) XFallSpeed--; end
        if (FallDirection==0) x+=XFallSpeed; end
        if (FallDirection==1) x-=XFallSpeed; end
        frame;
      until(collision(LevelCheckID) or y>MaxLevelY)
      repeat
        Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
        if (FallDirection==0) angle-=8000; end
        if (FallDirection==1) angle+=8000; end
        alpha-=20; y+=2;
        frame;
      until(alpha<40)
      return;
    end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process CreepingBrainPart(x,y,z,flags,Mode);
private
  int YFallSpeed;
  int XFallSpeed;
begin
  ctype=c_scroll;
  if (Mode==0 or Mode==3) graph=387; end
  if (Mode==1 or Mode==2) graph=388; end 
  YFallSpeed=-4; XFallSpeed=4;
  repeat
    if (YFallSpeed<10) YFallSpeed++; end
    y+=YFallSpeed;
    if (XFallSpeed>2) XFallSpeed--; end
    if (Mode==1) x+=XFallSpeed; end
    if (Mode==0) x-=XFallSpeed; end
    if (Mode==2) x-=XFallSpeed; end
    if (Mode==3) x+=XFallSpeed; end
    frame;
  until(collision(LevelCheckID) or y>MaxLevelY)
  repeat
    Explode(x+rand(-20,20),y+rand(-20,20),z-1,100);
    if (Mode==0 or Mode==3) angle+=8000; end
    if (Mode==1 or Mode==2) angle-=8000; end
    alpha-=20; y+=2;
    frame;
  until(alpha<40)
  return;
end



process SchmupGrunt(x,y,z,Mode);
private
  int TempID;
begin
  ctype=c_scroll; graph=310; HP=2;

  loop
    if (Mode==0) x-=5; end

    if (HP>1)
      if (y>PlayerY) y-=2; end
      if (y<PlayerY) y+=2; end
    end

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (HP==1)
      angle+=1000; y+=4;
      if (rand(1,2)==1) Explode(x+rand(-10,10),y+rand(-10,10),z-1,rand(40,60)); end
    end

    if (collision(LevelCheckID) or y>MaxLevelY or collision(type SchmupGrunt)) HP=0; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150);
      CreateSpread(x,y,z,4);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (collision(PlayerID)) PlayerHP-=5; HP=0; end

    if (x<CameraID.x-350) return; end

    frame;
  end
end



process SchmupGunner(x,y,z,Mode);
private
  int TempID;
  int ReloadCounter;
begin
  ctype=c_scroll; graph=308; HP=5;

  loop

    if (Mode==0) x-=2; end

    if (HP>2)
      if (y>PlayerY) y--; end
      if (y<PlayerY) y++; end
    end

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (HP==1 or HP==2)
      y+=3;
      if (rand(1,2)==1) Explode(x+rand(-10,10),y+rand(-10,10),z-1,rand(40,60)); end
    end
    if (collision(LevelCheckID)) HP=0; end
    if (y>MaxLevelY) return; end 
    if (TempID=collision(type SchmupGrunt)) TempID.HP=0; HP=0; end
    if (TempID=collision(type SchmupEnergyBalls)) TempID.HP=0; HP=0; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x-30,y,z-1,150); Explode(x+30,y,z-1,150);  Explode(x,y,z-1,150);
      CreateSpread(x-30,y,z,4); CreateSpread(x+30,y,z,4);
      repeat
        angle-=1000;
        Explode(x+rand(-30,30),y+rand(-30,30),z-1,100);
        y++;
        alpha-=5;
        frame;
      until(alpha<=205)
      Explode(x-30,y,z-1,150); Explode(x+30,y,z-1,150);  Explode(x,y,z-1,150);
      CreateSpread(x-30,y,z,4); CreateSpread(x+30,y,z,4);
      frame(200);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (collision(PlayerID)) PlayerHP-=10; Explode(PlayerX+30,PlayerY,z-1,100); HP=0; end

    if (x<CameraID.x-370) return; end

    if (ReloadCounter==0)
      SchmupShot1(x-34,y-14,z+1,0);
      ReloadCounter=20;
    end
    if (ReloadCounter>0) ReloadCounter--; end

    frame;
  end
end



process SchmupStar(x,y,z,Speed,Mode);
private
  int TempID;
  int MoveCounter;
  int AnimationCounter;
begin
  ctype=c_scroll; graph=311; HP=1;

  loop

    if (Mode==1) x-=3; end

    MoveCounter++;
    if (MoveCounter>0 and MoveCounter<=30) y-=Speed; end
    if (MoveCounter>30 and MoveCounter<=60) y+=Speed; end  
    if (MoveCounter==60) MoveCounter=0; end

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150);
      CreateSpread(x,y,z,4);
      frame(200);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (TempID=collision(type SchmupEnergyBalls)) TempID.HP=0; HP=0; end

    if (rand(1,50)==1 and AnimationCounter==0) AnimationCounter=7; end
    if (rand(1,50)==1 and AnimationCounter==0) AnimationCounter=-7; end

    if (AnimationCounter>0) AnimationCounter--; end
    if (AnimationCounter<0) AnimationCounter++; end

    if (AnimationCounter==7 or AnimationCounter==6) graph=312; end
    if (AnimationCounter==5 or AnimationCounter==4) graph=313; end
    if (AnimationCounter==3 or AnimationCounter==2) graph=314; end
    if (AnimationCounter==1) graph=311; end

    if (AnimationCounter==-7 or AnimationCounter==-6) graph=314; end
    if (AnimationCounter==-5 or AnimationCounter==-4) graph=313; end
    if (AnimationCounter==-3 or AnimationCounter==-2) graph=312; end
    if (AnimationCounter==-1) graph=311; end

    if (collision(PlayerID)) PlayerHP-=5; HP=0; end

    if (x<CameraID.x-350) return; end

    frame;
  end
end



process SchmupTank(x,y,z,Mode);
private
  int TempID;
  int HoverCounter;
begin
  ctype=c_scroll; graph=315; HP=17;

  loop

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (HP>0 and HP<7)
      y+=3;
      if (rand(1,2)==1) Explode(x+rand(-70,70),y+rand(-30,30),z-1,rand(40,60)); end
      if (TempID=collision(type SchmupEnergyBalls)) TempID.HP=0; HP=0; end
      if (TempID=collision(type SchmupGunner)) TempID.HP=0; HP=0; end
    end
    if (collision(LevelCheckID)) HP=0; end
    if (TempID=collision(type SchmupGrunt)) TempID.HP=0; HP--; end
    if (y>MaxLevelY) return; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y+45,z-1,150);
      CreateSpread(x,y,z,4);
      SchmupTankPart(x-40,y,z,0);
      SchmupTankPart(x+40,y,z,1);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (collision(PlayerID)) PlayerHP-=5; HP-=2; Explode(PlayerX+30,PlayerY,z-1,100); end

    if (x<CameraID.x-420) return; end

    HoverCounter++;
    if (HoverCounter==6 or HoverCounter==12) y++; end
    if (HoverCounter==18 or HoverCounter==24) y--; end
    if (HoverCounter==30) HoverCounter=0; end

    frame;
  end
end



process SchmupTankPart(x,y,z,Mode);
private
  int TempID;
begin
  ctype=c_scroll; HP=3;
  if (Mode==0) graph=316; end
  if (Mode==1) graph=317; end

  loop
    if (Mode==0) angle+=1000; x--; end
    if (Mode==1) angle-=1000; x++; end
    y+=3;
    if (rand(1,2)==1) Explode(x+rand(-70,70),y+rand(-30,30),z-1,rand(40,60)); end
    if (collision(LevelCheckID) or y>MaxLevelY or collision(type SchmupGrunt)) HP=0; end
    if (TempID=collision(type SchmupGunner)) TempID.HP=0; HP=0; end

    if (HP<=0)
      Explode(x,y,z-1,150);
      CreateSpread(x,y,z,4);
      frame(200);
      return;
    end

    frame;
  end
end



process SchmupEnergyBalls(x,y,z,flags,Mode);
private
  int TempID;
  int EnergyFieldID;
  int HoverCounter;
begin
  ctype=c_scroll; graph=319; HP=3;
  EnergyFieldID=EnergyBallField(x,y,z+1,flags,Mode);
  loop

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (TempID=collision(type SchmupGrunt)) TempID.HP=0; HP=0; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      EnergyFieldID.HP=0;
      if (flags==0)
        Explode(x+29,y-29,z-1,100); CreateSpread(x+29,y-29,z-1,4);
        Explode(x-25,y+30,z-1,100); CreateSpread(x-25,y+30,z-1,4);
      end
      if (flags==1)
        Explode(x-25,y+30,z-1,100); CreateSpread(x-25,y+30,z-1,4);
        Explode(x+29,y-29,z-1,100); CreateSpread(x+29,y-29,z-1,4);
      end
      if (flags==2)
        Explode(x+29,y+30,z-1,100); CreateSpread(x+29,y+30,z-1,4);
        Explode(x-25,y-29,z-1,100); CreateSpread(x-25,y-29,z-1,4);
      end
      if (flags==3)
        Explode(x-25,y+30,z-1,100); CreateSpread(x-25,y+30,z-1,4);
        Explode(x+29,y-29,z-1,100); CreateSpread(x+29,y-29,z-1,4);
      end
      frame;
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (collision(PlayerID)) PlayerHP-=5; HP=0; end

    if (x<CameraID.x-370) signal(EnergyFieldID, s_kill); return; end

    HoverCounter++;
    if (HoverCounter==6 or HoverCounter==12) y++; end
    if (HoverCounter==18 or HoverCounter==24) y--; end
    if (HoverCounter==30) HoverCounter=0; end

    frame;
  end
end



process EnergyBallField(x,y,z,flags,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll; graph=318; HP=1; flags=flags+16;

  loop
    HoverCounter++;
    if (HoverCounter==12 or HoverCounter==24) y++; end
    if (HoverCounter==36 or HoverCounter==48) y--; end
    if (HoverCounter==60) HoverCounter=0; end

    if (collision(PlayerID))
      PlayerHP--;
      Spread(PlayerX,PlayerY,z-1,10);
      Spread(PlayerX,PlayerY,z-1,10);
      if (GlobalRed<120) GlobalRed+=5; end
      if (GlobalGreen<110) GlobalGreen+=2; end
      if (GlobalBlue<110) GlobalBlue+=2; end
    end

    if (HP<=0)
      repeat alpha-=10; frame(50); until(alpha<=20) return;
    end

    size=rand(95,105); alpha=rand(160,255);

    frame(50);
  end
end



process SchmupTriGun(x,y,z,Mode);
private
  int TempID;
  int HoverCounter;
  int ReloadCounter;
begin
  ctype=c_scroll; graph=320; HP=5;

  loop

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end

    if (collision(type SchmupGrunt) or collision(type SchmupTank) or collision(type SchmupTankPart)) HP=0; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y-30,z-1,150); CreateSpread(x,y-30,z,4);
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      Explode(x,y+30,z-1,150); CreateSpread(x,y+30,z,4);
      frame(200);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (collision(PlayerID)) PlayerHP-=5; HP=0; end

    if (x<CameraID.x-350) return; end

    HoverCounter++;
    if (HoverCounter==6 or HoverCounter==12) y++; end
    if (HoverCounter==18 or HoverCounter==24) y--; end
    if (HoverCounter==30) HoverCounter=0; end

    if (ReloadCounter==0)
      play_wav(Photon,0);
      SchmupShot2(x-8,y-20,z+1,3);
      SchmupShot2(x-8,y,z+1,4);
      SchmupShot2(x-8,y+12,z+1,5);
      ReloadCounter=60;
    end
    if (ReloadCounter==30)
      play_wav(Photon,0);
      SchmupShot2(x+8,y-20,z+1,0);
      SchmupShot2(x+8,y,z+1,1);
      SchmupShot2(x+8,y+12,z+1,2);
    end
    if (ReloadCounter>0) ReloadCounter--; end

    frame;
  end
end



process SchmupSpiderBot(x,y,z,Mode);
private
  int TempID;
  int ReloadCounter;
begin
  ctype=c_scroll; graph=321; HP=3;

  loop

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP=0;
    end

    if (TempID=collision(type SchmupGrunt)) HP=0; TempID.HP=0; end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      repeat
        angle-=1000;
        Explode(x+rand(-20,20),y+rand(-20,20),z-1,50);
        y++;
        alpha-=5;
        frame;
      until(alpha<=205)
      frame(200);
      Explode(x,y,z-1,150); CreateSpread(x,y,z,4);
      if (rand(1,10)==1) SchmupPowerUp(x,y,z,rand(1,2)); end
      return;
    end

    if (ReloadCounter==0 and PlayerX>x-40 and PlayerX<x+40)
      SchmupShot2(x,y,z+1,8);
      ReloadCounter=50;
    end
    if (ReloadCounter>0) ReloadCounter--; end

    if (collision(PlayerID)) PlayerHP-=5; HP=0; end

    if (x<CameraID.x-350) return; end

    frame;
  end
end



process SchmupBoss1(x,y,z,Mode);
private
  int XSpeed;
  int StartSpin;
  int SpinSpeed;
  int TempID;
  int ReloadCounter;
begin
  ctype=c_scroll; graph=383; XSpeed=20; HP=100;
  repeat
    x-=XSpeed;
    if (XSpeed>0) XSpeed--; end
    frame;
  until(XSpeed==0)

  loop

    if (y>PlayerY) y-=2; end
    if (y<PlayerY) y+=2; end

    if (rand(1,70)==1 and StartSpin==0) StartSpin=1; end
    if (StartSpin==1) size_y-=SpinSpeed; SpinSpeed++; end
    if (size_y<=0) StartSpin=2; end
    if (StartSpin==2) size_y+=SpinSpeed; SpinSpeed--; end
    if (size_y=>100) StartSpin=0; end

    if (ReloadCounter==40 and StartSpin==0)
      play_wav(Photon,0);
      ShockWave(x+13,y-57,z+1,130); SchmupShot2(x+13,y-57,z-1,4);
      ShockWave(x+13,y+57,z+1,130); SchmupShot2(x+13,y+57,z-1,4);
    end
    if (ReloadCounter==20 and StartSpin==0)
      play_wav(Photon,0);
      ShockWave(x+13,y-12,z+1,130); SchmupShot2(x+13,y-12,z-1,4);
      ShockWave(x+13,y+12,z+1,130); SchmupShot2(x+13,y+12,z-1,4);
    end
    if (ReloadCounter==60 and StartSpin==0)
      SchmupEnemyMissile(x-10,y-15,6,0);
      SchmupEnemyMissile(x-10,y+15,6,0);
    end
    if (ReloadCounter<=0) ReloadCounter=61+HP; end
    if (ReloadCounter>0) ReloadCounter--; end

    if (TempID=collision(type Gun2Fire))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP--;
    end
    if (TempID=collision(type SchmupMissile))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end
    if (TempID=collision(type DeflectedShot))
      ShockWave(TempID.x,TempID.y,z,130);
      Explode(TempID.x,TempID.y,z-1,50);
      CreateSpread(TempID.x,TempID.y,z,5);
      signal(TempID, s_kill);
      HP-=2;
    end

    if (HP<=0 and StartSpin==0)
      PlayerScore+=10000;
      repeat
        y+=5;
        Spread(x+rand(-90,90),y+rand(-90,90),z-1,5);
        if (rand(1,2)==1) Explode(x+rand(-90,90),y+rand(-90,90),z-1,100); end
        if (rand(1,2)==1) Explode(x+rand(-90,90),y+rand(-90,90),z-1,rand(40,60)); end
        frame;
      until(y>580)
      return;
    end

    frame;
  end
end



process SchmupEnemyMissile(x,y,z,Mode);
private
  int FadeCounter;
  int SpeedCounter;
begin
  ctype=c_scroll; graph=265; flags=16; flags=Mode; SpeedCounter=1;
  play_wav(Rocket,0);
  if (flags==0) x-=6; end
  if (flags==1) x+=6; end
  repeat
    if (flags==0) x-=SpeedCounter; end
    if (flags==1) x+=SpeedCounter; end
    if (SpeedCounter<10) SpeedCounter++; end
    FadeCounter++;
    if (FadeCounter>140 or x<CameraID.x-350) return; end
    if (collision(PlayerID)) PlayerHP-=5; Explode(x,y,z-1,50); return; end
    GreySmoke(x,y,z,0);
    if (PlayerY>y) y++; end
    if (PlayerY<y) y--; end
    frame;
  until(collision(LevelCheckID))
  Explode(x,y,z-1,50);
  frame;
end



process SchmupShot1(x,y,z,Mode);
begin
  ctype=c_scroll;
  if (Mode==0) graph=309; flags=16; end
  play_wav(BigShot,0);
  repeat
    x-=5;
    if (collision(PlayerID))
      PlayerHP-=2;
      Explode(x-11,y-10,z-1,30); Explode(x-11,y,z-1,30); Explode(x-11,y+10,z-1,30);
      CreateSpread(x,y,z,4);
      return;
    end

    if (collision(type Deflector))
      CreateSpread(x,y,z,1);
      ShockWave(x,y,z,130);
      DeflectedShot(x,y,z,9);
      return;
    end

    frame(50);
  until(collision(LevelCheckID) or x<CameraID.x-350)
  if (x<CameraID.x-350) return; end
  CreateSpread(x,y,z,1);
  GlobalRed+=10; GlobalGreen+=5; GlobalBlue+=5;
  ShockWave(x,y,z,130);
  if (Mode==0) GunFade(x-11,y,z,0); GunFade(x-11,y-7,z,0); GunFade(x-11,y+7,z,0); end
end



process SchmupShot2(x,y,z,Mode);
begin
  ctype=c_scroll; graph=146; flags=16; size=80;
  if (Mode==8) graph=192; size=0; end
  play_wav(Photon,0);
  frame(50);

  repeat
    if (Mode==0) x+=3; y-=3; end
    if (Mode==1) x+=3; end
    if (Mode==2) x+=3; y+=3; end
    if (Mode==3) x-=3; y-=3; end
    if (Mode==4) x-=3; end
    if (Mode==5) x-=3; y+=3; end
    if (Mode==6) y-=3; end
    if (Mode==7) y+=3; end
    if (Mode==8) y-=3; end

    if (collision(PlayerID))
      PlayerHP-=2;
      if (Mode!=8) Explode(x,y,z-1,30); end
      if (Mode==8) Explode(x,y-16,z-1,50); end
      CreateSpread(x,y,z,4);
      return;
    end

    if (collision(type Deflector))
      CreateSpread(x,y,z,4);
      ShockWave(x,y,z,130);
      DeflectedShot(x,y,z,Mode);
      return;
    end

    if (Mode==8 and size<100) size+=5; end

    if (y<-30 or x<-30 or x>6000 or y>MaxLevelY or x<CameraID.x-350 or x>CameraID.x+350) return; end
    frame(50);
  until(collision(LevelCheckID))
  CreateSpread(x,y,z,4); GlobalRed+=10; GlobalGreen+=5;
  ShockWave(x,y,z,130);
  GunFade(x,y,z,Mode);
end



process DeflectedShot(x,y,z,Mode);
begin
  play_wav(Teleport,0);
  if (Mode=>0 and Mode<=8)
    ctype=c_scroll; graph=146; flags=16; size=80;
    if (Mode==8) graph=192; size=100; end
    frame(50);

    repeat
      if (Mode==0) x-=3; y+=3; end
      if (Mode==1) x-=3; end
      if (Mode==2) x-=3; y-=3; end
      if (Mode==3) x+=3; y+=3; end
      if (Mode==4) x+=3; end
      if (Mode==5) x+=3; y-=3; end
      if (Mode==6) y+=3; end
      if (Mode==7) y-=3; end
      if (Mode==8) y+=3; end

      if (y<-30 or x<-30 or x>5500 or y>MaxLevelY or x<CameraID.x-350 or x>CameraID.x+350) return; end
      frame(50);
    until(collision(LevelCheckID))
    CreateSpread(x,y,z,4); GlobalRed+=10; GlobalGreen+=5;
    ShockWave(x,y,z,130);
    GunFade(x,y,z,Mode);
    return;
  end

  if (Mode==9)
    ctype=c_scroll; graph=309; flags=16; size=100;
    repeat
      x+=5;
      frame(50);
    until(collision(LevelCheckID) or x>CameraID.x+350)
    if (x>CameraID.x+350) return; end
    CreateSpread(x,y,z,1);
    GlobalRed+=10; GlobalGreen+=5; GlobalBlue+=5;
    ShockWave(x,y,z,130);
    if (Mode==0) GunFade(x+11,y,z,0); GunFade(x+11,y-7,z,0); GunFade(x+11,y+7,z,0); end
    return;
  end
end



process SchmupPowerUp(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll; size=0;
  if (Mode==1) graph=324; end
  if (Mode==2) graph=325; end
  repeat size+=10; frame(50); until(size=>100)

  repeat
    HoverCounter++;
    if (HoverCounter==2 or HoverCounter==4 or HoverCounter==6 or HoverCounter==8) y++; end
    if (HoverCounter==12 or HoverCounter==14 or HoverCounter==16 or HoverCounter==18) y--; end
    if (HoverCounter==20) HoverCounter=0; end
    frame;
  until(collision(PlayerID))
  play_wav(PickUp,0);

  if (Mode==1)
    if (ShotUpgrade<2) ShotUpgrade++; end
  end
  if (Mode==2)
    if (MissileUpgrade<2) MissileUpgrade++; end
  end

  z=4;
  repeat y--; size_x-=5; frame(20); until(size_x<=20) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; frame(20); until(size_x<=20) flags=1;
  repeat y--; size_x+=5; frame(20); until(size_x=>100) flags=0;
  repeat y--; size_x-=5; size_y-=3; frame(20); until(size_x<=30)
  CreateSpread(x,y,z,1);
  frame(200);
end



process SolkBoss1(x,y,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int HandID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int LaughOn;
  int PsyFish1;
  int PsyFish2;
  int PsyFish3;
  int ReloadCounter;
  int ReloadCounter2;
  int AnimationCounter;
begin
  ctype=c_scroll; graph=355; HP=100;

  repeat
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end
    frame;
  until (fget_dist(x,y,PlayerX,PlayerY)<300)

  SolkConversation1();

  FadeSong();
  signal(type SongPlayer, s_kill);
  SongPlayer(10);

  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
  frame(2000); graph=356; SolkBossOn=2;
  LevelObject(147,1810,11,13);
  LevelObject(1052,1810,11,13);
  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen+=5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha+=10; size_x+=5; frame(20); until(size_x==100)
  BossHPMeter(0);

  loop

    if (ReloadCounter>0) ReloadCounter--; end
    if (ReloadCounter==0) ReloadCounter=200; end

    if (ReloadCounter==50)
      if (flags==0) SolkShot(x-2,y-28,z,40000,1); play_wav(Laser,0); end
      if (flags==1) SolkShot(x+2,y-28,z,-40000,1); play_wav(Laser,0); end
    end

    if (ReloadCounter2>0) ReloadCounter2--; end
    if (rand(1,20)==1 and ReloadCounter2==0 and MoveCounter<600)
      ReloadCounter2=30;
    end
    if (ReloadCounter2==20 or ReloadCounter2==25 or ReloadCounter2==30)
      if (flags==0) SolkShot(x-45,y+22,z,215000,0); play_wav(Laser,0); end
      if (flags==1) SolkShot(x+45,y+18,z,155000,0); play_wav(Laser,0); end
    end

    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter=>100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter<150) x+=3; end
    if (MoveCounter>150 and MoveCounter<450) x-=3; end
    if (MoveCounter>450 and MoveCounter<600) x+=3; end
    if (MoveCounter>600 and MoveCounter<650) y+=3; end
    if (MoveCounter==700)
      SolkBox(300,1650,4,0);
      SolkBox(900,1650,4,0);
    end
    if (MoveCounter==750)
      SolkBox(400,1650,4,0);
      SolkBox(800,1650,4,0);
    end
    if (MoveCounter==800)
      SolkBox(500,1650,4,0);
      SolkBox(700,1650,4,0);
    end
    if (MoveCounter>800 and MoveCounter<850) y-=3; end

    if (MoveCounter==900) MoveCounter=0; end

    AnimationCounter++;
    if (AnimationCounter==1) graph=356; end
    if (AnimationCounter==10) graph=357; end
    if (AnimationCounter==20) AnimationCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Explode(x,y,z-1,100); CreateSparks(x,y,z-1,2);
        Explode(x,y-35,z-1,100); CreateSparks(x,y-35,z-1,2);
        Explode(x,y+35,z-1,100); CreateSparks(x,y+35,z-1,2);
        HP-=3;
        frame;
      end
    end

    if (HP<=0)
      Combo++; ComboCounter=60; PlayerScore+=100*Combo;
      PsyFish1=FlyFish(x-80,y-80,z,1); frame(200);
      PsyFish2=FlyFish(x+80,y-80,z,1); frame(200);
      PsyFish3=FlyFish(x,y+80,z,1);
      FlyBeam(187,1516,3,0,0);
      FlyBeam(227,1516,3,22,0);
      FlyBeam(267,1516,3,44,0);
      FlyBeam(227,1516,3,66,0);

      FlyBeam(930,1516,3,0,0);
      FlyBeam(970,1516,3,22,0);
      FlyBeam(1010,1516,3,44,0);
      FlyBeam(970,1516,3,66,0);

      FlyBeam(54,790,3,0,1);
      FlyBeam(94,790,3,22,1);
      FlyBeam(134,790,3,44,1);
      FlyBeam(94,790,3,66,1);

      FlyBeam(1063,790,3,0,1);
      FlyBeam(1103,790,3,22,1);
      FlyBeam(1143,790,3,44,1);
      FlyBeam(1103,790,3,66,1);

      TeleportEffect(x,y,z-1,0);
      frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
      repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)

      SolkBossOn=3;
      return;
    end

    if (DodgeX==0 and x>330 and x<870)
      if (fget_dist(x,y,PlayerX,PlayerY)<160) DodgeX=14; end
    end
    if (DodgeX>0 and MoveCounter<600)
      if (flags==1) x-=DodgeX; end
      if (flags==0) x+=DodgeX; end
      if (collision(LevelChecKID))
        if (flags==1) x+=DodgeX; end
        if (flags==0) x-=DodgeX; end
      end
      DodgeX--;
    end

    if (x<250) x=250; MoveCounter=450; end
    if (x>950) x=950; MoveCounter=150; end

    if (x>PlayerX) flags=0; end
    if (x<PlayerX) flags=1; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process SolkBoss2(x,y,z,Mode);
private
  int HoverCounter;
  int MoveCounter;
  int HandID;
  int FallDirection;
  int YFallSpeed;
  int XFallSpeed;
  int TempID;
  int DodgeX;
  int LaughOn;
  int ReloadCounter;
  int ReloadCounter2;
  int AnimationCounter;
begin
  ctype=c_scroll; graph=355; HP=50;

  repeat
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end
    frame;
  until (fget_dist(x,y,PlayerX,PlayerY)<300)

  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
  frame(2000); graph=363;
  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen+=5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha+=10; size_x+=5; frame(20); until(size_x==100)
  BossHPMeter(1);

  SolkBoss2Ball(-80,-40,5,0,0);
  SolkBoss2Ball(-60,-20,5,0,1);

  SolkBoss2Ball(80,-40,5,0,2);
  SolkBoss2Ball(60,-20,5,0,3);

  loop

    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter=>100) HoverCounter=0; end

    MoveCounter++;
    if (MoveCounter<150) x+=3; end
    if (MoveCounter>150 and MoveCounter<450) x-=3; end
    if (MoveCounter>450 and MoveCounter<600) x+=3; end
    if (MoveCounter==600) MoveCounter=0; end

    AnimationCounter++;
    if (AnimationCounter==1) graph=363; end
    if (AnimationCounter==10) graph=364; end
    if (AnimationCounter==20) graph=365; end
    if (AnimationCounter==40) graph=364; end
    if (AnimationCounter==50) AnimationCounter=0; end

    if (SelectedWeapon==1)
      if (TempID=collision(type Gun1Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==2)
      if (TempID=collision(type Gun2Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,5);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==3)
      if (TempID=collision(type Gun3Fire))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==4)
      if (TempID=collision(type Gun4Shrapnel))
        ShockWave(TempID.x,TempID.y,z,130);
        Explode(TempID.x,TempID.y,z-1,50);
        CreateSpread(TempID.x,TempID.y,z,1);
        signal(TempID, s_kill);
        HP--;
      end
    end

    if (SelectedWeapon==5 and SwordDamage>0)
      if (collision(type PlayerWeapon) or collision(type SwordSlash))
        Explode(x,y,z-1,150);
        CreateSparks(x,y,z-1,2);
        CreateSparks(x,y-25,z-1,2);
        CreateSparks(x,y+25,z-1,2);
        HP-=3;
        frame;
      end
    end

    if (HP<=0)
      PlayerScore+=1000;
      TeleportEffect(x,y,z-1,0);
      frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
      repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
      signal(type SolkBoss2Ball, s_kill);
      SolkBoss3(625,745,5,0);
      frame;
      return;
    end

    if (DodgeX==0)
      if (fget_dist(x,y,PlayerX,PlayerY)<150) DodgeX=14; end
    end
    if (DodgeX>0 and MoveCounter<600)
      if (flags==1) x-=DodgeX; end
      if (flags==0) x+=DodgeX; end
      if (collision(LevelChecKID))
        if (flags==1) x+=DodgeX; end
        if (flags==0) x-=DodgeX; end
      end
      DodgeX--;
    end

    if (x<250) x=250; MoveCounter=450; end
    if (x>950) x=950; MoveCounter=150; end

    if (x>PlayerX) flags=0; end
    if (x<PlayerX) flags=1; end

    EnemyFindX=x;
    EnemyFindY=y;

    frame;
  end
end



process BossHPMeter(Mode);
private
  int XOffset;
begin
  ctype=c_scroll; graph=42;
  repeat
    if (Mode==0)
      y=father.y-60;
      XOffset=150-(father.HP);
      if (father.flags==0) x=(father.x+XOffset)-50; end
      if (father.flags==1) x=(father.x-XOffset)+50; end
      size_x=father.HP;
    end
    if (Mode==1)
      y=father.y-80;
      XOffset=100-(father.HP);
      if (father.flags==0) x=(father.x+XOffset)-40; end
      if (father.flags==1) x=(father.x-XOffset)+40; end
      size_x=father.HP*2;
    end
    if (size_x<=0) size_x=0; end
    frame;
  until(father.HP<=0)
end



process SolkBoss3(x,y,z,Mode);
private
  int HoverCounter;
  int SpiritBattleID;
  int SolkBossImageID;
begin
  ctype=c_scroll; graph=355;

  repeat
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end
    frame;
  until (fget_dist(x,y,PlayerX,PlayerY)<200)
  signal(type Lighting, s_kill);
  frame(1000); frame(500); fade(0,0,0,16); frame(1000);
  signal(type FlyBeam, s_kill);
  signal(type PlayerWeapon, s_kill);
  signal(type HoverBall, s_kill);
  signal(PlayerID, s_kill);
  PlayerID=SpiritBattlePlayer(475,814,5,0);
  SolkBossImageID=SolkBossImage(805,816,4,0);
  graph=367; x=760; y=750; flags=16;
  SpiritBattleID=SolkSpiritBattle1();
  fade(100,100,100,8);
  Lighting(1);
  repeat frame; until(SpiritBattleID.HP==1)
  repeat alpha-=10; frame(50); until(alpha<=0);
  SolkBossImageID.Control=1;
end



process SolkBossImage(x,y,z,Mode);
private
  int HoverCounter;
begin
  ctype=c_scroll; graph=355;
  repeat frame; until(Control==1)
  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
  x=610; y=1730; z=5; graph=355; DirectionArrow(625,1040,8,3);
  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen+=5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha+=10; size_x+=5; frame(20); until(size_x==100)
  repeat
    HoverCounter++;
    if (HoverCounter%2==0 and HoverCounter<50) y++; end
    if (HoverCounter%2==0 and HoverCounter>50 and HoverCounter<100) y--; end
    if (HoverCounter==100) HoverCounter=0; end
    frame;
  until (fget_dist(x,y,PlayerX,PlayerY)<200 and PlayerY>1800)
  frame(4000);
  SolkConversation2();
  frame(500);
  TeleportEffect(x,y,z-1,0);
  frame; GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; CreateSpread(x,y,z,6);
  repeat alpha-=10; size_x-=5; frame(20); until(size_x==0)
  frame(500);
  SolkConversation3();
  frame(500);
  signal(type LevelObject, s_kill); SolkBossOn=0; Boss1Done=1;
  PlayerScore+=10000;
end



process SolkSpiritBattle1();
private
  int MasherID;
  int DoFlash;
  int CameraID;
  int TempID;
  int GraphCounter;
  int BattleBallID;
  int BattleBoomID;
begin

  CameraID=CameraView(625,745,3);

  SpiritBattleOpponent(710,380,8,0);
  MasherID=ButtonMasher(320,80,2,1);

  BattleBoomID=SolkSpiritBattleBoom(635,720,4,0);
  SolkSpiritBattleBall(557,720,6,0);
  BattleBallID=SolkSpiritBattleBall(740,720,6,1);

  frame(500);

  ctype=c_scroll; flags=16; z=4;
  x=505; y=820; graph=291; size_y=0;
  repeat size_y+=10; y-=9; frame(50); until(size_y==100);

  loop

    if (key(_left) or joy_getaxis(0,0)<-20) alpha=255; end
    if (key(_right) or joy_getaxis(0,0)>20) alpha=200; end

    if (BattleBallID.Control=>70)
      BattleBoomID.HP=1; frame(1000); signal(type SolkSpiritBattleBall, s_kill);
      repeat size_y-=10; y+=9; frame; until(size_y<=0); frame(500);
      signal(MasherID, s_kill);
      signal(PlayerID, s_kill_tree);
      signal(type PlayerHealthMeter, s_kill);
      signal(type PlayerHealthMeterBorder, s_kill);
      delete_text(0);
      PlayerID=Player(475,814,5);
      PlayerHP=0;
      frame(2000); frame(2000);
      if (PlayerLives>0) PlayerLives--; RestartLevel(); frame; return; end
      GameOver(); frame;
      loop frame; end
    end

    if (MasherID.HP=>70)
      BattleBoomID.HP=2;
      signal(type SolkSpiritBattleBall, s_kill);
      signal(MasherID, s_kill);
      frame(2000); HP=1;
      repeat size_y-=10; y+=9; frame; until(size_y<=0);
      CameraView(625,745,4); frame(2000);
      signal(PlayerID, s_kill_tree);
      signal(type PlayerHealthMeter, s_kill);
      signal(type PlayerHealthMeterBorder, s_kill);
      delete_text(0);
      PlayerID=Player(475,814,5);
      return;
    end

    frame;
  end
end



process SolkSpiritBattleBall(x,y,z,Mode);
private
  int WinCounter;
begin
  ctype=c_scroll;
  if (Mode==0) graph=368; flags=16; end
  if (Mode==1) graph=366; flags=16; end

  if (Mode==0)
    repeat
      repeat
        frame;
      until(key(_left) or joy_getaxis(0,0)<-20)
      HP++;
      SolkSpiritBattleShot(x,y,z,Mode);
      repeat
        frame;
      until(key(_right) or joy_getaxis(0,0)>20)
      HP++;
      SolkSpiritBattleShot(x,y,z,Mode);
    until(HP=>70);
  end

  if (Mode==1)
    repeat
      WinCounter++;
      Control=WinCounter;
      SolkSpiritBattleShot(x,y,z,Mode);
      frame(400);
    until(WinCounter=>70)
    loop frame; end
  end
end



process SolkSpiritBattleShot(x,y,z,Mode);
private
  int TempID;
begin
  ctype=c_scroll;
  if (Mode==0) graph=368; flags=16; size=50; end
  if (Mode==1) graph=366; flags=16; size=50; end
  y+=rand(-5,5);
  repeat
    if (Mode==0) x+=2; end
    if (Mode==1) x-=2; end
    frame(20);
  until(Control==1)
  if (Mode==0) CreateSpread(x,y,3,6); GlobalBlue+=2; end
  if (Mode==1) CreateSpread(x,y,3,11); GlobalRed+=2; end
end



process SolkSpiritBattleBoom(x,y,z,Mode);
private
  int TempID;
begin
  ctype=c_scroll; graph=369; flags=16; size=20; HP=0;
  loop
    if (TempID=collision(type SolkSpiritBattleShot))
      TempID.Control=1;
      if (size<150) size+=5; end
      ShockWave(x+rand(-(size/2)-10,(size/2)-10),y+rand(-(size/2)-10,(size/2)-10),z,130);
      Explode(x+rand(-(size/2)-10,(size/2)-10),y+rand(-(size/2)-10,(size/2)-10),z-1,50);
    end

    if (size>20) size--; end
    alpha=rand(200,255);

    if (HP==1)
      z=2; play_wav(Slash,0);
      repeat
        x-=5; size+=5; GlobalRed+=4;
        frame;
      until(size=>200)
      repeat alpha-=50; frame; until(alpha<=0)
      return;
    end
    if (HP==2)
      z=2; play_wav(Slash,0);
      repeat
        x+=5; size+=5; GlobalBlue+=4;
        frame;
      until(size=>200)
      repeat alpha-=50; frame; until(alpha<=0)
      return;
    end

    frame;
  end
end



process SolkBoss2Ball(XOffset,YOffset,z,ReloadCounter,Mode);
private
  int ReloadCounter2;
begin
  ctype=c_scroll; graph=366;
  loop
    x=father.x+XOffset;
    y=father.y+YOffset;
    ReloadCounter++;
    if (ReloadCounter==3 or ReloadCounter==6 or ReloadCounter==9)
      if (Mode==0)
        play_wav(Laser,0);
        SolkShot(x,y,z,200000,0);
        SolkShot(x,y,z,190000,0);
      end
      if (Mode==1)
        SolkShot(x,y,z,215000,0);
        SolkShot(x,y,z,225000,0);
      end
      if (Mode==2)
        SolkShot(x,y,z,330000,0);
        SolkShot(x,y,z,340000,0);
      end
      if (Mode==3)
        SolkShot(x,y,z,310000,0);
        SolkShot(x,y,z,320000,0);
      end
    end
    if (ReloadCounter==60) ReloadCounter=0; end
    ReloadCounter2++;
    if (ReloadCounter2==200)
      if (Mode==0) SolkBoss2Ball2(x,y,z,0); end
      if (Mode==2) SolkBoss2Ball2(x,y,z,1); end
      ReloadCounter=0;
    end
    frame;
  end
end



process SolkBoss2Ball2(x,y,z,Mode);
private
  int InternalAngle;
begin
  ctype=c_scroll; graph=366;
  if (Mode==0)
    repeat x-=2; y+=1; alpha--; frame(50); until(alpha<=200)
  end
  if (Mode==1)
    repeat x+=2; y+=1; alpha--; frame(50); until(alpha<=200)
  end
  play_wav(Laser,0);
  repeat
    size--; alpha--;
    InternalAngle+=20000;
    SolkShot(x,y,z,InternalAngle,0);
    if (rand(1,5)==1) play_wav(Laser,0); end
    frame;
  until(InternalAngle==360000)
  ShockWave(x,y,z,130); frame;
  return;
end



process SolkShot(x,y,z,angle,Mode);
private
  int FadeCounter;
  int SpeedCounter;
begin
  ctype=c_scroll;
  if (Mode==0) graph=268; flags=16+father.flags; frame; end
  if (Mode==1) graph=358; flags=father.flags; SpeedCounter=4; frame; end
  if (Mode==2) graph=358; SpeedCounter=4; frame; end
  if (Mode==1) play_wav(Rocket,0); end
  repeat
    if (flags==16) advance(10); end
    if (flags==17) advance(-10); end
    if (flags==0) advance(-SpeedCounter); end
    if (flags==1) advance(SpeedCounter); end
    if (SpeedCounter<10) SpeedCounter++; end
    FadeCounter++;
    if (FadeCounter>140 or y<-30 or x<-30 or x>5000 or y>MaxLevelY) return; end
    if (collision(PlayerID))
      if (Mode==0) PlayerHP-=2; Explode(x,y,z-1,25); return; end
      if (Mode==1) PlayerHP-=4; Explode(x,y,z-1,50); return; end
      if (Mode==2) PlayerHP-=4; Explode(x,y,z-1,50); return; end
    end
    if (Mode==1 and angle<0) angle+=5000; end
    if (Mode==1 and angle>0) angle-=5000; end
    if (Mode==1 and x<PlayerX+20 and x>PlayerX-20)
      Explode(x,y,z-1,50); ShockWave(x,y,z,130);
      play_wav(Laser,0);
      SolkShot(x,y,z,angle+90000,2);
      SolkShot(x,y,z,angle+45000,2);
      SolkShot(x,y,z,angle+135000,2);
      return;
    end
    if (Mode==1 or Mode==2) if (rand(1,2)==1) GreySmoke(x,y,z+1,0); end end
    frame;
  until(collision(LevelCheckID))
  if (Mode==0) Explode(x,y,z-1,25); end
  if (Mode==1) Explode(x,y,z-1,75); end
  if (Mode==2) Explode(x,y,z-1,75); end
  repeat alpha-=20; frame(50); until(alpha<=50)
end



process SolkBox(x,y,z,Mode);
begin
  ctype=c_scroll; graph=359;
  CreateSpread(x,y,z,6); ShockWave(x,y,z,201); GlobalRed+=5; GlobalGreen=+5; GlobalBlue+=20; size=10;
  play_wav(Teleport,0);
  repeat alpha+=10; size+=5; frame(20); until(size==100)
  repeat
    y+=5;
    if (collision(PlayerID))
      PlayerHP-=10;
      Explode(x,y,z-1,150);
      Sparks(x-20,y-15,z,10); Sparks(x+20,y-15,z,10);
      Sparks(x-20,y+15,z,10); Sparks(x+20,y+15,z,10);
      return;
    end
    frame(50);
  until(collision(LevelCheckID))
  Explode(x,y,z-1,150);
  Sparks(x-20,y-15,z,10); Sparks(x+20,y-15,z,10);
  Sparks(x-20,y+15,z,10); Sparks(x+20,y+15,z,10);
end



process FlyBeam(x,y,z,MoveCounter,Mode);
begin
  ctype=c_scroll; flags=16; size_x=0;
  if (Mode==0) graph=361; end
  if (Mode==1) graph=362; end
  repeat size_x+=5; frame(50); until(size_x=>100)
  loop
    MoveCounter++;
    if (MoveCounter>0 and MoveCounter<44) x+=2; size_x=100; z=3; end
    if (MoveCounter>44 and MoveCounter<88) x-=2; size_x=50; z=6; end
    if (MoveCounter==88) MoveCounter=0; end
    frame(50);
  end
end



process StreetLight(x,y,z,ActiveLampMode,Mode);
begin
  ctype=c_scroll;

  loop
    if (Mode==1) graph=2; alpha=100; flags=16; end
    if (Mode==2) graph=62; alpha=100; flags=16; end
    if (Mode==3) graph=62; alpha=100; flags=17; end
    if (Mode==4) graph=65; alpha=100; flags=16; end
    if (Mode==5) graph=65; alpha=100; flags=17; end
    if (Mode==6) graph=108; alpha=220; flags=16; end
    if (Mode==7) graph=62; alpha=100; flags=16; angle=90000; end
    if (Mode==8) graph=62; alpha=100; flags=17; angle=90000; end
    if (Mode==9) graph=62; alpha=100; flags=18; angle=90000; end
    if (Mode==10) graph=62; alpha=100; flags=19; angle=90000; end
    if (Mode==11) graph=62; alpha=100; flags=16; angle=180000; end
    if (Mode==12) graph=62; alpha=100; flags=17; angle=180000; end
    if (Mode==13) graph=260; alpha=100; flags=16; end
    if (ActiveLampMode==1)
      if (PlayerX>x-150 and PlayerX<x+150 and PlayerY>y-150 and PlayerY<y+150)
        ActiveLamp1_X=x;
        ActiveLamp1_Y=y;
      end
    end
    if (ActiveLampMode==2)
      if (PlayerX>x-150 and PlayerX<x+150 and PlayerY>y-150 and PlayerY<y+150)
        ActiveLamp2_X=x;
        ActiveLamp2_Y=y;
      end
    end
    if (rand(1,100)==1) graph=0; end
    frame;
  end
end



process StreetLightHalo(x,y,z,Mode);
begin
  ctype=c_scroll;
  if (Mode==1) graph=115; alpha=100; flags=16; end
  if (Mode==2) graph=82; alpha=100; flags=16; end
  if (Mode==3) graph=116; alpha=100; flags=16; end
  if (Mode==4) graph=117; alpha=150; flags=16; end
  if (Mode==5) graph=261; alpha=110; flags=16; end
  if (Mode==6) graph=81; alpha=150; flags=16; end

  if (Mode==6)
    loop
      if (Control==1) alpha=200; Control=0; end
      if (alpha>150) alpha--; end
      frame;
    end
  end

  loop frame; end
end



process AlgaeLamp(x,y,z,Mode);
private
  int TempID;
begin
  ctype=c_scroll; graph=81; alpha=150; flags=16; size=0;
  repeat y++; size+=2; frame; until(size=>20)
  repeat
    y++;
    frame;
  until(TempID=collision(type StreetLightHalo))
  TempID.Control=1;
  repeat y++; size-=2; frame; until(size<0)
end



process ComputerScreen(x,y,z,flags,Mode);
begin
  ctype=c_scroll;
  if (Mode==2) graph=123; end
  if (Mode==4) graph=218; end
  loop
    if (Mode==1)
      if (rand(1,100)==1)
        graph=120; frame(400);
        graph=121; frame(400);
        graph=122; frame(2000); frame(2000);
        graph=121; frame(400);
        graph=120; frame(400);
        graph=0;
      end
    end
    if (Mode==2)
      if (rand(1,100)==1)
        graph=124; frame(400);
        graph=125; frame(400);
        graph=126; frame(400);
        graph=127; frame(400);
        graph=123;
      end
    end
    if (Mode==3)
      graph=118; frame(400);
      graph=119; frame(300);
    end
    if (Mode==4)
      if (rand(1,100)==1)
        graph=213; frame(200);
        graph=214; frame(200);
        graph=215; frame(200);
        graph=216; frame(200);
        graph=217; frame(2000); frame(2000);
        graph=216; frame(200);
        graph=215; frame(200);
        graph=214; frame(200);
        graph=213; frame(200);
        graph=218;
      end
    end
    if (Mode==5)
      graph=206; frame(300);
      graph=207; frame(300);
      graph=208; frame(300);
    end
    if (Mode==6)
      graph=209; frame(300);
      graph=210; frame(300);
      graph=211; frame(300);
      graph=212; frame(300);
      graph=211; frame(300);
      graph=210; frame(300);
    end
    frame;
  end
end



process SpaceParticles(StartX,StartY,z,Mode);
begin
  flags=16; y=StartY;
  if (Mode==1) graph=3; end
  if (Mode==2) graph=3; end
  if (Mode==3)
    graph=father.graph;
    repeat x=father.x; y=father.y; alpha-=10; frame; until(alpha<10); return;
  end
  loop
    if (rand(1,30)==1) SpaceParticles(x,y,z,3); end
    x=StartX-(PlayerX/5);
    frame;
  end
end



process BackgroundShip(x,y,z,Mode);
begin
  graph=183;
  loop
    x++;
    if (x>1280) x=-640; end
    frame;
  end
end



process DarknessMask();
begin
  ctype=c_scroll; z=3; graph=76; alpha=0;
  repeat
    x=PlayerX; y=PlayerY;
    alpha+=5;
    frame(25);
  until(alpha=>235)
  loop
    x=PlayerX; y=PlayerY;
    frame(50);
  end
end



process DarknessMask2();
begin
  ctype=c_scroll; z=3; graph=76; alpha=0;
  repeat
    x=PlayerX; y=PlayerY;
    alpha+=5;
    frame(25);
  until(alpha=>100)
  loop
    x=PlayerX; y=PlayerY;
    frame(50);
  end
end



process DarknessParticle2(x,y,z,Mode);
private
  int RotateSpeed;
begin
  ctype=c_scroll; graph=69; alpha=200; flags=16;
  RotateSpeed=rand(12,22)*1000;
  loop
    angle+=RotateSpeed;
    advance(7);
    frame;
  end
end



process DarknessParticle(x,y,z,Mode);
private
  int StopX;
  int StopY;
  int TargetAngle;
  int MoveSpeed;
begin
  ctype=c_scroll; graph=69; alpha=0; flags=16;
  if (Mode==1) StopX=1045; StopY=310; end
  angle=rand(1,360)*1000;
  repeat
    TargetAngle=fget_angle(x,y,StopX,StopY);
    if (angle<TargetAngle) angle+=10000; end
    if (angle>TargetAngle) angle-=10000; end
    advance(MoveSpeed);
    if (MoveSpeed<7) MoveSpeed++; end
    alpha+=10;
    frame(50);
  until(alpha=>200);
  repeat
    TargetAngle=fget_angle(x,y,StopX,StopY);
    if (angle<TargetAngle) angle+=20000; end
    if (angle>TargetAngle) angle-=20000; end
    advance(MoveSpeed);
    alpha+=10;
    frame(50);
  until(fget_dist(x,y,StopX,StopY)<30);
  repeat
    TargetAngle=fget_angle(x,y,StopX,StopY);
    if (angle>TargetAngle) angle+=20000; end
    if (angle<TargetAngle) angle-=20000; end
    advance(MoveSpeed);
    if (MoveSpeed>2) MoveSpeed--; end
    alpha-=10;
    DarknessCloud(x,y,z+2,angle,Mode);
    frame(50);
  until(alpha<=20);
end



process DarknessCloud(x,y,z,angle,Mode);
private
  int MoveSpeed;
begin
  ctype=c_scroll; graph=rand(73,74); flags=32; MoveSpeed=rand(5,7); alpha=200;
  repeat
    advance(MoveSpeed);
    if (MoveSpeed>3) MoveSpeed--; end
    alpha-=10;
    frame;
  until(alpha<=20)
end



/*
process BpmCounter(BpmMode);
private
  int FrameCounter;
  int SecondCounter;
  float SyncNumber;
  int Beat;
  int NextBeat;
  int BeatOffset;
begin
  Beat=0; BeatOffset=2;
  SyncNumber=1800/BpmMode;
  
  loop
    NextBeat=(Beat*SyncNumber)+BeatOffset;
    FrameCounter++;
    if (FrameCounter==NextBeat) Beat++; Control=1; end
    frame;
    Control=0;
  end
end
*/


process GreySmoke(x,y,z,Mode);
begin
  ctype=c_scroll; size=20; flags=16+rand(0,3);
  alpha=rand(150,250);
  repeat
    if (size<100) size+=10; end
    if (alpha>200 and alpha<250) graph=255; end
    if (alpha>150 and alpha<200) graph=256; end
    if (alpha>110 and alpha<150) graph=257; end
    if (alpha>70 and alpha<110) graph=258; end
    if (alpha>0 and alpha<70) graph=259; end
    alpha-=10;
    if (Mode==1 or Mode==3) x+=rand(1,2); end
    if (Mode==2 or Mode==4) x-=rand(1,2); end
    if (Mode==4 or Mode==3) y-=rand(1,3); end
    frame;
  until(alpha<40)
end



process Explode(x,y,z,size);
private
  int Animation;
begin
  if (size<50) play_wav(Explode0,0); end
  if (size=>50 and size<=100) play_wav(Explode1,0); end
  if (size>100) play_wav(Explode2,0); end
  ctype=c_scroll; alpha=220; flags=16;
  if (GlobalRed<120) GlobalRed+=5; end
  repeat
    Animation++;
    graph=20+Animation;
    frame;
  until (Animation==13)
end



process Shockwave(x,y,z,graph);
private
  int SizeCounter;
begin
  ctype=c_scroll; alpha=200; size=0; flags=16; SizeCounter=10;
  repeat
    size+=SizeCounter;
    alpha-=SizeCounter;
    SizeCounter+=4;
    frame;
  until(size>140)
end



process Shockwave2(x,y,z,graph);
private
  int SizeCounter;
begin
  alpha=200; size=0; flags=16; SizeCounter=10;
  repeat
    size+=SizeCounter;
    alpha-=SizeCounter;
    SizeCounter+=4;
    frame;
  until(size>140)
end



process Player_Shadow1(x,y,z);
private
  int ShadowOn;
begin
  ctype=c_scroll; graph=39; alpha=0; size=100; ShadowOn=0; flags=32;

  loop

    if(fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y)<220 and ShadowOn==0)
      if(x<ActiveLamp1_X) ShadowOn=1; end
      if(x>ActiveLamp1_X) ShadowOn=2; end
    end

    if (ShadowOn==1)
      alpha=200-fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y);
      size=100+(120-fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y));
      if (size<50) size=50; end
    
      if (x<ActiveLamp1_X) angle=0+90*fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y); end
      if (x>ActiveLamp1_X) angle=0-90*fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y); end
      if (x>ActiveLamp1_X-3 and x<ActiveLamp1_X+3) angle=0; end
        
      if(fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y)>220) ShadowOn=0; end
    end
    if (ShadowOn==2)
      alpha=200-fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y);
      size=100+(120-fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y));
      if (size<50) size=50; end
    
      if (x<ActiveLamp1_X) angle=0+90*fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y); end
      if (x>ActiveLamp1_X) angle=0-90*fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y); end
      if (x>ActiveLamp1_X-3 and x<ActiveLamp1_X+3) angle=0; end
    
      if(fget_dist(x,y,ActiveLamp1_X,ActiveLamp1_Y)>220) ShadowOn=0; end
    end

    if(ShadowOn==0)
      size=0;
      alpha=0;
    end

    if (PlayerID.Control>0) graph=40; end
    if (PlayerID.Control==0) graph=39; end
    flags=32+PlayerFlag;
    x=PlayerX;
    y=PlayerY+50;

    frame;
  end
end



process Player_Shadow2(x,y,z);
private
  int ShadowOn;
begin
  ctype=c_scroll; graph=39; alpha=0; size=100; ShadowOn=0; flags=32;

  loop

    if(fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y)<220 and ShadowOn==0)
      if(x<ActiveLamp2_X) ShadowOn=1; end
      if(x>ActiveLamp2_X) ShadowOn=2; end
    end
  
    if (ShadowOn==1)
      alpha=200-fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y);
      size=100+(120-fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y));
      if (size<50) size=50; end
    
      if (x<ActiveLamp2_X) angle=0+90*fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y); end
      if (x>ActiveLamp2_X) angle=0-90*fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y); end
      if (x>ActiveLamp2_X-3 and x<ActiveLamp2_X+3) angle=0; end
        
      if(fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y)>220) ShadowOn=0; end
    end
    if (ShadowOn==2)
      alpha=200-fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y);
      size=100+(120-fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y));
      if (size<50) size=50; end
    
      if (x<ActiveLamp2_X) angle=0+90*fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y); end
      if (x>ActiveLamp2_X) angle=0-90*fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y); end
      if (x>ActiveLamp2_X-3 and x<ActiveLamp2_X+3) angle=0; end
    
      if(fget_dist(x,y,ActiveLamp2_X,ActiveLamp2_Y)>220) ShadowOn=0; end
    end

    if(ShadowOn==0)
      size=0;
      alpha=0;
    end

    if (PlayerID.Control>0) graph=40; end
    if (PlayerID.Control==0) graph=39; end
    flags=32+PlayerFlag;
    x=PlayerX;
    y=PlayerY+50;

    frame;
  end
end



process AquariumFish(Start_X,Start_Y,z,Mode);
private
  int MoveCounter;
begin
  ctype=c_scroll; flags=rand(0,1); MoveCounter=rand(0,30);
  x=Start_X; y=Start_Y;
  if (Mode==1) graph=51+rand(1,5); end
  if (Mode==2) graph=67; end
  if (Mode==3) graph=77+rand(1,3); end
  loop
    MoveCounter++;
    if (MoveCounter==5 or MoveCounter==10 or MoveCounter==15) y--; end
    if (MoveCounter==20 or MoveCounter==25 or MoveCounter==30) y++; end
    if (MoveCounter==31) MoveCounter=0; end

    if (Mode==1 or Mode==3)
      if (flags==1) x+=1; end
      if (flags==0) x-=1; end
    end

    if (rand(1,40)==1 and flags==0); flags=1; end
    if (rand(1,40)==1 and flags==1); flags=0; end

    if (x<Start_X-50) flags=1; end
    if (x>Start_X+50) flags=0; end
    if (y<Start_Y-50) y++; end
    if (y>Start_Y+50) y--; end

    frame;
  end
end



process AquariumEel(Start_X,Start_Y,z,Mode);
private
  int MoveCounter;
  int AnimationCounter;
  int Direction;
begin
  ctype=c_scroll; flags=rand(0,1);
  x=Start_X; y=Start_Y; graph=418;
  loop
    MoveCounter++;
    if (MoveCounter==5 or MoveCounter==10 or MoveCounter==15) y--; end
    if (MoveCounter==20 or MoveCounter==25 or MoveCounter==30) y++; end
    if (MoveCounter==31) MoveCounter=0; end

    if (Direction==1) x+=2; end
    if (Direction==0) x-=2; end

    if (rand(1,60)==1 and Direction==0); Direction=1; end
    if (rand(1,60)==1 and Direction==1); Direction=0; end

    if (x<Start_X-90) Direction=1; end
    if (x>Start_X+90) Direction=0; end

    AnimationCounter++;
    if (AnimationCounter==1 or AnimationCounter==2)
      graph=418;
      if (Direction==1) flags=1; end
      if (Direction==0) flags=0; end
    end
    if (AnimationCounter==3 or AnimationCounter==4) graph=419; end
    if (AnimationCounter==5 or AnimationCounter==6) graph=420; end
    if (AnimationCounter==7 or AnimationCounter==8) graph=419; end
    if (AnimationCounter==9 or AnimationCounter==10)
      graph=418;
      if (Direction==1) flags=3; end
      if (Direction==0) flags=2; end
    end
    if (AnimationCounter==11 or AnimationCounter==12) graph=419; end
    if (AnimationCounter==13 or AnimationCounter==14) graph=420; end
    if (AnimationCounter==15 or AnimationCounter==16) graph=419; end
    if (AnimationCounter==17) AnimationCounter=0; end

    frame;
  end
end



process IntroBubble(x,y,z,StopY,StopSize);
begin
  ctype=c_scroll; graph=57; alpha=200; flags=16; y+=6; size=0;
  if (StopSize==80) IntroBubble(x,y,z,StopY,60); end
  if (StopSize==60) IntroBubble(x,y,z,StopY,40); end
  repeat
    y-=2;
    if (rand(1,3)==1) x+=rand(-1,1); end
    if (size<StopSize) size+=10; end
    frame;
  until(y==StopY)
end



process TextBox(Selections);
begin
  graph=276; x=320; y=425; z=2; size_y=10; alpha=0;
  repeat
    alpha+=22;
    size_y+=10;
    frame;
  until(size_y==100)

  Selector(Selections);
  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  if (Selections>0) frame(800); end

  delete_text(0);
  repeat
    alpha-=22;
    size_y-=10;
    frame;
  until(size_y==0)
end



process Selector(Selections);
private
  int State;
begin
  graph=277; x=319; flags=16; z=1; alpha=200;
  if (Selections==2)
    y=390; State=1;
    repeat
      if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); State--; frame; end
      if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); State++; frame; end
      if (State==0) State=2; end
      if (State==3) State=1; end
      if (State==1 and y>390) repeat y--; frame(20); until(y==390) end
      if (State==2 and y<420) repeat y++; frame(20); until(y==420) end
      frame;
    until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
    Selection=State;
    repeat alpha-=10; size_y-=5; frame(40); until(alpha<20)
    return;
  end
  if (Selections==3)
    y=390; State=1;
    repeat
      if (key(_up) or joy_getaxis(0,1)<-20) play_wav(MenuMove,0); State--; frame; end
      if (key(_down) or joy_getaxis(0,1)>20) play_wav(MenuMove,0); State++; frame; end
      if (State==0) State=3; end
      if (State==4) State=1; end
      if (State==1 and y>390) repeat y--; frame(20); until(y==390) end
      if (State==2 and y>420) repeat y--; frame(20); until(y==420) end
      if (State==2 and y<420) repeat y++; frame(20); until(y==420) end
      if (State==3 and y<450) repeat y++; frame(20); until(y==450) end
      frame;
    until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
    Selection=State;
    repeat alpha-=10; size_y-=5; frame(40); until(alpha<20)
    return;
  end
end



process CharacterPortrait(StartX,StartY,z,graph,Mode);
private
  int ShakeCounter;
begin
  x=StartX; y=StartY; size_y=10; alpha=0;
  repeat
    alpha+=25;
    size_y+=10;
    frame;
  until(size_y==100)
  if (Mode==0)
    repeat
      x=StartX+rand(-1,1);
      y=StartY+rand(-1,1);
      ShakeCounter++;
      frame(50);
    until(ShakeCounter==14 or key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  end
  if (Mode>0)
    repeat
      ShakeCounter++;
      frame(50);
    until(ShakeCounter==14 or key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  end
  x=StartX; y=StartY;
  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  repeat
    alpha-=25;
    size_y-=10;
    frame;
  until(size_y==0)
end



process CharacterExpression(x,y,z,graph);
begin
  repeat
    y--;
    alpha-=15;
    frame;
  until(alpha<40 or key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
end



function CreateSparks(x,y,z,Mode);
begin
  Sparks(x,y,z,Mode);
  Sparks(x,y,z,Mode);
  Sparks(x,y,z,Mode);
  Sparks(x,y,z,Mode);
  Sparks(x,y,z,Mode);
end



process Sparks(x,y,z,Mode);
private
int Speed;
int DownSpeed;
begin
  ctype=c_scroll;
  if (Mode==1) graph=7; flags=16; size=10; DownSpeed=rand(-1,0); Speed=rand(-1,2); end
  if (Mode==2) graph=7; flags=16; size=10; DownSpeed=rand(-6,-4); Speed=rand(-2,2); end
  if (Mode==3) graph=71; flags=16; DownSpeed=rand(-6,-4); Speed=rand(-2,2); end
  if (Mode==4) graph=107; flags=16; size=20; DownSpeed=rand(-6,-4); Speed=rand(-2,2); end
  if (Mode==5) graph=185+rand(0,2); flags=16; DownSpeed=rand(-7,-5); Speed=rand(-3,-1); end
  if (Mode==6) graph=185+rand(0,2); flags=16; DownSpeed=rand(-7,-5); Speed=rand(1,3); end
  if (Mode==7) graph=186; flags=16; alpha=160; DownSpeed=rand(-5,-3); Speed=rand(-2,2); end
  if (Mode==8) graph=7; size=10; flags=16; alpha=200; DownSpeed=rand(-4,-2); Speed=rand(-2,2); end
  if (Mode==9) graph=306; size=100; flags=16+rand(0,3); alpha=150; DownSpeed=rand(-4,-2); Speed=rand(-2,2); end
  if (Mode==10) graph=360; size=100; flags=rand(0,3); DownSpeed=rand(-4,-2); Speed=rand(-3,3); end
  if (Mode==11) graph=7; flags=16; size=10; DownSpeed=rand(-6,-4); Speed=rand(-2,2); end
  repeat
    x-=Speed;
    y+=DownSpeed;
    if (Speed>2 and rand(1,2)==1) Speed--; end
    if (DownSpeed<5) DownSpeed++; end
    if (Mode==7 and rand(1,3)==1) DownSpeed--; end
    alpha-=10;
    if (Mode==1 or Mode==2) if (collision(LevelCheckID)) y-=DownSpeed; end end
    if (Mode==5 or Mode==6 or Mode==8 or Mode==10) if (collision(LevelCheckID)) alpha-=20; y-=DownSpeed; end end
    if (Mode==9)
      if (Speed>0) angle+=5000; end
      if (Speed<0) angle-=5000; end
    end
    frame;
  until(alpha<40)
  if (Mode==10) Explode(x,y,z-1,100); end
end



function CreateSpread(x,y,z,Mode);
begin
  if (MoreParticles==1)
    Spread(x,y,z,Mode); Spread(x,y,z,Mode);
    Spread(x,y,z,Mode); Spread(x,y,z,Mode);
  end
  Spread(x,y,z,Mode); Spread(x,y,z,Mode);
  Spread(x,y,z,Mode); Spread(x,y,z,Mode);
  Spread(x,y,z,Mode); Spread(x,y,z,Mode);
end



process Spread(x,y,z,Mode);
private
  int Speed;
begin
  ctype=c_scroll;
  if (Mode==1) graph=14; size=10; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(5,7); end
  if (Mode==2) graph=20; size=10; flags=16; alpha=200; angle=(rand(200,340)*1000); Speed=rand(7,9); end
  if (Mode==3) graph=63; size=20; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(9,10); end
  if (Mode==4) graph=63; size=20; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(7,9); end
  if (Mode==5) graph=63; size=10; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(5,7); end
  if (Mode==6) graph=107; size=20; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(7,9); end
  if (Mode==7) graph=43; size=20; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(7,9); end
  if (Mode==8) graph=43; size=10; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(7,9); end
  if (Mode==9) graph=63; size=20; flags=16; alpha=100; angle=(rand(1,8)*45000); Speed=rand(5,7); ctype=c_screen; end
  if (Mode==10) graph=7; size=20; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(5,7); end
  if (Mode==11) graph=20; size=10; flags=16; alpha=200; angle=(rand(1,360)*1000); Speed=rand(7,9); end

  repeat
    if (Mode==3) if (collision(PlayerID)) PlayerHP-=2; size=40; Explode(x,y,z-1,25); frame; return; end end
    if (Mode==7) if (collision(PlayerID)) PlayerHP--; size=40; frame; return; end end
    if (Mode==2) if (rand(1,3)==1) Speed++; end if (collision(LevelCheckID)) return; end end
    if (Mode==9)
      if (collision(TempCollisionID)) advance(-1); angle+=90000; alpha++; end
    end
    if (Mode==7 and alpha<=70) return; end
    advance(Speed);
    if (rand(1,2)==1) if (Speed>3) Speed--; end end
    alpha-=5;
    frame;
  until(alpha<=40)
  return;
end



process Lighting(Mode);
begin
  ActiveLamp1_X=-150; ActiveLamp1_Y=-150;
  ActiveLamp2_X=-150; ActiveLamp2_Y=-150;

  if (Mode==0)
    fade(20,20,20,64); frame;
    fade(100,100,100,8);
  end

  loop
    if (GlobalRed>100) fade(GlobalRed,GlobalGreen,GlobalBlue,64); GlobalRed-=2; end
    if (GlobalGreen>100) fade(GlobalRed,GlobalGreen,GlobalBlue,64); GlobalGreen-=2; end
    if (GlobalBlue>100) fade(GlobalRed,GlobalGreen,GlobalBlue,64); GlobalBlue-=2; end

    if (GlobalRed<100) GlobalRed=100; end
    if (GlobalGreen<100) GlobalGreen=100; end
    if (GlobalBlue<100) GlobalBlue=100; end

    if (GlobalRed>150) GlobalRed=150; end
    if (GlobalGreen>150) GlobalGreen=150; end
    if (GlobalBlue>150) GlobalBlue=150; end
    frame;
  end
end



process LevelScroll(Gfx,Gfx2,Gfx3,z);
begin
  if (Gfx2>0) start_scroll(0,0,Gfx,Gfx2,0,12); end
  if (Gfx2==0) start_scroll(0,0,Gfx,0,0,0); end
  Scroll[0].z=z;
  Scroll[0].ratio=200;
  x=320; y=240; z=20; graph=Gfx3;
  loop frame; end
end



process LevelCheck(x,y,z,graph);
begin
  ctype=c_scroll;
  loop frame; end
end



process LevelForeground(x,y,z,graph);
begin
  ctype=c_scroll;
  loop frame; end
end




process SongPlayer(Number);
begin
  repeat frame; until(exists(type FadeSong)==0)
  loop
    if (is_playing_song()==0)
      if (Number==1) Song=load_song("Music/DoomEngine.ogg"); play_song(Song,1); end
      if (Number==2) Song=load_song("Music/SvartLjus.ogg"); play_song(Song,1); end
      if (Number==3) Song=load_song("Music/SvartLjus_Retro.ogg"); play_song(Song,1); end
      if (Number==4) Song=load_song("Music/SvartLjus_RetroGame.ogg"); play_song(Song,1); end
      if (Number==5) Song=load_song("Music/Futurejazz_Doom.ogg"); play_song(Song,1); end
      if (Number==6) Song=load_song("Music/ATARAXIA.ogg"); play_song(Song,1); end
      if (Number==7) Song=load_song("Music/DestructiVoiders.ogg"); play_song(Song,1); end
      if (Number==8) Song=load_song("Music/TheFuture.ogg"); play_song(Song,1); end
      if (Number==9) Song=load_song("Music/YtanArAllt(DestructedVoid).ogg"); play_song(Song,1); end
      if (Number==10) Song=load_song("Music/DoomBattle.ogg"); play_song(Song,1); end
    end
    frame;
  end
end



process FadeSong();
private
  int VolumeCounter;
begin
  VolumeCounter=Volume;
  repeat
    set_song_volume(VolumeCounter);
    VolumeCounter--;
    frame(50);
  until(VolumeCounter<=0);
  stop_song();
  set_song_volume(Volume);
end



process FeedbackMode();
private
  int TempScreen;
begin
  frame; z=0; x=320; y=240; size=110; alpha=100; flags=16;
  loop
    TempScreen=screen_get();
    graph=TempScreen;
    frame;
  end
end



process DreamMode();
private
  int TempScreen;
begin
  frame; z=0; x=320; y=240; size=101; alpha=100;
  loop
    TempScreen=screen_get();
    frame;
    graph=TempScreen;
  end
end



process Database(Mode);
private
  int SelectData;
  int TotalData;
  int TempRedraw;
begin
  SelectData=1; TotalData=11;

  if (Mode==0 or Mode==1)
    signal(PlayerID, s_freeze_tree);
    signal(father, s_freeze);
  end

  frame(800);
  MenuBackground(0);
  frame(2000); frame(1000);

  repeat

    if (key(_left) or joy_getaxis(0,0)<-20) play_wav(MenuMove,0); SelectData--; frame(500); end
    if (key(_right) or joy_getaxis(0,0)>20) play_wav(MenuMove,0); SelectData++; frame(500); end

    if (SelectData==0) SelectData=TotalData; end
    if (SelectData==TotalData+1) SelectData=1; end

    if (TempRedraw!=SelectData)
      delete_text(0);
      set_text_color(rgb(255,255,255));

      if (SelectData==1)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 1 - Section 1 - Terrora");
        write(0,130,58,0,"Terrora is the homeworld of all Selachimorph-kind. It is an");
        write(0,130,68,0,"old planet, revolving around a single sun. The environments");
        write(0,130,78,0,"of Terrora are as strange as they are varied, ranging from");
        write(0,130,88,0,"the extremely dangerous deep sea to red jungles, black");
        write(0,130,98,0,"deserts, blue fields and steep mountains. A lot of its more");
        write(0,130,108,0,"obscure natural occurrences are influenced by the planets");
        write(0,130,118,0,"natural streams of energy, usually leaking out from the");
        write(0,130,128,0,"core of the planet. This kind of energy has yet to be");
        write(0,130,138,0,"explained but twists nature, animal and Selach alike");
        write(0,130,148,0,"wherever it emerges. Sometimes seismic activity pushes");
        write(0,130,158,0,"a previously underground area to the surface, revealing");
        write(0,130,168,0,"its energy-influenced obscurities. Such a place is called");
        write(0,130,178,0,"a Hadesite, referring to the deepest parts of the sea, which");
        write(0,130,188,0,"these sites share a surprising amount of similarities to.");
        write(0,130,198,0,"Since the beginning of the modern age, known as Moderna,");
        write(0,130,208,0,"about 35% of the planets massive surface has been");
        write(0,130,218,0,"converted into giant Monolithic Cities. Cities where");
        write(0,130,228,0,"buildings reach for the sky and leave Terroras scorched");
        write(0,130,238,0,"crust far beneath their peaks.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==2)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 2 - Section 1 - Mystical Relics");
        write(0,130,58,0,"Terrora is a world of mysteries and one of the grander ones");
        write(0,130,68,0,"is the presence of mystical relics or artifacts, so-called");
        write(0,130,78,0,"'Essences'. No one knows where these come from but");
        write(0,130,88,0,"sometimes items, creatures or other things can be defined");
        write(0,130,98,0,"as an essence. An essence seems to incorporate the very");
        write(0,130,108,0,"idea of the thing, or could maybe be called the ghost of");
        write(0,130,118,0,"the thing made flesh. An essence may or may not be ancient,");
        write(0,130,128,0,"as it seems that these kinds of things sometimes are");
        write(0,130,138,0,"randomly created, seemingly out of thin air.");

        write(0,130,158,0,"Some of the more famous known essences are noted here :");
        write(0,130,178,0,"The medieval 'Essence of Dagger', wielded by");
        write(0,130,188,0,"Krim the Traitor and later lost.");

        write(0,130,208,0,"The 'Essence of Manifestation', originally wielded by");
        write(0,130,218,0,"Rifta Recog and currently owned by the Recogno Concern.");

        write(0,130,228,0,"The 'Essence of Darkness', enveloped in the genetic code of");
        write(0,130,238,0,"the Darkbringer-species.");

        write(0,130,258,0,"The ancient 'Essence of Thunder', originally wielded by");
        write(0,130,268,0,"Dirtram the Devestator, currently wielded by Grim Orber of");
        write(0,130,278,0,"the Leviathan Concern.");

        write(0,130,298,0,"The 'Essence of Depravity', manifested as the");
        write(0,130,308,0,"'hedonistic ghost', a strange force of nature that randomly");
        write(0,130,318,0,"inhabits the host of any festive occasion, pushing it to its ");
        write(0,130,328,0,"limits and engulfing anyone in a certain area around the");
        write(0,130,338,0,"host in a state of pure mania.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==3)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 3 - Section 1 - Selachimorphs");
        write(0,130,58,0,"The Selachimorphs are the dominant species of Terrora and");
        write(0,130,68,0,"has forced a lot of the planet to bend to its will.");
        write(0,130,78,0,"It has not always been so. The oldest recordings of the");
        write(0,130,88,0,"Selachimorph-people speak of another intelligent species");
        write(0,130,98,0,"simply known as 'The Fish' or the more complex and");
        write(0,130,108,0,"mysterious 'The ever-changing'. This was in ancient times,");
        write(0,130,118,0,"before Selachimorphs emerged from the deep waters of the");
        write(0,130,128,0,"sea and began ruling Terrora.");
        write(0,130,138,0,"The records say that the people known as 'The Fish' were");
        write(0,130,148,0,"exterminated by the Selachimorphs as the Warlords of the");
        write(0,130,158,0,"time saw them as a long-term threat to Selachimorph-kind.");
        write(0,130,168,0,"Selachimorphs are an aggressive species, partly due to the");
        write(0,130,178,0,"violence inherently necessary in the production of children.");
        write(0,130,188,0,"The Selachs have always been predators, with a diet");
        write(0,130,198,0,"consisting at first only of meat but later, as modern");
        write(0,130,208,0,"society evolved, also by meat-substitutes such as Blech");
        write(0,130,218,0,"and Bleck. Some scientists have theories concerning the");
        write(0,130,228,0,"harsh environment of Terrora and how, for a species to");
        write(0,130,238,0,"come as far as the Selachs have, it is necessary for");
        write(0,130,248,0,"society and the species itself to incorporate a certain");
        write(0,130,258,0,"amount of aggression and lust for war. It is said a");
        write(0,130,268,0,"species becomes strong enough to survive by enduring");
        write(0,130,278,0,"hardship.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==4)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 4 - Section 1 - The Tribes of Terrora");
        write(0,130,58,0,"Tribal life has been the main structure of Selachimorph");
        write(0,130,68,0,"society for all recorded time. Any Selachimorph is born into");
        write(0,130,78,0,"a tribe, usually determined by a birthmark inherited either");
        write(0,130,88,0,"by the mother or father of the child. The Tribes have");
        write(0,130,98,0,"characteristic traits, but diversity among members of a");
        write(0,130,108,0,"Tribe is still huge. Some members barely have any of the");
        write(0,130,118,0,"characteristics of their tribes while others are genuine");
        write(0,130,128,0,"archetypes. Most of the Tribes are ancient, but some tribes");
        write(0,130,138,0,"appeared, or have been founded over years. A founder is");
        write(0,130,148,0,"usually someone with an especially strong genetic heritage");
        write(0,130,158,0,"or born with a yet unseen shape of tribal birthmark.");
        write(0,130,168,0,"The Leviathan, Prometheus and Reaver Tribes are the oldest");
        write(0,130,178,0,"known Tribes, while the Psykodrome Tribe emerged as");
        write(0,130,188,0,"Selachimorphs moved from sea to land. The Recogno Tribe is");
        write(0,130,198,0,"the youngest Tribe and was founded just as the Dark Ages");
        write(0,130,208,0,"where about to end. There have been discussions concerning");
        write(0,130,218,0,"the shaping of a tribe during the modern age, as more and");
        write(0,130,228,0,"more Selachs are born with diffuse tribal birth-marks,");
        write(0,130,238,0,"usually among the lower classes of society. Some speak");
        write(0,130,248,0,"of them as 'Tribeless' or belonging to the 'Unknowns'.");

        write(0,130,268,0,"A Tribe is controlled by a strict hierarchy revolving");
        write(0,130,278,0,"around the tribes Warlord. A warlord is more or less the");
        write(0,130,288,0,"supreme leader of a tribe until the warlord either dies or");
        write(0,130,298,0,"is the victim of a political coup. Historically the different");
        write(0,130,308,0,"tribes have warred and formed alliances with each other for");
        write(0,130,318,0,"dominance over inhabited territories, but this ended with the");
        write(0,130,328,0,"forming of the Senate of Warlords, during the modern age.");

        write(0,130,348,0,"The current Warlord of the Tribes of Terrora are :");
        write(0,130,368,0,"- Drue Drauger of the Reaver Tribe.");
        write(0,130,378,0,"- Grim Orber of the Leviathan Tribe.");
        write(0,130,388,0,"- Duna Stark of the Prometheon Tribe.");
        write(0,130,398,0,"- Lucidor Seer of the Psykodrome Tribe.");
        write(0,130,408,0,"- Starver Kraft of the Recogno Tribe.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==5)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 5 - Section 1 - Prometheon");
        write(0,130,58,0,"Prometheon is a crystalline construct often found around");
        write(0,130,68,0,"Aclocudios Pits. Bright yellow fumes and magenta beams of");
        write(0,130,78,0,"light emerge from its surface, slowly evaporating into thin");
        write(0,130,88,0,"air. When it undergoes Aclopolarization it becomes liquid");
        write(0,130,98,0,"and in this process vast amounts of Energy are released,");
        write(0,130,108,0,"forming Circular Pulsating Clouds.");
        write(0,130,118,0,"Prometheon has been, and still is, the main energy-source of");
        write(0,130,128,0,"the collective Selachimorph-society. It powers weapons,");
        write(0,130,138,0,"cities and much grander machinations.");

        write(0,130,158,0,"Prometheon was the herald of the Modern Age and is the");
        write(0,130,168,0,"foundation that Modern society has been built upon.");
        write(0,130,178,0,"The invention of the G-engine is, however, said to be the");
        write(0,130,188,0,"herald of yet another step in the evolution of technical");
        write(0,130,198,0,"advancement, but is yet to be utilized on such a grand scale");
        write(0,130,208,0,"as Prometheon has been.");

        write(0,130,238,0,"Page 5 - Section 2 - Aclopolarization :");

        write(0,130,258,0,"A means of destabilizing the state of Prometheon-crystals");
        write(0,130,268,0,"by introducing them to parts of Gelatinum.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==6)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 6 - Section 1 - Gelatinum");
        write(0,130,58,0,"Gelatinum is a semi-gelatinous mineral, changing between");
        write(0,130,68,0,"a hard and a gelatinous state in a seamless process.");
        write(0,130,78,0,"Touching its hard surface sends ripples through its");
        write(0,130,88,0,"gelatinous innards. It has been known for some time that");
        write(0,130,98,0,"Gelatinum has morphing and destabilizing properties that");
        write(0,130,108,0,"sometimes can change other gelatinous materials or fluids");
        write(0,130,118,0,"into hard or loose states, including itself.");
        write(0,130,128,0,"This process is known to be entirely random, although it is");
        write(0,130,138,0,"known that the ancient race known as Jellicons used this in");
        write(0,130,148,0,"various ways. It is also known that Gelatinum generally");
        write(0,130,158,0,"destabilize Prometheon-crystals, turning them into a liquid");
        write(0,130,168,0,"state.");
        write(0,130,178,0,"In the year 3X: 351 Starver Kraft of the Recogno Concern,");
        write(0,130,188,0,"Executive Director of the Energore Corporation, unveiled");
        write(0,130,198,0,"the Gellenium project. This project was focused on");
        write(0,130,208,0,"developing a means to harvest energy from Gelatinum by");
        write(0,130,218,0,"manipulating the inner processes of its shifting forms.");
        write(0,130,228,0,"The success of the project was tremendous and has shown");
        write(0,130,238,0,"that Gelatinum possibly can be used to harness endless");
        write(0,130,248,0,"amounts of energy.");

        write(0,150,278,0,"'Its hard to explain. The Gelatinum works as a sort of");
        write(0,150,288,0,"conductor, or transmitter I guess. Its properties are");
        write(0,150,298,0,"not entirely unlike those found around Mystic Gates or");
        write(0,150,308,0,"Hadessites. Energy just appears, as if brought from");
        write(0,150,318,0,"somewhere else. It never ends, it's potentially endless.'");

        write(0,190,338,0,"- Starver Kraft, Warlord of the Recogno Tribe.");
        write(0,190,348,0,"   Executive Director of Energore corporation.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==7)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 7 - Section 1 - Arc White Space Program");
        write(0,130,58,0,"The Arch White project is the culmination of two of");
        write(0,130,68,0,"Selachimorph-kinds greatest inventions: the Dark-drive");
        write(0,130,78,0,"and the G-engine. While Gelatinum grants access to");
        write(0,130,88,0,"supposedly limitless amounts of energy a G-engine needs");
        write(0,130,98,0,"to have a containment field made out of concentrated");
        write(0,130,108,0,"darkness too work at a higher capacity. Operating on");
        write(0,130,118,0,"higher levels G-engines are known to either release energy");
        write(0,130,128,0,"that runs amok or such copious amounts of energy that it");
        write(0,130,138,0,"instantly dissolves into the universe, possibly increasing");
        write(0,130,148,0,"its mass. The containment-field a Dark-drive can create is");
        write(0,130,158,0,"the only known means to keep the energy releases contained,");
        write(0,130,168,0,"allowing a controlled output.");

        write(0,130,188,0,"The Arc White Space Program is a co-joint project between");
        write(0,130,198,0,"the Recogno Concern, the creators of the G-engine, and");
        write(0,130,208,0,"Psykodrome Concern, the creators of the Dark-drive.");
        write(0,130,218,0,"It is a space exploration program that has the specific goal");
        write(0,130,228,0,"of discovering and conquering planets for Terroforming and");
        write(0,130,238,0,"colonization. The process of Terroforming, and the greatest");
        write(0,130,248,0,"of the programs spaceships, was made possible only by");
        write(0,130,258,0,"using Gelatinum as an energy-source.");

        write(0,130,278,0,"The first planet too be explored and exploited by the");
        write(0,130,288,0,"program is known as Blank Planet, named after its almost");
        write(0,130,298,0,"entirely cloud-covered atmosphere. It is believed to be a");
        write(0,130,308,0,"planet rich of resources.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==8)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 8 - Section 1 - Psykodrome Tribe/Psykodrome Concern");
        write(0,130,58,0,"In ancient times, during the process where selachs ventured");
        write(0,130,68,0,"from the depths of the sea to land, the Psykodrome Tribe");
        write(0,130,78,0,"was created. The name of the original founder has been lost");
        write(0,130,88,0,"in time. However, it is believed that the Psykodromes hail");
        write(0,130,98,0,"from a branch of the Prometheus Tribe that started to");
        write(0,130,108,0,"develop psychic proficiency. There are many theories on");
        write(0,130,118,0,"how this came to be but it is known that those of the");
        write(0,130,128,0,"Prometheus Tribe who developed these powers lived in or");
        write(0,130,138,0,"near the Psykodrome reef, and thusly it is believed that");
        write(0,130,148,0,"something in this reef has influenced the process.");

        write(0,130,168,0,"Psychic proficiency manifests itself in many ways and no");
        write(0,130,178,0,"one outside the Psykodrome Tribe has any real knowledge");
        write(0,130,188,0,"about how it works. Some powers connected to psychic");
        write(0,130,198,0,"proficiency are well known, such as: astral projection,");
        write(0,130,208,0,"kinetic manipulation, psykokinesis, telekinesis,");
        write(0,130,218,0,"dream-manipulation, domination and telepathy.");

        write(0,130,238,0,"The Psykes, as all tribes, have a long and violent history.");
        write(0,130,248,0,"Some highlights are worth taking notice of however. During");
        write(0,130,258,0,"the Second period of the Dark Ages the Psykodrome Tribe");
        write(0,130,268,0,"was actually the ruling faction on Terrora, imposing a reign");
        write(0,130,278,0,"of terror through its grand Overlords Morkh the War-loch and");
        write(0,130,288,0,"Cirva the Dominator. For a short while, more or less the");
        write(0,130,298,0,"life-span of these two incredibly powerful individuals,");
        write(0,130,308,0,"Terrora was mostly under the influence of one ruling empire.");
        write(0,130,318,0,"The empire crumbled quickly as the rest of the tribes");
        write(0,130,328,0,"rebelled when Morkh and Cirva died due too strange");
        write(0,130,338,0,"circumstances. The two had, however, lived for 160 years,");
        write(0,130,348,0,"far longer than the usual lifespan of a Selachimorph,");
        write(0,130,358,0,"especially during the Dark Ages.");
        set_text_color(rgb(255,255,255));
      end

      if (SelectData==9)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 9 - Section 2 - Psykodrome Tribe/Psykodrome Concern");
        write(0,130,58,0,"When the Modern Age began The Psykodrome Tribe");
        write(0,130,68,0,"transitioned quite smoothly from the tribal structure to");
        write(0,130,78,0,"corporations as parts of a grand concern. The forceful");
        write(0,130,88,0,"nature of the power-hierarchy inside the tribe may have");
        write(0,130,98,0,"made this process easier. It is far more convenient to");
        write(0,130,108,0,"dominate the opposition of an idea than to coerce them.");

        write(0,130,128,0,"Today the Psykodrome Concern has an equal share of the");
        write(0,130,138,0,"collective power on Terrora, just as the other tribes on");
        write(0,130,148,0,"the Council of Warlords. Led by its Warlord Lucidor Seer");
        write(0,130,158,0,"the Concern leads the market in areas such as :");
        write(0,130,168,0,"psychic studies, psy-application, cloning, dream-products");
        write(0,130,178,0,"and processes and neural technology.");

        set_text_color(rgb(255,255,255));
      end

      if (SelectData==10)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 10 - Section 1 - Recogno Tribe/Recogno Concern");
        write(0,130,58,0,"The Recogno tribe was created during the late Dark Ages,");
        write(0,130,68,0,"just as the pre-modern age was about to begin, by the");
        write(0,130,78,0,"legendary Rifta Recog. Rifta was a great inventor and");
        write(0,130,88,0,"among other things invented Clockwork, which she used to");
        write(0,130,98,0,"create machinations far beyond her time. Among her most");
        write(0,130,108,0,"famous inventions are the Cogbow, the Clockwork");
        write(0,130,118,0,"Power-Armor and the Automated Battle-Chariot.");

        write(0,130,138,0,"Rifta carved out a small empire during her life and");
        write(0,130,148,0,"left a heritage of both science and power to her many");
        write(0,130,158,0,"children and her followers who in time formed the bulk of");
        write(0,130,168,0,"the Recogno Tribe.");

        write(0,130,178,0,"The Recogno Tribe has always been centered around the");
        write(0,130,188,0,"development of technology and the advancement of science.");
        write(0,130,198,0,"It is a relatively small tribe, mostly due to being young,");
        write(0,130,208,0,"but this has not made it any  less significant in the power");
        write(0,130,218,0,"struggles on Terrora. What Recognos lack in manpower they");
        write(0,130,228,0,"make up for in superior technology and planning.");

        write(0,130,248,0,"The Recogno Tribe has a relatively loose hierarchy, based");
        write(0,130,258,0,"on both family ties and on what contributions an individual");
        write(0,130,268,0,"has made to the Tribe. A position of power can be inherited");
        write(0,130,278,0,"but it can also be granted as a reward for scientific");
        write(0,130,288,0,"discovery or other kinds of contributions to the tribe.");
        write(0,130,298,0,"Any individual found unworthy of a position can be");
        write(0,130,308,0,"challenged for it. The challenger must prove that its");
        write(0,130,318,0,"contributions make it more worthy of the position. This is");
        write(0,130,328,0,"usually a somewhat peaceful process but sometimes a");
        write(0,130,338,0,"challenger might want to show off their contributions, most");
        write(0,130,348,0,"commonly some kind of new weapon, by applying it to the");
        write(0,130,358,0,"challenged.");

        set_text_color(rgb(255,255,255));
      end

      if (SelectData==11)
        set_text_color(rgb(255,180,180));
        write(0,130,38,0,"Page 11 - Section 2 - Recogno Tribe/Recogno Concern");
        write(0,130,58,0,"The Recogno Tribe had no problems adapting to the Moder");
        write(0,130,68,0,"Age as they were already divided into smaller cells");
        write(0,130,78,0,"focused on different kinds of research and production.");
        write(0,130,88,0,"The Recogno Tribe turned into a Concern relatively quickly");
        write(0,130,98,0,"and soon secured a strong position on the Market.");

        write(0,130,118,0,"Today the Concern is led by its Warlord Starver Kraft,");
        write(0,130,128,0,"Executive director of Energore Corporation, and leads the");
        write(0,130,138,0,"Market in areas such as: computer technology,");
        write(0,130,148,0,"AI-development, robotics, energy-development and");
        write(0,130,158,0,"application, nano-technology, space-crafts and");
        write(0,130,168,0,"advanced weaponry.");

        set_text_color(rgb(255,255,255));
      end

    end
    TempRedraw=SelectData;

  frame;
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))

  delete_text(0);
  frame(2000);
  if (Mode==0 or Mode==1)
    signal(PlayerID, s_wakeup_tree);
    signal(father, s_wakeup);
  end
  if (Mode==1) frame(2000); Extras(); end
  if (Mode==2) frame(2000); GameMenu(); end
  return;
end



process SolkExamine1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Solk seems to have a very distinct taste in books. All of these");
  write(0,110,410,0,"revolve around the Occult. Manifests concerning old religions");
  write(0,110,420,0,"and myths. Some of these, concerning dream-like realities and");
  write(0,110,430,0,"dream-structures, are actually considered canon among the");
  write(0,110,440,0,"members of Lucidotech, the dream-corporation of the Psykodrome");
  write(0,110,450,0,"concern.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This is a classic, painted by Vercazo the Dream-stealer, one of");
  write(0,110,410,0,"the founders of the Psykodrome Tribe. It portrays what Vercazo");
  write(0,110,420,0,"called 'the mad master of the divine body', hidden in shame behind");
  write(0,110,430,0,"a one-eyed mask.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"A small model of the great Terroformer-ship of the Arc White");
  write(0,110,410,0,"project. This colossus of machinery is in reality accompanied");
  write(0,110,420,0,"by a fleet of smaller war- and transportation ships.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine4();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This is a Lucidotech product, a so called memory-chair.");
  write(0,110,410,0,"Connected to a memory-stone and a neural wave interface");
  write(0,110,420,0,"this chair is actually capable of recording thoughts.");
  write(0,110,430,0,"Shall I review its latest entry?");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(2); CharacterPortrait(57,423,1,281,0); frame(800); CharacterExpression(82,403,0,284);
  write(0,110,380,0,"Yes");
  write(0,110,410,0,"No");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  if (Selection==1)
    MemoryChair=1;
    set_text_color(rgb(240,30,180));
    frame(800); TextBox(0); CharacterPortrait(57,423,1,0,0); frame(800);
    write(0,110,380,0,"Ghost and Flesh, how is it possible to separate these things?");
    write(0,110,390,0,"Selachimorphs consist of both a fleshy body its source of");
    write(0,110,400,0,"energy, the ghost. Yet now I am equipped with two!");
    write(0,110,410,0,"What a wonderful creature this is! I feel alive, like I am now");
    write(0,110,420,0,"living for the both of us. A symbiosis like this surely is the");
    write(0,110,430,0,"future destiny of our species, or at least the Psykodrome Tribe.");
    write(0,110,440,0,"We have always been more open to the deepest corners of our");
    write(0,110,450,0,"reality than our genetically diverse brethren.");
    repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

    frame(800); TextBox(0); CharacterPortrait(57,423,1,0,0); frame(800);
    write(0,110,380,0,"And yet there are other possibilities, as my soon to be foe has");
    write(0,110,390,0,"shown through her use of the Essence of Manifestation. This world");
    write(0,110,400,0,"is full of strange and wonderful things, how I wish to delve");
    write(0,110,410,0,"deeper into this vast and murky ocean of secrets!");
    repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

    set_text_color(rgb(255,255,255));
  end

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine5();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This... looks kind of like a Gellolynom... but not really.");
  write(0,110,410,0,"It's actually more akin to the description of the ancient Jellicons,");
  write(0,110,420,0,"but that couldn't be. They became extinct centuries ago.");
  write(0,110,430,0,"Solk seems to have several kinds of apparatus connected to the");
  write(0,110,440,0,"aquarium.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine6();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This is some kind of crystalized ancient creature. Probably");
  write(0,110,410,0,"something brought to light by an erupting Hadesite. All kinds of");
  write(0,110,420,0,"weird crud hail from those accursed places. It kind of looks like");
  write(0,110,430,0,"a Darkbringer hatchling, but twisted and deformed.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkExamine7();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,282,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Hmm. These books are romantic novels, written for hormone-ridden");
  write(0,110,410,0,"juveniles. Rom-novs usually have cheesy stories that ends in");
  write(0,110,420,0,"copious amounts of violence. Solk sure does have some weird");
  write(0,110,430,0,"tastes.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process EnerGoreExamine1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,0,0); frame(800);
  write(0,110,380,0,"Starver Kraft, current president of the EnerGore Corporation,");
  write(0,110,390,0,"Warlord of the Recogno Tribe.");
  write(0,110,410,0,"'Progress begins with conflict'");
  write(0,110,430,0,"                             - Starver Kraft");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process EnerGoreExamine2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"They still keep these old guys around... I guess the clock-work");
  write(0,110,410,0,"mechanisms have a certain charm to them. But...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process EnerGoreExamine3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"Here are the Specifics of your Mission.");
  write(0,110,410,0,"The Intestinal Sludge-tubes are ready to transport you to your");
  write(0,110,420,0,"Deeeeeeeesti- Nation.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,0); CharacterPortrait(581,423,1,327,1); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Always a pleasure...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800);

  TutorialText=6;
  MissionBriefing1(0);

  repeat frame; until(exists(type MissionBriefing1)==0)

  signal(father, s_wakeup);

end



process MissionBriefing1(Mode);
begin
  if (Mode==0)
    signal(PlayerID, s_freeze_tree);
    signal(father, s_freeze);
    signal(type Sign, s_kill);
  end

  frame(800);

  MenuBackground(0);
  frame(2000); frame(400);

  set_text_color(rgb(255,180,180));
  write(0,260,38,0,"MISSION BRIEFING:");
  write(0,180,58,0,"Security-clearance: Zeta Kraft Executive 12.");

  write(0,130,88,0,"Hello dear Child. I am sorry to disturb you in your moments");
  write(0,130,98,0,"of private time. I am very well aware that the few moments");
  write(0,130,108,0,"of Tranquility a Regulator Agent of your capacity gets");
  write(0,130,118,0,"are precious indeed. However, I could trust no other with");
  write(0,130,128,0,"this.");

  write(0,130,148,0,"As you may be aware of we lost contact with Arc White,");
  write(0,130,158,0,"our space-exploration program, some time ago. My resources");
  write(0,130,168,0,"now tell me that our colleagues in this grand endeavor,");
  write(0,130,178,0,"the psychics of the Psykodrome Tribe, more specifically");
  write(0,130,188,0,"employees of PsyCorp, have intercepted a message from our");
  write(0,130,198,0,"fleet.");

  write(0,130,218,0,"They won't share it and there is something very suspicious");
  write(0,130,228,0,"about this entire situation. A PsyCorp Overlord named");
  write(0,130,238,0,"Solk Cidonian is the current guardian of this transmission.");
  write(0,130,248,0,"I want you to get it. And teach them a lesson about crossing");
  write(0,130,258,0,"the Recogno Tribe. Kill anything that moves.");

  write(0,130,288,0,"With proper Affection // Starver Kraft.");

  write(0,130,308,0,"(PS: I added some notes about the Arc White Project and the");
  write(0,130,318,0,"Psykodrome Tribe among other things to your database. View");
  write(0,130,328,0,"them as you please.)");

  write(0,130,348,0,"Mission summary: Travel through the city, into the PsyCorp");
  write(0,130,358,0,"compound and find Solk Cidonian. Kill everything that moves");
  write(0,130,368,0,"and get the transmission from Arc White.");

  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  set_text_color(rgb(255,255,255));

  delete_text(0);
  frame(2000);
  if (Mode==0)
    signal(PlayerID, s_wakeup_tree);
    signal(father, s_wakeup);
  end
  if (Mode==1) frame(2000); GameMenu(); end
  return;
end



process VreidaIntro();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,1); frame(800);
  write(0,110,380,0,"You are Vreida Kraft, a Regulator Agent working for the EnerGore");
  write(0,110,390,0,"Corporation. One day you will inherit the vast fortunes and");
  write(0,110,400,0,"diabolical secrets of this organization. For now, however, your");
  write(0,110,410,0,"work is the work of a killer. As a Regulator you take care of");
  write(0,110,420,0,"corporate problems wherever they arise.");
  write(0,110,440,0,"Your code name is Emissary.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,1); frame(800);
  write(0,110,380,0,"You are armed, not only with the Prometheon EnerGod Glidesuit and");
  write(0,110,390,0,"the latest in Recogno weapons-technology but also with an ancient");
  write(0,110,400,0,"artifact. It is known as the Essence of Manifestation and was");
  write(0,110,410,0,"once wielded by Rifta Recog herself.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,1); frame(800);
  write(0,110,380,0,"You are also a member of the Recogno Tribe, now more known as");
  write(0,110,390,0,"the Recogno Concern. The Recogno Tribe is a relatively young");
  write(0,110,400,0,"tribe, formed and shaped just as the Dark Ages where about to");
  write(0,110,410,0,"come to an end. Your Tribe hails from Rifta Regoc, the Seer of");
  write(0,110,420,0,"Future Dreams, and the Recogno Tribe has always been on the");
  write(0,110,430,0,"forefront when Selachimorph society evolves. That is your trait.");
  write(0,110,440,0,"As the Leviathan Tribe leads and the Reaver Tribe destroys,");
  write(0,110,450,0,"Recognos discover and create. And destroy.");
  //write(0,110,460,0,"What will you discover, as the new century begins?");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,1); frame(800);
  write(0,110,380,0,"You have just received notice that you are once more called into");
  write(0,110,390,0,"action.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process TutorialText1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"*Activating* hrrrtzZZZ.");
  write(0,110,410,0,"Operator One, running Armament CheckUp routine...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"G-oouuud... Good Evening Agent Emissary.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"How has your resting time/preparation/social activities been");
  write(0,110,410,0,"going? No need to answer that. Unless you feel the need for");
  write(0,110,420,0,"interaction. If you feel the need to talk to a Psychiatrist");
  write(0,110,430,0,"answer YES to make an appointment...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"Vuuee- Vrieda. Are you ready to begin Checkup routine before");
  write(0,110,410,0,"departing to your mission?");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); CharacterPortrait(581,423,1,327,1); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"With AI-programming as strong as yours, it's surprising how");
  write(0,110,410,0,"strange you guys actually turned out. Yes, I am ready.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"G-oouud, let's begin with the basics of your Energod Glidesuit.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  if (TutorialText==0) TutorialText=1; end
  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process TutorialText2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"You are equipped with the ZeroG Gravity-ball, made for");
  write(0,110,410,0,"your gliding convenience. Try to perform a double-jump.");
  set_text_color(rgb(180,255,180));
  write(0,110,430,0,"- To perform a jump, use the JUMP-button. To make a");
  write(0,110,440,0,"double-jump, simply jump while already in the air.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  set_text_color(rgb(255,255,255));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"To review button layout, press ESC to open your wrist-computer");
  write(0,110,410,0,"and select 'Controls' to see all available input commands.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  if (TutorialText==1) TutorialText=2; end
  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process TutorialText3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"Your Energod Glidesuit seems to be fully functional. Now let's");
  write(0,110,410,0,"try out some target practice. Change from your Standard Tech-gun");
  write(0,110,420,0,"to The Recogno Laserconverter. Hit all targets in the next area.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,0,0); frame(800);
  set_text_color(rgb(180,255,180));
  write(0,110,380,0,"To change your weapon use SWITCH-NEXT or SWITCH-PREVIOUS.");
  write(0,110,390,0,"Aim your weapon with the ARROWS. Fire with the FIRE button.");
  write(0,110,400,0,"There are several different kinds of ammo for the Recogno");
  write(0,110,410,0,"Laserconverter. As you pick them up, change between them just");
  write(0,110,420,0,"as you change weapons.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  set_text_color(rgb(255,255,255));

  if (TutorialText==2) TutorialText=3; end
  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process TutorialText4();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"G-oouud. Excellent work Agent. I will send a detailed summary to");
  write(0,110,410,0,"your father: Suuuuuooooot- Starver Kraft.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"Now let's try out your hacking skills. Hack the two terminals in");
  write(0,110,410,0,"the following area.");
  set_text_color(rgb(180,255,180));
  write(0,110,430,0,"- Sometimes Vreida will need to solve a small puzzle or");
  write(0,110,440,0,"action-game to advance. To Examine or Activate something, in");
  write(0,110,450,0,"this case a computer-console, use EXAMINE.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  set_text_color(rgb(255,255,255));

  if (TutorialText==3) TutorialText=4; end
  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process TutorialText5();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"Impressive work Agent. You will be briefed about your mission");
  write(0,110,410,0,"in the lobby.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process DisplayControls();
begin

  frame(800);
  MenuBackground(0);
  frame(2000); frame(400);
  graph=415; x=320; y=100; z=0; alpha=5;
  repeat alpha+=10; frame(50); until(alpha=>255)

  set_text_color(rgb(255,180,180));

  write(0,130,178,0,"Controls are as follows :");
  write(0,130,198,0,"Arrow Keys control Vreidas movement and aiming.");
  write(0,130,208,0,"Ctrl or Z jumps.");
  write(0,130,218,0,"Alt or X fires the selected weapon.");
  write(0,130,228,0,"Space or Enter talks to people, examines objects or selects");
  write(0,130,238,0,"options in menus.");
  write(0,130,248,0,"Tab and Backspace switches between weapons.");
  write(0,130,258,0,"Esc opens the in-game menu.");

  write(0,130,278,0,"There are also many special actions which can be performed");
  write(0,130,288,0,"at specific locations in the game. These will be detailed");
  write(0,130,298,0,"at those occasions.");

  write(0,130,318,0,"If the sword is selected it can be charged by keeping the");
  write(0,130,328,0,"fire-button pressed. Release the button when the meter is");
  write(0,130,338,0,"fully charged to release a devestating attack.");

  write(0,130,358,0,"It is also possible to play the game using a gamepad or");
  write(0,130,368,0,"joystick. It will automatically be detected if connected");
  write(0,130,378,0,"and can then be used instead of the keyboard controls.");

  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  set_text_color(rgb(255,255,255));

  delete_text(0);
  repeat alpha-=10; frame(25); until(alpha<=5) alpha=0;
  frame(2000); frame(2000); GameMenu();
  return;
end



process VreidaRoom1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Art of kicking people, The decapitation of your rivals and the");
  write(0,110,410,0,"pleasures it can give you, How To: make a bowl out of a skull,");
  write(0,110,420,0,"Killing the Corporal, Killing the meta-physical, History of");
  write(0,110,430,0,"Progress: The founding of the Recogno Tribe. Ancient Relics and");
  write(0,110,440,0,"Dangerous Depths.");
  write(0,110,450,0,"Hmm. Blarry Smother and the Philosophers Moans. It's been a long");
  write(0,110,460,0,"time since I read this.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process VreidaRoom2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,282,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"My collection of special weapons. Some of them are real antiques.");
  write(0,110,410,0,"I specially favor the late-medieval Cogbow. A powerful weapon");
  write(0,110,420,0,"used by the very first of the Recogno Tribe.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process VreidaRoom3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This is a painting of Rifta Recoq, the founder of the Recogno");
  write(0,110,410,0,"Tribe, by an unknown artist. Rifta was a great inventor and");
  write(0,110,420,0,"warrior. Her first invention was the clock, her second a");
  write(0,110,430,0,"clockwork-driven power-armor that let her hit things harder.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process GhostFishExamine();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Unevolved Ghost fish, how rare. These pets are grown from");
  write(0,110,410,0,"preserved strands of DNA found crystalized in black-rock in");
  write(0,110,420,0,"the deep sea or around Hadesites. These guys are quite cute");
  write(0,110,430,0,"and aggressive, not at all alike their modern shape.");
  write(0,110,440,0,"The evolved breed of Ghost fish are quite a pest, appearing");
  write(0,110,450,0,"around Prometheon crystals and disturbing the peace with");
  write(0,110,460,0,"their blind bloodlust.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process GEngineExamine();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This is the first generation G-Engine. Just one of these should");
  write(0,110,410,0,"be enough to power this entire city, but no concern or");
  write(0,110,420,0,"corporation would be willing to risk sharing energy supplies");
  write(0,110,430,0,"with other companies. The Dark-Drive doesn't seem to be optimal");
  write(0,110,440,0,"either as handling the great amounts of energy released has");
  write(0,110,450,0,"turned out to be a problem.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process LucidorExamine();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Lucidor Seer, Warlord of the Psykodrome Concern and the");
  write(0,110,410,0,"Executive director and founder of Lucidocorp. No one has seen");
  write(0,110,420,0,"Lucidor in recent years as he usually appears in various");
  write(0,110,430,0,"host-bodies as an avatar of himself. Lucidor is known as a");
  write(0,110,440,0,"visionary, and among the dream adepts of Lucidocorp as a");
  write(0,110,450,0,"god among selachs.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SpiritBattle1Text1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"(A strange sensation sends ripples through the air and low");
  write(0,110,390,0,"humming sound fills the room. Your gills widen as energy");
  write(0,110,400,0,"begins to gather in front of you, forming some kind of");
  write(0,110,410,0,"creature.)");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(800); CharacterExpression(82,403,0,283);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Whats this? It appears to be some kind of spiritual construct...");
  write(0,110,410,0,"I can see why father needed me for this mission.");
  write(0,110,420,0,"It's time use the Essence of Manifestation.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"(The Essence of Manifestation is an ancient Mystical Relic");
  write(0,110,390,0,"that allows a person's 'inner being' or Ghost to manifest");
  write(0,110,400,0,"itself into a physical form. To power up your Manifestation");
  write(0,110,410,0,"rapidly tap left and right and continue doing so.");
  write(0,110,420,0,"Your Manifestation will take care of the rest.)");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SpiritBattle1Text2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,280,0); frame(800); CharacterExpression(82,403,0,283);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Great, it's gone. But I don't think it's dead... yet.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SpiritBattle2Text1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"(A strange sensation sends ripples through the air and low");
  write(0,110,390,0,"humming sound fills the room. Your gills widen as energy");
  write(0,110,400,0,"begins to gather in front of you, forming some kind of");
  write(0,110,410,0,"creature.)");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(800); CharacterExpression(82,403,0,284);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Wait... is it feline? It looks like some kind of cat doesn't it?");
  write(0,110,410,0,"Almost sickeningly cute. If this is a manifestation of some sort...");
  write(0,110,420,0,"I wonder what kind of person it hails from. Let's kill it for good");
  write(0,110,430,0,"this time.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SpiritBattle2Text2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(800); CharacterExpression(82,403,0,284);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Gone again! I don't think I can kill it this way.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkConversation1();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(581,423,1,394,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"And here comes the lady of the evening, the always so delightful");
  write(0,110,410,0,"Miss Vreida Kraft. Though I thought you would get here sooner.");
  write(0,110,420,0,"You have left quite the trail of psychic emission through-out");
  write(0,110,430,0,"the city. The blood of your many victims dissolves into the air,");
  write(0,110,440,0,"their ghosts yearning for your death. It has not been hard to");
  write(0,110,450,0,"track your movements with my astral sensors.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  if (BabbyCount==1)
    frame(800); TextBox(0); CharacterPortrait(581,423,1,416,0); frame(800);
    write(0,110,380,0,"Solk :");
    write(0,110,400,0,"Indeed, you even killed one of our precious baby-clones.");
    if (BrainDestroyed==1)
      write(0,110,410,0,"Not to mention destroying the main node of our neural");
      write(0,110,420,0,"network...");
    end
    repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  end

  if (BabbyCount>1)
    frame(800); TextBox(0); CharacterPortrait(581,423,1,416,0); frame(800);
    write(0,110,380,0,"Solk :");
    write(0,110,400,0,"Indeed, you even killed many of our precious baby-clones.");
    if (BrainDestroyed==1)
      write(0,110,410,0,"Not to mention destroying the main node of our neural");
      write(0,110,420,0,"network...");
    end
    repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  end

  if (BabbyCount==0 and BrainDestroyed==1)
    frame(800); TextBox(0); CharacterPortrait(581,423,1,416,0); frame(800);
    write(0,110,380,0,"Solk :");
    write(0,110,400,0,"Indeed, you even destroyed the main node of our neural");
    write(0,110,410,0,"network...");
    repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
  end

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,0); CharacterPortrait(581,423,1,394,1); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Cut the chatter fish-guts. I am here for the transmission.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,1); CharacterPortrait(581,423,1,416,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"So you are. But let's not cut to the chase just yet.");
  write(0,110,410,0,"Humor me for a while with pleasant conversation");
  write(0,110,420,0,"before you make your attempt upon my being.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));


  frame(800); TextBox(3); CharacterPortrait(57,423,1,279,0); CharacterPortrait(581,423,1,394,1); frame(800);
  write(0,110,380,0,"...");

  write(0,110,410,0,"Very well. This better be interesting. ");

  write(0,110,440,0,"Time to die.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));


  if (Selection==3) frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return; end

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,1); CharacterPortrait(581,423,1,416,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"Such manners! Such grace! I sense a strong presence");
  write(0,110,410,0,"surrounding you. Bright red, strong with contempt. But also...");
  write(0,110,420,0,"strangely blue. As blue as the sea. Strikingly beautiful of course.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,1); CharacterPortrait(581,423,1,394,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"Allow me to introduce myself properly. I am Solk Cidonian,");
  write(0,110,410,0,"Overlord of this facility, and it is unfortunate that we meet");
  write(0,110,420,0,"under such circumstances.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,1); CharacterPortrait(581,423,1,394,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"This transmission is not for you, or your technology-obsessed");
  write(0,110,410,0,"tribe. The Arc White will soon become the harbinger of the");
  write(0,110,420,0,"future of our species.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));


  frame(800); TextBox(3); CharacterPortrait(57,423,1,282,0); CharacterPortrait(581,423,1,394,1); frame(800);
  write(0,110,380,0,"Psykodromes always had flavor for all that mystical crud.");
  write(0,110,390,0,"But please, do explain.");

  write(0,110,410,0,"So typical for your kind to only speak pseudo-philosophical");
  write(0,110,420,0,"bull-shit. Just tell me your 'master-plan' or whatever.");

  write(0,110,440,0,"(Attack him.)");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  if (Selection==3) frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return; end

  frame(800); TextBox(0); CharacterPortrait(57,423,1,279,1); CharacterPortrait(581,423,1,394,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"You will soon understand. Where once there was flesh and");
  write(0,110,410,0,"ghost we have discovered communion! A bond to grant us the");
  write(0,110,420,0,"power to rule Terrora, as was always intended. But don't take");
  write(0,110,430,0,"my word for it. I will show you the strength of my bond.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkConversation2();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(581,423,1,417,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"Haaah haah. And so I am defeated. For now. I have to admit that");
  write(0,110,410,0,"I knew I would not be strong enough to stand against your");
  write(0,110,420,0,"advances... My ghost will be ready the next time we face");
  write(0,110,430,0,"each other.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(581,423,1,416,0); frame(800);
  write(0,110,380,0,"Solk :");
  write(0,110,400,0,"I bid you farewell, lady of death. I will look into the collective");
  write(0,110,410,0,"dreams of my kind and search for your future. Mayhap my role in");
  write(0,110,420,0,"it will not be the preconceived one... Or maybe I will end you");
  write(0,110,430,0,"as abruptly as we have met.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SolkConversation3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(3); CharacterPortrait(57,423,1,281,0); frame(800);
  write(0,110,380,0,"What a nerd, I'll have your head just yet Cidonian.");

  write(0,110,410,0,"Such a strange man. It's been a while since I had a");
  write(0,110,420,0,"battle worth remembering.");

  write(0,110,440,0,"Gah! I didn't get to kill him? How dissatisfying!");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"Computer :");
  write(0,110,400,0,"Transfer complete. Initiating decryption sequence.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(800);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"I should get out of here.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process SchmupTutorialText();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"*Activating* hrrrtzZZZ.");
  write(0,110,410,0,"Ship Operator, running System CheckUp routine...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"G-oouuud... Good Evening Agent Emissary.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"T-uuaaa... Thanks for using the Recogno Personal Shuttle System.");
  write(0,110,410,0,"Thrusters on. Use LEFT/RIGHT/UP/DOWN to use them.");
  write(0,110,420,0,"Main weapon system activated. Use JUMP to fire.");
  write(0,110,430,0,"Secondary weapons checked. Activate them with FIRE.");
  write(0,110,440,0,"Deflector shield engaged. Deflect shots with USE.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); TextBox(0); CharacterPortrait(57,423,1,278,1); CharacterPortrait(581,423,1,327,0); frame(800);
  write(0,110,380,0,"Operator :");
  write(0,110,400,0,"You can try the systems out if you want. But my sensors are");
  write(0,110,410,0,"picking up a huge amount of ships ahead so you might want");
  write(0,110,420,0,"to get o-uuuunnnn... on the way before they get here.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process ComputerHackTutorial1();
begin
  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"Stop the panels in the correct sequence. Use JUMP, FIRE");
  write(0,110,390,0,"or DOWN to stop the panels. To complete the hacking all");
  write(0,110,400,0,"four symbols must match.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or key(_esc) or joy_getbutton(0,0) or joy_getbutton(0,1) or exists(type ComputerGame1)==0);
  signal(type TextBox, s_kill); delete_text(0); return;
end



process ComputerHackTutorial2();
begin
  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"Use LEFT and RIGHT to transfer the file package from the");
  write(0,110,390,0,"left side to the right. Avoid the virus-scanning software.");
  write(0,110,410,0,"If you get hit you must restart from the beginning.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or key(_esc) or joy_getbutton(0,0) or joy_getbutton(0,1) or exists(type ComputerGame2)==0);
  signal(type TextBox, s_kill); delete_text(0); return;
end


process ComputerHackTutorial4();
begin
  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"Follow the arrows to transfer the file to the host computer.");
  write(0,110,390,0,"When an arrow reaches the lower part of the screen press the");
  write(0,110,400,0,"corresponding command by using LEFT, RIGHT, UP or DOWN.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or key(_esc) or joy_getbutton(0,0) or joy_getbutton(0,1) or exists(type ComputerGame4)==0);
  signal(type TextBox, s_kill); delete_text(0); return;
end



process ComputerHackTutorial5();
begin
  frame(800); TextBox(0); frame(800);
  write(0,110,380,0,"Use UP and DOWN to avoid the tracer programs. If you can");
  write(0,110,390,0,"hide long enough the file transfer will be successful.");
  write(0,110,400,0,"If you get hit your transfer will be temporarliy hindered.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or key(_esc) or joy_getbutton(0,0) or joy_getbutton(0,1) or exists(type ComputerGame5)==0);
  signal(type TextBox, s_kill); delete_text(0); return;
end



process ComputerHackTutorial3();
begin
  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(800); TextBox(0);  frame(800);
  write(0,110,380,0,"Beat Solk's score to access his computer!");
  write(0,110,400,0,"Control your fish with UP, DOWN, LEFT and RIGHT.");
  write(0,110,410,0,"Picking up small food pellets will increase your score.");
  write(0,110,420,0,"Once it's charged you can emit a shockwave that temporarily");
  write(0,110,430,0,"stops enemies by pressing JUMP. Good Luck!");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(800); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end




process TestDialog();
begin

  //set_text_color(rgb(180,180,180));

  signal(PlayerID, s_freeze_tree);
  signal(father, s_freeze);

  frame(700); TextBox(0); CharacterPortrait(57,423,1,278,0); frame(700);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"This place...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(700); TextBox(0); CharacterPortrait(57,423,1,279,0); frame(700);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"It makes me so angry!");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(700); TextBox(0); CharacterPortrait(57,423,1,280,0); frame(700);
  CharacterExpression(82,403,0,283);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"Still, being angry makes me feel good.");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(700); TextBox(0); CharacterPortrait(57,423,1,281,0); frame(700);
  CharacterExpression(82,403,0,284);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"No, wait...");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

  frame(700); TextBox(0); CharacterPortrait(57,423,1,282,0); frame(700);
  write(0,110,380,0,"Vreida :");
  write(0,110,400,0,"It makes me feel sadistic!");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));

/*
  frame(500); TextBox(3); frame(500);
  write(0,110,380,0,"Selection 1");

  write(0,110,410,0,"Selection 2");

  write(0,110,440,0,"Selection 3");
  repeat frame; until (key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0));
*/
  frame(700); signal(PlayerID, s_wakeup_tree); signal(father, s_wakeup); return;
end



process Credits();
begin
  FadeSong();
  SongPlayer(9);
  MenuBackground(1);
  frame(2000); frame(2000);
  set_text_color(rgb(255,180,180));

  write(0,175,148,0,"Story and Worldbuilding :");
  write(0,175,158,0,"Marcus Fredriksson and Daniel Eriksson");

  write(0,175,178,0,"Programming : Daniel Eriksson");

  write(0,175,198,0,"Writing : Marcus Fredriksson");

  write(0,175,218,0,"Music : Marcus Fredriksson");

  write(0,175,238,0,"Graphics : Marcus Fredriksson");

  write(0,175,258,0,"Additional Graphics : Daniel Eriksson");

  write(0,175,278,0,"Testing : Josef Johansson, ?");

  set_text_color(rgb(255,255,255));

  CreditsOption(320,80,1,1);
  CreditsOption(320,380,1,2);
  frame(1000);

  repeat frame; until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  delete_text(0);
  frame(2000); frame(2000); fade(0,0,0,8); frame(2000); fade(100,100,100,8); MainMenu();
end



process CreditsOption(x,y,z,Mode);
begin
  if (Mode==1) graph=422; end
  if (Mode==2) graph=337; end
  alpha=0; flags=16;
  repeat
    if (alpha<255) alpha+=5; end
    frame(25);
  until(key(_enter) or key(_space) or key(_c) or joy_getbutton(0,0))
  repeat size_y-=5; frame(25); until(size_y==5)
  repeat size_x-=5; frame(25); until(size_x==5)
  MainMenuBlip(x,y,z,Mode);
  end
